Ext.data.JsonP.data({"title":"Data Package Overview","guide":"<h1>Using the data package in Sencha Touch 2</h1>\n\n<p>The data package is responsible for loading and saving all data in a Sencha Touch app. Most of what you do with the data package has to do with models, stores, and proxies:</p>\n\n<ul>\n<li><strong>Model:</strong> A model represents an entity your app cares about. User, Contact, Address, and Product could all be models. At its simplest, a model is just a collection of fields and their data, but they can do a lot more.</li>\n<li><strong>Store:</strong> A store is just a collection of model instances. Mostly it's just a glorified array, but it also provides capabilities like sorting, filtering, and grouping, as well as firing useful events.</li>\n<li><strong>Proxy:</strong> Proxies are responsible for all of the actual loading and saving of data. Usually you'll create an <a href=\"#!/api/Ext.data.proxy.Ajax\" rel=\"Ext.data.proxy.Ajax\" class=\"docClass\">AJAX proxy</a> which will fetch data from your server and populate it into a store.</li>\n</ul>\n\n\n<p>Find out more about <a href=\"#!/guide/models\">Models</a>, <a href=\"#!/guide/stores\">Stores</a> and <a href=\"#!/guide/proxies\">Proxies</a> in their individual guides.</p>\n\n<h2>Further Reading</h2>\n\n<p>Data is just part of the Sencha Touch 2 ecosystem. To understand more about the framework and how it works, we recommend the following:</p>\n\n<ul>\n<li><a href=\"#!/guide/components\">Components and Containers</a></li>\n<li><a href=\"#!/guide/class_system\">The Class System</a></li>\n<li><a href=\"#!/guide/layouts\">The Layout System</a></li>\n<li><a href=\"#!/guide/getting_started\">Getting Started</a></li>\n</ul>\n\n"});