Ext.data.JsonP.getting_started({"title":"Getting Started with Touch 2","guide":"<h1>Getting Started with Sencha Touch 2</h1>\n<div class='toc'>\n<p><strong>Contents</strong></p>\n<ol>\n<li><a href='#!/guide/getting_started-section-1'>What is Sencha Touch?</a></li>\n<li><a href='#!/guide/getting_started-section-2'>Things you'll need</a></li>\n<li><a href='#!/guide/getting_started-section-3'>Installation</a></li>\n<li><a href='#!/guide/getting_started-section-4'>Generating your first app</a></li>\n<li><a href='#!/guide/getting_started-section-5'>Explore the code</a></li>\n<li><a href='#!/guide/getting_started-section-6'>Next Steps</a></li>\n</ol>\n</div>\n\n<p><p><object width=\"640\" height=\"360\"><param name=\"allowfullscreen\" value=\"true\" /><param name=\"allowscriptaccess\" value=\"always\" /><param name=\"flashvars\" value=\"api=1\" /><param name=\"movie\" value=\"http://vimeo.com/moogaloop.swf?clip_id=37974749&amp;server=vimeo.com&amp;color=4CC208&amp;fullscreen=1\" /><embed src=\"http://vimeo.com/moogaloop.swf?clip_id=37974749&amp;server=vimeo.com&amp;color=4CC208&amp;fullscreen=1\" type=\"application/x-shockwave-flash\" allowfullscreen=\"true\" allowscriptaccess=\"always\" width=\"640\" height=\"360\"></embed></object></p></p>\n\n<h2 id='getting_started-section-1'>What is Sencha Touch?</h2>\n\n<p>Sencha Touch enables you to quickly and easily create HTML5 based mobile apps that work on Android, iOS and Blackberry devices and produce a native-app-like experience inside a browser.</p>\n\n<h2 id='getting_started-section-2'>Things you'll need</h2>\n\n<p>First, you'll need to download the free <a href=\"http://www.sencha.com/products/touch/download/\">Sencha Touch 2 SDK</a> and\n<a href=\"http://www.sencha.com/products/sdk-tools/download\">SDK Tools</a> from the Sencha website. You'll also need:</p>\n\n<ul>\n<li>A web server running locally on your computer</li>\n<li>A modern web browser; <a href=\"https://www.google.com/chrome\">Chrome</a> and <a href=\"http://www.apple.com/safari/download/\">Safari</a> are recommended</li>\n</ul>\n\n\n<h2 id='getting_started-section-3'>Installation</h2>\n\n<p>First, extract your SDK zip file to your projects directory. Ideally, this folder will be accessible by your HTTP server.\nFor example, you should be able to navigate to http://localhost/sencha-touch-2.0.0-gpl from your web browser and see the\nSencha Touch documentation.</p>\n\n<p>You'll also need to run the SDK Tools installer. The SDK Tools will add the <strong><code>sencha</code></strong> command line tool to your path\nso that you can generate a fresh application template among other things. To check you have installed the SDK tools,\nchange to your Sencha Touch directory and type the <code>sencha</code> command. For example:</p>\n\n<pre><code>$ cd ~/webroot/sencha-touch-2.0.0-gpl/\n$ sencha\nSencha Command v2.0.0 for Sencha Touch 2\nCopyright (c) 2012 Sencha Inc.\n...\n</code></pre>\n\n<p><strong>NOTE</strong>: You <strong>must</strong> be inside either the downloaded SDK directory or a generated Touch app when using the <strong><code>sencha</code></strong> command.</p>\n\n<h2 id='getting_started-section-4'>Generating your first app</h2>\n\n<p>Now you have Sencha Touch and the SDK Tools installed, lets generate an application. Make sure you're still in the\nSencha Touch SDK folder, and type the following:</p>\n\n<pre><code>$ sencha generate app GS ../GS\n[INFO] Created file /Users/nickpoulden/Projects/sencha/GS/.senchasdk\n[INFO] Created file /Users/nickpoulden/Projects/sencha/GS/index.html\n[INFO] Created file /Users/nickpoulden/Projects/sencha/GS/app.js\n...\n</code></pre>\n\n<p>This will generate a skeleton Sencha Touch application namespaced to the <code>GS</code> variable (short for Getting Started) and\nlocated in the directory <code>../GS</code> (one level up from the Sencha Touch SDK directory). The skeleton app contains all the\nfiles you need to create a Touch application, including the default index.html, a copy of the Touch SDK, CSS, images and\nconfiguration files for packaging your app for native.</p>\n\n<p>Lets check if your application has generated successfully by opening it in a web browser. Assuming you extracted the SDK\nto your webroot folder, you should be able to nativate to <code>http://localhost/GS</code> and see the default app:</p>\n\n<p><p class='screenshot'><img src='guides/getting_started/screen1.png' alt=''><span></span></p></p>\n\n<h2 id='getting_started-section-5'>Explore the code</h2>\n\n<p>Open up the GS directory in your favorite IDE or Text editor. The directory structure looks like this:</p>\n\n<p><p class='screenshot'><img src='guides/getting_started/files.png' alt=''><span></span></p></p>\n\n<p>Here's a description of each file and directory:</p>\n\n<ul>\n<li><strong><code>app</code></strong> - directory containing the Models, Views, Controllers and Stores for your app.</li>\n<li><strong><code>app.js</code></strong> - the main Javascript entry point for your app.</li>\n<li><strong><code>app.json</code></strong> - your app configuration file - used by the Builder to create a minified version of your app.</li>\n<li><strong><code>index.html</code></strong> - The HTML file for your app.</li>\n<li><strong><code>packager.json</code></strong> - The configuration file used by the Packager to create native versions of your app for iOS and Android app stores.</li>\n<li><strong><code>resources</code></strong> - directory containing the CSS and Images for your app</li>\n<li><strong><code>sdk</code></strong> - A copy of the Sencha Touch SDK. You shouldn't need to change the contents of this folder.</li>\n</ul>\n\n\n<p>Open <code>app.js</code>, the main entry point for your app, in your editor.</p>\n\n<p><p class='screenshot'><img src='guides/getting_started/appjs.png' alt=''><span></span></p></p>\n\n<p>The <code>launch</code> function is the entry point to your application. In the default application, we first hide the application\nloading indictor, then create an instance of our Main view and add it to the Viewport.</p>\n\n<p>The Viewport is a <a href=\"#!/api/Ext.layout.Card\" rel=\"Ext.layout.Card\" class=\"docClass\">Card layout</a> to which you can add components to your application. The default\napp adds the <code>Main</code> view to the viewport so it is visible on the screen. Lets look at the code inside the Main view.</p>\n\n<p>Open <code>app/view/Main.js</code> in your code editor and try editing line 10 to this:</p>\n\n<pre><code>title: 'Home Tab'\n</code></pre>\n\n<p>Now change line 19 to this:</p>\n\n<pre><code>title: 'Woohoo!'\n</code></pre>\n\n<p>Also, change lines 22-26 to this:</p>\n\n<pre><code>html: [\n    \"I changed the default &lt;b&gt;HTML Contents&lt;/b&gt; to something different!\"\n].join(\"\")\n</code></pre>\n\n<p>Now refresh the app in your browser to see your changes:</p>\n\n<p><p class='screenshot'><img src='guides/getting_started/changed.png' alt=''><span></span></p></p>\n\n<h2 id='getting_started-section-6'>Next Steps</h2>\n\n<p>The next step is to follow the <a href=\"#!/guide/first_app\">First Application guide</a>, which builds on what you've\njust done and guides your through creating a simple but powerful app in around 15 minutes. You can also follow along\nwith the video at the top of this guide.</p>\n\n<p>If you'd like to skip ahead or find out more detailed information about other aspects of the framework we recommend\nchecking out the following guides and resources:</p>\n\n<h3>Guides</h3>\n\n<ul>\n<li><a href=\"#!/guide/components\">Components and Containers</a></li>\n<li><a href=\"#!/guide/apps_intro\">Intro to Applications</a></li>\n<li><a href=\"#!/guide/layouts\">The Layout System</a></li>\n<li><a href=\"#!/guide/data\">The Data Package</a></li>\n<li><a href=\"#!/guide/whats_new\">What's New in Sencha Touch 2</a></li>\n</ul>\n\n\n<h3>Application Examples</h3>\n\n<ul>\n<li><a href=\"#!/example/kitchen-sink\">Kitchen Sink</a></li>\n<li><a href=\"#!/example/twitter\">Twitter</a></li>\n<li><a href=\"#!/example/kiva\">Kiva</a></li>\n</ul>\n\n\n<h3>Component Examples</h3>\n\n<ul>\n<li><a href=\"#!/example/carousel\">Carousel</a></li>\n<li><a href=\"#!/example/forms\">Forms</a></li>\n<li><a href=\"#!/example/pickers\">Date Picker</a></li>\n</ul>\n\n"});