Ext.data.JsonP.Ext_dataview_List({"meta":{"aside":[{"type":"guide","name":"list"},{"type":"video","name":"list"}]},"mixedInto":[],"aliases":{"widget":["list"]},"html":"<div><pre class=\"hierarchy\"><h4>Alternate names</h4><div class='alternate-class-name'>Ext.List</div><h4>Hierarchy</h4><div class='subclass first-child'><a href='#!/api/Ext.Base' rel='Ext.Base' class='docClass'>Ext.Base</a><div class='subclass '><a href='#!/api/Ext.Evented' rel='Ext.Evented' class='docClass'>Ext.Evented</a><div class='subclass '><a href='#!/api/Ext.AbstractComponent' rel='Ext.AbstractComponent' class='docClass'>Ext.AbstractComponent</a><div class='subclass '><a href='#!/api/Ext.Component' rel='Ext.Component' class='docClass'>Ext.Component</a><div class='subclass '><a href='#!/api/Ext.Container' rel='Ext.Container' class='docClass'>Ext.Container</a><div class='subclass '><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='docClass'>Ext.dataview.DataView</a><div class='subclass '><strong>Ext.dataview.List</strong></div></div></div></div></div></div></div><h4>Inherited mixins</h4><div class='dependency'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='docClass'>Ext.mixin.Observable</a></div><div class='dependency'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='docClass'>Ext.mixin.Selectable</a></div><div class='dependency'><a href='#!/api/Ext.mixin.Traversable' rel='Ext.mixin.Traversable' class='docClass'>Ext.mixin.Traversable</a></div><h4>Requires</h4><div class='dependency'><a href='#!/api/Ext.dataview.IndexBar' rel='Ext.dataview.IndexBar' class='docClass'>Ext.dataview.IndexBar</a></div><div class='dependency'><a href='#!/api/Ext.dataview.ListItemHeader' rel='Ext.dataview.ListItemHeader' class='docClass'>Ext.dataview.ListItemHeader</a></div><div class='dependency'><a href='#!/api/Ext.dataview.element.List' rel='Ext.dataview.element.List' class='docClass'>Ext.dataview.element.List</a></div><h4>Files</h4><div class='dependency'><a href='source/List2.html#Ext-dataview-List' target='_blank'>List.js</a></div><div class='dependency'><a href='source/_list.scss.html#Ext-dataview-List' target='_blank'>_list.scss</a></div></pre><div class='doc-contents'>            <div class='aside guide'>\n              <h4>Guide</h4>\n              <p><a href='#!/guide/list'><img src='guides/list/icon.png' alt=''> Using List</a></p>\n            </div>\n            <div class='aside video'>\n              <h4>Video</h4>\n              <p><a href='#!/video/list'><img src='http://b.vimeocdn.com/ts/255/531/255531831_200.jpg' alt=''> Intro to List Component</a></p>\n            </div>\n<p>List is a custom styled DataView which allows Grouping, Indexing, Icons, and a Disclosure. See the\n<a href=\"#!/guide/list\">Guide</a> and <a href=\"#!/video/list\">Video</a> for more.</p>\n\n<pre class='inline-example miniphone preview'><code><a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">Ext.List</a>', {\n    fullscreen: true,\n    itemTpl: '{title}',\n    data: [\n        { title: 'Item 1' },\n        { title: 'Item 2' },\n        { title: 'Item 3' },\n        { title: 'Item 4' }\n    ]\n});\n</code></pre>\n\n<p>A more advanced example showing a list of people groped by last name:</p>\n\n<pre class='inline-example miniphone preview'><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('Contact', {\n    extend: '<a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a>',\n    config: {\n        fields: ['firstName', 'lastName']\n    }\n});\n\nvar store = <a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.data.Store\" rel=\"Ext.data.Store\" class=\"docClass\">Ext.data.Store</a>', {\n   model: 'Contact',\n   sorters: 'lastName',\n\n   grouper: {\n       groupFn: function(record) {\n           return record.get('lastName')[0];\n       }\n   },\n\n   data: [\n       { firstName: 'Tommy',   lastName: 'Maintz'  },\n       { firstName: 'Rob',     lastName: 'Dougan'  },\n       { firstName: 'Ed',      lastName: 'Spencer' },\n       { firstName: 'Jamie',   lastName: 'Avins'   },\n       { firstName: 'Aaron',   lastName: 'Conran'  },\n       { firstName: 'Dave',    lastName: 'Kaneda'  },\n       { firstName: 'Jacky',   lastName: 'Nguyen'  },\n       { firstName: 'Abraham', lastName: 'Elias'   },\n       { firstName: 'Jay',     lastName: 'Robinson'},\n       { firstName: 'Nigel',   lastName: 'White'   },\n       { firstName: 'Don',     lastName: 'Griffin' },\n       { firstName: 'Nico',    lastName: 'Ferrero' },\n       { firstName: 'Jason',   lastName: 'Johnston'}\n   ]\n});\n\n<a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">Ext.List</a>', {\n   fullscreen: true,\n   itemTpl: '&lt;div class=\"contact\"&gt;{firstName} &lt;strong&gt;{lastName}&lt;/strong&gt;&lt;/div&gt;',\n   store: store,\n   grouped: true\n});\n</code></pre>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-cfg'>Config options</h3><div class='subsection'><div id='cfg-activeItem' class='member first-child inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-activeItem' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-cfg-activeItem' class='name expandable'>activeItem</a><span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></span></div><div class='description'><div class='short'>The item from the items collection that will be active first. ...</div><div class='long'><p>The item from the <a href=\"#!/api/Ext.Container-cfg-items\" rel=\"Ext.Container-cfg-items\" class=\"docClass\">items</a> collection that will be active first. This is\nusually only meaningful in a <a href=\"#!/api/Ext.layout.Card\" rel=\"Ext.layout.Card\" class=\"docClass\">card layout</a>, where only one item can be active at a\ntime</p>\n<p>Defaults to: <code>0</code></p></div></div></div><div id='cfg-allowDeselect' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-cfg-allowDeselect' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-cfg-allowDeselect' class='name expandable'>allowDeselect</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>Allow users to deselect a record in a DataView, List or Grid. ...</div><div class='long'><p>Allow users to deselect a record in a DataView, List or Grid. Only applicable when the Selectable's mode is\n'SINGLE'. Defaults to false.</p>\n<p>Defaults to: <code>false</code></p></div></div></div><div id='cfg-autoDestroy' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-autoDestroy' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-cfg-autoDestroy' class='name expandable'>autoDestroy</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>If true, child items will be destroyed as soon as they are removed\nfrom this container ...</div><div class='long'><p>If true, child items will be destroyed as soon as they are <a href=\"#!/api/Ext.Container-method-remove\" rel=\"Ext.Container-method-remove\" class=\"docClass\">removed</a>\nfrom this container</p>\n<p>Defaults to: <code>true</code></p></div></div></div><div id='cfg-baseCls' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-baseCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-cfg-baseCls' class='name expandable'>baseCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The base CSS class to apply to this components's element. ...</div><div class='long'><p>The base CSS class to apply to this components's element. This will also be prepended to\nother elements within this component. To add specific styling for sub-classes, use the <a href=\"#!/api/Ext.dataview.List-cfg-cls\" rel=\"Ext.dataview.List-cfg-cls\" class=\"docClass\">cls</a> config.</p>\n<p>Defaults to: <code>&quot;x-list&quot;</code></p><p>Overrides: <a href='#!/api/Ext.dataview.DataView-cfg-baseCls' rel='Ext.dataview.DataView-cfg-baseCls' class='docClass'>Ext.dataview.DataView.baseCls</a></p></div></div></div><div id='cfg-blockRefresh' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-blockRefresh' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-blockRefresh' class='name not-expandable'>blockRefresh</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'><p>Set this to true to ignore datachanged events on the bound store.</p>\n</div><div class='long'><p>Set this to true to ignore datachanged events on the bound store.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='cfg-border' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-border' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-border' class='name expandable'>border</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The border to use on this Component. ...</div><div class='long'><p>The border to use on this Component. Can be specified as a number (in which\ncase all edges get the same border width) or a CSS string like '5 10 10 10'</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-bottom' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-bottom' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-bottom' class='name expandable'>bottom</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The absolute bottom position of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The absolute bottom position of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.\nExplicitly setting this value will make this Component become 'floating', which means its layout will no\nlonger be affected by the Container that it resides in.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-bubbleEvents' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-cfg-bubbleEvents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-cfg-bubbleEvents' class='name expandable'>bubbleEvents</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]</span></div><div class='description'><div class='short'>The event name to bubble, or an Array of event names. ...</div><div class='long'><p>The event name to bubble, or an Array of event names.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-cardSwitchAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-cardSwitchAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-cfg-cardSwitchAnimation' class='name not-expandable'>cardSwitchAnimation</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'><p>Animation to be used during transitions of cards.</p>\n</div><div class='long'><p>Animation to be used during transitions of cards.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.layout.Card-cfg-animation\" rel=\"Ext.layout.Card-cfg-animation\" class=\"docClass\">Ext.layout.Card.animation</a> instead</p>\n\n        </div>\n</div></div></div><div id='cfg-centered' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-centered' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-centered' class='name expandable'>centered</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>Whether or not this Component is absolutely centered inside its Container ...</div><div class='long'><p>Whether or not this Component is absolutely centered inside its Container</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-clearSelectionOnDeactivate' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-clearSelectionOnDeactivate' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-cfg-clearSelectionOnDeactivate' class='name not-expandable'>clearSelectionOnDeactivate</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'><p>True to clear any selections on the list when the list is deactivated.</p>\n</div><div class='long'><p>True to clear any selections on the list when the list is deactivated.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='cfg-cls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-cls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-cls' class='name expandable'>cls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]</span></div><div class='description'><div class='short'>The CSS class to add to this component's element, in addition to the baseCls ...</div><div class='long'><p>The CSS class to add to this component's element, in addition to the <a href=\"#!/api/Ext.Component-cfg-baseCls\" rel=\"Ext.Component-cfg-baseCls\" class=\"docClass\">baseCls</a></p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-componentCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-componentCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-componentCls' class='name expandable'>componentCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>CSS class to add to this Component. ...</div><div class='long'><p>CSS class to add to this Component. Deprecated, please use <a href=\"#!/api/Ext.Component-cfg-cls\" rel=\"Ext.Component-cfg-cls\" class=\"docClass\">cls</a> instead</p>\n        <div class='signature-box deprecated'>\n        <p>This cfg has been <strong>deprecated</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='cfg-contentEl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-contentEl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-contentEl' class='name expandable'>contentEl</a><span> : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The configured element will automatically be\nadded as the content of this component. ...</div><div class='long'><p>The configured element will automatically be\nadded as the content of this component. When you pass a string, we expect it to be an element id.\nIf the content element is hidden, we will automatically show it.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-control' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-control' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-cfg-control' class='name expandable'>control</a><span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span></div><div class='description'><div class='short'>Enables you to easily control Components inside this Container by listening to their\nevents and taking some action. ...</div><div class='long'><p>Enables you to easily control Components inside this Container by listening to their\nevents and taking some action. For example, if we had a container with a nested Disable button, and we\nwanted to hide the Container when the Disable button is tapped, we could do this:</p>\n\n<pre><code><a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a>', {\n    control: {\n       'button[text=Disable]': {\n           tap: 'hideMe'\n       }\n    },\n\n    hideMe: function() {\n        this.hide()\n    }\n});\n</code></pre>\n\n<p>We used a <a href=\"#!/api/Ext.ComponentQuery\" rel=\"Ext.ComponentQuery\" class=\"docClass\">Ext.ComponentQuery</a> selector to listen to the <a href=\"#!/api/Ext.Button-event-tap\" rel=\"Ext.Button-event-tap\" class=\"docClass\">tap</a> event on any\n<a href=\"#!/api/Ext.Button\" rel=\"Ext.Button\" class=\"docClass\">button</a> anywhere inside the Container that has the <a href=\"#!/api/Ext.Button-cfg-text\" rel=\"Ext.Button-cfg-text\" class=\"docClass\">text</a> 'Disable'.\nWhenever a Component matching that selector fires the 'tap' event our hideMe function is called. hideMe is\ncalled with scope: this (e.g. 'this' is the Container instance).</p>\n<p>Defaults to: <code>{}</code></p></div></div></div><div id='cfg-data' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-data' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-data' class='name expandable'>data</a><span> : Mixed</span></div><div class='description'><div class='short'>The initial set of data to apply to the tpl to\nupdate the content area of the Component. ...</div><div class='long'><p>The initial set of data to apply to the <code><a href=\"#!/api/Ext.Component-cfg-tpl\" rel=\"Ext.Component-cfg-tpl\" class=\"docClass\">tpl</a></code> to\nupdate the content area of the Component.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-defaultType' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-defaultType' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-cfg-defaultType' class='name expandable'>defaultType</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'>The xtype used for the component based DataView. ...</div><div class='long'><p>The xtype used for the component based DataView. Defaults to dataitem.\nNote this is only used when useComponents is true.</p>\n<p>Overrides: <a href='#!/api/Ext.dataview.DataView-cfg-defaultType' rel='Ext.dataview.DataView-cfg-defaultType' class='docClass'>Ext.dataview.DataView.defaultType</a></p></div></div></div><div id='cfg-defaults' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-defaults' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-cfg-defaults' class='name expandable'>defaults</a><span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span></div><div class='description'><div class='short'>A set of default configurations to apply to all child Components in this Container. ...</div><div class='long'><p>A set of default configurations to apply to all child Components in this Container.\nIt's often useful to specify defaults when creating more than one items with similar configurations. For\nexample here we can specify that each child is a panel and avoid repeating the xtype declaration for each\none:</p>\n\n<p>   <a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a>', {</p>\n\n<pre><code>   defaults: {\n       xtype: 'panel'\n   },\n   items: [\n       {\n           html: 'Panel 1'\n       },\n       {\n           html: 'Panel 2'\n       }\n   ]\n</code></pre>\n\n<p>   });</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-deferEmptyText' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-deferEmptyText' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-deferEmptyText' class='name expandable'>deferEmptyText</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>True to defer emptyText being applied until the store's first load ...</div><div class='long'><p>True to defer emptyText being applied until the store's first load</p>\n<p>Defaults to: <code>true</code></p></div></div></div><div id='cfg-deselectOnContainerClick' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-deselectOnContainerClick' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-deselectOnContainerClick' class='name expandable'>deselectOnContainerClick</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>When set to true, tapping on the DataView's background (i.e. ...</div><div class='long'><p>When set to true, tapping on the DataView's background (i.e. not on\nan item in the DataView) will deselect any currently selected items.</p>\n<p>Defaults to: <code>true</code></p><p>Overrides: <a href='#!/api/Ext.mixin.Selectable-cfg-deselectOnContainerClick' rel='Ext.mixin.Selectable-cfg-deselectOnContainerClick' class='docClass'>Ext.mixin.Selectable.deselectOnContainerClick</a></p></div></div></div><div id='cfg-disableSelection' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-cfg-disableSelection' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-cfg-disableSelection' class='name expandable'>disableSelection</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>true to disable selection. ...</div><div class='long'><p><tt>true</tt> to disable selection.\nThis configuration will lock the selection model that the DataView uses.</p>\n\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-disabled' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-disabled' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-disabled' class='name expandable'>disabled</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>Whether or not this component is disabled ...</div><div class='long'><p>Whether or not this component is disabled</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-disabledCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-disabledCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-disabledCls' class='name not-expandable'>disabledCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'><p>The CSS class to add to the component when it is disabled</p>\n</div><div class='long'><p>The CSS class to add to the component when it is disabled</p>\n</div></div></div><div id='cfg-disclosureProperty' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-disclosureProperty' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-cfg-disclosureProperty' class='name expandable'>disclosureProperty</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>A property to check on each record to display the disclosure on a per record basis. ...</div><div class='long'><p>A property to check on each record to display the disclosure on a per record basis.  This\nproperty must be false to prevent the disclosure from being displayed on the item.</p>\n<p>Defaults to: <code>&quot;disclosure&quot;</code></p></div></div></div><div id='cfg-dock' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-dock' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-dock' class='name expandable'>dock</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>The dock position of this component in its container. ...</div><div class='long'><p>The dock position of this component in its container. Can be 'left', 'top', 'right' or 'bottom'.</p>\n\n<p><b>Notes</b></p>\n\n<p>You must use a HTML5 doctype for <a href=\"#!/api/Ext.Component-cfg-docked\" rel=\"Ext.Component-cfg-docked\" class=\"docClass\">docked</a> <code>bottom</code> to work. To do this, simply add the following code to the HTML file:</p>\n\n<pre><code>&lt;!doctype html&gt;\n</code></pre>\n\n<p>So your index.html file should look a little like this:</p>\n\n<pre><code>&lt;!doctype html&gt;\n&lt;html&gt;\n    &lt;head&gt;\n        &lt;title&gt;MY application title&lt;/title&gt;\n        ...\n</code></pre>\n        <div class='signature-box deprecated'>\n        <p>This cfg has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>This has been deprecated. Please use <a href=\"#!/api/Ext.Component-cfg-docked\" rel=\"Ext.Component-cfg-docked\" class=\"docClass\">docked</a> instead.</p>\n\n        </div>\n</div></div></div><div id='cfg-docked' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-docked' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-docked' class='name expandable'>docked</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The dock position of this component in its container. ...</div><div class='long'><p>The dock position of this component in its container. Can be 'left', 'top', 'right' or 'bottom'.</p>\n\n<p><b>Notes</b></p>\n\n<p>You must use a HTML5 doctype for <a href=\"#!/api/Ext.Component-cfg-docked\" rel=\"Ext.Component-cfg-docked\" class=\"docClass\">docked</a> <code>bottom</code> to work. To do this, simply add the following code to the HTML file:</p>\n\n<pre><code>&lt;!doctype html&gt;\n</code></pre>\n\n<p>So your index.html file should look a little like this:</p>\n\n<pre><code>&lt;!doctype html&gt;\n&lt;html&gt;\n    &lt;head&gt;\n        &lt;title&gt;MY application title&lt;/title&gt;\n        ...\n</code></pre>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-draggable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-draggable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-draggable' class='name expandable'>draggable</a><span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span></div><div class='description'><div class='short'>Configuration options to make this Component draggable ...</div><div class='long'><p>Configuration options to make this Component draggable</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-emptyText' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-emptyText' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-emptyText' class='name expandable'>emptyText</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The text to display in the view when there is no data to display ...</div><div class='long'><p>The text to display in the view when there is no data to display</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-enterAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-enterAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-enterAnimation' class='name expandable'>enterAnimation</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</span><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Animation effect to apply when the Component is being shown. ...</div><div class='long'><p>Animation effect to apply when the Component is being shown.  Typically you want to use an\ninbound animation type such as 'fadeIn' or 'slideIn'.</p>\n<p>Defaults to: <code>null</code></p>        <div class='signature-box deprecated'>\n        <p>This cfg has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.Component-cfg-showAnimation\" rel=\"Ext.Component-cfg-showAnimation\" class=\"docClass\">showAnimation</a> instead.</p>\n\n        </div>\n</div></div></div><div id='cfg-exitAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-exitAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-exitAnimation' class='name expandable'>exitAnimation</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</span><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Animation effect to apply when the Component is being hidden. ...</div><div class='long'><p>Animation effect to apply when the Component is being hidden.</p>\n<p>Defaults to: <code>null</code></p>        <div class='signature-box deprecated'>\n        <p>This cfg has been <strong>deprecated</strong> </p>\n        <p>2.0.0 Please use <a href=\"#!/api/Ext.Component-cfg-hideAnimation\" rel=\"Ext.Component-cfg-hideAnimation\" class=\"docClass\">hideAnimation</a> instead.  Typically you want to use an\noutbound animation type such as 'fadeOut' or 'slideOut'.</p>\n\n        </div>\n</div></div></div><div id='cfg-flex' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-flex' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-flex' class='name expandable'>flex</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></span></div><div class='description'><div class='short'>The flex of this item if this item item is inside a Ext.layout.HBox or Ext.layout.VBox\nlayout. ...</div><div class='long'><p>The flex of this item <em>if</em> this item item is inside a <a href=\"#!/api/Ext.layout.HBox\" rel=\"Ext.layout.HBox\" class=\"docClass\">Ext.layout.HBox</a> or <a href=\"#!/api/Ext.layout.VBox\" rel=\"Ext.layout.VBox\" class=\"docClass\">Ext.layout.VBox</a>\nlayout.</p>\n\n<p>You can also update the flex of a component dynamically using the <a href=\"#!/api/Ext.layout.AbstractBox-method-setItemFlex\" rel=\"Ext.layout.AbstractBox-method-setItemFlex\" class=\"docClass\">Ext.layout.AbstractBox.setItemFlex</a>\nmethod.</p>\n</div></div></div><div id='cfg-floating' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-floating' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-floating' class='name expandable'>floating</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Deprecated, please use left, top, right or\nbottom instead. ...</div><div class='long'><p>Deprecated, please use <a href=\"#!/api/Ext.Component-cfg-left\" rel=\"Ext.Component-cfg-left\" class=\"docClass\">left</a>, <a href=\"#!/api/Ext.Component-cfg-top\" rel=\"Ext.Component-cfg-top\" class=\"docClass\">top</a>, <a href=\"#!/api/Ext.Component-cfg-right\" rel=\"Ext.Component-cfg-right\" class=\"docClass\">right</a> or\n<a href=\"#!/api/Ext.Component-cfg-bottom\" rel=\"Ext.Component-cfg-bottom\" class=\"docClass\">bottom</a> instead.</p>\n\n<pre><code><a href=\"#!/api/Ext.Viewport-event-add\" rel=\"Ext.Viewport-event-add\" class=\"docClass\">Ext.Viewport.add</a>({\n    top: 100,\n    left: 100,\n    width: 500,\n    height: 200,\n    html: 'Floating component!'\n});\n</code></pre>\n        <div class='signature-box deprecated'>\n        <p>This cfg has been <strong>deprecated</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='cfg-floatingCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-floatingCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-floatingCls' class='name expandable'>floatingCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The CSS class to add to this component when it is floatable. ...</div><div class='long'><p>The CSS class to add to this component when it is floatable.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-fullscreen' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-fullscreen' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-fullscreen' class='name not-expandable'>fullscreen</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'><p>Force the component to take up 100% width and height available, by adding it to <a href=\"#!/api/Ext.Viewport\" rel=\"Ext.Viewport\" class=\"docClass\">Ext.Viewport</a>.</p>\n</div><div class='long'><p>Force the component to take up 100% width and height available, by adding it to <a href=\"#!/api/Ext.Viewport\" rel=\"Ext.Viewport\" class=\"docClass\">Ext.Viewport</a>.</p>\n</div></div></div><div id='cfg-grouped' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-grouped' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-cfg-grouped' class='name expandable'>grouped</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>Whether or not to group items in the provided Store with a header for each item. ...</div><div class='long'><p>Whether or not to group items in the provided Store with a header for each item.</p>\n<p>Defaults to: <code>false</code></p></div></div></div><div id='cfg-height' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-height' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-height' class='name expandable'>height</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The height of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The height of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.\nBy default, if this is not explicitly set, this Component's element will simply have its own natual size.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-hidden' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hidden' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-hidden' class='name expandable'>hidden</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>Whether or not this Component is hidden (its CSS display property is set to none) ...</div><div class='long'><p>Whether or not this Component is hidden (its CSS <code>display</code> property is set to <code>none</code>)</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-hiddenCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hiddenCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-hiddenCls' class='name not-expandable'>hiddenCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'><p>The CSS class to add to the component when it is hidden</p>\n</div><div class='long'><p>The CSS class to add to the component when it is hidden</p>\n</div></div></div><div id='cfg-hideAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hideAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-hideAnimation' class='name expandable'>hideAnimation</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</span></div><div class='description'><div class='short'>Animation effect to apply when the Component is being hidden. ...</div><div class='long'><p>Animation effect to apply when the Component is being hidden.  Typically you want to use an\noutbound animation type such as 'fadeOut' or 'slideOut'.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-hideOnMaskTap' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-hideOnMaskTap' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-cfg-hideOnMaskTap' class='name expandable'>hideOnMaskTap</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>When using a modal Component, setting this to true will hide the modal\nmask and the Container when the mask is tapped on ...</div><div class='long'><p>When using a <a href=\"#!/api/Ext.Container-cfg-modal\" rel=\"Ext.Container-cfg-modal\" class=\"docClass\">modal</a> Component, setting this to true will hide the modal\nmask and the Container when the mask is tapped on</p>\n<p>Defaults to: <code>null</code></p><p>Overrides: <a href='#!/api/Ext.Component-cfg-hideOnMaskTap' rel='Ext.Component-cfg-hideOnMaskTap' class='docClass'>Ext.Component.hideOnMaskTap</a></p></div></div></div><div id='cfg-html' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-html' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-html' class='name expandable'>html</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement</span></div><div class='description'><div class='short'>Optional HTML content to render inside this Component, or a reference\nto an existing element on the page. ...</div><div class='long'><p>Optional HTML content to render inside this Component, or a reference\nto an existing element on the page.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-id' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-id' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-id' class='name expandable'>id</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The unique id of this component instance. ...</div><div class='long'><p>The <strong>unique id of this component instance.</strong></p>\n\n<p>It should not be necessary to use this configuration except for singleton objects in your application. Components\ncreated with an id may be accessed globally using <a href=\"#!/api/Ext-method-getCmp\" rel=\"Ext-method-getCmp\" class=\"docClass\">Ext.getCmp</a>.</p>\n\n<p>Instead of using assigned ids, use the <a href=\"#!/api/Ext.Component-cfg-itemId\" rel=\"Ext.Component-cfg-itemId\" class=\"docClass\">itemId</a> config, and <a href=\"#!/api/Ext.ComponentQuery\" rel=\"Ext.ComponentQuery\" class=\"docClass\">ComponentQuery</a>\nwhich provides selector-based searching for Sencha Components analogous to DOM querying. The\n<a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a> class contains <a href=\"#!/api/Ext.Container-method-down\" rel=\"Ext.Container-method-down\" class=\"docClass\">shortcut methods</a> to query\nits descendant Components by selector.</p>\n\n<p>Note that this id will also be used as the element id for the containing HTML element that is rendered to the\npage for this component. This allows you to write id-based CSS rules to style the specific instance of this\ncomponent uniquely, and also to select sub-elements using this component's id as the parent.</p>\n\n<p><strong>Note</strong>: to avoid complications imposed by a unique id also see <code><a href=\"#!/api/Ext.Component-cfg-itemId\" rel=\"Ext.Component-cfg-itemId\" class=\"docClass\">itemId</a></code>.</p>\n\n<p>Defaults to an auto-assigned id.</p>\n</div></div></div><div id='cfg-indexBar' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-indexBar' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-cfg-indexBar' class='name expandable'>indexBar</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span></div><div class='description'><div class='short'>True to render an alphabet IndexBar docked on the right. ...</div><div class='long'><p>True to render an alphabet IndexBar docked on the right.\nThis can also be a config object that will be passed to <a href=\"#!/api/Ext.dataview.IndexBar\" rel=\"Ext.dataview.IndexBar\" class=\"docClass\">Ext.IndexBar</a>\n(defaults to false)</p>\n<p>Defaults to: <code>false</code></p></div></div></div><div id='cfg-inline' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-inline' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-inline' class='name expandable'>inline</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span></div><div class='description'><div class='short'>When set to true the items within the DataView will have their display set to inline-block\nand be arranged horizontally. ...</div><div class='long'><p>When set to true the items within the DataView will have their display set to inline-block\nand be arranged horizontally. By default the items will wrap to the width of the DataView.\nPassing an object with { wrap: false } will turn off this wrapping behavior and overflowed\nitems will need to be scrolled to horizontally.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-itemCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-itemCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-itemCls' class='name expandable'>itemCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>An additional CSS class to apply to items within the DataView. ...</div><div class='long'><p>An additional CSS class to apply to items within the DataView.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-itemConfig' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-itemConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-cfg-itemConfig' class='name expandable'>itemConfig</a><span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'>A configuration object that is passed to every item created by a component based DataView. ...</div><div class='long'><p>A configuration object that is passed to every item created by a component based DataView. Because each\nitem that a DataView renders is a Component, we can pass configuration options to each component to\neasily customize how each child component behaves.\nNote this is only used when useComponents is true.</p>\n<p>Overrides: <a href='#!/api/Ext.dataview.DataView-cfg-itemConfig' rel='Ext.dataview.DataView-cfg-itemConfig' class='docClass'>Ext.dataview.DataView.itemConfig</a></p></div></div></div><div id='cfg-itemId' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-itemId' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-itemId' class='name expandable'>itemId</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>An itemId can be used as an alternative way to get a reference to a component when no object reference is\navailable. ...</div><div class='long'><p>An itemId can be used as an alternative way to get a reference to a component when no object reference is\navailable. Instead of using an <code><a href=\"#!/api/Ext.Component-cfg-id\" rel=\"Ext.Component-cfg-id\" class=\"docClass\">id</a></code> with <a href=\"#!/api/Ext-method-getCmp\" rel=\"Ext-method-getCmp\" class=\"docClass\">Ext.getCmp</a>, use <code>itemId</code> with\n<a href=\"#!/api/Ext.Container-method-getComponent\" rel=\"Ext.Container-method-getComponent\" class=\"docClass\">Ext.Container.getComponent</a> which will retrieve <code>itemId</code>'s or <a href=\"#!/api/Ext.Component-cfg-id\" rel=\"Ext.Component-cfg-id\" class=\"docClass\">id</a>'s. Since <code>itemId</code>'s are an\nindex to the container's internal MixedCollection, the <code>itemId</code> is scoped locally to the container - avoiding\npotential conflicts with <a href=\"#!/api/Ext.ComponentManager\" rel=\"Ext.ComponentManager\" class=\"docClass\">Ext.ComponentManager</a> which requires a <strong>unique</strong> <code><a href=\"#!/api/Ext.Component-cfg-id\" rel=\"Ext.Component-cfg-id\" class=\"docClass\">id</a></code>.</p>\n\n<p>Also see <a href=\"#!/api/Ext.Component-cfg-id\" rel=\"Ext.Component-cfg-id\" class=\"docClass\">id</a>, <a href=\"#!/api/Ext.Container-method-query\" rel=\"Ext.Container-method-query\" class=\"docClass\">Ext.Container.query</a>, <a href=\"#!/api/Ext.Container-method-down\" rel=\"Ext.Container-method-down\" class=\"docClass\">Ext.Container.down</a> and <a href=\"#!/api/Ext.Container-method-child\" rel=\"Ext.Container-method-child\" class=\"docClass\">Ext.Container.child</a>.</p>\n</div></div></div><div id='cfg-itemSelector' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-itemSelector' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-itemSelector' class='name not-expandable'>itemSelector</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'><p>A simple CSS selector that will be used to determine what nodes this DataView will be working with.</p>\n</div><div class='long'><p>A simple CSS selector that will be used to determine what nodes this DataView will be working with.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='cfg-itemTpl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-itemTpl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-itemTpl' class='name expandable'>itemTpl</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]/<a href=\"#!/api/Ext.XTemplate\" rel=\"Ext.XTemplate\" class=\"docClass\">Ext.XTemplate</a></span></div><div class='description'><div class='short'>The tpl to use for each of the items displayed in this DataView. ...</div><div class='long'><p>The tpl to use for each of the items displayed in this DataView.</p>\n<p>Defaults to: <code>&quot;&lt;div&gt;{text}&lt;/div&gt;&quot;</code></p></div></div></div><div id='cfg-items' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-items' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-cfg-items' class='name expandable'>items</a><span> : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span></div><div class='description'><div class='short'>The child items to add to this Container. ...</div><div class='long'><p>The child items to add to this Container. This is usually an array of Component\nconfigurations or instances, for example:</p>\n\n<p>   <a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a>', {</p>\n\n<pre><code>   items: [\n       {\n           xtype: 'panel',\n           html: 'This is an item'\n       }\n   ]\n</code></pre>\n\n<p>   });</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-lastFocused' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-cfg-lastFocused' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-cfg-lastFocused' class='name expandable'>lastFocused</a><span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-lastSelected' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-cfg-lastSelected' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-cfg-lastSelected' class='name expandable'>lastSelected</a><span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-layout' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-layout' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-layout' class='name expandable'>layout</a><span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'>Hide layout config in DataView. ...</div><div class='long'><p>Hide layout config in DataView. It only causes confusion.</p>\n<p>Overrides: <a href='#!/api/Ext.Container-cfg-layout' rel='Ext.Container-cfg-layout' class='docClass'>Ext.Container.layout</a></p></div></div></div><div id='cfg-layoutOnOrientationChange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-layoutOnOrientationChange' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-layoutOnOrientationChange' class='name not-expandable'>layoutOnOrientationChange</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'><p>True to automatically relayout this component on orientation change.</p>\n</div><div class='long'><p>True to automatically relayout this component on orientation change.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='cfg-left' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-left' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-left' class='name expandable'>left</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The absolute left position of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The absolute left position of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.\nExplicitly setting this value will make this Component become 'floating', which means its layout will no\nlonger be affected by the Container that it resides in.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-listeners' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-cfg-listeners' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-cfg-listeners' class='name expandable'>listeners</a><span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span></div><div class='description'><div class='short'>A config object containing one or more event handlers to be added to this object during initialization. ...</div><div class='long'><p>A config object containing one or more event handlers to be added to this object during initialization. This\nshould be a valid listeners config object as specified in the <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> example for attaching\nmultiple handlers at once.</p>\n\n<p>See the <a href=\"#!/guide/events\">Event guide</a> for more</p>\n\n<p><strong>Note</strong> it is bad practice to specify a listeners config when you are defining a class using <a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>.\nInstead, only specify listeners when you are instantiating your class with <a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-loadingText' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-loadingText' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-loadingText' class='name expandable'>loadingText</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>A string to display during data load operations (defaults to 'Loading...'). ...</div><div class='long'><p>A string to display during data load operations (defaults to 'Loading...').  If specified, this text will be\ndisplayed in a loading div and the view's contents will be cleared while loading, otherwise the view's\ncontents will continue to display normally until the new data is loaded and the contents are replaced.</p>\n<p>Defaults to: <code>&quot;Loading...&quot;</code></p></div></div></div><div id='cfg-locked' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-cfg-locked' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-cfg-locked' class='name expandable'>locked</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>true to disable selection. ...</div><div class='long'><p><tt>true</tt> to disable selection.\nThis configuration will lock the selection model that the DataView uses.</p>\n\n        <div class='signature-box deprecated'>\n        <p>This cfg has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.mixin.Selectable-cfg-disableSelection\" rel=\"Ext.mixin.Selectable-cfg-disableSelection\" class=\"docClass\">disableSelection</a> instead.</p>\n\n        </div>\n</div></div></div><div id='cfg-margin' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-margin' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-margin' class='name expandable'>margin</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The margin to use on this Component. ...</div><div class='long'><p>The margin to use on this Component. Can be specified as a number (in which case\nall edges get the same margin) or a CSS string like '5 10 10 10'</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-masked' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-masked' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-cfg-masked' class='name expandable'>masked</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Ext.Mask\" rel=\"Ext.Mask\" class=\"docClass\">Ext.Mask</a>/<a href=\"#!/api/Ext.LoadMask\" rel=\"Ext.LoadMask\" class=\"docClass\">Ext.LoadMask</a></span></div><div class='description'><div class='short'>A configuration to allow you to mask this container. ...</div><div class='long'><p>A configuration to allow you to mask this container.\nYou can optionally pass an object block with and xtype of <code>loadmask</code>, and an optional <code>message</code> value to\ndisplay a loading mask. Please refer to the <a href=\"#!/api/Ext.LoadMask\" rel=\"Ext.LoadMask\" class=\"docClass\">Ext.LoadMask</a> component to see other configurations.</p>\n\n<pre><code>masked: {\n    xtype: 'loadmask',\n    message: 'My message'\n}\n</code></pre>\n\n<p>Alternatively, you can just call the setter at any time with true/false to show/hide the mask\"</p>\n\n<pre><code>setMasked(true); //show the mask\nsetMasked(false); //hides the mask\n</code></pre>\n\n<p>There are also two convience methods, <a href=\"#!/api/Ext.Container-method-mask\" rel=\"Ext.Container-method-mask\" class=\"docClass\">mask</a> and <a href=\"#!/api/Ext.Container-method-unmask\" rel=\"Ext.Container-method-unmask\" class=\"docClass\">unmask</a>, to allow you to mask and unmask\nthis container at any time.</p>\n\n<p>Remember, the <a href=\"#!/api/Ext.Viewport\" rel=\"Ext.Viewport\" class=\"docClass\">Ext.Viewport</a> is always a container, so if you want to mask your whole application at anytime,\ncan call:</p>\n\n<pre><code><a href=\"#!/api/Ext.Viewport-method-setMasked\" rel=\"Ext.Viewport-method-setMasked\" class=\"docClass\">Ext.Viewport.setMasked</a>({\n    xtype: 'loadmask',\n    message: 'Hello'\n});\n</code></pre>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-maxHeight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-maxHeight' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-maxHeight' class='name expandable'>maxHeight</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The maximum height of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The maximum height of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.\nNote that this config will not apply if the Component is 'floating' (absolutely positioned or centered)</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-maxItemCache' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-maxItemCache' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-cfg-maxItemCache' class='name expandable'>maxItemCache</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'>Maintains a cache of reusable components when using a component based DataView. ...</div><div class='long'><p>Maintains a cache of reusable components when using a component based DataView.  Improveing performance at\nthe cost of memory.\nNote this is currently only used when useComponents is true.</p>\n<p>Overrides: <a href='#!/api/Ext.dataview.DataView-cfg-maxItemCache' rel='Ext.dataview.DataView-cfg-maxItemCache' class='docClass'>Ext.dataview.DataView.maxItemCache</a></p></div></div></div><div id='cfg-maxWidth' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-maxWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-maxWidth' class='name expandable'>maxWidth</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The maximum width of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The maximum width of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.\nNote that this config will not apply if the Component is 'floating' (absolutely positioned or centered)</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-minHeight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-minHeight' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-minHeight' class='name expandable'>minHeight</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The minimum height of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The minimum height of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-minWidth' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-minWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-minWidth' class='name expandable'>minWidth</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The minimum width of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The minimum width of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-modal' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-modal' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-cfg-modal' class='name expandable'>modal</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>True to make this Container modal. ...</div><div class='long'><p>True to make this Container modal. This will create a mask underneath the Container\nthat covers its parent and does not allow the user to interact with any other Components until this\nContainer is dismissed</p>\n<p>Defaults to: <code>null</code></p><p>Overrides: <a href='#!/api/Ext.Component-cfg-modal' rel='Ext.Component-cfg-modal' class='docClass'>Ext.Component.modal</a></p></div></div></div><div id='cfg-mode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-cfg-mode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-cfg-mode' class='name expandable'>mode</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>Modes of selection. ...</div><div class='long'><p>Modes of selection.\nValid values are SINGLE, SIMPLE, and MULTI. Defaults to 'SINGLE'</p>\n<p>Defaults to: <code>&quot;SINGLE&quot;</code></p></div></div></div><div id='cfg-monitorOrientation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-monitorOrientation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-monitorOrientation' class='name not-expandable'>monitorOrientation</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'><p>True to monitor Orientation change.</p>\n</div><div class='long'><p>True to monitor Orientation change.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='cfg-multiSelect' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-multiSelect' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-multiSelect' class='name not-expandable'>multiSelect</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'><p>True to allow selection of more than one item at a time.</p>\n</div><div class='long'><p>True to allow selection of more than one item at a time.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        <p>multiSelect is deprecated. Please use <a href=\"#!/api/Ext.mixin.Selectable-cfg-mode\" rel=\"Ext.mixin.Selectable-cfg-mode\" class=\"docClass\">mode</a> instead</p>\n\n        </div>\n</div></div></div><div id='cfg-onItemDisclosure' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-onItemDisclosure' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-cfg-onItemDisclosure' class='name expandable'>onItemDisclosure</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span></div><div class='description'><div class='short'>True to display a disclosure icon on each list item. ...</div><div class='long'><p>True to display a disclosure icon on each list item.\nThe list will still fire the disclose event, and the event can be stopped before itemtap.\nBy setting this config to a function, the function passed will be called when the disclosure\nis tapped.\nFinally you can specify an object with a 'scope' and 'handler'\nproperty defined. This will also be bound to the tap event listener\nand is useful when you want to change the scope of the handler.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-overItemCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-overItemCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-overItemCls' class='name not-expandable'>overItemCls</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'><p>A CSS class to apply to each item in the view on mouseover.</p>\n</div><div class='long'><p>A CSS class to apply to each item in the view on mouseover.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='cfg-padding' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-padding' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-padding' class='name expandable'>padding</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The padding to use on this Component. ...</div><div class='long'><p>The padding to use on this Component. Can be specified as a number (in which\ncase all edges get the same padding) or a CSS string like '5 10 10 10'</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-pinHeaders' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-pinHeaders' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-cfg-pinHeaders' class='name expandable'>pinHeaders</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>Whether or not to pin headers on top of item groups while scrolling for an iPhone native list experience. ...</div><div class='long'><p>Whether or not to pin headers on top of item groups while scrolling for an iPhone native list experience.</p>\n<p>Defaults to: <code>true</code></p></div></div></div><div id='cfg-plugins' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-plugins' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-plugins' class='name expandable'>plugins</a><span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a></span></div><div class='description'><div class='short'>An object or array of objects that will provide custom functionality for this component. ...</div><div class='long'><p>An object or array of objects that will provide custom functionality for this component.  The only\nrequirement for a valid plugin is that it contain an init method that accepts a reference of type <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a>.</p>\n\n<p>When a component is created, if any plugins are available, the component will call the init method on each\nplugin, passing a reference to itself.  Each plugin can then call methods or respond to events on the\ncomponent as needed to provide its functionality.</p>\n\n<p>For examples of plugins, see <a href=\"#!/api/Ext.plugin.PullRefresh\" rel=\"Ext.plugin.PullRefresh\" class=\"docClass\">Ext.plugin.PullRefresh</a> and <a href=\"#!/api/Ext.plugin.ListPaging\" rel=\"Ext.plugin.ListPaging\" class=\"docClass\">Ext.plugin.ListPaging</a></p>\n\n<h2>Example code</h2>\n\n<p>A plugin by alias:</p>\n\n<pre><code><a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">Ext.dataview.List</a>', {\n    config: {\n        plugins: 'listpaging',\n        itemTpl: '&lt;div class=\"item\"&gt;{title}&lt;/div&gt;',\n        store: 'Items'\n    }\n});\n</code></pre>\n\n<p>Multiple plugins by alias:</p>\n\n<pre><code><a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">Ext.dataview.List</a>', {\n    config: {\n        plugins: ['listpaging', 'pullrefresh'],\n        itemTpl: '&lt;div class=\"item\"&gt;{title}&lt;/div&gt;',\n        store: 'Items'\n    }\n});\n</code></pre>\n\n<p>Single plugin by class name with config options:</p>\n\n<pre><code><a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">Ext.dataview.List</a>', {\n    config: {\n        plugins: {\n            xclass: '<a href=\"#!/api/Ext.plugin.ListPaging\" rel=\"Ext.plugin.ListPaging\" class=\"docClass\">Ext.plugin.ListPaging</a>', // Reference plugin by class\n            autoPaging: true\n        },\n\n        itemTpl: '&lt;div class=\"item\"&gt;{title}&lt;/div&gt;',\n        store: 'Items'\n    }\n});\n</code></pre>\n\n<p>Multiple plugins by class name with config options:</p>\n\n<pre><code><a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">Ext.dataview.List</a>', {\n    config: {\n        plugins: [\n            {\n                xclass: '<a href=\"#!/api/Ext.plugin.PullRefresh\" rel=\"Ext.plugin.PullRefresh\" class=\"docClass\">Ext.plugin.PullRefresh</a>',\n                pullRefreshText: 'Pull to refresh...'\n            },\n            {\n                xclass: '<a href=\"#!/api/Ext.plugin.ListPaging\" rel=\"Ext.plugin.ListPaging\" class=\"docClass\">Ext.plugin.ListPaging</a>',\n                autoPaging: true\n            }\n        ],\n\n        itemTpl: '&lt;div class=\"item\"&gt;{title}&lt;/div&gt;',\n        store: 'Items'\n    }\n});\n</code></pre>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-pressedCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-pressedCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-pressedCls' class='name expandable'>pressedCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The CSS class to apply to an item on the view while it is being pressed. ...</div><div class='long'><p>The CSS class to apply to an item on the view while it is being pressed.</p>\n<p>Defaults to: <code>&quot;x-item-pressed&quot;</code></p></div></div></div><div id='cfg-pressedDelay' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-pressedDelay' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-pressedDelay' class='name expandable'>pressedDelay</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></span></div><div class='description'><div class='short'>The amount of delay between the tapstart and the moment we add the pressedCls. ...</div><div class='long'><p>The amount of delay between the tapstart and the moment we add the pressedCls.\nSettings this to true defaults to 100ms.</p>\n<p>Defaults to: <code>100</code></p></div></div></div><div id='cfg-preventSelectionOnDisclose' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-preventSelectionOnDisclose' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-cfg-preventSelectionOnDisclose' class='name expandable'>preventSelectionOnDisclose</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>True to prevent the item selection when the user\ntaps a disclose icon. ...</div><div class='long'><p>True to prevent the item selection when the user\ntaps a disclose icon. Defaults to <tt>true</tt></p>\n<p>Defaults to: <code>true</code></p></div></div></div><div id='cfg-record' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-record' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-record' class='name expandable'>record</a><span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a></span></div><div class='description'><div class='short'>A model instance which updates the Component's html based on it's tpl. ...</div><div class='long'><p>A model instance which updates the Component's html based on it's tpl. Similar to the data\nconfiguration, but tied to to a record to make allow dynamic updates.  This must be a model\ninstance and not a configuration of one.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-renderTo' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-renderTo' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-renderTo' class='name expandable'>renderTo</a><span> : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a></span></div><div class='description'><div class='short'>Optional element to render this Component to. ...</div><div class='long'><p>Optional element to render this Component to. Usually this is not needed because\na Component is normally full screen or automatically rendered inside another <a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Container</a></p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-renderTpl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-renderTpl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-renderTpl' class='name expandable'>renderTpl</a><span> : Mixed</span></div><div class='description'><div class='short'>An XTemplate used to create the internal structure inside this Component's\nencapsulating Element. ...</div><div class='long'><p>An <a href=\"#!/api/Ext.XTemplate\" rel=\"Ext.XTemplate\" class=\"docClass\">XTemplate</a> used to create the internal structure inside this Component's\nencapsulating Element.</p>\n\n\n<p>You do not normally need to specify this. For the base classes <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a>\nand <a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a>, this defaults to <b><code>null</code></b> which means that they will be initially rendered\nwith no internal structure; they render their <a href=\"#!/api/Ext.Component-method-getEl\" rel=\"Ext.Component-method-getEl\" class=\"docClass\">Element</a> empty. The more specialized ExtJS and Touch classes\nwhich use a more complex DOM structure, provide their own template definitions.</p>\n\n\n<p>This is intended to allow the developer to create application-specific utility Components with customized\ninternal structure.</p>\n\n</div></div></div><div id='cfg-right' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-right' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-right' class='name expandable'>right</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The absolute right position of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The absolute right position of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.\nExplicitly setting this value will make this Component become 'floating', which means its layout will no\nlonger be affected by the Container that it resides in.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-scroll' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-scroll' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-cfg-scroll' class='name expandable'>scroll</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Configuration options to make this Container scrollable. ...</div><div class='long'><p>Configuration options to make this Container scrollable. Acceptable values are:</p>\n\n<ul>\n<li>'horizontal', 'vertical', 'both' to enabling scrolling for that direction.</li>\n<li>true/false to explicitly enable/disable scrolling.</li>\n</ul>\n\n\n<p>Alternatively, you can give it an object which is then passed to the scroller instance:</p>\n\n<pre><code>scrollable: {\n    direction: 'vertical',\n    directionLock: true\n}\n</code></pre>\n\n<p>Please look at the <a href=\"#!/api/Ext.scroll.Scroller\" rel=\"Ext.scroll.Scroller\" class=\"docClass\">Ext.scroll.Scroller</a> documentation for more example on how to use this.</p>\n        <div class='signature-box deprecated'>\n        <p>This cfg has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use the <a href=\"#!/api/Ext.Container-cfg-scrollable\" rel=\"Ext.Container-cfg-scrollable\" class=\"docClass\">scrollable</a> configuration.</p>\n\n        </div>\n<p>Overrides: <a href='#!/api/Ext.Component-cfg-scroll' rel='Ext.Component-cfg-scroll' class='docClass'>Ext.Component.scroll</a></p></div></div></div><div id='cfg-scrollToTopOnRefresh' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-scrollToTopOnRefresh' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-scrollToTopOnRefresh' class='name expandable'>scrollToTopOnRefresh</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>Scroll the DataView to the top when the DataView is refreshed ...</div><div class='long'><p>Scroll the DataView to the top when the DataView is refreshed</p>\n<p>Defaults to: <code>true</code></p></div></div></div><div id='cfg-scrollable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-scrollable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-scrollable' class='name expandable'>scrollable</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>Configuration options to make this Container scrollable. ...</div><div class='long'><p>Configuration options to make this Container scrollable. Acceptable values are:</p>\n\n<ul>\n<li>'horizontal', 'vertical', 'both' to enabling scrolling for that direction.</li>\n<li>true/false to explicitly enable/disable scrolling.</li>\n</ul>\n\n\n<p>Alternatively, you can give it an object which is then passed to the scroller instance:</p>\n\n<pre><code>scrollable: {\n    direction: 'vertical',\n    directionLock: true\n}\n</code></pre>\n\n<p>Please look at the <a href=\"#!/api/Ext.scroll.Scroller\" rel=\"Ext.scroll.Scroller\" class=\"docClass\">Ext.scroll.Scroller</a> documentation for more example on how to use this.</p>\n<p>Defaults to: <code>true</code></p><p>Overrides: <a href='#!/api/Ext.Container-cfg-scrollable' rel='Ext.Container-cfg-scrollable' class='docClass'>Ext.Container.scrollable</a></p></div></div></div><div id='cfg-selectedCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-selectedCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-selectedCls' class='name expandable'>selectedCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The CSS class to apply to an item on the view while it is selected. ...</div><div class='long'><p>The CSS class to apply to an item on the view while it is selected.</p>\n<p>Defaults to: <code>&quot;x-item-selected&quot;</code></p></div></div></div><div id='cfg-selectedItemCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-selectedItemCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-selectedItemCls' class='name not-expandable'>selectedItemCls</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'><p>A CSS class to apply to each selected item in the view.</p>\n</div><div class='long'><p>A CSS class to apply to each selected item in the view.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.dataview.DataView-cfg-selectedCls\" rel=\"Ext.dataview.DataView-cfg-selectedCls\" class=\"docClass\">selectedCls</a> instead</p>\n\n        </div>\n</div></div></div><div id='cfg-showAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-showAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-showAnimation' class='name expandable'>showAnimation</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</span></div><div class='description'><div class='short'>Animation effect to apply when the Component is being shown. ...</div><div class='long'><p>Animation effect to apply when the Component is being shown.  Typically you want to use an\ninbound animation type such as 'fadeIn' or 'slideIn'.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-simpleSelect' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-simpleSelect' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-simpleSelect' class='name expandable'>simpleSelect</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>True to enable multiselection by clicking on multiple items without requiring\nthe user to hold Shift or Ctrl, false t...</div><div class='long'><p>True to enable multiselection by clicking on multiple items without requiring\nthe user to hold Shift or Ctrl, false to force the user to hold Ctrl or Shift\nto select more than on item.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.mixin.Selectable-cfg-mode\" rel=\"Ext.mixin.Selectable-cfg-mode\" class=\"docClass\">mode</a> instead</p>\n\n        </div>\n</div></div></div><div id='cfg-singleSelect' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-singleSelect' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-singleSelect' class='name not-expandable'>singleSelect</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'><p>True to allow selection of exactly one item at a time, false to allow no selection at all.</p>\n</div><div class='long'><p>True to allow selection of exactly one item at a time, false to allow no selection at all.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.mixin.Selectable-cfg-mode\" rel=\"Ext.mixin.Selectable-cfg-mode\" class=\"docClass\">mode</a> instead</p>\n\n        </div>\n</div></div></div><div id='cfg-stopMaskTapEvent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-stopMaskTapEvent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-stopMaskTapEvent' class='name not-expandable'>stopMaskTapEvent</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'><p>True to stop the event that fires when you click outside the floating component.</p>\n</div><div class='long'><p>True to stop the event that fires when you click outside the floating component.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='cfg-store' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-store' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-store' class='name expandable'>store</a><span> : <a href=\"#!/api/Ext.data.Store\" rel=\"Ext.data.Store\" class=\"docClass\">Ext.data.Store</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span></div><div class='description'><div class='short'>Can be either a Store instance or a configuration object that will be turned into a Store. ...</div><div class='long'><p>Can be either a Store instance or a configuration object that will be turned into a Store. The Store is used\nto populate the set of items that will be rendered in the DataView. See the DataView intro documentation for\nmore information about the relationship between Store and DataView.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-style' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-style' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-style' class='name expandable'>style</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span></div><div class='description'><div class='short'>Optional CSS styles that will be rendered into an inline style attribute when the\nComponent is rendered. ...</div><div class='long'><p>Optional CSS styles that will be rendered into an inline style attribute when the\nComponent is rendered.</p>\n\n<p>You can pass either a string syntax:</p>\n\n<pre><code>style: 'background:red'\n</code></pre>\n\n<p>Or by using an object:</p>\n\n<pre><code>style: {\n    background: 'red'\n}\n</code></pre>\n\n<p>When using the object syntax, you can define CSS Properties by using a string:</p>\n\n<pre><code>style: {\n    'border-left': '1px solid red'\n}\n</code></pre>\n\n<p>Although the object syntax is much easier to read, we suggest you to use the string syntax for better performance.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-styleHtmlCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-styleHtmlCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-styleHtmlCls' class='name not-expandable'>styleHtmlCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'><p>The class that is added to the content target when you set styleHtmlContent to true.</p>\n</div><div class='long'><p>The class that is added to the content target when you set styleHtmlContent to true.</p>\n</div></div></div><div id='cfg-styleHtmlContent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-styleHtmlContent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-styleHtmlContent' class='name expandable'>styleHtmlContent</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>True to automatically style the html inside the content target of this component (body for panels). ...</div><div class='long'><p>True to automatically style the html inside the content target of this component (body for panels).</p>\n<p>Defaults to: <code>false</code></p></div></div></div><div id='cfg-top' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-top' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-top' class='name expandable'>top</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The absolute top position of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The absolute top position of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.\nExplicitly setting this value will make this Component become 'floating', which means its layout will no\nlonger be affected by the Container that it resides in.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-tpl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-tpl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-tpl' class='name expandable'>tpl</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]/<a href=\"#!/api/Ext.Template\" rel=\"Ext.Template\" class=\"docClass\">Ext.Template</a>[]/<a href=\"#!/api/Ext.XTemplate\" rel=\"Ext.XTemplate\" class=\"docClass\">Ext.XTemplate</a>[]</span></div><div class='description'><div class='short'>A String, Ext.Template, Ext.XTemplate or an Array of strings to form an Ext.XTemplate. ...</div><div class='long'><p>A <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>, <a href=\"#!/api/Ext.Template\" rel=\"Ext.Template\" class=\"docClass\">Ext.Template</a>, <a href=\"#!/api/Ext.XTemplate\" rel=\"Ext.XTemplate\" class=\"docClass\">Ext.XTemplate</a> or an <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a> of strings to form an <a href=\"#!/api/Ext.XTemplate\" rel=\"Ext.XTemplate\" class=\"docClass\">Ext.XTemplate</a>.\nUsed in conjunction with the <a href=\"#!/api/Ext.Component-cfg-data\" rel=\"Ext.Component-cfg-data\" class=\"docClass\">data</a> and <a href=\"#!/api/Ext.Component-cfg-tplWriteMode\" rel=\"Ext.Component-cfg-tplWriteMode\" class=\"docClass\">tplWriteMode</a> configurations.</p>\n\n<p><b>Note</b>\nThe <a href=\"#!/api/Ext.Component-cfg-data\" rel=\"Ext.Component-cfg-data\" class=\"docClass\">data</a> configuration <i>must</i> be set for any content to be shown in the component when using this configuration.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-tplWriteMode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-tplWriteMode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-tplWriteMode' class='name expandable'>tplWriteMode</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The Ext.(X)Template method to use when\nupdating the content area of the Component. ...</div><div class='long'><p>The Ext.(X)Template method to use when\nupdating the content area of the Component. Defaults to <code>'overwrite'</code>\n(see <code><a href=\"#!/api/Ext.XTemplate-method-overwrite\" rel=\"Ext.XTemplate-method-overwrite\" class=\"docClass\">Ext.XTemplate.overwrite</a></code>).</p>\n<p>Defaults to: <code>&quot;overwrite&quot;</code></p></div></div></div><div id='cfg-trackOver' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-trackOver' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-trackOver' class='name not-expandable'>trackOver</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'><p>True to enable mouseenter and mouseleave events.</p>\n</div><div class='long'><p>True to enable mouseenter and mouseleave events.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='cfg-translatable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-translatable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-translatable' class='name expandable'>translatable</a><span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-triggerCtEvent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-triggerCtEvent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-triggerCtEvent' class='name expandable'>triggerCtEvent</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>Determines what type of touch event is recognized as a touch on the container. ...</div><div class='long'><p>Determines what type of touch event is recognized as a touch on the container.\nValid options are 'tap' and 'singletap'.</p>\n<p>Defaults to: <code>&quot;tap&quot;</code></p></div></div></div><div id='cfg-triggerEvent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-triggerEvent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-cfg-triggerEvent' class='name expandable'>triggerEvent</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>Determines what type of touch event causes an item to be selected. ...</div><div class='long'><p>Determines what type of touch event causes an item to be selected. Defaults to 'itemtap'.\nValid options are 'itemtap', 'itemsingletap', 'itemdoubletap', 'itemswipe', 'itemtaphold'.</p>\n<p>Defaults to: <code>&quot;itemtap&quot;</code></p></div></div></div><div id='cfg-ui' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-ui' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-cfg-ui' class='name expandable'>ui</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The style of this list. ...</div><div class='long'><p>The style of this list. Available options are <code>normal</code> and <code>round</code>.</p>\n<p>Defaults to: <code>&quot;normal&quot;</code></p><p>Overrides: <a href='#!/api/Ext.Component-cfg-ui' rel='Ext.Component-cfg-ui' class='docClass'>Ext.Component.ui</a></p></div></div></div><div id='cfg-useComponents' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-useComponents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-cfg-useComponents' class='name expandable'>useComponents</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'>Flag the use a component based DataView implementation. ...</div><div class='long'><p>Flag the use a component based DataView implementation.  This allows the full use of components in the\nDataView at the cost of some performance.</p>\n\n<p>Checkout the <a href=\"#!/guide/dataview\">DataView Guide</a> for more information on using this configuration.</p>\n<p>Overrides: <a href='#!/api/Ext.dataview.DataView-cfg-useComponents' rel='Ext.dataview.DataView-cfg-useComponents' class='docClass'>Ext.dataview.DataView.useComponents</a></p></div></div></div><div id='cfg-width' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-width' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-width' class='name expandable'>width</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The width of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The width of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.\nBy default, if this is not explicitly set, this Component's element will simply have its own natual size.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-xtype' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-xtype' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-xtype' class='name expandable'>xtype</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The xtype configuration option can be used to optimize Component creation and rendering. ...</div><div class='long'><p>The <code>xtype</code> configuration option can be used to optimize Component creation and rendering. It serves as a\nshortcut to the full componet name. For example, the component <code>Ext.button.Button</code> has an xtype of <code>button</code>.</p>\n\n<p>You can define your own xtype on a custom <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">component</a> by specifying the\n<a href=\"#!/api/Ext.Class-cfg-alias\" rel=\"Ext.Class-cfg-alias\" class=\"docClass\">alias</a> config option with a prefix of <code>widget</code>. For example:</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('PressMeButton', {\n    extend: 'Ext.button.Button',\n    alias: 'widget.pressmebutton',\n    text: 'Press Me'\n})\n</code></pre>\n\n<p>Any Component can be created implicitly as an object config with an xtype specified, allowing it to be\ndeclared and passed into the rendering pipeline without actually being instantiated as an object. Not only is\nrendering deferred, but the actual creation of the object itself is also deferred, saving memory and resources\nuntil they are actually needed. In complex, nested layouts containing many Components, this can make a\nnoticeable improvement in performance.</p>\n\n<pre><code>// Explicit creation of contained Components:\nvar panel = new <a href=\"#!/api/Ext.Panel\" rel=\"Ext.Panel\" class=\"docClass\">Ext.Panel</a>({\n   ...\n   items: [\n      <a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('Ext.button.Button', {\n         text: 'OK'\n      })\n   ]\n};\n\n// Implicit creation using xtype:\nvar panel = new <a href=\"#!/api/Ext.Panel\" rel=\"Ext.Panel\" class=\"docClass\">Ext.Panel</a>({\n   ...\n   items: [{\n      xtype: 'button',\n      text: 'OK'\n   }]\n};\n</code></pre>\n\n<p>In the first example, the button will always be created immediately during the panel's initialization. With\nmany added Components, this approach could potentially slow the rendering of the page. In the second example,\nthe button will not be created or rendered until the panel is actually displayed in the browser. If the panel\nis never displayed (for example, if it is a tab that remains hidden) then the button will never be created and\nwill never consume any resources whatsoever.</p>\n<p>Defaults to: <code>&quot;component&quot;</code></p></div></div></div><div id='cfg-zIndex' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-zIndex' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-zIndex' class='name expandable'>zIndex</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></span></div><div class='description'><div class='short'>The z-index to give this Component when it is rendered ...</div><div class='long'><p>The z-index to give this Component when it is rendered</p>\n<p>Defaults to: <code>null</code></p></div></div></div></div></div><div class='members-section'><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div class='definedBy'>Defined By</div><h4 class='members-subtitle'>Instance Properties</h3><div id='property-alignmentRegex' class='member first-child inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-property-alignmentRegex' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-property-alignmentRegex' class='name expandable'>alignmentRegex</a><span> : <a href=\"#!/api/RegExp\" rel=\"RegExp\" class=\"docClass\">RegExp</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>/^([a-z]+)-([a-z]+)(\\?)?$/</code></p></div></div></div><div id='property-dockPositions' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-property-dockPositions' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-property-dockPositions' class='name expandable'>dockPositions</a><span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><strong class='private signature'>private</strong><strong class='readonly signature'>readonly</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>{top: true, right: true, bottom: true, left: true}</code></p></div></div></div><div id='property-floating' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-property-floating' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-property-floating' class='name expandable'>floating</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>false</code></p></div></div></div><div id='property-isComponent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-property-isComponent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-property-isComponent' class='name expandable'>isComponent</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>true</code></p></div></div></div><div id='property-items' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-property-items' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-property-items' class='name expandable'>items</a><span> : <a href=\"#!/api/Ext.util.MixedCollection\" rel=\"Ext.util.MixedCollection\" class=\"docClass\">Ext.util.MixedCollection</a></span><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>The set of all items in this Container. ...</div><div class='long'><p>The set of all items in this Container.</p>\n        <div class='signature-box deprecated'>\n        <p>This property has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.Container-method-getItems\" rel=\"Ext.Container-method-getItems\" class=\"docClass\">getItems</a> method instead.</p>\n\n        </div>\n</div></div></div><div id='property-listenerOptionsRegex' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-property-listenerOptionsRegex' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-property-listenerOptionsRegex' class='name expandable'>listenerOptionsRegex</a><span> : <a href=\"#!/api/RegExp\" rel=\"RegExp\" class=\"docClass\">RegExp</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>/^(?:delegate|single|delay|buffer|args|prepend|element)$/</code></p></div></div></div><div id='property-rendered' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-property-rendered' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-property-rendered' class='name expandable'>rendered</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>false</code></p></div></div></div><div id='property-self' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-property-self' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-property-self' class='name expandable'>self</a><span> : <a href=\"#!/api/Ext.Class\" rel=\"Ext.Class\" class=\"docClass\">Ext.Class</a></span><strong class='protected signature'>protected</strong></div><div class='description'><div class='short'>Get the reference to the current class from which this object was instantiated. ...</div><div class='long'><p>Get the reference to the current class from which this object was instantiated. Unlike <a href=\"#!/api/Ext.Base-method-statics\" rel=\"Ext.Base-method-statics\" class=\"docClass\">statics</a>,\n<code>this.self</code> is scope-dependent and it's meant to be used for dynamic inheritance. See <a href=\"#!/api/Ext.Base-method-statics\" rel=\"Ext.Base-method-statics\" class=\"docClass\">statics</a>\nfor a detailed comparison</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.Cat', {\n    statics: {\n        speciesName: 'Cat' // My.Cat.speciesName = 'Cat'\n    },\n\n    constructor: function() {\n        alert(this.self.speciesName); / dependentOL on 'this'\n    },\n\n    clone: function() {\n        return new this.self();\n    }\n});\n\n\n<a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.SnowLeopard', {\n    extend: 'My.Cat',\n    statics: {\n        speciesName: 'Snow Leopard'         // My.SnowLeopard.speciesName = 'Snow Leopard'\n    }\n});\n\nvar cat = new My.Cat();                     // alerts 'Cat'\nvar snowLeopard = new My.SnowLeopard();     // alerts 'Snow Leopard'\n\nvar clone = snowLeopard.clone();\nalert(<a href=\"#!/api/Ext-method-getClassName\" rel=\"Ext-method-getClassName\" class=\"docClass\">Ext.getClassName</a>(clone));             // alerts 'My.SnowLeopard'\n</code></pre>\n</div></div></div></div><div class='subsection'><div class='definedBy'>Defined By</div><h4 class='members-subtitle'>Static Properties</h3><div id='static-property-S-onExtended' class='member first-child inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-property-S-onExtended' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-property-S-onExtended' class='name expandable'>$onExtended</a><span> : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a></span><strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>[]</code></p></div></div></div></div></div><div class='members-section'><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div class='definedBy'>Defined By</div><h4 class='members-subtitle'>Instance Methods</h3><div id='method-constructor' class='member first-child inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-constructor' target='_blank' class='view-source'>view source</a></div><strong class='new-keyword'>new</strong><a href='#!/api/Ext.Component-method-constructor' class='name expandable'>Ext.dataview.List</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> config</span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></div><div class='description'><div class='short'>Creates new Component. ...</div><div class='long'><p>Creates new Component.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>config</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The standard configuration object.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-add' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-add' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-add' class='name expandable'>add</a>( <span class='pre'><a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a> newItems</span> )</div><div class='description'><div class='short'>Adds one or more Components to this Container. ...</div><div class='long'><p>Adds one or more Components to this Container. Example:</p>\n\n<pre><code>var myPanel = <a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.Panel\" rel=\"Ext.Panel\" class=\"docClass\">Ext.Panel</a>', {\n    html: 'This will be added to a Container'\n});\n\nmyContainer.add([myPanel]);\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>newItems</span> : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a><div class='sub-desc'><p>The new items to add to the Container</p>\n</div></li></ul></div></div></div><div id='method-addAfterListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-addAfterListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-addAfterListener' class='name expandable'>addAfterListener</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )</div><div class='description'><div class='short'>Appends an after-event handler. ...</div><div class='long'><p>Appends an after-event handler.</p>\n\n<p>Same as <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> with <code>order</code> set to <code>'after'</code>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event to listen for.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The method the event invokes.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope for <code>fn</code>.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>An object containing handler configuration.</p>\n\n</div></li></ul></div></div></div><div id='method-addAll' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-addAll' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-addAll' class='name expandable'>addAll</a>( <span class='pre'><a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a> items</span> ) : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Adds an array of Components to this Container. ...</div><div class='long'><p>Adds an array of Components to this Container.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.Container-method-add\" rel=\"Ext.Container-method-add\" class=\"docClass\">add</a> instead.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>items</span> : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a><div class='sub-desc'><p>The array of items to add to this container</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a></span><div class='sub-desc'><p>The array of items after they have been added</p>\n</div></li></ul></div></div></div><div id='method-addBeforeListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-addBeforeListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-addBeforeListener' class='name expandable'>addBeforeListener</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )</div><div class='description'><div class='short'>Appends a before-event handler. ...</div><div class='long'><p>Appends a before-event handler.  Returning <code>false</code> from the handler will stop the event.</p>\n\n<p>Same as <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> with <code>order</code> set to <code>'before'</code>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event to listen for.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The method the event invokes.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope for <code>fn</code>.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>An object containing handler configuration.</p>\n\n</div></li></ul></div></div></div><div id='method-addCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-addCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-addCls' class='name expandable'>addCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> cls, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> prefix, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> suffix</span> )</div><div class='description'><div class='short'>Adds a CSS class (or classes) to this Component's rendered element ...</div><div class='long'><p>Adds a CSS class (or classes) to this Component's rendered element</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>cls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The CSS class to add</p>\n</div></li><li><span class='pre'>prefix</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>Optional prefix to add to each class</p>\n</div></li><li><span class='pre'>suffix</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>Optional suffix to add to each class</p>\n</div></li></ul></div></div></div><div id='method-addEvents' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-addEvents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-addEvents' class='name expandable'>addEvents</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>... eventNames</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Adds the specified events to the list of events which this Observable may fire. ...</div><div class='long'><p>Adds the specified events to the list of events which this Observable may fire.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0</p>\n        <p>It's no longer needed to add events before firing.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventNames</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>...<div class='sub-desc'><p>Either an object with event names as properties with a value of <code>true</code>\nor the first event name string if multiple event names are being passed as separate parameters.</p>\n</div></li></ul></div></div></div><div id='method-addListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-addListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-addListener' class='name expandable'>addListener</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options], [<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> order]</span> )</div><div class='description'><div class='short'>Appends an event handler to this object. ...</div><div class='long'><p>Appends an event handler to this object. You can review the available handlers by looking at the 'events'\nsection of the documentation for the component you are working with.</p>\n\n<h2>Combining Options</h2>\n\n<p>Using the options argument, it is possible to combine different types of listeners:</p>\n\n<p>A delayed, one-time listener:</p>\n\n<pre><code>container.on('tap', this.handleTap, this, {\n    single: true,\n    delay: 100\n});\n</code></pre>\n\n<h2>Attaching multiple handlers in 1 call</h2>\n\n<p>The method also allows for a single argument to be passed which is a config object containing properties which\nspecify multiple events. For example:</p>\n\n<pre><code>container.on({\n    tap  : this.onTap,\n    swipe: this.onSwipe,\n\n    scope: this // Important. Ensure \"this\" is correct during handler execution\n});\n</code></pre>\n\n<p>One can also specify options for each event handler separately:</p>\n\n<pre><code>container.on({\n    tap  : { fn: this.onTap, scope: this, single: true },\n    swipe: { fn: button.onSwipe, scope: button }\n});\n</code></pre>\n\n<p>See the <a href=\"#!/guide/events\">Events Guide</a> for more.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event to listen for. May also be an object who's property names are\nevent names.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The method the event invokes.  Will be called with arguments given to\n<a href=\"#!/api/Ext.mixin.Observable-method-fireEvent\" rel=\"Ext.mixin.Observable-method-fireEvent\" class=\"docClass\">fireEvent</a> plus the <code>options</code> parameter described below.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope (<code>this</code> reference) in which the handler function is executed. <strong>If\nomitted, defaults to the object which fired the event.</strong></p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>An object containing handler configuration.</p>\n\n\n\n\n<p>This object may contain any of the following properties:</p>\n\n\n\n\n<ul>\n<li><p><strong>scope</strong> : Object</p>\n\n<p>The scope (<code>this</code> reference) in which the handler function is executed. <strong>If omitted, defaults to the object\nwhich fired the event.</strong></p></li>\n<li><p><strong>delay</strong> : Number</p>\n\n<p>The number of milliseconds to delay the invocation of the handler after the event fires.</p></li>\n<li><p><strong>single</strong> : Boolean</p>\n\n<p>True to add a handler to handle just the next firing of the event, and then remove itself.</p></li>\n<li><p><strong>order</strong> : String</p>\n\n<p>The order of when the listener should be added into the listener queue.</p>\n\n<p>If you set an order of <code>before</code> and the event you are listening to is preventable, you can return <code>false</code> and it will stop the event.</p>\n\n<p>Available options are <code>before</code>, <code>current</code> and <code>after</code>. Defaults to <code>current</code>.</p></li>\n<li><p><strong>buffer</strong> : Number</p>\n\n<p>Causes the handler to be delayed by the specified number of milliseconds. If the event fires again within that\ntime, the original handler is <em>not</em> invoked, but the new handler is scheduled in its place.</p></li>\n<li><p><strong>element</strong> : String</p>\n\n<p>Allows you to add a listener onto a element of this component using the elements reference.</p>\n\n<pre><code><a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a>', {\n    listeners: {\n        element: 'element',\n        tap: function() {\n            console.log('element tap!');\n        }\n    }\n});\n</code></pre>\n\n<p>All components have the <code>element</code> reference, which is the outer most element of the component. <a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a> also has the\n<code>innerElement</code> element which contains all children. In most cases <code>element</code> is adequate.</p></li>\n<li><p><strong>delegate</strong> : String</p>\n\n<p>Uses <a href=\"#!/api/Ext.ComponentQuery\" rel=\"Ext.ComponentQuery\" class=\"docClass\">Ext.ComponentQuery</a> to delegate events to a specified query selector within this item.</p>\n\n<pre><code>// Create a container with a two children; a button and a toolbar\nvar container = <a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a>', {\n    items: [\n        {\n           xtype: 'toolbar',\n           docked: 'top',\n           title: 'My Toolbar'\n        },\n        {\n           xtype: 'button',\n           text: 'My Button'\n        }\n    ]\n});\n\ncontainer.on({\n    // Ext.Buttons have an xtype of 'button', so we use that are a selector for our delegate\n    delegate: 'button',\n\n    tap: function() {\n        alert('Button tapped!');\n    }\n});\n</code></pre></li>\n</ul>\n\n\n\n</div></li><li><span class='pre'>order</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> (optional)<div class='sub-desc'><p>The order of when the listener should be added into the listener queue.\nPossible values are <code>before</code>, <code>current</code> and <code>after</code>.</p>\n\n<p>Defaults to: <code>&quot;current&quot;</code></p></div></li></ul></div></div></div><div id='method-addManagedListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-addManagedListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-addManagedListener' class='name expandable'>addManagedListener</a>( <span class='pre'><a href=\"#!/api/Ext.mixin.Observable\" rel=\"Ext.mixin.Observable\" class=\"docClass\">Ext.mixin.Observable</a>/HTMLElement object, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, [<a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Adds listeners to any Observable object (or Element) which are automatically removed when this Component\nis destroyed. ...</div><div class='long'><p>Adds listeners to any Observable object (or Element) which are automatically removed when this Component\nis destroyed.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0</p>\n        <p>All listeners are now automatically managed where necessary. Simply use <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a>.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>object</span> : <a href=\"#!/api/Ext.mixin.Observable\" rel=\"Ext.mixin.Observable\" class=\"docClass\">Ext.mixin.Observable</a>/HTMLElement<div class='sub-desc'><p>The item to which to add a listener/listeners.</p>\n\n</div></li><li><span class='pre'>eventName</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The event name, or an object containing event name properties.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the handler function.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the scope in which\nthe handler function is executed.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the\n<a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> options.</p>\n\n</div></li></ul></div></div></div><div id='method-addReferenceNode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.AbstractComponent' rel='Ext.AbstractComponent' class='defined-in docClass'>Ext.AbstractComponent</a><br/><a href='source/AbstractComponent.html#Ext-AbstractComponent-method-addReferenceNode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.AbstractComponent-method-addReferenceNode' class='name expandable'>addReferenceNode</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> name, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> domNode</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Significantly improve instantiation time for Component with multiple references\nExt.Element instance of the reference...</div><div class='long'><p>Significantly improve instantiation time for Component with multiple references\n<a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a> instance of the reference domNode is only created the very first time\nit's ever used</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>domNode</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-alignTo' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-alignTo' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-alignTo' class='name expandable'>alignTo</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> component, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> alignment</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>component</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>alignment</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-animateActiveItem' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-animateActiveItem' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-animateActiveItem' class='name expandable'>animateActiveItem</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> activeItem, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Ext.fx.layout.Card\" rel=\"Ext.fx.layout.Card\" class=\"docClass\">Ext.fx.layout.Card</a> animation</span> )</div><div class='description'><div class='short'>Animates to the supplied activeItem with a specified animation. ...</div><div class='long'><p>Animates to the supplied activeItem with a specified animation. Currently this only works\nwith a Card layout.  This passed animation will override any default animations on the\ncontainer, for a single card switch. The animation will be destroyed when complete.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>activeItem</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The item or item index to make active</p>\n</div></li><li><span class='pre'>animation</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Ext.fx.layout.Card\" rel=\"Ext.fx.layout.Card\" class=\"docClass\">Ext.fx.layout.Card</a><div class='sub-desc'><p>Card animation configuration or instance</p>\n</div></li></ul></div></div></div><div id='method-applyActiveItem' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-applyActiveItem' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-applyActiveItem' class='name expandable'>applyActiveItem</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> activeItem, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> currentActiveItem</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>activeItem</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>currentActiveItem</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-applyCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-applyCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-applyCls' class='name expandable'>applyCls</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> cls</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Checks if the cls is a string. ...</div><div class='long'><p>Checks if the cls is a string. If it is, changed it into an array</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>cls</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-applyControl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-applyControl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-applyControl' class='name expandable'>applyControl</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> selectors</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>selectors</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-applyMasked' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-applyMasked' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-applyMasked' class='name expandable'>applyMasked</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> masked, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> currentMask</span> )</div><div class='description'><div class='short'>Changes the masked configuration when its setter is called, which will convert the value\ninto a proper object/instanc...</div><div class='long'><p>Changes the <a href=\"#!/api/Ext.Container-cfg-masked\" rel=\"Ext.Container-cfg-masked\" class=\"docClass\">masked</a> configuration when its setter is called, which will convert the value\ninto a proper object/instance of <a href=\"#!/api/Ext.Mask\" rel=\"Ext.Mask\" class=\"docClass\">Ext.Mask</a>/<a href=\"#!/api/Ext.LoadMask\" rel=\"Ext.LoadMask\" class=\"docClass\">Ext.LoadMask</a>. If a mask already exists,\nit will use that instead.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>masked</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>currentMask</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-applyMode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-applyMode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-applyMode' class='name expandable'>applyMode</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> mode</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>mode</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-applyScrollable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-applyScrollable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-applyScrollable' class='name expandable'>applyScrollable</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> config</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>config</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-applyTpl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-applyTpl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-applyTpl' class='name expandable'>applyTpl</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> config</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>config</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-beforeInitialize' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-beforeInitialize' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-beforeInitialize' class='name expandable'>beforeInitialize</a>( <span class='pre'></span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-bindStore' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-method-bindStore' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-bindStore' class='name expandable'>bindStore</a>( <span class='pre'></span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Binds a new Store to this DataView. ...</div><div class='long'><p>Binds a new <a href=\"#!/api/Ext.data.Store\" rel=\"Ext.data.Store\" class=\"docClass\">Store</a> to this DataView.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0</p>\n        <p>please use <a href=\"#!/api/Ext.dataview.DataView-method-setStore\" rel=\"Ext.dataview.DataView-method-setStore\" class=\"docClass\">setStore</a> instead</p>\n\n        </div>\n</div></div></div><div id='method-callOverridden' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-callOverridden' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-callOverridden' class='name expandable'>callOverridden</a>( <span class='pre'><a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/Arguments args</span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><strong class='protected signature'>protected</strong></div><div class='description'><div class='short'>Call the original method that was previously overridden with override\n\nExt.define('My.Cat', {\n    constructor: functi...</div><div class='long'><p>Call the original method that was previously overridden with <a href=\"#!/api/Ext.Base-static-method-override\" rel=\"Ext.Base-static-method-override\" class=\"docClass\">override</a></p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.Cat', {\n    constructor: function() {\n        alert(\"I'm a cat!\");\n    }\n});\n\nMy.Cat.override({\n    constructor: function() {\n        alert(\"I'm going to be a cat!\");\n\n        var instance = this.callOverridden();\n\n        alert(\"Meeeeoooowwww\");\n\n        return instance;\n    }\n});\n\nvar kitty = new My.Cat(); // alerts \"I'm going to be a cat!\"\n                          // alerts \"I'm a cat!\"\n                          // alerts \"Meeeeoooowwww\"\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>args</span> : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/Arguments<div class='sub-desc'><p>The arguments, either an array or the <code>arguments</code> object\nfrom the current method, for example: <code>this.callOverridden(arguments)</code></p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'><p>Returns the result of calling the overridden method</p>\n</div></li></ul></div></div></div><div id='method-callParent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-callParent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-callParent' class='name expandable'>callParent</a>( <span class='pre'><a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/Arguments args</span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><strong class='protected signature'>protected</strong></div><div class='description'><div class='short'>Call the \"parent\" method of the current method. ...</div><div class='long'><p>Call the \"parent\" method of the current method. That is the method previously\noverridden by derivation or by an override (see <a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>).</p>\n\n<pre><code> <a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.Base', {\n     constructor: function (x) {\n         this.x = x;\n     },\n\n     statics: {\n         method: function (x) {\n             return x;\n         }\n     }\n });\n\n <a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.Derived', {\n     extend: 'My.Base',\n\n     constructor: function () {\n         this.callParent([21]);\n     }\n });\n\n var obj = new My.Derived();\n\n alert(obj.x);  // alerts 21\n</code></pre>\n\n<p>This can be used with an override as follows:</p>\n\n<pre><code> <a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.DerivedOverride', {\n     override: 'My.Derived',\n\n     constructor: function (x) {\n         this.callParent([x*2]); // calls original My.Derived constructor\n     }\n });\n\n var obj = new My.Derived();\n\n alert(obj.x);  // now alerts 42\n</code></pre>\n\n<p>This also works with static methods.</p>\n\n<pre><code> <a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.Derived2', {\n     extend: 'My.Base',\n\n     statics: {\n         method: function (x) {\n             return this.callParent([x*2]); // calls My.Base.method\n         }\n     }\n });\n\n alert(My.Base.method(10);     // alerts 10\n alert(My.Derived2.method(10); // alerts 20\n</code></pre>\n\n<p>Lastly, it also works with overridden static methods.</p>\n\n<pre><code> <a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.Derived2Override', {\n     override: 'My.Derived2',\n\n     statics: {\n         method: function (x) {\n             return this.callParent([x*2]); // calls My.Derived2.method\n         }\n     }\n });\n\n alert(My.Derived2.method(10); // now alerts 40\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>args</span> : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/Arguments<div class='sub-desc'><p>The arguments, either an array or the <code>arguments</code> object\nfrom the current method, for example: <code>this.callParent(arguments)</code></p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'><p>Returns the result of calling the parent method</p>\n</div></li></ul></div></div></div><div id='method-changeListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-changeListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-changeListener' class='name expandable'>changeListener</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> operation, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eventName, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> fn, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> order</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>operation</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>eventName</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>order</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-child' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-child' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-child' class='name expandable'>child</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> selector</span> )</div><div class='description'><div class='short'>Retrieves the first direct child of this container which matches the passed selector. ...</div><div class='long'><p>Retrieves the first direct child of this container which matches the passed selector.\nThe passed in selector must comply with an <a href=\"#!/api/Ext.ComponentQuery\" rel=\"Ext.ComponentQuery\" class=\"docClass\">Ext.ComponentQuery</a> selector.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>selector</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>An <a href=\"#!/api/Ext.ComponentQuery\" rel=\"Ext.ComponentQuery\" class=\"docClass\">Ext.ComponentQuery</a> selector</p>\n</div></li></ul></div></div></div><div id='method-clearListeners' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-clearListeners' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-clearListeners' class='name expandable'>clearListeners</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Removes all listeners for this object. ...</div><div class='long'><p>Removes all listeners for this object.</p>\n</div></div></div><div id='method-clearSelections' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-clearSelections' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-clearSelections' class='name expandable'>clearSelections</a>( <span class='pre'></span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Deselects any currently selected records and clears all stored selections ...</div><div class='long'><p>Deselects any currently selected records and clears all stored selections</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.mixin.Selectable-method-deselectAll\" rel=\"Ext.mixin.Selectable-method-deselectAll\" class=\"docClass\">deselectAll</a> instead.</p>\n\n        </div>\n</div></div></div><div id='method-collectData' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-method-collectData' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-collectData' class='name expandable'>collectData</a>( <span class='pre'></span> )<strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>Function which can be overridden which returns the data object passed to\nthis DataView's template to render the whole...</div><div class='long'><p>Function which can be overridden which returns the data object passed to\nthis DataView's template to render the whole DataView.</p>\n        <div class='signature-box removed'>\n        <p>This method has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='method-createEventRelayer' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-createEventRelayer' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-createEventRelayer' class='name expandable'>createEventRelayer</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> newName</span> ) : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><strong class='private signature'>private</strong></div><div class='description'><div class='short'>Creates an event handling function which refires the event from this object as the passed event name. ...</div><div class='long'><p>Creates an event handling function which refires the event from this object as the passed event name.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>newName</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-deselect' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-deselect' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-deselect' class='name expandable'>deselect</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a> records, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> suppressEvent</span> )</div><div class='description'><div class='short'>Deselects the given record(s). ...</div><div class='long'><p>Deselects the given record(s). If many records are currently selected, it will only deselect those you pass in.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>records</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a><div class='sub-desc'><p>The record(s) to deselect. Can also be a number to reference by index</p>\n</div></li><li><span class='pre'>suppressEvent</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>If true the deselect event will not be fired</p>\n</div></li></ul></div></div></div><div id='method-deselectAll' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-deselectAll' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-deselectAll' class='name expandable'>deselectAll</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> supress</span> )</div><div class='description'><div class='short'>Deselects all records. ...</div><div class='long'><p>Deselects all records.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>supress</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-destroy' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-destroy' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-destroy' class='name expandable'>destroy</a>( <span class='pre'></span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Overrides: <a href='#!/api/Ext.Component-method-destroy' rel='Ext.Component-method-destroy' class='docClass'>Ext.Component.destroy</a></p></div></div></div><div id='method-disable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-disable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-disable' class='name expandable'>disable</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Disables this Component ...</div><div class='long'><p>Disables this Component</p>\n</div></div></div><div id='method-doAdd' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-doAdd' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-doAdd' class='name expandable'>doAdd</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-doAddListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-doAddListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-doAddListener' class='name expandable'>doAddListener</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> name, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> fn, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-doDeselect' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-doDeselect' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-doDeselect' class='name expandable'>doDeselect</a>( <span class='pre'><a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> records, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> suppressEvent</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Deselects a record instance by record instance or index. ...</div><div class='long'><p>Deselects a record instance by record instance or index.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.mixin.Selectable-method-deselect\" rel=\"Ext.mixin.Selectable-method-deselect\" class=\"docClass\">deselect</a> instead.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>records</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>An array of records or an index</p>\n</div></li><li><span class='pre'>suppressEvent</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>Set to false to not fire a deselect event</p>\n</div></li></ul></div></div></div><div id='method-doInsert' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-doInsert' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-doInsert' class='name expandable'>doInsert</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> index, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>index</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-doMultiSelect' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-doMultiSelect' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-doMultiSelect' class='name expandable'>doMultiSelect</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> records, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> keepExisting, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> suppressEvent</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Selects a set of multiple records ...</div><div class='long'><p>Selects a set of multiple records</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>records</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>keepExisting</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>suppressEvent</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-doSelect' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-doSelect' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-doSelect' class='name expandable'>doSelect</a>( <span class='pre'><a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> records, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> keepExisting, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> suppressEvent</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Selects a record instance by record instance or index. ...</div><div class='long'><p>Selects a record instance by record instance or index.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.mixin.Selectable-method-select\" rel=\"Ext.mixin.Selectable-method-select\" class=\"docClass\">select</a> instead.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>records</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>An array of records or an index</p>\n</div></li><li><span class='pre'>keepExisting</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li><li><span class='pre'>suppressEvent</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>Set to false to not fire a select event</p>\n</div></li></ul></div></div></div><div id='method-doSetActiveItem' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-doSetActiveItem' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-doSetActiveItem' class='name expandable'>doSetActiveItem</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> newActiveItem, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> oldActiveItem</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>newActiveItem</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>oldActiveItem</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-doSingleSelect' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-doSingleSelect' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-doSingleSelect' class='name expandable'>doSingleSelect</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> record, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> suppressEvent</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Selects a single record ...</div><div class='long'><p>Selects a single record</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>record</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>suppressEvent</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-down' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-down' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-down' class='name expandable'>down</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> selector</span> )</div><div class='description'><div class='short'>Retrieves the first descendant of this container which matches the passed selector. ...</div><div class='long'><p>Retrieves the first descendant of this container which matches the passed selector.\nThe passed in selector must comply with an <a href=\"#!/api/Ext.ComponentQuery\" rel=\"Ext.ComponentQuery\" class=\"docClass\">Ext.ComponentQuery</a> selector.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>selector</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>An <a href=\"#!/api/Ext.ComponentQuery\" rel=\"Ext.ComponentQuery\" class=\"docClass\">Ext.ComponentQuery</a> selector</p>\n</div></li></ul></div></div></div><div id='method-enable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-enable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-enable' class='name expandable'>enable</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Enables this Component ...</div><div class='long'><p>Enables this Component</p>\n</div></div></div><div id='method-enableBubble' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-enableBubble' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-enableBubble' class='name expandable'>enableBubble</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[] events</span> )</div><div class='description'><div class='short'>Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if\npresent. ...</div><div class='long'><p>Enables events fired by this Observable to bubble up an owner hierarchy by calling <code>this.getBubbleTarget()</code> if\npresent. There is no implementation in the Observable base class.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>events</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]<div class='sub-desc'><p>The event name to bubble, or an Array of event names.</p>\n</div></li></ul></div></div></div><div id='method-findItemByChild' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-method-findItemByChild' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-findItemByChild' class='name expandable'>findItemByChild</a>( <span class='pre'></span> )<strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>Returns the template node the passed child belongs to, or null if it doesn't belong to one. ...</div><div class='long'><p>Returns the template node the passed child belongs to, or null if it doesn't belong to one.</p>\n        <div class='signature-box removed'>\n        <p>This method has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='method-findTargetByEvent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-method-findTargetByEvent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-findTargetByEvent' class='name expandable'>findTargetByEvent</a>( <span class='pre'></span> )<strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>Returns the template node by the Ext.EventObject or null if it is not found. ...</div><div class='long'><p>Returns the template node by the <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a> or null if it is not found.</p>\n        <div class='signature-box removed'>\n        <p>This method has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='method-fireAction' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-fireAction' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-fireAction' class='name expandable'>fireAction</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a> args, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope</span> )</div><div class='description'><div class='short'>Fires the specified event with the passed parameters and execute a function (action)\nat the end if there are no liste...</div><div class='long'><p>Fires the specified event with the passed parameters and execute a function (action)\nat the end if there are no listeners that return false.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event to fire.</p>\n</div></li><li><span class='pre'>args</span> : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a><div class='sub-desc'><p>Arguments to pass to handers</p>\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>Action</p>\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>scope of fn</p>\n</div></li></ul></div></div></div><div id='method-fireEvent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-fireEvent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-fireEvent' class='name expandable'>fireEvent</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>... args</span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Fires the specified event with the passed parameters (minus the event name, plus the options object passed\nto addList...</div><div class='long'><p>Fires the specified event with the passed parameters (minus the event name, plus the <code>options</code> object passed\nto <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a>).</p>\n\n<p>An event may be set to bubble up an Observable parent hierarchy by calling <a href=\"#!/api/Ext.mixin.Observable-method-enableBubble\" rel=\"Ext.mixin.Observable-method-enableBubble\" class=\"docClass\">enableBubble</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event to fire.</p>\n</div></li><li><span class='pre'>args</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>...<div class='sub-desc'><p>Variable number of parameters are passed to handlers.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'><p>returns false if any of the handlers return false otherwise it returns true.</p>\n</div></li></ul></div></div></div><div id='method-getActiveItem' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-activeItem' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-getActiveItem' class='name expandable'>getActiveItem</a>( <span class='pre'></span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></div><div class='description'><div class='short'>Returns the value of activeItem. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Container-cfg-activeItem\" rel=\"Ext.Container-cfg-activeItem\" class=\"docClass\">activeItem</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getAllowDeselect' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-cfg-allowDeselect' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-getAllowDeselect' class='name expandable'>getAllowDeselect</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of allowDeselect. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.mixin.Selectable-cfg-allowDeselect\" rel=\"Ext.mixin.Selectable-cfg-allowDeselect\" class=\"docClass\">allowDeselect</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getAt' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-getAt' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-getAt' class='name expandable'>getAt</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> index</span> ) : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a></div><div class='description'><div class='short'>Returns the Component for a given index in the Container's items ...</div><div class='long'><p>Returns the Component for a given index in the Container's <a href=\"#!/api/Ext.Container-property-items\" rel=\"Ext.Container-property-items\" class=\"docClass\">items</a></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>index</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The index of the Component to return</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a></span><div class='sub-desc'><p>The item at the specified index, if found</p>\n</div></li></ul></div></div></div><div id='method-getAutoDestroy' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-autoDestroy' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-getAutoDestroy' class='name expandable'>getAutoDestroy</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of autoDestroy. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Container-cfg-autoDestroy\" rel=\"Ext.Container-cfg-autoDestroy\" class=\"docClass\">autoDestroy</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getBaseCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-baseCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getBaseCls' class='name expandable'>getBaseCls</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of baseCls. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-baseCls\" rel=\"Ext.Component-cfg-baseCls\" class=\"docClass\">baseCls</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getBorder' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-border' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getBorder' class='name expandable'>getBorder</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of border. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-border\" rel=\"Ext.Component-cfg-border\" class=\"docClass\">border</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getBottom' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-bottom' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getBottom' class='name expandable'>getBottom</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of bottom. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-bottom\" rel=\"Ext.Component-cfg-bottom\" class=\"docClass\">bottom</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getBubbleEvents' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-cfg-bubbleEvents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-getBubbleEvents' class='name expandable'>getBubbleEvents</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]</div><div class='description'><div class='short'>Returns the value of bubbleEvents. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.mixin.Observable-cfg-bubbleEvents\" rel=\"Ext.mixin.Observable-cfg-bubbleEvents\" class=\"docClass\">bubbleEvents</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getCentered' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-centered' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getCentered' class='name expandable'>getCentered</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of centered. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-centered\" rel=\"Ext.Component-cfg-centered\" class=\"docClass\">centered</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-cls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getCls' class='name expandable'>getCls</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]</div><div class='description'><div class='short'>Returns the value of cls. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-cls\" rel=\"Ext.Component-cfg-cls\" class=\"docClass\">cls</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getComponent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-getComponent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-getComponent' class='name expandable'>getComponent</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> component</span> )</div><div class='description'><div class='short'>Examines this container's items property\nand gets a direct child component of this container. ...</div><div class='long'><p>Examines this container's <code><a href=\"#!/api/Ext.Container-property-items\" rel=\"Ext.Container-property-items\" class=\"docClass\">items</a></code> <b>property</b>\nand gets a direct child component of this container.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>component</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>This parameter may be any of the following:</p>\n\n<div><ul class=\"mdetail-params\">\n<li>a <b><code>String</code></b> : representing the <code>itemId</code>\nor <code><a href=\"#!/api/Ext.Component-method-getId\" rel=\"Ext.Component-method-getId\" class=\"docClass\">id</a></code> of the child component </li>\n<li>a <b><code>Number</code></b> : representing the position of the child component\nwithin the <code><a href=\"#!/api/Ext.Container-property-items\" rel=\"Ext.Container-property-items\" class=\"docClass\">items</a></code> <b>property</b></li>\n</ul></div>\n\n\n<p>For additional information see <a href=\"#!/api/Ext.util.MixedCollection-method-get\" rel=\"Ext.util.MixedCollection-method-get\" class=\"docClass\">Ext.util.MixedCollection.get</a>.\n\n</div></li></ul></div></div></div><div id='method-getConfig' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-getConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-getConfig' class='name expandable'>getConfig</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> name</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getContentEl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-contentEl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getContentEl' class='name expandable'>getContentEl</a>( <span class='pre'></span> ) : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of contentEl. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-contentEl\" rel=\"Ext.Component-cfg-contentEl\" class=\"docClass\">contentEl</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getCount' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-getCount' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-getCount' class='name expandable'>getCount</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Returns the number of selections. ...</div><div class='long'><p>Returns the number of selections.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.mixin.Selectable-method-getSelectionCount\" rel=\"Ext.mixin.Selectable-method-getSelectionCount\" class=\"docClass\">getSelectionCount</a> instead.</p>\n\n        </div>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getCurrentConfig' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-getCurrentConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-getCurrentConfig' class='name expandable'>getCurrentConfig</a>( <span class='pre'></span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-getData' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-data' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getData' class='name expandable'>getData</a>( <span class='pre'></span> ) : Mixed</div><div class='description'><div class='short'>Returns the value of data. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-data\" rel=\"Ext.Component-cfg-data\" class=\"docClass\">data</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Mixed</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getDefaultType' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-defaultType' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-getDefaultType' class='name expandable'>getDefaultType</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><strong class='private signature'>private</strong></div><div class='description'><div class='short'>Returns the value of defaultType. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">defaultType</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul><p>Overrides: <a href='#!/api/Ext.dataview.DataView-method-getDefaultType' rel='Ext.dataview.DataView-method-getDefaultType' class='docClass'>Ext.dataview.DataView.getDefaultType</a></p></div></div></div><div id='method-getDefaults' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-defaults' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-getDefaults' class='name expandable'>getDefaults</a>( <span class='pre'></span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></div><div class='description'><div class='short'>Returns the value of defaults. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Container-cfg-defaults\" rel=\"Ext.Container-cfg-defaults\" class=\"docClass\">defaults</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getDeselectOnContainerClick' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-deselectOnContainerClick' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-getDeselectOnContainerClick' class='name expandable'>getDeselectOnContainerClick</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of deselectOnContainerClick. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-deselectOnContainerClick\" rel=\"Ext.dataview.DataView-cfg-deselectOnContainerClick\" class=\"docClass\">deselectOnContainerClick</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul><p>Overrides: <a href='#!/api/Ext.mixin.Selectable-method-getDeselectOnContainerClick' rel='Ext.mixin.Selectable-method-getDeselectOnContainerClick' class='docClass'>Ext.mixin.Selectable.getDeselectOnContainerClick</a></p></div></div></div><div id='method-getDisableSelection' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-cfg-disableSelection' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-getDisableSelection' class='name expandable'>getDisableSelection</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of disableSelection. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.mixin.Selectable-cfg-disableSelection\" rel=\"Ext.mixin.Selectable-cfg-disableSelection\" class=\"docClass\">disableSelection</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getDisabled' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-disabled' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getDisabled' class='name expandable'>getDisabled</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of disabled. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-disabled\" rel=\"Ext.Component-cfg-disabled\" class=\"docClass\">disabled</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getDisabledCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-disabledCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getDisabledCls' class='name expandable'>getDisabledCls</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of disabledCls. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-disabledCls\" rel=\"Ext.Component-cfg-disabledCls\" class=\"docClass\">disabledCls</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getDisclosureProperty' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-disclosureProperty' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-getDisclosureProperty' class='name expandable'>getDisclosureProperty</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of disclosureProperty. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.List-cfg-disclosureProperty\" rel=\"Ext.dataview.List-cfg-disclosureProperty\" class=\"docClass\">disclosureProperty</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getDocked' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-docked' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getDocked' class='name expandable'>getDocked</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of docked. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-docked\" rel=\"Ext.Component-cfg-docked\" class=\"docClass\">docked</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getDockedComponent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-getDockedComponent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-getDockedComponent' class='name expandable'>getDockedComponent</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> component</span> ) : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a>/<a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Finds a docked item of this container using a reference, id or an index of its location\nin getDockedItems. ...</div><div class='long'><p>Finds a docked item of this container using a reference, id or an index of its location\nin <a href=\"#!/api/Ext.Container-method-getDockedItems\" rel=\"Ext.Container-method-getDockedItems\" class=\"docClass\">getDockedItems</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>component</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The id or index of the component to find</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a>/<a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'><p>The docked component, if found</p>\n</div></li></ul></div></div></div><div id='method-getDockedItems' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-getDockedItems' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-getDockedItems' class='name expandable'>getDockedItems</a>( <span class='pre'></span> ) : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a></div><div class='description'><div class='short'>Returns all the Ext.Component.docked items in this container. ...</div><div class='long'><p>Returns all the <a href=\"#!/api/Ext.Component-cfg-docked\" rel=\"Ext.Component-cfg-docked\" class=\"docClass\">Ext.Component.docked</a> items in this container.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a></span><div class='sub-desc'><p>The docked items of this container</p>\n</div></li></ul></div></div></div><div id='method-getDraggable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-draggable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getDraggable' class='name expandable'>getDraggable</a>( <span class='pre'></span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></div><div class='description'><div class='short'>Returns the value of draggable. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-draggable\" rel=\"Ext.Component-cfg-draggable\" class=\"docClass\">draggable</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getEl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-getEl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getEl' class='name expandable'>getEl</a>( <span class='pre'></span> ) : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.dom.Element</a><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Retrieves the top level element representing this component. ...</div><div class='long'><p>Retrieves the top level element representing this component.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> </p>\n        <p>2.0.0 Please access the Component's element from the 'element' property instead, i.e:</p>\n\n<pre><code> var element = component.element;\n</code></pre>\n\n        </div>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.dom.Element</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getEnterAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-enterAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getEnterAnimation' class='name expandable'>getEnterAnimation</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Returns the value of enterAnimation. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-enterAnimation\" rel=\"Ext.Component-cfg-enterAnimation\" class=\"docClass\">enterAnimation</a>.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.Component-cfg-showAnimation\" rel=\"Ext.Component-cfg-showAnimation\" class=\"docClass\">showAnimation</a> instead.</p>\n\n        </div>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getExitAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-exitAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getExitAnimation' class='name expandable'>getExitAnimation</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Returns the value of exitAnimation. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-exitAnimation\" rel=\"Ext.Component-cfg-exitAnimation\" class=\"docClass\">exitAnimation</a>.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> </p>\n        <p>2.0.0 Please use <a href=\"#!/api/Ext.Component-cfg-hideAnimation\" rel=\"Ext.Component-cfg-hideAnimation\" class=\"docClass\">hideAnimation</a> instead.  Typically you want to use an\noutbound animation type such as 'fadeOut' or 'slideOut'.</p>\n\n        </div>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getFloatingCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-floatingCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getFloatingCls' class='name expandable'>getFloatingCls</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of floatingCls. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-floatingCls\" rel=\"Ext.Component-cfg-floatingCls\" class=\"docClass\">floatingCls</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getGrouped' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-grouped' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-getGrouped' class='name expandable'>getGrouped</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of grouped. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.List-cfg-grouped\" rel=\"Ext.dataview.List-cfg-grouped\" class=\"docClass\">grouped</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getHeight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-height' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getHeight' class='name expandable'>getHeight</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of height. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-height\" rel=\"Ext.Component-cfg-height\" class=\"docClass\">height</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getHidden' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hidden' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getHidden' class='name expandable'>getHidden</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of hidden. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-hidden\" rel=\"Ext.Component-cfg-hidden\" class=\"docClass\">hidden</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getHiddenCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hiddenCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getHiddenCls' class='name expandable'>getHiddenCls</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of hiddenCls. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-hiddenCls\" rel=\"Ext.Component-cfg-hiddenCls\" class=\"docClass\">hiddenCls</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getHideAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hideAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getHideAnimation' class='name expandable'>getHideAnimation</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</div><div class='description'><div class='short'>Returns the value of hideAnimation. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-hideAnimation\" rel=\"Ext.Component-cfg-hideAnimation\" class=\"docClass\">hideAnimation</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getHideOnMaskTap' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-hideOnMaskTap' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-getHideOnMaskTap' class='name expandable'>getHideOnMaskTap</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of hideOnMaskTap. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Container-cfg-hideOnMaskTap\" rel=\"Ext.Container-cfg-hideOnMaskTap\" class=\"docClass\">hideOnMaskTap</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getHtml' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-html' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getHtml' class='name expandable'>getHtml</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement</div><div class='description'><div class='short'>Returns the value of html. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-html\" rel=\"Ext.Component-cfg-html\" class=\"docClass\">html</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getId' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Identifiable' rel='Ext.mixin.Identifiable' class='defined-in docClass'>Ext.mixin.Identifiable</a><br/><a href='source/Identifiable.html#Ext-mixin-Identifiable-method-getId' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Identifiable-method-getId' class='name expandable'>getId</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Retrieves the id of this component. ...</div><div class='long'><p>Retrieves the id of this component. Will autogenerate an id if one has not already been set.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'><p>id</p>\n</div></li></ul></div></div></div><div id='method-getIndexBar' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-indexBar' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-getIndexBar' class='name expandable'>getIndexBar</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></div><div class='description'><div class='short'>Returns the value of indexBar. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.List-cfg-indexBar\" rel=\"Ext.dataview.List-cfg-indexBar\" class=\"docClass\">indexBar</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getInitialConfig' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-getInitialConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-getInitialConfig' class='name expandable'>getInitialConfig</a>( <span class='pre'>[<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> name]</span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/Mixed</div><div class='description'><div class='short'>Returns the initial configuration passed to constructor. ...</div><div class='long'><p>Returns the initial configuration passed to constructor.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> (optional)<div class='sub-desc'><p>When supplied, value for particular configuration\noption is returned, otherwise the full config object is returned.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/Mixed</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getInline' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-inline' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-getInline' class='name expandable'>getInline</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></div><div class='description'><div class='short'>Returns the value of inline. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-inline\" rel=\"Ext.dataview.DataView-cfg-inline\" class=\"docClass\">inline</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getInnerItems' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-getInnerItems' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-getInnerItems' class='name expandable'>getInnerItems</a>( <span class='pre'></span> ) : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a></div><div class='description'><div class='short'>Returns all inner items of this container. ...</div><div class='long'><p>Returns all inner <a href=\"#!/api/Ext.Container-property-items\" rel=\"Ext.Container-property-items\" class=\"docClass\">items</a> of this container. <code>inner</code> means that the item is not <code>docked</code> or\n<code>floating</code>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a></span><div class='sub-desc'><p>The inner items of this container.</p>\n</div></li></ul></div></div></div><div id='method-getItemCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-itemCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-getItemCls' class='name expandable'>getItemCls</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of itemCls. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-itemCls\" rel=\"Ext.dataview.DataView-cfg-itemCls\" class=\"docClass\">itemCls</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getItemConfig' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-itemConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-getItemConfig' class='name expandable'>getItemConfig</a>( <span class='pre'></span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><strong class='private signature'>private</strong></div><div class='description'><div class='short'>Returns the value of itemConfig. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">itemConfig</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul><p>Overrides: <a href='#!/api/Ext.dataview.DataView-method-getItemConfig' rel='Ext.dataview.DataView-method-getItemConfig' class='docClass'>Ext.dataview.DataView.getItemConfig</a></p></div></div></div><div id='method-getItemId' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-itemId' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getItemId' class='name expandable'>getItemId</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of itemId. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-itemId\" rel=\"Ext.Component-cfg-itemId\" class=\"docClass\">itemId</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getItems' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-items' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-getItems' class='name expandable'>getItems</a>( <span class='pre'></span> ) : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></div><div class='description'><div class='short'>Returns the value of items. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Container-cfg-items\" rel=\"Ext.Container-cfg-items\" class=\"docClass\">items</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getLastFocused' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-cfg-lastFocused' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-getLastFocused' class='name expandable'>getLastFocused</a>( <span class='pre'></span> ) : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a><strong class='private signature'>private</strong></div><div class='description'><div class='short'>Returns the value of lastFocused. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.mixin.Selectable\" rel=\"Ext.mixin.Selectable\" class=\"docClass\">lastFocused</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getLastSelected' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-getLastSelected' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-getLastSelected' class='name expandable'>getLastSelected</a>( <span class='pre'></span> ) : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Returns the array of previously selected items ...</div><div class='long'><p>Returns the array of previously selected items</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        \n\n        </div>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a></span><div class='sub-desc'><p>The previous selection</p>\n</div></li></ul></div></div></div><div id='method-getLayout' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-layout' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-getLayout' class='name expandable'>getLayout</a>( <span class='pre'></span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><strong class='private signature'>private</strong></div><div class='description'><div class='short'>Returns the value of layout. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">layout</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul><p>Overrides: <a href='#!/api/Ext.Container-method-getLayout' rel='Ext.Container-method-getLayout' class='docClass'>Ext.Container.getLayout</a></p></div></div></div><div id='method-getLeft' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-left' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getLeft' class='name expandable'>getLeft</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of left. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-left\" rel=\"Ext.Component-cfg-left\" class=\"docClass\">left</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getListeners' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-cfg-listeners' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-getListeners' class='name expandable'>getListeners</a>( <span class='pre'></span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></div><div class='description'><div class='short'>Returns the value of listeners. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.mixin.Observable-cfg-listeners\" rel=\"Ext.mixin.Observable-cfg-listeners\" class=\"docClass\">listeners</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getMargin' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-margin' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getMargin' class='name expandable'>getMargin</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of margin. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-margin\" rel=\"Ext.Component-cfg-margin\" class=\"docClass\">margin</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getMasked' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-masked' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-getMasked' class='name expandable'>getMasked</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Ext.Mask\" rel=\"Ext.Mask\" class=\"docClass\">Ext.Mask</a>/<a href=\"#!/api/Ext.LoadMask\" rel=\"Ext.LoadMask\" class=\"docClass\">Ext.LoadMask</a></div><div class='description'><div class='short'>Returns the value of masked. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Container-cfg-masked\" rel=\"Ext.Container-cfg-masked\" class=\"docClass\">masked</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Ext.Mask\" rel=\"Ext.Mask\" class=\"docClass\">Ext.Mask</a>/<a href=\"#!/api/Ext.LoadMask\" rel=\"Ext.LoadMask\" class=\"docClass\">Ext.LoadMask</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getMaxHeight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-maxHeight' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getMaxHeight' class='name expandable'>getMaxHeight</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of maxHeight. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-maxHeight\" rel=\"Ext.Component-cfg-maxHeight\" class=\"docClass\">maxHeight</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getMaxItemCache' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-maxItemCache' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-getMaxItemCache' class='name expandable'>getMaxItemCache</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><strong class='private signature'>private</strong></div><div class='description'><div class='short'>Returns the value of maxItemCache. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">maxItemCache</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></span><div class='sub-desc'>\n</div></li></ul><p>Overrides: <a href='#!/api/Ext.dataview.DataView-method-getMaxItemCache' rel='Ext.dataview.DataView-method-getMaxItemCache' class='docClass'>Ext.dataview.DataView.getMaxItemCache</a></p></div></div></div><div id='method-getMaxWidth' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-maxWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getMaxWidth' class='name expandable'>getMaxWidth</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of maxWidth. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-maxWidth\" rel=\"Ext.Component-cfg-maxWidth\" class=\"docClass\">maxWidth</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getMinHeight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-minHeight' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getMinHeight' class='name expandable'>getMinHeight</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of minHeight. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-minHeight\" rel=\"Ext.Component-cfg-minHeight\" class=\"docClass\">minHeight</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getMinWidth' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-minWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getMinWidth' class='name expandable'>getMinWidth</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of minWidth. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-minWidth\" rel=\"Ext.Component-cfg-minWidth\" class=\"docClass\">minWidth</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getModal' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-modal' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-getModal' class='name expandable'>getModal</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of modal. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Container-cfg-modal\" rel=\"Ext.Container-cfg-modal\" class=\"docClass\">modal</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getMode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-cfg-mode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-getMode' class='name expandable'>getMode</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of mode. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.mixin.Selectable-cfg-mode\" rel=\"Ext.mixin.Selectable-cfg-mode\" class=\"docClass\">mode</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getNode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-method-getNode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-getNode' class='name expandable'>getNode</a>( <span class='pre'></span> )<strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>Gets a template node. ...</div><div class='long'><p>Gets a template node.</p>\n        <div class='signature-box removed'>\n        <p>This method has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='method-getNodes' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-method-getNodes' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-getNodes' class='name expandable'>getNodes</a>( <span class='pre'></span> )<strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>Gets a range nodes. ...</div><div class='long'><p>Gets a range nodes.</p>\n        <div class='signature-box removed'>\n        <p>This method has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='method-getOnItemDisclosure' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-onItemDisclosure' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-getOnItemDisclosure' class='name expandable'>getOnItemDisclosure</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></div><div class='description'><div class='short'>Returns the value of onItemDisclosure. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.List-cfg-onItemDisclosure\" rel=\"Ext.dataview.List-cfg-onItemDisclosure\" class=\"docClass\">onItemDisclosure</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getPadding' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-padding' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getPadding' class='name expandable'>getPadding</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of padding. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-padding\" rel=\"Ext.Component-cfg-padding\" class=\"docClass\">padding</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getParent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Traversable.html#Ext-Component-method-getParent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getParent' class='name expandable'>getParent</a>( <span class='pre'></span> ) : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a></div><div class='description'><div class='short'>Returns the parent of this component, if it has one. ...</div><div class='long'><p>Returns the parent of this component, if it has one.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a></span><div class='sub-desc'><p>The parent of this component.</p>\n</div></li></ul></div></div></div><div id='method-getPinHeaders' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-pinHeaders' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-getPinHeaders' class='name expandable'>getPinHeaders</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of pinHeaders. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.List-cfg-pinHeaders\" rel=\"Ext.dataview.List-cfg-pinHeaders\" class=\"docClass\">pinHeaders</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getPlugins' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-plugins' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getPlugins' class='name expandable'>getPlugins</a>( <span class='pre'></span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a></div><div class='description'><div class='short'>Returns the value of plugins. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-plugins\" rel=\"Ext.Component-cfg-plugins\" class=\"docClass\">plugins</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getPressedCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-pressedCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-getPressedCls' class='name expandable'>getPressedCls</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of pressedCls. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-pressedCls\" rel=\"Ext.dataview.DataView-cfg-pressedCls\" class=\"docClass\">pressedCls</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getPressedDelay' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-pressedDelay' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-getPressedDelay' class='name expandable'>getPressedDelay</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></div><div class='description'><div class='short'>Returns the value of pressedDelay. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-pressedDelay\" rel=\"Ext.dataview.DataView-cfg-pressedDelay\" class=\"docClass\">pressedDelay</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getPreventSelectionOnDisclose' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-preventSelectionOnDisclose' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-getPreventSelectionOnDisclose' class='name expandable'>getPreventSelectionOnDisclose</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of preventSelectionOnDisclose. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.List-cfg-preventSelectionOnDisclose\" rel=\"Ext.dataview.List-cfg-preventSelectionOnDisclose\" class=\"docClass\">preventSelectionOnDisclose</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getRecord' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-record' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getRecord' class='name expandable'>getRecord</a>( <span class='pre'></span> ) : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a></div><div class='description'><div class='short'>Returns the value of record. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-record\" rel=\"Ext.Component-cfg-record\" class=\"docClass\">record</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getRecords' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-method-getRecords' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-getRecords' class='name expandable'>getRecords</a>( <span class='pre'></span> )<strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>Gets an array of the records from an array of nodes. ...</div><div class='long'><p>Gets an array of the records from an array of nodes.</p>\n        <div class='signature-box removed'>\n        <p>This method has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='method-getRenderTo' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-renderTo' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getRenderTo' class='name expandable'>getRenderTo</a>( <span class='pre'></span> ) : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a></div><div class='description'><div class='short'>Returns the value of renderTo. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-renderTo\" rel=\"Ext.Component-cfg-renderTo\" class=\"docClass\">renderTo</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getRenderTpl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-renderTpl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getRenderTpl' class='name expandable'>getRenderTpl</a>( <span class='pre'></span> ) : Mixed</div><div class='description'><div class='short'>Returns the value of renderTpl. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-renderTpl\" rel=\"Ext.Component-cfg-renderTpl\" class=\"docClass\">renderTpl</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Mixed</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getRight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-right' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getRight' class='name expandable'>getRight</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of right. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-right\" rel=\"Ext.Component-cfg-right\" class=\"docClass\">right</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getScrollToTopOnRefresh' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-scrollToTopOnRefresh' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-getScrollToTopOnRefresh' class='name expandable'>getScrollToTopOnRefresh</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of scrollToTopOnRefresh. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-scrollToTopOnRefresh\" rel=\"Ext.dataview.DataView-cfg-scrollToTopOnRefresh\" class=\"docClass\">scrollToTopOnRefresh</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getScrollable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-getScrollable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-getScrollable' class='name expandable'>getScrollable</a>( <span class='pre'></span> ) : <a href=\"#!/api/Ext.scroll.View\" rel=\"Ext.scroll.View\" class=\"docClass\">Ext.scroll.View</a></div><div class='description'><div class='short'>Returns an the scrollable instance for this container, which is a Ext.scroll.View class. ...</div><div class='long'><p>Returns an the scrollable instance for this container, which is a <a href=\"#!/api/Ext.scroll.View\" rel=\"Ext.scroll.View\" class=\"docClass\">Ext.scroll.View</a> class.</p>\n\n<p>Please checkout the documentation for <a href=\"#!/api/Ext.scroll.View\" rel=\"Ext.scroll.View\" class=\"docClass\">Ext.scroll.View</a>, <a href=\"#!/api/Ext.scroll.View-method-getScroller\" rel=\"Ext.scroll.View-method-getScroller\" class=\"docClass\">Ext.scroll.View.getScroller</a>\nand <a href=\"#!/api/Ext.scroll.Scroller\" rel=\"Ext.scroll.Scroller\" class=\"docClass\">Ext.scroll.Scroller</a> for more information.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.scroll.View\" rel=\"Ext.scroll.View\" class=\"docClass\">Ext.scroll.View</a></span><div class='sub-desc'><p>The scroll view</p>\n</div></li></ul></div></div></div><div id='method-getScrollableBehavior' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-getScrollableBehavior' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-getScrollableBehavior' class='name expandable'>getScrollableBehavior</a>( <span class='pre'></span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-getSelectedCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-selectedCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-getSelectedCls' class='name expandable'>getSelectedCls</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of selectedCls. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-selectedCls\" rel=\"Ext.dataview.DataView-cfg-selectedCls\" class=\"docClass\">selectedCls</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getSelectedNodes' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-method-getSelectedNodes' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-getSelectedNodes' class='name expandable'>getSelectedNodes</a>( <span class='pre'></span> )<strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>Gets the currently selected nodes. ...</div><div class='long'><p>Gets the currently selected nodes.</p>\n        <div class='signature-box removed'>\n        <p>This method has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='method-getSelectedRecords' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-method-getSelectedRecords' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-getSelectedRecords' class='name expandable'>getSelectedRecords</a>( <span class='pre'></span> )<strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>Gets an array of the selected records. ...</div><div class='long'><p>Gets an array of the selected records.</p>\n        <div class='signature-box removed'>\n        <p>This method has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='method-getSelection' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-getSelection' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-getSelection' class='name expandable'>getSelection</a>( <span class='pre'></span> ) : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a></div><div class='description'><div class='short'>Returns an array of the currently selected records. ...</div><div class='long'><p>Returns an array of the currently selected records.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a></span><div class='sub-desc'><p>An array of selected records</p>\n</div></li></ul></div></div></div><div id='method-getSelectionCount' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-getSelectionCount' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-getSelectionCount' class='name expandable'>getSelectionCount</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></div><div class='description'><div class='short'>Returns the number of selections. ...</div><div class='long'><p>Returns the number of selections.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getSelectionMode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-getSelectionMode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-getSelectionMode' class='name expandable'>getSelectionMode</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Returns the selection mode currently used by this Selectable ...</div><div class='long'><p>Returns the selection mode currently used by this Selectable</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.mixin.Selectable-method-getMode\" rel=\"Ext.mixin.Selectable-method-getMode\" class=\"docClass\">getMode</a> instead.</p>\n\n        </div>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'><p>The current mode</p>\n</div></li></ul></div></div></div><div id='method-getShowAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-showAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getShowAnimation' class='name expandable'>getShowAnimation</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</div><div class='description'><div class='short'>Returns the value of showAnimation. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-showAnimation\" rel=\"Ext.Component-cfg-showAnimation\" class=\"docClass\">showAnimation</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getSize' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-getSize' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getSize' class='name expandable'>getSize</a>( <span class='pre'></span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></div><div class='description'><div class='short'>Returns the height and width of the Component ...</div><div class='long'><p>Returns the height and width of the Component</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'><p>The current height and width of the Component</p>\n</div></li></ul></div></div></div><div id='method-getStore' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-store' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-getStore' class='name expandable'>getStore</a>( <span class='pre'></span> ) : <a href=\"#!/api/Ext.data.Store\" rel=\"Ext.data.Store\" class=\"docClass\">Ext.data.Store</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></div><div class='description'><div class='short'>Returns the value of store. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-store\" rel=\"Ext.dataview.DataView-cfg-store\" class=\"docClass\">store</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.data.Store\" rel=\"Ext.data.Store\" class=\"docClass\">Ext.data.Store</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getStyle' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-style' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getStyle' class='name expandable'>getStyle</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></div><div class='description'><div class='short'>Returns the value of style. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-style\" rel=\"Ext.Component-cfg-style\" class=\"docClass\">style</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getStyleHtmlCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-styleHtmlCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getStyleHtmlCls' class='name expandable'>getStyleHtmlCls</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of styleHtmlCls. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-styleHtmlCls\" rel=\"Ext.Component-cfg-styleHtmlCls\" class=\"docClass\">styleHtmlCls</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getStyleHtmlContent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-styleHtmlContent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getStyleHtmlContent' class='name expandable'>getStyleHtmlContent</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of styleHtmlContent. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-styleHtmlContent\" rel=\"Ext.Component-cfg-styleHtmlContent\" class=\"docClass\">styleHtmlContent</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getTop' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-top' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getTop' class='name expandable'>getTop</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of top. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-top\" rel=\"Ext.Component-cfg-top\" class=\"docClass\">top</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getTpl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-tpl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getTpl' class='name expandable'>getTpl</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]/<a href=\"#!/api/Ext.Template\" rel=\"Ext.Template\" class=\"docClass\">Ext.Template</a>[]/<a href=\"#!/api/Ext.XTemplate\" rel=\"Ext.XTemplate\" class=\"docClass\">Ext.XTemplate</a>[]</div><div class='description'><div class='short'>Returns the value of tpl. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-tpl\" rel=\"Ext.Component-cfg-tpl\" class=\"docClass\">tpl</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]/<a href=\"#!/api/Ext.Template\" rel=\"Ext.Template\" class=\"docClass\">Ext.Template</a>[]/<a href=\"#!/api/Ext.XTemplate\" rel=\"Ext.XTemplate\" class=\"docClass\">Ext.XTemplate</a>[]</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getTplWriteMode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-tplWriteMode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getTplWriteMode' class='name expandable'>getTplWriteMode</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of tplWriteMode. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-tplWriteMode\" rel=\"Ext.Component-cfg-tplWriteMode\" class=\"docClass\">tplWriteMode</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getTranslatable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-translatable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getTranslatable' class='name expandable'>getTranslatable</a>( <span class='pre'></span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><strong class='private signature'>private</strong></div><div class='description'><div class='short'>Returns the value of translatable. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">translatable</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getTriggerCtEvent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-triggerCtEvent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-getTriggerCtEvent' class='name expandable'>getTriggerCtEvent</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of triggerCtEvent. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-triggerCtEvent\" rel=\"Ext.dataview.DataView-cfg-triggerCtEvent\" class=\"docClass\">triggerCtEvent</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getTriggerEvent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-triggerEvent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-getTriggerEvent' class='name expandable'>getTriggerEvent</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of triggerEvent. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-triggerEvent\" rel=\"Ext.dataview.DataView-cfg-triggerEvent\" class=\"docClass\">triggerEvent</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getUseComponents' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-useComponents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-getUseComponents' class='name expandable'>getUseComponents</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><strong class='private signature'>private</strong></div><div class='description'><div class='short'>Returns the value of useComponents. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">useComponents</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul><p>Overrides: <a href='#!/api/Ext.dataview.DataView-method-getUseComponents' rel='Ext.dataview.DataView-method-getUseComponents' class='docClass'>Ext.dataview.DataView.getUseComponents</a></p></div></div></div><div id='method-getWidth' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-width' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getWidth' class='name expandable'>getWidth</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of width. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-width\" rel=\"Ext.Component-cfg-width\" class=\"docClass\">width</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getXTypes' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-getXTypes' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getXTypes' class='name expandable'>getXTypes</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns this Component's xtype hierarchy as a slash-delimited string. ...</div><div class='long'><p>Returns this Component's xtype hierarchy as a slash-delimited string. For a list of all\navailable xtypes, see the <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> header.</p>\n\n\n<p><b>If using your own subclasses, be aware that a Component must register its own xtype\nto participate in determination of inherited xtypes.</b></p>\n\n\n<p>Example usage:</p>\n\n\n<pre><code>var t = new <a href=\"#!/api/Ext.field.Text\" rel=\"Ext.field.Text\" class=\"docClass\">Ext.field.Text</a>();\nalert(t.getXTypes());  // alerts 'component/field/textfield'\n</code></pre>\n\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'><p>The xtype hierarchy string</p>\n</div></li></ul></div></div></div><div id='method-getZIndex' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-zIndex' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getZIndex' class='name expandable'>getZIndex</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></div><div class='description'><div class='short'>Returns the value of zIndex. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-zIndex\" rel=\"Ext.Component-cfg-zIndex\" class=\"docClass\">zIndex</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-handleException' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-method-handleException' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-handleException' class='name expandable'>handleException</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Method called when the Store's Reader throws an exception ...</div><div class='long'><p>Method called when the Store's Reader throws an exception</p>\n</div></div></div><div id='method-has' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-has' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-has' class='name expandable'>has</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-hasConfig' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-hasConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-hasConfig' class='name expandable'>hasConfig</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> name</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-hasInnerItem' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-hasInnerItem' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-hasInnerItem' class='name expandable'>hasInnerItem</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-hasListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-hasListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-hasListener' class='name expandable'>hasListener</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName</span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Checks to see if this object has any listeners for a specified event ...</div><div class='long'><p>Checks to see if this object has any listeners for a specified event</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event to check for</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'><p>True if the event is being listened for, else false</p>\n</div></li></ul></div></div></div><div id='method-hasParent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Traversable.html#Ext-Component-method-hasParent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-hasParent' class='name expandable'>hasParent</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns true if this component has a parent. ...</div><div class='long'><p>Returns <code>true</code> if this component has a parent.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'><p><code>true</code> if this component has a parent.</p>\n</div></li></ul></div></div></div><div id='method-hasSelection' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-hasSelection' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-hasSelection' class='name expandable'>hasSelection</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns true if there is a selected record. ...</div><div class='long'><p>Returns true if there is a selected record.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-hide' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-hide' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-hide' class='name expandable'>hide</a>( <span class='pre'>[<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> animation]</span> )</div><div class='description'><div class='short'>Hides this Component ...</div><div class='long'><p>Hides this Component</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>animation</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> (optional)<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-indexOf' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-method-indexOf' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-indexOf' class='name expandable'>indexOf</a>( <span class='pre'></span> )<strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>Finds the index of the passed node. ...</div><div class='long'><p>Finds the index of the passed node.</p>\n        <div class='signature-box removed'>\n        <p>This method has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n<p>Overrides: <a href='#!/api/Ext.Container-method-indexOf' rel='Ext.Container-method-indexOf' class='docClass'>Ext.Container.indexOf</a></p></div></div></div><div id='method-initConfig' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-initConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-initConfig' class='name expandable'>initConfig</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> instanceConfig</span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><strong class='protected signature'>protected</strong></div><div class='description'><div class='short'>Initialize configuration for this class. ...</div><div class='long'><p>Initialize configuration for this class. a typical example:</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.awesome.Class', {\n    // The default config\n    config: {\n        name: 'Awesome',\n        isAwesome: true\n    },\n\n    constructor: function(config) {\n        this.initConfig(config);\n    }\n});\n\nvar awesome = new My.awesome.Class({\n    name: 'Super Awesome'\n});\n\nalert(awesome.getName()); // 'Super Awesome'\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>instanceConfig</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'><p>mixins The mixin prototypes as key - value pairs</p>\n</div></li></ul></div></div></div><div id='method-initialize' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-initialize' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-initialize' class='name expandable'>initialize</a>( <span class='pre'></span> )<strong class='protected signature'>protected</strong><strong class='template signature'>template</strong></div><div class='description'><div class='short'>Allows addition of behavior to the rendering phase. ...</div><div class='long'><p>Allows addition of behavior to the rendering phase.</p>\n      <div class='signature-box template'>\n      <p>This is a <a href=\"#!/guide/components\">template method</a>.\n         a hook into the functionality of this class.\n         Feel free to override it in child classes.</p>\n      </div>\n</div></div></div><div id='method-insert' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-insert' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-insert' class='name expandable'>insert</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> index, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item</span> )</div><div class='description'><div class='short'>Adds a child Component at the given index. ...</div><div class='long'><p>Adds a child Component at the given index. For example, here's how we can add a new item, making it the first\nchild Component of this Container:</p>\n\n<pre><code>myContainer.insert(0, {xtype: 'panel', html: 'new item'});\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>index</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The index to insert the Component at</p>\n</div></li><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The Component to insert</p>\n</div></li></ul></div></div></div><div id='method-insertAfter' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-insertAfter' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-insertAfter' class='name expandable'>insertAfter</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> relativeToItem</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>relativeToItem</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-insertBefore' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-insertBefore' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-insertBefore' class='name expandable'>insertBefore</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> relativeToItem</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>relativeToItem</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-insertFirst' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-insertFirst' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-insertFirst' class='name expandable'>insertFirst</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-insertInner' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-insertInner' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-insertInner' class='name expandable'>insertInner</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> index</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>index</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-insertLast' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-insertLast' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-insertLast' class='name expandable'>insertLast</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-isDisabled' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-isDisabled' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-isDisabled' class='name expandable'>isDisabled</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns true if this Component is currently disabled ...</div><div class='long'><p>Returns true if this Component is currently disabled</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'><p>True if currently disabled</p>\n</div></li></ul></div></div></div><div id='method-isHidden' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-isHidden' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-isHidden' class='name expandable'>isHidden</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns true if this Component is currently hidden ...</div><div class='long'><p>Returns true if this Component is currently hidden</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'><p>True if currently hidden</p>\n</div></li></ul></div></div></div><div id='method-isLocked' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-isLocked' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-isLocked' class='name expandable'>isLocked</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Returns true if the Selectable is currently locked ...</div><div class='long'><p>Returns true if the Selectable is currently locked</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.mixin.Selectable-method-getDisableSelection\" rel=\"Ext.mixin.Selectable-method-getDisableSelection\" class=\"docClass\">getDisableSelection</a> instead.</p>\n\n        </div>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'><p>True if currently locked</p>\n</div></li></ul></div></div></div><div id='method-isPainted' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-isPainted' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-isPainted' class='name expandable'>isPainted</a>( <span class='pre'></span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-isRendered' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-isRendered' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-isRendered' class='name expandable'>isRendered</a>( <span class='pre'></span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-isSelected' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-isSelected' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-isSelected' class='name expandable'>isSelected</a>( <span class='pre'><a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> record</span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns true if the specified row is selected. ...</div><div class='long'><p>Returns <tt>true</tt> if the specified row is selected.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>record</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The record or index of the record to check</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-isXType' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-isXType' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-isXType' class='name expandable'>isXType</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> xtype, [<a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> shallow]</span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Tests whether or not this Component is of a specific xtype. ...</div><div class='long'><p>Tests whether or not this Component is of a specific xtype. This can test whether this Component is descended\nfrom the xtype (default) or whether it is directly of the xtype specified (shallow = true).</p>\n\n\n<p><b>If using your own subclasses, be aware that a Component must register its own xtype\nto participate in determination of inherited xtypes.</b></p>\n\n\n<p>For a list of all available xtypes, see the <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> header.</p>\n\n\n<p>Example usage:</p>\n\n\n<pre><code>var t = new <a href=\"#!/api/Ext.field.Text\" rel=\"Ext.field.Text\" class=\"docClass\">Ext.field.Text</a>();\nvar isText = t.isXType('textfield');        // true\nvar isBoxSubclass = t.isXType('field');       // true, descended from <a href=\"#!/api/Ext.field.Field\" rel=\"Ext.field.Field\" class=\"docClass\">Ext.field.Field</a>\nvar isBoxInstance = t.isXType('field', true); // false, not a direct <a href=\"#!/api/Ext.field.Field\" rel=\"Ext.field.Field\" class=\"docClass\">Ext.field.Field</a> instance\n</code></pre>\n\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>xtype</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The xtype to check for this Component</p>\n</div></li><li><span class='pre'>shallow</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> (optional)<div class='sub-desc'><p>False to check whether this Component is descended from the xtype (this is\nthe default), or true to check whether this Component is directly of the specified xtype.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'><p>True if this component descends from the specified xtype, false otherwise.</p>\n</div></li></ul></div></div></div><div id='method-mask' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-mask' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-mask' class='name expandable'>mask</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> mask</span> )</div><div class='description'><div class='short'>Convience method which calls setMasked with a value of true (to show the mask). ...</div><div class='long'><p>Convience method which calls <a href=\"#!/api/Ext.Container-method-setMasked\" rel=\"Ext.Container-method-setMasked\" class=\"docClass\">setMasked</a> with a value of true (to show the mask). For additional\nfunctionality, call the <a href=\"#!/api/Ext.Container-method-setMasked\" rel=\"Ext.Container-method-setMasked\" class=\"docClass\">setMasked</a> function direction (See the <a href=\"#!/api/Ext.Container-cfg-masked\" rel=\"Ext.Container-cfg-masked\" class=\"docClass\">masked</a> configuration documention\nfor more information).</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>mask</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-mon' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-mon' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-mon' class='name expandable'>mon</a>( <span class='pre'><a href=\"#!/api/Ext.mixin.Observable\" rel=\"Ext.mixin.Observable\" class=\"docClass\">Ext.mixin.Observable</a>/HTMLElement object, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, [<a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Alias for addManagedListener. ...</div><div class='long'><p>Alias for <a href=\"#!/api/Ext.mixin.Observable-method-addManagedListener\" rel=\"Ext.mixin.Observable-method-addManagedListener\" class=\"docClass\">addManagedListener</a>.</p>\n\n<p>Adds listeners to any Observable object (or Element) which are automatically removed when this Component\nis destroyed.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>This is now done automatically</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>object</span> : <a href=\"#!/api/Ext.mixin.Observable\" rel=\"Ext.mixin.Observable\" class=\"docClass\">Ext.mixin.Observable</a>/HTMLElement<div class='sub-desc'><p>The item to which to add a listener/listeners.</p>\n\n</div></li><li><span class='pre'>eventName</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The event name, or an object containing event name properties.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the handler function.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the scope in which\nthe handler function is executed.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the\n<a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> options.</p>\n\n</div></li></ul></div></div></div><div id='method-mun' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-mun' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-mun' class='name expandable'>mun</a>( <span class='pre'><a href=\"#!/api/Ext.mixin.Observable\" rel=\"Ext.mixin.Observable\" class=\"docClass\">Ext.mixin.Observable</a>/HTMLElement object, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, [<a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope]</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Alias for removeManagedListener. ...</div><div class='long'><p>Alias for <a href=\"#!/api/Ext.mixin.Observable-method-removeManagedListener\" rel=\"Ext.mixin.Observable-method-removeManagedListener\" class=\"docClass\">removeManagedListener</a>.</p>\n\n<p>Adds listeners to any Observable object (or Element) which are automatically removed when this Component\nis destroyed.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>This is now done automatically</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>object</span> : <a href=\"#!/api/Ext.mixin.Observable\" rel=\"Ext.mixin.Observable\" class=\"docClass\">Ext.mixin.Observable</a>/HTMLElement<div class='sub-desc'><p>The item to which to add a listener/listeners.</p>\n\n</div></li><li><span class='pre'>eventName</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The event name, or an object containing event name properties.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the handler function.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the scope in which\nthe handler function is executed.</p>\n\n</div></li></ul></div></div></div><div id='method-on' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-on' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-on' class='name expandable'>on</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options], [<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> order]</span> )</div><div class='description'><div class='short'>Alias for addListener. ...</div><div class='long'><p>Alias for <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a>.</p>\n\n<p>Appends an event handler to this object. You can review the available handlers by looking at the 'events'\nsection of the documentation for the component you are working with.</p>\n\n<h2>Combining Options</h2>\n\n<p>Using the options argument, it is possible to combine different types of listeners:</p>\n\n<p>A delayed, one-time listener:</p>\n\n<pre><code>container.on('tap', this.handleTap, this, {\n    single: true,\n    delay: 100\n});\n</code></pre>\n\n<h2>Attaching multiple handlers in 1 call</h2>\n\n<p>The method also allows for a single argument to be passed which is a config object containing properties which\nspecify multiple events. For example:</p>\n\n<pre><code>container.on({\n    tap  : this.onTap,\n    swipe: this.onSwipe,\n\n    scope: this // Important. Ensure \"this\" is correct during handler execution\n});\n</code></pre>\n\n<p>One can also specify options for each event handler separately:</p>\n\n<pre><code>container.on({\n    tap  : { fn: this.onTap, scope: this, single: true },\n    swipe: { fn: button.onSwipe, scope: button }\n});\n</code></pre>\n\n<p>See the <a href=\"#!/guide/events\">Events Guide</a> for more.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event to listen for. May also be an object who's property names are\nevent names.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The method the event invokes.  Will be called with arguments given to\n<a href=\"#!/api/Ext.mixin.Observable-method-fireEvent\" rel=\"Ext.mixin.Observable-method-fireEvent\" class=\"docClass\">fireEvent</a> plus the <code>options</code> parameter described below.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope (<code>this</code> reference) in which the handler function is executed. <strong>If\nomitted, defaults to the object which fired the event.</strong></p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>An object containing handler configuration.</p>\n\n\n\n\n<p>This object may contain any of the following properties:</p>\n\n\n\n\n<ul>\n<li><p><strong>scope</strong> : Object</p>\n\n<p>The scope (<code>this</code> reference) in which the handler function is executed. <strong>If omitted, defaults to the object\nwhich fired the event.</strong></p></li>\n<li><p><strong>delay</strong> : Number</p>\n\n<p>The number of milliseconds to delay the invocation of the handler after the event fires.</p></li>\n<li><p><strong>single</strong> : Boolean</p>\n\n<p>True to add a handler to handle just the next firing of the event, and then remove itself.</p></li>\n<li><p><strong>order</strong> : String</p>\n\n<p>The order of when the listener should be added into the listener queue.</p>\n\n<p>If you set an order of <code>before</code> and the event you are listening to is preventable, you can return <code>false</code> and it will stop the event.</p>\n\n<p>Available options are <code>before</code>, <code>current</code> and <code>after</code>. Defaults to <code>current</code>.</p></li>\n<li><p><strong>buffer</strong> : Number</p>\n\n<p>Causes the handler to be delayed by the specified number of milliseconds. If the event fires again within that\ntime, the original handler is <em>not</em> invoked, but the new handler is scheduled in its place.</p></li>\n<li><p><strong>element</strong> : String</p>\n\n<p>Allows you to add a listener onto a element of this component using the elements reference.</p>\n\n<pre><code><a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a>', {\n    listeners: {\n        element: 'element',\n        tap: function() {\n            console.log('element tap!');\n        }\n    }\n});\n</code></pre>\n\n<p>All components have the <code>element</code> reference, which is the outer most element of the component. <a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a> also has the\n<code>innerElement</code> element which contains all children. In most cases <code>element</code> is adequate.</p></li>\n<li><p><strong>delegate</strong> : String</p>\n\n<p>Uses <a href=\"#!/api/Ext.ComponentQuery\" rel=\"Ext.ComponentQuery\" class=\"docClass\">Ext.ComponentQuery</a> to delegate events to a specified query selector within this item.</p>\n\n<pre><code>// Create a container with a two children; a button and a toolbar\nvar container = <a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a>', {\n    items: [\n        {\n           xtype: 'toolbar',\n           docked: 'top',\n           title: 'My Toolbar'\n        },\n        {\n           xtype: 'button',\n           text: 'My Button'\n        }\n    ]\n});\n\ncontainer.on({\n    // Ext.Buttons have an xtype of 'button', so we use that are a selector for our delegate\n    delegate: 'button',\n\n    tap: function() {\n        alert('Button tapped!');\n    }\n});\n</code></pre></li>\n</ul>\n\n\n\n</div></li><li><span class='pre'>order</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> (optional)<div class='sub-desc'><p>The order of when the listener should be added into the listener queue.\nPossible values are <code>before</code>, <code>current</code> and <code>after</code>.</p>\n\n<p>Defaults to: <code>&quot;current&quot;</code></p></div></li></ul></div></div></div><div id='method-onAfter' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-onAfter' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-onAfter' class='name expandable'>onAfter</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )</div><div class='description'><div class='short'>Alias for addAfterListener. ...</div><div class='long'><p>Alias for <a href=\"#!/api/Ext.mixin.Observable-method-addAfterListener\" rel=\"Ext.mixin.Observable-method-addAfterListener\" class=\"docClass\">addAfterListener</a>.</p>\n\n<p>Appends an after-event handler.</p>\n\n<p>Same as <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> with <code>order</code> set to <code>'after'</code>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event to listen for.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The method the event invokes.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope for <code>fn</code>.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>An object containing handler configuration.</p>\n\n</div></li></ul></div></div></div><div id='method-onBefore' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-onBefore' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-onBefore' class='name expandable'>onBefore</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )</div><div class='description'><div class='short'>Alias for addBeforeListener. ...</div><div class='long'><p>Alias for <a href=\"#!/api/Ext.mixin.Observable-method-addBeforeListener\" rel=\"Ext.mixin.Observable-method-addBeforeListener\" class=\"docClass\">addBeforeListener</a>.</p>\n\n<p>Appends a before-event handler.  Returning <code>false</code> from the handler will stop the event.</p>\n\n<p>Same as <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> with <code>order</code> set to <code>'before'</code>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event to listen for.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The method the event invokes.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope for <code>fn</code>.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>An object containing handler configuration.</p>\n\n</div></li></ul></div></div></div><div id='method-onConfigUpdate' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-onConfigUpdate' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-onConfigUpdate' class='name expandable'>onConfigUpdate</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> names, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> callback, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>names</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>callback</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-onFirstItemAdd' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-onFirstItemAdd' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-onFirstItemAdd' class='name expandable'>onFirstItemAdd</a>( <span class='pre'></span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Initialize layout and event listeners the very first time an item is added ...</div><div class='long'><p>Initialize layout and event listeners the very first time an item is added</p>\n</div></div></div><div id='method-onInitialized' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-onInitialized' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-onInitialized' class='name expandable'>onInitialized</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> fn, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>fn</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-onItemAdd' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-onItemAdd' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-onItemAdd' class='name expandable'>onItemAdd</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> index</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>index</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-onItemCenteredChange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-onItemCenteredChange' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-onItemCenteredChange' class='name expandable'>onItemCenteredChange</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> centered</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>centered</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-onItemDockedChange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-onItemDockedChange' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-onItemDockedChange' class='name expandable'>onItemDockedChange</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> docked, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> oldDocked</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>docked</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>oldDocked</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-onItemFloatingChange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-onItemFloatingChange' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-onItemFloatingChange' class='name expandable'>onItemFloatingChange</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> floating</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>floating</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-onItemMove' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-onItemMove' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-onItemMove' class='name expandable'>onItemMove</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> toIndex, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> fromIndex</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>toIndex</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>fromIndex</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-onItemRemove' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-onItemRemove' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-onItemRemove' class='name expandable'>onItemRemove</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> index</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>index</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-onShowByErased' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-onShowByErased' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-onShowByErased' class='name expandable'>onShowByErased</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> component</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>component</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-prepareData' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-method-prepareData' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-prepareData' class='name expandable'>prepareData</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>[] data, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> recordIndex, <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a> record</span> ) : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></div><div class='description'><div class='short'>Function which can be overridden to provide custom formatting for each Record that is used by this\nDataView's templat...</div><div class='long'><p>Function which can be overridden to provide custom formatting for each Record that is used by this\nDataView's <a href=\"#!/api/Ext.dataview.DataView-cfg-tpl\" rel=\"Ext.dataview.DataView-cfg-tpl\" class=\"docClass\">template</a> to render each node.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>data</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>[]<div class='sub-desc'><p>The raw data object that was used to create the Record.</p>\n</div></li><li><span class='pre'>recordIndex</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>the index number of the Record being prepared for rendering.</p>\n</div></li><li><span class='pre'>record</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a><div class='sub-desc'><p>The Record being prepared for rendering.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'><p>The formatted data in a format expected by the internal <a href=\"#!/api/Ext.dataview.DataView-cfg-tpl\" rel=\"Ext.dataview.DataView-cfg-tpl\" class=\"docClass\">template</a>'s overwrite() method.\n(either an array if your params are numeric (i.e. {0}) or an object (i.e. {foo: 'bar'}))</p>\n</div></li></ul></div></div></div><div id='method-query' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-query' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-query' class='name expandable'>query</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> selector</span> ) : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a></div><div class='description'><div class='short'>Retrieves all descendant components which match the passed selector. ...</div><div class='long'><p>Retrieves all descendant components which match the passed selector.\nExecutes an <a href=\"#!/api/Ext.ComponentQuery-method-query\" rel=\"Ext.ComponentQuery-method-query\" class=\"docClass\">Ext.ComponentQuery.query</a> using this container as its root.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>selector</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>Selector complying to an <a href=\"#!/api/Ext.ComponentQuery\" rel=\"Ext.ComponentQuery\" class=\"docClass\">Ext.ComponentQuery</a> selector</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a></span><div class='sub-desc'><p><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a>'s which matched the selector</p>\n</div></li></ul></div></div></div><div id='method-refresh' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-method-refresh' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-refresh' class='name expandable'>refresh</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Refreshes the view by reloading the data from the store and re-rendering the template. ...</div><div class='long'><p>Refreshes the view by reloading the data from the store and re-rendering the template.</p>\n</div></div></div><div id='method-refreshNode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-method-refreshNode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-refreshNode' class='name expandable'>refreshNode</a>( <span class='pre'></span> )<strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>Refreshes an individual node's data from the store. ...</div><div class='long'><p>Refreshes an individual node's data from the store.</p>\n        <div class='signature-box removed'>\n        <p>This method has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='method-refreshSelection' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-refreshSelection' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-refreshSelection' class='name expandable'>refreshSelection</a>( <span class='pre'></span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-relayEvent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-relayEvent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-relayEvent' class='name expandable'>relayEvent</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> args, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> fn</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>args</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-relayEvents' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-relayEvents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-relayEvents' class='name expandable'>relayEvents</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> object, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> events</span> )</div><div class='description'><div class='short'>Relays selected events from the specified Observable as if the events were fired by this. ...</div><div class='long'><p>Relays selected events from the specified Observable as if the events were fired by <code><b>this</b></code>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>object</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The Observable whose events this object is to relay.</p>\n</div></li><li><span class='pre'>events</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>Array of event names to relay.</p>\n</div></li></ul></div></div></div><div id='method-remove' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-remove' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-remove' class='name expandable'>remove</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> destroy</span> ) : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a></div><div class='description'><div class='short'>Removes an item from this Container, optionally destroying it ...</div><div class='long'><p>Removes an item from this Container, optionally destroying it</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The item to remove</p>\n</div></li><li><span class='pre'>destroy</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>Calls the Component's <a href=\"#!/api/Ext.Component-method-destroy\" rel=\"Ext.Component-method-destroy\" class=\"docClass\">destroy</a> method if true</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a></span><div class='sub-desc'><p>this</p>\n</div></li></ul></div></div></div><div id='method-removeAfterListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-removeAfterListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-removeAfterListener' class='name expandable'>removeAfterListener</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )</div><div class='description'><div class='short'>Removes a before-event handler. ...</div><div class='long'><p>Removes a before-event handler.</p>\n\n<p>Same as <a href=\"#!/api/Ext.mixin.Observable-method-removeListener\" rel=\"Ext.mixin.Observable-method-removeListener\" class=\"docClass\">removeListener</a> with <code>order</code> set to <code>'after'</code>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event the handler was associated with.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The handler to remove.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope originally specified for <code>fn</code>.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>Extra options object.</p>\n\n</div></li></ul></div></div></div><div id='method-removeAll' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-removeAll' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-removeAll' class='name expandable'>removeAll</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> destroy, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> everything</span> ) : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a></div><div class='description'><div class='short'>Removes all items currently in the Container, optionally destroying them all ...</div><div class='long'><p>Removes all items currently in the Container, optionally destroying them all</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>destroy</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>If true, <a href=\"#!/api/Ext.Component-method-destroy\" rel=\"Ext.Component-method-destroy\" class=\"docClass\">destroys</a> each removed Component</p>\n</div></li><li><span class='pre'>everything</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>If true, completely remove all items including docked / centered and floating items</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a></span><div class='sub-desc'><p>this</p>\n</div></li></ul></div></div></div><div id='method-removeAt' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-removeAt' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-removeAt' class='name expandable'>removeAt</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> index</span> )</div><div class='description'><div class='short'>Removes the Component at the specified index:\n\nmyContainer.removeAt(0); //removes the first item ...</div><div class='long'><p>Removes the Component at the specified index:</p>\n\n<pre><code>myContainer.removeAt(0); //removes the first item\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>index</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The index of the Component to remove</p>\n</div></li></ul></div></div></div><div id='method-removeBeforeListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-removeBeforeListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-removeBeforeListener' class='name expandable'>removeBeforeListener</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )</div><div class='description'><div class='short'>Removes a before-event handler. ...</div><div class='long'><p>Removes a before-event handler.</p>\n\n<p>Same as <a href=\"#!/api/Ext.mixin.Observable-method-removeListener\" rel=\"Ext.mixin.Observable-method-removeListener\" class=\"docClass\">removeListener</a> with <code>order</code> set to <code>'before'</code>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event the handler was associated with.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The handler to remove.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope originally specified for <code>fn</code>.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>Extra options object.</p>\n\n</div></li></ul></div></div></div><div id='method-removeCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-removeCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-removeCls' class='name expandable'>removeCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> cls, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> prefix, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> suffix</span> )</div><div class='description'><div class='short'>Removes the given CSS class(es) from this Component's rendered element ...</div><div class='long'><p>Removes the given CSS class(es) from this Component's rendered element</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>cls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The class(es) to remove</p>\n</div></li><li><span class='pre'>prefix</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>Optional prefix to prepend before each class</p>\n</div></li><li><span class='pre'>suffix</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>Optional suffix to append to each class</p>\n</div></li></ul></div></div></div><div id='method-removeDocked' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-removeDocked' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-removeDocked' class='name expandable'>removeDocked</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> destroy</span> ) : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Removes a docked item from this Container. ...</div><div class='long'><p>Removes a docked item from this Container.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.Container-method-remove\" rel=\"Ext.Container-method-remove\" class=\"docClass\">remove</a> instead.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The item to remove</p>\n</div></li><li><span class='pre'>destroy</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>Calls the Component's <a href=\"#!/api/Ext.Component-method-destroy\" rel=\"Ext.Component-method-destroy\" class=\"docClass\">destroy</a> method if true</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a></span><div class='sub-desc'><p>this</p>\n</div></li></ul></div></div></div><div id='method-removeInner' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-removeInner' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-removeInner' class='name expandable'>removeInner</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-removeInnerAt' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-removeInnerAt' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-removeInnerAt' class='name expandable'>removeInnerAt</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> index</span> )</div><div class='description'><div class='short'>Removes an inner Component at the specified index:\n\nmyContainer.removeInnerAt(0); //removes the first item of the inn...</div><div class='long'><p>Removes an inner Component at the specified index:</p>\n\n<pre><code>myContainer.removeInnerAt(0); //removes the first item of the innerItems propety\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>index</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The index of the Component to remove</p>\n</div></li></ul></div></div></div><div id='method-removeListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-removeListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-removeListener' class='name expandable'>removeListener</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options], [<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> order]</span> )</div><div class='description'><div class='short'>Removes an event handler. ...</div><div class='long'><p>Removes an event handler.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The type of event the handler was associated with.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The handler to remove. <strong>This must be a reference to the function passed into the\n<a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> call.</strong></p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope originally specified for the handler. It must be the same as the\nscope argument specified in the original call to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> or the listener will not be removed.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>Extra options object. See <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> for details.</p>\n\n</div></li><li><span class='pre'>order</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> (optional)<div class='sub-desc'><p>The order of the listener to remove.\nPossible values are <code>before</code>, <code>current</code> and <code>after</code>.</p>\n\n<p>Defaults to: <code>&quot;current&quot;</code></p></div></li></ul></div></div></div><div id='method-removeManagedListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-removeManagedListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-removeManagedListener' class='name expandable'>removeManagedListener</a>( <span class='pre'><a href=\"#!/api/Ext.mixin.Observable\" rel=\"Ext.mixin.Observable\" class=\"docClass\">Ext.mixin.Observable</a>/HTMLElement object, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, [<a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope]</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Adds listeners to any Observable object (or Element) which are automatically removed when this Component\nis destroyed. ...</div><div class='long'><p>Adds listeners to any Observable object (or Element) which are automatically removed when this Component\nis destroyed.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0</p>\n        <p>All listeners are now automatically managed where necessary. Simply use <a href=\"#!/api/Ext.mixin.Observable-method-removeListener\" rel=\"Ext.mixin.Observable-method-removeListener\" class=\"docClass\">removeListener</a>.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>object</span> : <a href=\"#!/api/Ext.mixin.Observable\" rel=\"Ext.mixin.Observable\" class=\"docClass\">Ext.mixin.Observable</a>/HTMLElement<div class='sub-desc'><p>The item to which to add a listener/listeners.</p>\n\n</div></li><li><span class='pre'>eventName</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The event name, or an object containing event name properties.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the handler function.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the scope in which\nthe handler function is executed.</p>\n\n</div></li></ul></div></div></div><div id='method-replaceCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-replaceCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-replaceCls' class='name expandable'>replaceCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldCls, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> newCls, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> prefix, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> suffix</span> )</div><div class='description'><div class='short'>Replaces specified classes with the newly specified classes. ...</div><div class='long'><p>Replaces specified classes with the newly specified classes.\nIt uses the <a href=\"#!/api/Ext.Component-method-addCls\" rel=\"Ext.Component-method-addCls\" class=\"docClass\">addCls</a> and <a href=\"#!/api/Ext.Component-method-removeCls\" rel=\"Ext.Component-method-removeCls\" class=\"docClass\">removeCls</a> methdos, so if the class(es) you are removing don't exist, it will\nstill add the new classes.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>oldCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The class(es) to remove</p>\n</div></li><li><span class='pre'>newCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The class(es) to add</p>\n</div></li><li><span class='pre'>prefix</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>Optional prefix to prepend before each class</p>\n</div></li><li><span class='pre'>suffix</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>Optional suffix to append to each class</p>\n</div></li></ul></div></div></div><div id='method-resetFloating' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-resetFloating' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-resetFloating' class='name expandable'>resetFloating</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Resets top, right, bottom and left configurations to null, which\nwill unfloat this component. ...</div><div class='long'><p>Resets <a href=\"#!/api/Ext.Component-cfg-top\" rel=\"Ext.Component-cfg-top\" class=\"docClass\">top</a>, <a href=\"#!/api/Ext.Component-cfg-right\" rel=\"Ext.Component-cfg-right\" class=\"docClass\">right</a>, <a href=\"#!/api/Ext.Component-cfg-bottom\" rel=\"Ext.Component-cfg-bottom\" class=\"docClass\">bottom</a> and <a href=\"#!/api/Ext.Component-cfg-left\" rel=\"Ext.Component-cfg-left\" class=\"docClass\">left</a> configurations to <code>null</code>, which\nwill unfloat this component.</p>\n</div></div></div><div id='method-resumeEvents' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-resumeEvents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-resumeEvents' class='name expandable'>resumeEvents</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Resumes firing events (see suspendEvents). ...</div><div class='long'><p>Resumes firing events (see <a href=\"#!/api/Ext.mixin.Observable-method-suspendEvents\" rel=\"Ext.mixin.Observable-method-suspendEvents\" class=\"docClass\">suspendEvents</a>).</p>\n\n<p>If events were suspended using the <code>queueSuspended</code> parameter, then all events fired\nduring event suspension will be sent to any listeners now.</p>\n</div></div></div><div id='method-select' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-select' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-select' class='name expandable'>select</a>( <span class='pre'><a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a>/<a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> records, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> keepExisting, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> suppressEvent</span> )</div><div class='description'><div class='short'>Adds the given records to the currently selected set ...</div><div class='long'><p>Adds the given records to the currently selected set</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>records</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a>/<a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The records to select</p>\n</div></li><li><span class='pre'>keepExisting</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>If true, the existing selection will be added to (if not, the old selection is replaced)</p>\n</div></li><li><span class='pre'>suppressEvent</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>If true, the 'select' event will not be fired</p>\n</div></li></ul></div></div></div><div id='method-selectAll' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-selectAll' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-selectAll' class='name expandable'>selectAll</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> silent</span> )</div><div class='description'><div class='short'>Selects all records. ...</div><div class='long'><p>Selects all records.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>silent</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>True to suppress all select events.</p>\n</div></li></ul></div></div></div><div id='method-selectRange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-selectRange' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-selectRange' class='name expandable'>selectRange</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> startRow, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> endRow, [<a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> keepExisting]</span> )</div><div class='description'><div class='short'>Selects a range of rows if the selection model is not locked. ...</div><div class='long'><p>Selects a range of rows if the selection model <a href=\"#!/api/Ext.mixin.Selectable-method-getDisableSelection\" rel=\"Ext.mixin.Selectable-method-getDisableSelection\" class=\"docClass\">is not locked</a>.\nAll rows in between startRow and endRow are also selected.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>startRow</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The index of the first row in the range</p>\n</div></li><li><span class='pre'>endRow</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The index of the last row in the range</p>\n</div></li><li><span class='pre'>keepExisting</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> (optional)<div class='sub-desc'><p>True to retain existing selections</p>\n</div></li></ul></div></div></div><div id='method-setActiveGroup' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-method-setActiveGroup' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-setActiveGroup' class='name expandable'>setActiveGroup</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> group</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Set the current active group ...</div><div class='long'><p>Set the current active group</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>group</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The group to set active</p>\n</div></li></ul></div></div></div><div id='method-setActiveItem' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-activeItem' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-setActiveItem' class='name expandable'>setActiveItem</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> activeItem</span> )</div><div class='description'><div class='short'>Sets the value of activeItem. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Container-cfg-activeItem\" rel=\"Ext.Container-cfg-activeItem\" class=\"docClass\">activeItem</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>activeItem</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setAllowDeselect' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-cfg-allowDeselect' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-setAllowDeselect' class='name expandable'>setAllowDeselect</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> allowDeselect</span> )</div><div class='description'><div class='short'>Sets the value of allowDeselect. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.mixin.Selectable-cfg-allowDeselect\" rel=\"Ext.mixin.Selectable-cfg-allowDeselect\" class=\"docClass\">allowDeselect</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>allowDeselect</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setAutoDestroy' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-autoDestroy' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-setAutoDestroy' class='name expandable'>setAutoDestroy</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> autoDestroy</span> )</div><div class='description'><div class='short'>Sets the value of autoDestroy. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Container-cfg-autoDestroy\" rel=\"Ext.Container-cfg-autoDestroy\" class=\"docClass\">autoDestroy</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>autoDestroy</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setBaseCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-baseCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setBaseCls' class='name expandable'>setBaseCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> baseCls</span> )</div><div class='description'><div class='short'>Sets the value of baseCls. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-baseCls\" rel=\"Ext.Component-cfg-baseCls\" class=\"docClass\">baseCls</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>baseCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setBorder' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-border' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setBorder' class='name expandable'>setBorder</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> border</span> )</div><div class='description'><div class='short'>Sets the value of border. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-border\" rel=\"Ext.Component-cfg-border\" class=\"docClass\">border</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>border</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setBottom' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-bottom' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setBottom' class='name expandable'>setBottom</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> bottom</span> )</div><div class='description'><div class='short'>Sets the value of bottom. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-bottom\" rel=\"Ext.Component-cfg-bottom\" class=\"docClass\">bottom</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>bottom</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setBubbleEvents' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-cfg-bubbleEvents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-setBubbleEvents' class='name expandable'>setBubbleEvents</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[] bubbleEvents</span> )</div><div class='description'><div class='short'>Sets the value of bubbleEvents. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.mixin.Observable-cfg-bubbleEvents\" rel=\"Ext.mixin.Observable-cfg-bubbleEvents\" class=\"docClass\">bubbleEvents</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>bubbleEvents</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setCentered' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-centered' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setCentered' class='name expandable'>setCentered</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> centered</span> )</div><div class='description'><div class='short'>Sets the value of centered. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-centered\" rel=\"Ext.Component-cfg-centered\" class=\"docClass\">centered</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>centered</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-cls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setCls' class='name expandable'>setCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[] cls</span> )</div><div class='description'><div class='short'>Sets the value of cls. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-cls\" rel=\"Ext.Component-cfg-cls\" class=\"docClass\">cls</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>cls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setConfig' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-setConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-setConfig' class='name expandable'>setConfig</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> config, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> applyIfNotSet</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>config</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>applyIfNotSet</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setContentEl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-contentEl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setContentEl' class='name expandable'>setContentEl</a>( <span class='pre'><a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> contentEl</span> )</div><div class='description'><div class='short'>Sets the value of contentEl. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-contentEl\" rel=\"Ext.Component-cfg-contentEl\" class=\"docClass\">contentEl</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>contentEl</span> : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setData' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-data' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setData' class='name expandable'>setData</a>( <span class='pre'>Mixed data</span> )</div><div class='description'><div class='short'>Sets the value of data. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-data\" rel=\"Ext.Component-cfg-data\" class=\"docClass\">data</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>data</span> : Mixed<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setDefaultType' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-defaultType' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-setDefaultType' class='name expandable'>setDefaultType</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> defaultType</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Sets the value of defaultType. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">defaultType</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>defaultType</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul><p>Overrides: <a href='#!/api/Ext.dataview.DataView-method-setDefaultType' rel='Ext.dataview.DataView-method-setDefaultType' class='docClass'>Ext.dataview.DataView.setDefaultType</a></p></div></div></div><div id='method-setDefaults' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-defaults' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-setDefaults' class='name expandable'>setDefaults</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> defaults</span> )</div><div class='description'><div class='short'>Sets the value of defaults. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Container-cfg-defaults\" rel=\"Ext.Container-cfg-defaults\" class=\"docClass\">defaults</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>defaults</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setDeselectOnContainerClick' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-deselectOnContainerClick' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-setDeselectOnContainerClick' class='name expandable'>setDeselectOnContainerClick</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> deselectOnContainerClick</span> )</div><div class='description'><div class='short'>Sets the value of deselectOnContainerClick. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-deselectOnContainerClick\" rel=\"Ext.dataview.DataView-cfg-deselectOnContainerClick\" class=\"docClass\">deselectOnContainerClick</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>deselectOnContainerClick</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul><p>Overrides: <a href='#!/api/Ext.mixin.Selectable-method-setDeselectOnContainerClick' rel='Ext.mixin.Selectable-method-setDeselectOnContainerClick' class='docClass'>Ext.mixin.Selectable.setDeselectOnContainerClick</a></p></div></div></div><div id='method-setDisableSelection' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-cfg-disableSelection' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-setDisableSelection' class='name expandable'>setDisableSelection</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> disableSelection</span> )</div><div class='description'><div class='short'>Sets the value of disableSelection. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.mixin.Selectable-cfg-disableSelection\" rel=\"Ext.mixin.Selectable-cfg-disableSelection\" class=\"docClass\">disableSelection</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>disableSelection</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setDisabled' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-disabled' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setDisabled' class='name expandable'>setDisabled</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> disabled</span> )</div><div class='description'><div class='short'>Sets the value of disabled. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-disabled\" rel=\"Ext.Component-cfg-disabled\" class=\"docClass\">disabled</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>disabled</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setDisabledCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-disabledCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setDisabledCls' class='name expandable'>setDisabledCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> disabledCls</span> )</div><div class='description'><div class='short'>Sets the value of disabledCls. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-disabledCls\" rel=\"Ext.Component-cfg-disabledCls\" class=\"docClass\">disabledCls</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>disabledCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setDisclosureProperty' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-disclosureProperty' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-setDisclosureProperty' class='name expandable'>setDisclosureProperty</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> disclosureProperty</span> )</div><div class='description'><div class='short'>Sets the value of disclosureProperty. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.List-cfg-disclosureProperty\" rel=\"Ext.dataview.List-cfg-disclosureProperty\" class=\"docClass\">disclosureProperty</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>disclosureProperty</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setDocked' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-docked' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setDocked' class='name expandable'>setDocked</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> docked</span> )</div><div class='description'><div class='short'>Sets the value of docked. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-docked\" rel=\"Ext.Component-cfg-docked\" class=\"docClass\">docked</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>docked</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setDraggable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-draggable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setDraggable' class='name expandable'>setDraggable</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> draggable</span> )</div><div class='description'><div class='short'>Sets the value of draggable. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-draggable\" rel=\"Ext.Component-cfg-draggable\" class=\"docClass\">draggable</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>draggable</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setEnterAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-enterAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setEnterAnimation' class='name expandable'>setEnterAnimation</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed enterAnimation</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Sets the value of enterAnimation. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-enterAnimation\" rel=\"Ext.Component-cfg-enterAnimation\" class=\"docClass\">enterAnimation</a>.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.Component-cfg-showAnimation\" rel=\"Ext.Component-cfg-showAnimation\" class=\"docClass\">showAnimation</a> instead.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>enterAnimation</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setExitAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-exitAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setExitAnimation' class='name expandable'>setExitAnimation</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed exitAnimation</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Sets the value of exitAnimation. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-exitAnimation\" rel=\"Ext.Component-cfg-exitAnimation\" class=\"docClass\">exitAnimation</a>.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> </p>\n        <p>2.0.0 Please use <a href=\"#!/api/Ext.Component-cfg-hideAnimation\" rel=\"Ext.Component-cfg-hideAnimation\" class=\"docClass\">hideAnimation</a> instead.  Typically you want to use an\noutbound animation type such as 'fadeOut' or 'slideOut'.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>exitAnimation</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setFloating' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-setFloating' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setFloating' class='name expandable'>setFloating</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> floating</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Used to update the floating state of this component. ...</div><div class='long'><p>Used to update the floating state of this component.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>This has been deprecated. Please use <a href=\"#!/api/Ext.Component-method-setTop\" rel=\"Ext.Component-method-setTop\" class=\"docClass\">setTop</a>, <a href=\"#!/api/Ext.Component-method-setRight\" rel=\"Ext.Component-method-setRight\" class=\"docClass\">setRight</a>, <a href=\"#!/api/Ext.Component-method-setBottom\" rel=\"Ext.Component-method-setBottom\" class=\"docClass\">setBottom</a> and <a href=\"#!/api/Ext.Component-method-setLeft\" rel=\"Ext.Component-method-setLeft\" class=\"docClass\">setLeft</a> instead.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>floating</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>True if you want to float this component</p>\n</div></li></ul></div></div></div><div id='method-setFloatingCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-floatingCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setFloatingCls' class='name expandable'>setFloatingCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> floatingCls</span> )</div><div class='description'><div class='short'>Sets the value of floatingCls. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-floatingCls\" rel=\"Ext.Component-cfg-floatingCls\" class=\"docClass\">floatingCls</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>floatingCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setGrouped' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-grouped' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-setGrouped' class='name expandable'>setGrouped</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> grouped</span> )</div><div class='description'><div class='short'>Sets the value of grouped. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.List-cfg-grouped\" rel=\"Ext.dataview.List-cfg-grouped\" class=\"docClass\">grouped</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>grouped</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setHeight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-height' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setHeight' class='name expandable'>setHeight</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> height</span> )</div><div class='description'><div class='short'>Sets the value of height. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-height\" rel=\"Ext.Component-cfg-height\" class=\"docClass\">height</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>height</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setHidden' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hidden' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setHidden' class='name expandable'>setHidden</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> hidden</span> )</div><div class='description'><div class='short'>Sets the value of hidden. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-hidden\" rel=\"Ext.Component-cfg-hidden\" class=\"docClass\">hidden</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>hidden</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setHiddenCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hiddenCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setHiddenCls' class='name expandable'>setHiddenCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> hiddenCls</span> )</div><div class='description'><div class='short'>Sets the value of hiddenCls. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-hiddenCls\" rel=\"Ext.Component-cfg-hiddenCls\" class=\"docClass\">hiddenCls</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>hiddenCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setHideAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hideAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setHideAnimation' class='name expandable'>setHideAnimation</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed hideAnimation</span> )</div><div class='description'><div class='short'>Sets the value of hideAnimation. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-hideAnimation\" rel=\"Ext.Component-cfg-hideAnimation\" class=\"docClass\">hideAnimation</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>hideAnimation</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setHideOnMaskTap' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-hideOnMaskTap' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-setHideOnMaskTap' class='name expandable'>setHideOnMaskTap</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> hideOnMaskTap</span> )</div><div class='description'><div class='short'>Sets the value of hideOnMaskTap. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Container-cfg-hideOnMaskTap\" rel=\"Ext.Container-cfg-hideOnMaskTap\" class=\"docClass\">hideOnMaskTap</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>hideOnMaskTap</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setHtml' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-html' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setHtml' class='name expandable'>setHtml</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement html</span> )</div><div class='description'><div class='short'>Sets the value of html. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-html\" rel=\"Ext.Component-cfg-html\" class=\"docClass\">html</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>html</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setIndexBar' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-indexBar' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-setIndexBar' class='name expandable'>setIndexBar</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> indexBar</span> )</div><div class='description'><div class='short'>Sets the value of indexBar. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.List-cfg-indexBar\" rel=\"Ext.dataview.List-cfg-indexBar\" class=\"docClass\">indexBar</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>indexBar</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setInline' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-inline' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-setInline' class='name expandable'>setInline</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> inline</span> )</div><div class='description'><div class='short'>Sets the value of inline. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-inline\" rel=\"Ext.dataview.DataView-cfg-inline\" class=\"docClass\">inline</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>inline</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setItemCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-itemCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-setItemCls' class='name expandable'>setItemCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> itemCls</span> )</div><div class='description'><div class='short'>Sets the value of itemCls. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-itemCls\" rel=\"Ext.dataview.DataView-cfg-itemCls\" class=\"docClass\">itemCls</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>itemCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setItemConfig' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-itemConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-setItemConfig' class='name expandable'>setItemConfig</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> itemConfig</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Sets the value of itemConfig. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">itemConfig</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>itemConfig</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul><p>Overrides: <a href='#!/api/Ext.dataview.DataView-method-setItemConfig' rel='Ext.dataview.DataView-method-setItemConfig' class='docClass'>Ext.dataview.DataView.setItemConfig</a></p></div></div></div><div id='method-setItemId' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-itemId' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setItemId' class='name expandable'>setItemId</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> itemId</span> )</div><div class='description'><div class='short'>Sets the value of itemId. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-itemId\" rel=\"Ext.Component-cfg-itemId\" class=\"docClass\">itemId</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>itemId</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setItems' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-items' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-setItems' class='name expandable'>setItems</a>( <span class='pre'><a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> items</span> )</div><div class='description'><div class='short'>Sets the value of items. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Container-cfg-items\" rel=\"Ext.Container-cfg-items\" class=\"docClass\">items</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>items</span> : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setLastFocused' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-setLastFocused' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-setLastFocused' class='name expandable'>setLastFocused</a>( <span class='pre'></span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>This was an internal function accidentally exposed in 1.x and now deprecated. ...</div><div class='long'><p>This was an internal function accidentally exposed in 1.x and now deprecated. Calling it has no effect</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='method-setLastSelected' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-cfg-lastSelected' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-setLastSelected' class='name expandable'>setLastSelected</a>( <span class='pre'><a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a> lastSelected</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Sets the value of lastSelected. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.mixin.Selectable\" rel=\"Ext.mixin.Selectable\" class=\"docClass\">lastSelected</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>lastSelected</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setLayout' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-layout' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-setLayout' class='name expandable'>setLayout</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> layout</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Sets the value of layout. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">layout</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>layout</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul><p>Overrides: <a href='#!/api/Ext.Container-method-setLayout' rel='Ext.Container-method-setLayout' class='docClass'>Ext.Container.setLayout</a></p></div></div></div><div id='method-setLeft' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-left' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setLeft' class='name expandable'>setLeft</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> left</span> )</div><div class='description'><div class='short'>Sets the value of left. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-left\" rel=\"Ext.Component-cfg-left\" class=\"docClass\">left</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>left</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setListeners' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-cfg-listeners' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-setListeners' class='name expandable'>setListeners</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> listeners</span> )</div><div class='description'><div class='short'>Sets the value of listeners. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.mixin.Observable-cfg-listeners\" rel=\"Ext.mixin.Observable-cfg-listeners\" class=\"docClass\">listeners</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>listeners</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setMargin' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-margin' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setMargin' class='name expandable'>setMargin</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> margin</span> )</div><div class='description'><div class='short'>Sets the value of margin. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-margin\" rel=\"Ext.Component-cfg-margin\" class=\"docClass\">margin</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>margin</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setMasked' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-masked' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-setMasked' class='name expandable'>setMasked</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Ext.Mask\" rel=\"Ext.Mask\" class=\"docClass\">Ext.Mask</a>/<a href=\"#!/api/Ext.LoadMask\" rel=\"Ext.LoadMask\" class=\"docClass\">Ext.LoadMask</a> masked</span> )</div><div class='description'><div class='short'>Sets the value of masked. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Container-cfg-masked\" rel=\"Ext.Container-cfg-masked\" class=\"docClass\">masked</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>masked</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Ext.Mask\" rel=\"Ext.Mask\" class=\"docClass\">Ext.Mask</a>/<a href=\"#!/api/Ext.LoadMask\" rel=\"Ext.LoadMask\" class=\"docClass\">Ext.LoadMask</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setMaxHeight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-maxHeight' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setMaxHeight' class='name expandable'>setMaxHeight</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> maxHeight</span> )</div><div class='description'><div class='short'>Sets the value of maxHeight. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-maxHeight\" rel=\"Ext.Component-cfg-maxHeight\" class=\"docClass\">maxHeight</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>maxHeight</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setMaxItemCache' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-maxItemCache' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-setMaxItemCache' class='name expandable'>setMaxItemCache</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> maxItemCache</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Sets the value of maxItemCache. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">maxItemCache</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>maxItemCache</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'>\n</div></li></ul><p>Overrides: <a href='#!/api/Ext.dataview.DataView-method-setMaxItemCache' rel='Ext.dataview.DataView-method-setMaxItemCache' class='docClass'>Ext.dataview.DataView.setMaxItemCache</a></p></div></div></div><div id='method-setMaxWidth' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-maxWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setMaxWidth' class='name expandable'>setMaxWidth</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> maxWidth</span> )</div><div class='description'><div class='short'>Sets the value of maxWidth. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-maxWidth\" rel=\"Ext.Component-cfg-maxWidth\" class=\"docClass\">maxWidth</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>maxWidth</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setMinHeight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-minHeight' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setMinHeight' class='name expandable'>setMinHeight</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> minHeight</span> )</div><div class='description'><div class='short'>Sets the value of minHeight. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-minHeight\" rel=\"Ext.Component-cfg-minHeight\" class=\"docClass\">minHeight</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>minHeight</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setMinWidth' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-minWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setMinWidth' class='name expandable'>setMinWidth</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> minWidth</span> )</div><div class='description'><div class='short'>Sets the value of minWidth. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-minWidth\" rel=\"Ext.Component-cfg-minWidth\" class=\"docClass\">minWidth</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>minWidth</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setModal' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-modal' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-setModal' class='name expandable'>setModal</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> modal</span> )</div><div class='description'><div class='short'>Sets the value of modal. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Container-cfg-modal\" rel=\"Ext.Container-cfg-modal\" class=\"docClass\">modal</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>modal</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setMode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-cfg-mode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-setMode' class='name expandable'>setMode</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> mode</span> )</div><div class='description'><div class='short'>Sets the value of mode. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.mixin.Selectable-cfg-mode\" rel=\"Ext.mixin.Selectable-cfg-mode\" class=\"docClass\">mode</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>mode</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setOnItemDisclosure' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-onItemDisclosure' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-setOnItemDisclosure' class='name expandable'>setOnItemDisclosure</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> onItemDisclosure</span> )</div><div class='description'><div class='short'>Sets the value of onItemDisclosure. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.List-cfg-onItemDisclosure\" rel=\"Ext.dataview.List-cfg-onItemDisclosure\" class=\"docClass\">onItemDisclosure</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>onItemDisclosure</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setPadding' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-padding' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setPadding' class='name expandable'>setPadding</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> padding</span> )</div><div class='description'><div class='short'>Sets the value of padding. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-padding\" rel=\"Ext.Component-cfg-padding\" class=\"docClass\">padding</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>padding</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setPinHeaders' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-pinHeaders' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-setPinHeaders' class='name expandable'>setPinHeaders</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> pinHeaders</span> )</div><div class='description'><div class='short'>Sets the value of pinHeaders. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.List-cfg-pinHeaders\" rel=\"Ext.dataview.List-cfg-pinHeaders\" class=\"docClass\">pinHeaders</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>pinHeaders</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setPlugins' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-plugins' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setPlugins' class='name expandable'>setPlugins</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a> plugins</span> )</div><div class='description'><div class='short'>Sets the value of plugins. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-plugins\" rel=\"Ext.Component-cfg-plugins\" class=\"docClass\">plugins</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>plugins</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setPressedCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-pressedCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-setPressedCls' class='name expandable'>setPressedCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> pressedCls</span> )</div><div class='description'><div class='short'>Sets the value of pressedCls. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-pressedCls\" rel=\"Ext.dataview.DataView-cfg-pressedCls\" class=\"docClass\">pressedCls</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>pressedCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setPressedDelay' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-pressedDelay' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-setPressedDelay' class='name expandable'>setPressedDelay</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> pressedDelay</span> )</div><div class='description'><div class='short'>Sets the value of pressedDelay. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-pressedDelay\" rel=\"Ext.dataview.DataView-cfg-pressedDelay\" class=\"docClass\">pressedDelay</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>pressedDelay</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setPreventSelectionOnDisclose' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-preventSelectionOnDisclose' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-setPreventSelectionOnDisclose' class='name expandable'>setPreventSelectionOnDisclose</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> preventSelectionOnDisclose</span> )</div><div class='description'><div class='short'>Sets the value of preventSelectionOnDisclose. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.List-cfg-preventSelectionOnDisclose\" rel=\"Ext.dataview.List-cfg-preventSelectionOnDisclose\" class=\"docClass\">preventSelectionOnDisclose</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>preventSelectionOnDisclose</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setRecord' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-record' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setRecord' class='name expandable'>setRecord</a>( <span class='pre'><a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a> record</span> )</div><div class='description'><div class='short'>Sets the value of record. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-record\" rel=\"Ext.Component-cfg-record\" class=\"docClass\">record</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>record</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setRenderTo' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-renderTo' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setRenderTo' class='name expandable'>setRenderTo</a>( <span class='pre'><a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a> renderTo</span> )</div><div class='description'><div class='short'>Sets the value of renderTo. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-renderTo\" rel=\"Ext.Component-cfg-renderTo\" class=\"docClass\">renderTo</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>renderTo</span> : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setRenderTpl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-renderTpl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setRenderTpl' class='name expandable'>setRenderTpl</a>( <span class='pre'>Mixed renderTpl</span> )</div><div class='description'><div class='short'>Sets the value of renderTpl. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-renderTpl\" rel=\"Ext.Component-cfg-renderTpl\" class=\"docClass\">renderTpl</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>renderTpl</span> : Mixed<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setRendered' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-setRendered' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-setRendered' class='name expandable'>setRendered</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> rendered</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>rendered</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul><p>Overrides: <a href='#!/api/Ext.Component-method-setRendered' rel='Ext.Component-method-setRendered' class='docClass'>Ext.Component.setRendered</a></p></div></div></div><div id='method-setRight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-right' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setRight' class='name expandable'>setRight</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> right</span> )</div><div class='description'><div class='short'>Sets the value of right. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-right\" rel=\"Ext.Component-cfg-right\" class=\"docClass\">right</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>right</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setScrollToTopOnRefresh' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-scrollToTopOnRefresh' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-setScrollToTopOnRefresh' class='name expandable'>setScrollToTopOnRefresh</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> scrollToTopOnRefresh</span> )</div><div class='description'><div class='short'>Sets the value of scrollToTopOnRefresh. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-scrollToTopOnRefresh\" rel=\"Ext.dataview.DataView-cfg-scrollToTopOnRefresh\" class=\"docClass\">scrollToTopOnRefresh</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>scrollToTopOnRefresh</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setScrollable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-scrollable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-setScrollable' class='name expandable'>setScrollable</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scrollable</span> )</div><div class='description'><div class='short'>Sets the value of scrollable. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Container-cfg-scrollable\" rel=\"Ext.Container-cfg-scrollable\" class=\"docClass\">scrollable</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>scrollable</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul><p>Overrides: <a href='#!/api/Ext.Component-method-setScrollable' rel='Ext.Component-method-setScrollable' class='docClass'>Ext.Component.setScrollable</a></p></div></div></div><div id='method-setSelectedCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-selectedCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-setSelectedCls' class='name expandable'>setSelectedCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> selectedCls</span> )</div><div class='description'><div class='short'>Sets the value of selectedCls. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-selectedCls\" rel=\"Ext.dataview.DataView-cfg-selectedCls\" class=\"docClass\">selectedCls</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>selectedCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setShowAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-showAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setShowAnimation' class='name expandable'>setShowAnimation</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed showAnimation</span> )</div><div class='description'><div class='short'>Sets the value of showAnimation. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-showAnimation\" rel=\"Ext.Component-cfg-showAnimation\" class=\"docClass\">showAnimation</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>showAnimation</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setSize' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-setSize' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setSize' class='name expandable'>setSize</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> width, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> height</span> )</div><div class='description'><div class='short'>Sets the size of the Component ...</div><div class='long'><p>Sets the size of the Component</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>width</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The new width for the Component</p>\n</div></li><li><span class='pre'>height</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The new height for the Component</p>\n</div></li></ul></div></div></div><div id='method-setStore' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-store' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-setStore' class='name expandable'>setStore</a>( <span class='pre'><a href=\"#!/api/Ext.data.Store\" rel=\"Ext.data.Store\" class=\"docClass\">Ext.data.Store</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> store</span> )</div><div class='description'><div class='short'>Sets the value of store. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-store\" rel=\"Ext.dataview.DataView-cfg-store\" class=\"docClass\">store</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>store</span> : <a href=\"#!/api/Ext.data.Store\" rel=\"Ext.data.Store\" class=\"docClass\">Ext.data.Store</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setStyle' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-style' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setStyle' class='name expandable'>setStyle</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> style</span> )</div><div class='description'><div class='short'>Sets the value of style. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-style\" rel=\"Ext.Component-cfg-style\" class=\"docClass\">style</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>style</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setStyleHtmlCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-styleHtmlCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setStyleHtmlCls' class='name expandable'>setStyleHtmlCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> styleHtmlCls</span> )</div><div class='description'><div class='short'>Sets the value of styleHtmlCls. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-styleHtmlCls\" rel=\"Ext.Component-cfg-styleHtmlCls\" class=\"docClass\">styleHtmlCls</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>styleHtmlCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setStyleHtmlContent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-styleHtmlContent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setStyleHtmlContent' class='name expandable'>setStyleHtmlContent</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> styleHtmlContent</span> )</div><div class='description'><div class='short'>Sets the value of styleHtmlContent. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-styleHtmlContent\" rel=\"Ext.Component-cfg-styleHtmlContent\" class=\"docClass\">styleHtmlContent</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>styleHtmlContent</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setTop' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-top' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setTop' class='name expandable'>setTop</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> top</span> )</div><div class='description'><div class='short'>Sets the value of top. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-top\" rel=\"Ext.Component-cfg-top\" class=\"docClass\">top</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>top</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setTpl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-tpl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setTpl' class='name expandable'>setTpl</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]/<a href=\"#!/api/Ext.Template\" rel=\"Ext.Template\" class=\"docClass\">Ext.Template</a>[]/<a href=\"#!/api/Ext.XTemplate\" rel=\"Ext.XTemplate\" class=\"docClass\">Ext.XTemplate</a>[] tpl</span> )</div><div class='description'><div class='short'>Sets the value of tpl. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-tpl\" rel=\"Ext.Component-cfg-tpl\" class=\"docClass\">tpl</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>tpl</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]/<a href=\"#!/api/Ext.Template\" rel=\"Ext.Template\" class=\"docClass\">Ext.Template</a>[]/<a href=\"#!/api/Ext.XTemplate\" rel=\"Ext.XTemplate\" class=\"docClass\">Ext.XTemplate</a>[]<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setTplWriteMode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-tplWriteMode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setTplWriteMode' class='name expandable'>setTplWriteMode</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> tplWriteMode</span> )</div><div class='description'><div class='short'>Sets the value of tplWriteMode. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-tplWriteMode\" rel=\"Ext.Component-cfg-tplWriteMode\" class=\"docClass\">tplWriteMode</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>tplWriteMode</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setTranslatable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-translatable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setTranslatable' class='name expandable'>setTranslatable</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> translatable</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Sets the value of translatable. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">translatable</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>translatable</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setTriggerCtEvent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-triggerCtEvent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-setTriggerCtEvent' class='name expandable'>setTriggerCtEvent</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> triggerCtEvent</span> )</div><div class='description'><div class='short'>Sets the value of triggerCtEvent. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-triggerCtEvent\" rel=\"Ext.dataview.DataView-cfg-triggerCtEvent\" class=\"docClass\">triggerCtEvent</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>triggerCtEvent</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setTriggerEvent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-cfg-triggerEvent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-method-setTriggerEvent' class='name expandable'>setTriggerEvent</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> triggerEvent</span> )</div><div class='description'><div class='short'>Sets the value of triggerEvent. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.DataView-cfg-triggerEvent\" rel=\"Ext.dataview.DataView-cfg-triggerEvent\" class=\"docClass\">triggerEvent</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>triggerEvent</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setUseComponents' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-cfg-useComponents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-method-setUseComponents' class='name expandable'>setUseComponents</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> useComponents</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Sets the value of useComponents. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">useComponents</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>useComponents</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul><p>Overrides: <a href='#!/api/Ext.dataview.DataView-method-setUseComponents' rel='Ext.dataview.DataView-method-setUseComponents' class='docClass'>Ext.dataview.DataView.setUseComponents</a></p></div></div></div><div id='method-setVisibility' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-setVisibility' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setVisibility' class='name expandable'>setVisibility</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> isVisible</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>isVisible</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setWidth' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-width' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setWidth' class='name expandable'>setWidth</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> width</span> )</div><div class='description'><div class='short'>Sets the value of width. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-width\" rel=\"Ext.Component-cfg-width\" class=\"docClass\">width</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>width</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setZIndex' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-zIndex' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setZIndex' class='name expandable'>setZIndex</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> zIndex</span> )</div><div class='description'><div class='short'>Sets the value of zIndex. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-zIndex\" rel=\"Ext.Component-cfg-zIndex\" class=\"docClass\">zIndex</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>zIndex</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-show' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-show' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-show' class='name expandable'>show</a>( <span class='pre'>[<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> animation]</span> )</div><div class='description'><div class='short'>Shows this component ...</div><div class='long'><p>Shows this component</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>animation</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> (optional)<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-showBy' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-showBy' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-showBy' class='name expandable'>showBy</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> component, [<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> alignment]</span> )</div><div class='description'><div class='short'>Shows this component by another component. ...</div><div class='long'><p>Shows this component by another component. If you specify no alignment, it will automatically\nposition this component relative to the reference component.</p>\n\n<p>For example, say we are aligning a Panel next to a Button, the alignment string would look like this:</p>\n\n<pre><code>[panel-vertical (t/b/c)][panel-horizontal (l/r/c)]-[button-vertical (t/b/c)][button-horizontal (l/r/c)]\n</code></pre>\n\n<p>where t = top, b = bottom, c = center, l = left, r = right.</p>\n\n<h2>Examples</h2>\n\n<ul>\n<li><code>tl-tr</code> means top-left corner of the Panel to the top-right corner of the Button</li>\n<li><code>tc-bc</code> means top-center of the Panel to the bottom-center of the Button</li>\n</ul>\n\n\n<p>You can put a '?' at the end of the alignment string to constrain the floating element to the\n<a href=\"#!/api/Ext.Viewport\" rel=\"Ext.Viewport\" class=\"docClass\">Viewport</a></p>\n\n<pre><code>// show `panel` by `button` using the default positioning (auto fit)\npanel.showBy(button);\n\n// align the top left corner of `panel` with the top right corner of `button` (constrained to viewport)\npanel.showBy(button, \"tl-tr?\");\n\n// align the bottom right corner of `panel` with the center left edge of `button` (not constrained by viewport)\npanel.showBy(button, \"br-cl\");\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>component</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The target component to show this component by</p>\n</div></li><li><span class='pre'>alignment</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> (optional)<div class='sub-desc'><p>The specific alignment.</p>\n</div></li></ul></div></div></div><div id='method-statics' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-statics' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-statics' class='name expandable'>statics</a>( <span class='pre'></span> ) : <a href=\"#!/api/Ext.Class\" rel=\"Ext.Class\" class=\"docClass\">Ext.Class</a><strong class='protected signature'>protected</strong></div><div class='description'><div class='short'>Get the reference to the class from which this object was instantiated. ...</div><div class='long'><p>Get the reference to the class from which this object was instantiated. Note that unlike <a href=\"#!/api/Ext.Base-property-self\" rel=\"Ext.Base-property-self\" class=\"docClass\">self</a>,\n<code>this.statics()</code> is scope-independent and it always returns the class from which it was called, regardless of what\n<code>this</code> points to during run-time</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.Cat', {\n    statics: {\n        totalCreated: 0,\n        speciesName: 'Cat' // My.Cat.speciesName = 'Cat'\n    },\n\n    constructor: function() {\n        var statics = this.statics();\n\n        alert(statics.speciesName);     // always equals to 'Cat' no matter what 'this' refers to\n                                        // equivalent to: My.Cat.speciesName\n\n        alert(this.self.speciesName);   // dependent on 'this'\n\n        statics.totalCreated++;\n    },\n\n    clone: function() {\n        var cloned = new this.self;                      // dependent on 'this'\n\n        cloned.groupName = this.statics().speciesName;   // equivalent to: My.Cat.speciesName\n\n        return cloned;\n    }\n});\n\n\n<a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.SnowLeopard', {\n    extend: 'My.Cat',\n\n    statics: {\n        speciesName: 'Snow Leopard'     // My.SnowLeopard.speciesName = 'Snow Leopard'\n    },\n\n    constructor: function() {\n        this.callParent();\n    }\n});\n\nvar cat = new My.Cat();                 // alerts 'Cat', then alerts 'Cat'\n\nvar snowLeopard = new My.SnowLeopard(); // alerts 'Cat', then alerts 'Snow Leopard'\n\nvar clone = snowLeopard.clone();\nalert(<a href=\"#!/api/Ext-method-getClassName\" rel=\"Ext-method-getClassName\" class=\"docClass\">Ext.getClassName</a>(clone));         // alerts 'My.SnowLeopard'\nalert(clone.groupName);                 // alerts 'Cat'\n\nalert(My.Cat.totalCreated);             // alerts 3\n</code></pre>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.Class\" rel=\"Ext.Class\" class=\"docClass\">Ext.Class</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-suspendEvents' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-suspendEvents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-suspendEvents' class='name expandable'>suspendEvents</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> queueSuspended</span> )</div><div class='description'><div class='short'>Suspends the firing of all events. ...</div><div class='long'><p>Suspends the firing of all events. (see <a href=\"#!/api/Ext.mixin.Observable-method-resumeEvents\" rel=\"Ext.mixin.Observable-method-resumeEvents\" class=\"docClass\">resumeEvents</a>)</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>queueSuspended</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>Pass as true to queue up suspended events to be fired\nafter the <a href=\"#!/api/Ext.mixin.Observable-method-resumeEvents\" rel=\"Ext.mixin.Observable-method-resumeEvents\" class=\"docClass\">resumeEvents</a> call instead of discarding all suspended events.</p>\n</div></li></ul></div></div></div><div id='method-triggerInitialized' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-triggerInitialized' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-triggerInitialized' class='name expandable'>triggerInitialized</a>( <span class='pre'></span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-un' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-un' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-un' class='name expandable'>un</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options], [<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> order]</span> )</div><div class='description'><div class='short'>Alias for removeListener. ...</div><div class='long'><p>Alias for <a href=\"#!/api/Ext.mixin.Observable-method-removeListener\" rel=\"Ext.mixin.Observable-method-removeListener\" class=\"docClass\">removeListener</a>.</p>\n\n<p>Removes an event handler.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The type of event the handler was associated with.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The handler to remove. <strong>This must be a reference to the function passed into the\n<a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> call.</strong></p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope originally specified for the handler. It must be the same as the\nscope argument specified in the original call to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> or the listener will not be removed.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>Extra options object. See <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> for details.</p>\n\n</div></li><li><span class='pre'>order</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> (optional)<div class='sub-desc'><p>The order of the listener to remove.\nPossible values are <code>before</code>, <code>current</code> and <code>after</code>.</p>\n\n<p>Defaults to: <code>&quot;current&quot;</code></p></div></li></ul></div></div></div><div id='method-unAfter' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-unAfter' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-unAfter' class='name expandable'>unAfter</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )</div><div class='description'><div class='short'>Alias for removeAfterListener. ...</div><div class='long'><p>Alias for <a href=\"#!/api/Ext.mixin.Observable-method-removeAfterListener\" rel=\"Ext.mixin.Observable-method-removeAfterListener\" class=\"docClass\">removeAfterListener</a>.</p>\n\n<p>Removes a before-event handler.</p>\n\n<p>Same as <a href=\"#!/api/Ext.mixin.Observable-method-removeListener\" rel=\"Ext.mixin.Observable-method-removeListener\" class=\"docClass\">removeListener</a> with <code>order</code> set to <code>'after'</code>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event the handler was associated with.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The handler to remove.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope originally specified for <code>fn</code>.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>Extra options object.</p>\n\n</div></li></ul></div></div></div><div id='method-unBefore' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-unBefore' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-unBefore' class='name expandable'>unBefore</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )</div><div class='description'><div class='short'>Alias for removeBeforeListener. ...</div><div class='long'><p>Alias for <a href=\"#!/api/Ext.mixin.Observable-method-removeBeforeListener\" rel=\"Ext.mixin.Observable-method-removeBeforeListener\" class=\"docClass\">removeBeforeListener</a>.</p>\n\n<p>Removes a before-event handler.</p>\n\n<p>Same as <a href=\"#!/api/Ext.mixin.Observable-method-removeListener\" rel=\"Ext.mixin.Observable-method-removeListener\" class=\"docClass\">removeListener</a> with <code>order</code> set to <code>'before'</code>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event the handler was associated with.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The handler to remove.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope originally specified for <code>fn</code>.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>Extra options object.</p>\n\n</div></li></ul></div></div></div><div id='method-unmask' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-method-unmask' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-method-unmask' class='name expandable'>unmask</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Convience method which calls setMasked with a value of false (to hide the mask). ...</div><div class='long'><p>Convience method which calls <a href=\"#!/api/Ext.Container-method-setMasked\" rel=\"Ext.Container-method-setMasked\" class=\"docClass\">setMasked</a> with a value of false (to hide the mask). For additional\nfunctionality, call the <a href=\"#!/api/Ext.Container-method-setMasked\" rel=\"Ext.Container-method-setMasked\" class=\"docClass\">setMasked</a> function direction (See the <a href=\"#!/api/Ext.Container-cfg-masked\" rel=\"Ext.Container-cfg-masked\" class=\"docClass\">masked</a> configuration documention\nfor more information).</p>\n</div></div></div><div id='method-up' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-up' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-up' class='name expandable'>up</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> selector</span> ) : <a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a></div><div class='description'><div class='short'>Walks up the ownerCt axis looking for an ancestor Container which matches\nthe passed simple selector. ...</div><div class='long'><p>Walks up the <code>ownerCt</code> axis looking for an ancestor Container which matches\nthe passed simple selector.</p>\n\n\n<p>Example:\n<pre><code>var owningTabPanel = grid.up('tabpanel');\n</code></pre>\n\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>selector</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>Optional. The simple selector to test.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a></span><div class='sub-desc'><p>The matching ancestor Container (or <code>undefined</code> if no match was found).</p>\n</div></li></ul></div></div></div><div id='method-update' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-update' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-update' class='name expandable'>update</a>( <span class='pre'></span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Updates the HTML content of the Component. ...</div><div class='long'><p>Updates the HTML content of the Component.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.Component-method-setHtml\" rel=\"Ext.Component-method-setHtml\" class=\"docClass\">setHtml</a>, <a href=\"#!/api/Ext.Component-method-setTpl\" rel=\"Ext.Component-method-setTpl\" class=\"docClass\">setTpl</a> or <a href=\"#!/api/Ext.Component-method-setData\" rel=\"Ext.Component-method-setData\" class=\"docClass\">setData</a> instead.</p>\n\n        </div>\n</div></div></div><div id='method-updateCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-updateCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-updateCls' class='name expandable'>updateCls</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> newCls, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> oldCls</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>All cls methods directly report to the cls configuration, so anytime it changes, updateCls will be called ...</div><div class='long'><p>All cls methods directly report to the <a href=\"#!/api/Ext.Component-cfg-cls\" rel=\"Ext.Component-cfg-cls\" class=\"docClass\">cls</a> configuration, so anytime it changes, <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">updateCls</a> will be called</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>newCls</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>oldCls</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-updateData' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-updateData' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-updateData' class='name expandable'>updateData</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> newData</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>newData</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-updateFloatingCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-updateFloatingCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-updateFloatingCls' class='name expandable'>updateFloatingCls</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> newFloatingCls, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> oldFloatingCls</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Updates the floatingCls if the component is currently floating ...</div><div class='long'><p>Updates the floatingCls if the component is currently floating</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>newFloatingCls</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>oldFloatingCls</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-updateLastFocused' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-updateLastFocused' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-updateLastFocused' class='name expandable'>updateLastFocused</a>( <span class='pre'><a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Record</a> newRecord, <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Record</a> oldRecord</span> )</div><div class='description'><div class='short'>Sets a record as the last focused record. ...</div><div class='long'><p>Sets a record as the last focused record. This does NOT mean\nthat the record has been selected.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>newRecord</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Record</a><div class='sub-desc'>\n</div></li><li><span class='pre'>oldRecord</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Record</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-updateStore' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-method-updateStore' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-method-updateStore' class='name expandable'>updateStore</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> newStore, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> oldStore</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>newStore</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>oldStore</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-updateStyleHtmlCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-updateStyleHtmlCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-updateStyleHtmlCls' class='name expandable'>updateStyleHtmlCls</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> newHtmlCls, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> oldHtmlCls</span> )</div><div class='description'><div class='short'>Updates the styleHtmlCls configuration ...</div><div class='long'><p>Updates the <a href=\"#!/api/Ext.Component-cfg-styleHtmlCls\" rel=\"Ext.Component-cfg-styleHtmlCls\" class=\"docClass\">styleHtmlCls</a> configuration</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>newHtmlCls</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>oldHtmlCls</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div></div><div class='subsection'><div class='definedBy'>Defined By</div><h4 class='members-subtitle'>Static Methods</h3><div id='static-method-addConfig' class='member first-child inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-addConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-addConfig' class='name expandable'>addConfig</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> config, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> fullMerge</span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>config</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>fullMerge</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-addInheritableStatics' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-addInheritableStatics' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-addInheritableStatics' class='name expandable'>addInheritableStatics</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> members</span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>members</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-addMember' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-addMember' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-addMember' class='name expandable'>addMember</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> name, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> member</span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>member</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-addMembers' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-addMembers' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-addMembers' class='name expandable'>addMembers</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> members</span> )<strong class='static signature'>static</strong></div><div class='description'><div class='short'>Add methods / properties to the prototype of this class. ...</div><div class='long'><p>Add methods / properties to the prototype of this class.</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.awesome.Cat', {\n    constructor: function() {\n        ...\n    }\n});\n\n My.awesome.Cat.implement({\n     meow: function() {\n        alert('Meowww...');\n     }\n });\n\n var kitty = new My.awesome.Cat;\n kitty.meow();\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>members</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-addStatics' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-addStatics' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-addStatics' class='name expandable'>addStatics</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> members</span> ) : <a href=\"#!/api/Ext.Base\" rel=\"Ext.Base\" class=\"docClass\">Ext.Base</a><strong class='static signature'>static</strong></div><div class='description'><div class='short'>Add / override static properties of this class. ...</div><div class='long'><p>Add / override static properties of this class.</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.cool.Class', {\n    ...\n});\n\nMy.cool.Class.addStatics({\n    someProperty: 'someValue',      // My.cool.Class.someProperty = 'someValue'\n    method1: function() { ... },    // My.cool.Class.method1 = function() { ... };\n    method2: function() { ... }     // My.cool.Class.method2 = function() { ... };\n});\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>members</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.Base\" rel=\"Ext.Base\" class=\"docClass\">Ext.Base</a></span><div class='sub-desc'><p>this</p>\n</div></li></ul></div></div></div><div id='static-method-addXtype' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-addXtype' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-addXtype' class='name expandable'>addXtype</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> xtype</span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>xtype</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-borrow' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-borrow' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-borrow' class='name expandable'>borrow</a>( <span class='pre'><a href=\"#!/api/Ext.Base\" rel=\"Ext.Base\" class=\"docClass\">Ext.Base</a> fromClass, <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> members</span> ) : <a href=\"#!/api/Ext.Base\" rel=\"Ext.Base\" class=\"docClass\">Ext.Base</a><strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'>Borrow another class' members to the prototype of this class. ...</div><div class='long'><p>Borrow another class' members to the prototype of this class.</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('Bank', {\n    money: '$$$',\n    printMoney: function() {\n        alert('$$$$$$$');\n    }\n});\n\n<a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('Thief', {\n    ...\n});\n\nThief.borrow(Bank, ['money', 'printMoney']);\n\nvar steve = new Thief();\n\nalert(steve.money); // alerts '$$$'\nsteve.printMoney(); // alerts '$$$$$$$'\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>fromClass</span> : <a href=\"#!/api/Ext.Base\" rel=\"Ext.Base\" class=\"docClass\">Ext.Base</a><div class='sub-desc'><p>The class to borrow members from</p>\n</div></li><li><span class='pre'>members</span> : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The names of the members to borrow</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.Base\" rel=\"Ext.Base\" class=\"docClass\">Ext.Base</a></span><div class='sub-desc'><p>this</p>\n</div></li></ul></div></div></div><div id='static-method-callParent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-callParent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-callParent' class='name expandable'>callParent</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> args</span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>args</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-create' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-create' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-create' class='name expandable'>create</a>( <span class='pre'></span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><strong class='static signature'>static</strong></div><div class='description'><div class='short'>Create a new instance of this Class. ...</div><div class='long'><p>Create a new instance of this Class.</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.cool.Class', {\n    ...\n});\n\nMy.cool.Class.create({\n    someConfig: true\n});\n</code></pre>\n\n<p>All parameters are passed to the constructor of the class.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'><p>the created instance.</p>\n</div></li></ul></div></div></div><div id='static-method-createAlias' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-createAlias' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-createAlias' class='name expandable'>createAlias</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> alias, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> origin</span> )<strong class='static signature'>static</strong></div><div class='description'><div class='short'>Create aliases for existing prototype methods. ...</div><div class='long'><p>Create aliases for existing prototype methods. Example:</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.cool.Class', {\n    method1: function() { ... },\n    method2: function() { ... }\n});\n\nvar test = new My.cool.Class();\n\nMy.cool.Class.createAlias({\n    method3: 'method1',\n    method4: 'method2'\n});\n\ntest.method3(); // test.method1()\n\nMy.cool.Class.createAlias('method5', 'method3');\n\ntest.method5(); // test.method3() -&gt; test.method1()\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>alias</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The new method name, or an object to set multiple aliases. See\n<a href=\"#!/api/Ext.Function-method-flexSetter\" rel=\"Ext.Function-method-flexSetter\" class=\"docClass\">flexSetter</a></p>\n</div></li><li><span class='pre'>origin</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The original method name</p>\n</div></li></ul></div></div></div><div id='static-method-extend' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-extend' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-extend' class='name expandable'>extend</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> parent</span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>parent</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-getName' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-getName' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-getName' class='name expandable'>getName</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><strong class='static signature'>static</strong></div><div class='description'><div class='short'>Get the current class' name in string format. ...</div><div class='long'><p>Get the current class' name in string format.</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.cool.Class', {\n    constructor: function() {\n        alert(this.self.getName()); // alerts 'My.cool.Class'\n    }\n});\n\nMy.cool.Class.getName(); // 'My.cool.Class'\n</code></pre>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'><p>className</p>\n</div></li></ul></div></div></div><div id='static-method-implement' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-implement' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-implement' class='name expandable'>implement</a>( <span class='pre'></span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='static-method-mixin' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-mixin' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-mixin' class='name expandable'>mixin</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> name, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> mixinClass</span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'>Used internally by the mixins pre-processor ...</div><div class='long'><p>Used internally by the mixins pre-processor</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>mixinClass</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-onExtended' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-onExtended' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-onExtended' class='name expandable'>onExtended</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> fn, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope</span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>fn</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-override' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-override' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-override' class='name expandable'>override</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> members</span> ) : <a href=\"#!/api/Ext.Base\" rel=\"Ext.Base\" class=\"docClass\">Ext.Base</a><strong class='deprecated signature'>deprecated</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'>Override members of this class. ...</div><div class='long'><p>Override members of this class. Overridden methods can be invoked via\n<a href=\"#!/api/Ext.Base-method-callParent\" rel=\"Ext.Base-method-callParent\" class=\"docClass\">callParent</a>.</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.Cat', {\n    constructor: function() {\n        alert(\"I'm a cat!\");\n    }\n});\n\nMy.Cat.override({\n    constructor: function() {\n        alert(\"I'm going to be a cat!\");\n\n        var instance = this.callParent(arguments);\n\n        alert(\"Meeeeoooowwww\");\n\n        return instance;\n    }\n});\n\nvar kitty = new My.Cat(); // alerts \"I'm going to be a cat!\"\n                          // alerts \"I'm a cat!\"\n                          // alerts \"Meeeeoooowwww\"\n</code></pre>\n\n<p>As of 4.1, direct use of this method is deprecated. Use <a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>\ninstead:</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.CatOverride', {\n    override: 'My.Cat',\n    constructor: function() {\n        alert(\"I'm going to be a cat!\");\n\n        var instance = this.callParent(arguments);\n\n        alert(\"Meeeeoooowwww\");\n\n        return instance;\n    }\n});\n</code></pre>\n\n<p>The above accomplishes the same result but can be managed by the <a href=\"#!/api/Ext.Loader\" rel=\"Ext.Loader\" class=\"docClass\">Ext.Loader</a>\nwhich can properly order the override and its target class and the build process\ncan determine whether the override is needed based on the required state of the\ntarget class (My.Cat).</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 4.1.0</p>\n        <p>Please use <a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a> instead</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>members</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The properties to add to this class. This should be\nspecified as an object literal containing one or more properties.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.Base\" rel=\"Ext.Base\" class=\"docClass\">Ext.Base</a></span><div class='sub-desc'><p>this class</p>\n</div></li></ul></div></div></div><div id='static-method-triggerExtended' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-triggerExtended' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-triggerExtended' class='name expandable'>triggerExtended</a>( <span class='pre'></span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-event'>Events</h3><div class='subsection'><div id='event-activate' class='member first-child inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-event-activate' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-event-activate' class='name expandable'>activate</a>( <span class='pre'><a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> newActiveItem, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> oldActiveItem, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever item within the Container is activated ...</div><div class='long'><p>Fires whenever item within the Container is activated</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a><div class='sub-desc'><p>The Container instance</p>\n</div></li><li><span class='pre'>newActiveItem</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The new active item within the container</p>\n</div></li><li><span class='pre'>oldActiveItem</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The old active item within the container</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-activeitemchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-cfg-activeItem' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-event-activeitemchange' class='name expandable'>activeitemchange</a>( <span class='pre'><a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> value, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the activeItem configuration is changed by setActiveItem. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Container-cfg-activeItem\" rel=\"Ext.Container-cfg-activeItem\" class=\"docClass\">activeItem</a> configuration is changed by <a href=\"#!/api/Ext.Container-method-setActiveItem\" rel=\"Ext.Container-method-setActiveItem\" class=\"docClass\">setActiveItem</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-beforeorientationchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-beforeorientationchange' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-beforeorientationchange' class='name expandable'>beforeorientationchange</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )<strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>Fires before orientation changes. ...</div><div class='long'><p>Fires before orientation changes.</p>\n        <div class='signature-box removed'>\n        <p>This event has been <strong>removed</strong> since 2.0.0</p>\n        <p>This event is now only available onBefore the Viewport's <a href=\"#!/api/Ext.Viewport-event-orientationchange\" rel=\"Ext.Viewport-event-orientationchange\" class=\"docClass\">Ext.Viewport.orientationchange</a></p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-beforeselectionchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-event-beforeselectionchange' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-event-beforeselectionchange' class='name expandable'>beforeselectionchange</a>( <span class='pre'><a href=\"#!/api/Ext.mixin.Selectable\" rel=\"Ext.mixin.Selectable\" class=\"docClass\">Ext.mixin.Selectable</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )<strong class='deprecated signature'>deprecated</strong><strong class='preventable signature'>preventable</strong></div><div class='description'><div class='short'>Fires before an item is selected ...</div><div class='long'><p>Fires before an item is selected</p>\n        <div class='signature-box deprecated'>\n        <p>This event has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please listen to the <a href=\"#!/api/Ext.mixin.Selectable-event-selectionchange\" rel=\"Ext.mixin.Selectable-event-selectionchange\" class=\"docClass\">selectionchange</a> event with an order of <code>before</code> instead.</p>\n\n        </div>\n        <div class='signature-box preventable'>\n        <p>This action following this event is <b>preventable</b>.\n        When any of the listeners returns false, the action is cancelled.</p>\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.mixin.Selectable\" rel=\"Ext.mixin.Selectable\" class=\"docClass\">Ext.mixin.Selectable</a><div class='sub-desc'>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n</div></li></ul></div></div></div><div id='event-bottomchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-bottom' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-bottomchange' class='name expandable'>bottomchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the bottom configuration is changed by setBottom. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-bottom\" rel=\"Ext.Component-cfg-bottom\" class=\"docClass\">bottom</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setBottom\" rel=\"Ext.Component-method-setBottom\" class=\"docClass\">setBottom</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-centeredchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-centered' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-centeredchange' class='name expandable'>centeredchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> value, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the centered configuration is changed by setCentered. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-centered\" rel=\"Ext.Component-cfg-centered\" class=\"docClass\">centered</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setCentered\" rel=\"Ext.Component-method-setCentered\" class=\"docClass\">setCentered</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-containertap' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-event-containertap' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-event-containertap' class='name expandable'>containertap</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )<strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>Fires when a tap occurs and it is not on a template node. ...</div><div class='long'><p>Fires when a tap occurs and it is not on a template node.</p>\n        <div class='signature-box removed'>\n        <p>This event has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-deactivate' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-event-deactivate' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-event-deactivate' class='name expandable'>deactivate</a>( <span class='pre'><a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> newActiveItem, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> oldActiveItem, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever item within the Container is deactivated ...</div><div class='long'><p>Fires whenever item within the Container is deactivated</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a><div class='sub-desc'><p>The Container instance</p>\n</div></li><li><span class='pre'>newActiveItem</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The new active item within the container</p>\n</div></li><li><span class='pre'>oldActiveItem</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The old active item within the container</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-deselect' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-event-deselect' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-event-deselect' class='name expandable'>deselect</a>( <span class='pre'><a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a> this, <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a> record, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> supressed, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )<strong class='preventable signature'>preventable</strong></div><div class='description'><div class='short'>Fires whenever an item is deselected ...</div><div class='long'><p>Fires whenever an item is deselected</p>\n        <div class='signature-box preventable'>\n        <p>This action following this event is <b>preventable</b>.\n        When any of the listeners returns false, the action is cancelled.</p>\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a><div class='sub-desc'>\n</div></li><li><span class='pre'>record</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a><div class='sub-desc'><p>The record assosciated to the item</p>\n</div></li><li><span class='pre'>supressed</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>Flag to supress the event</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-disabledchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-disabled' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-disabledchange' class='name expandable'>disabledchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> value, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the disabled configuration is changed by setDisabled. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-disabled\" rel=\"Ext.Component-cfg-disabled\" class=\"docClass\">disabled</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setDisabled\" rel=\"Ext.Component-method-setDisabled\" class=\"docClass\">setDisabled</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-disclose' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/List2.html#Ext-dataview-List-event-disclose' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-event-disclose' class='name expandable'>disclose</a>( <span class='pre'><a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">Ext.dataview.List</a> this, <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a> record, HTMLElement target, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> index, <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a> e, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )<strong class='preventable signature'>preventable</strong></div><div class='description'><div class='short'>Fires whenever a disclosure is handled ...</div><div class='long'><p>Fires whenever a disclosure is handled</p>\n        <div class='signature-box preventable'>\n        <p>This action following this event is <b>preventable</b>.\n        When any of the listeners returns false, the action is cancelled.</p>\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">Ext.dataview.List</a><div class='sub-desc'><p>The List instance</p>\n</div></li><li><span class='pre'>record</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a><div class='sub-desc'><p>The record assisciated to the item</p>\n</div></li><li><span class='pre'>target</span> : HTMLElement<div class='sub-desc'><p>The element doubletapped</p>\n</div></li><li><span class='pre'>index</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The index of the item doubletapped</p>\n</div></li><li><span class='pre'>e</span> : <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a><div class='sub-desc'><p>The event object</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-dockedchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-docked' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-dockedchange' class='name expandable'>dockedchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the docked configuration is changed by setDocked. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-docked\" rel=\"Ext.Component-cfg-docked\" class=\"docClass\">docked</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setDocked\" rel=\"Ext.Component-method-setDocked\" class=\"docClass\">setDocked</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-erased' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-erased' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-erased' class='name expandable'>erased</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>The opposite event of painted. ...</div><div class='long'><p>The opposite event of <a href=\"#!/api/Ext.Component-event-painted\" rel=\"Ext.Component-event-painted\" class=\"docClass\">painted</a>. This event fires whenever this Component are no longer visible\n(erased) on the screen. This might be triggered either when this Component <a href=\"#!/api/Ext.Component-cfg-hidden\" rel=\"Ext.Component-cfg-hidden\" class=\"docClass\">hidden</a> config is set to\n<code>true</code>, or when its Element is taken out of the document's DOM tree. This is normally useful to perform cleaning\nup after what you have set up from listening to <a href=\"#!/api/Ext.Component-event-painted\" rel=\"Ext.Component-event-painted\" class=\"docClass\">painted</a> event.</p>\n\n<p>Note: This event is not available to be used with event delegation. Instead 'erased' only fires if you explicily\nadd at least one listener to it, due to performance reason.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The component instance</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-floatingchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-floatingchange' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-floatingchange' class='name expandable'>floatingchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> floating, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever there is a change in the floating status of a component ...</div><div class='long'><p>Fires whenever there is a change in the floating status of a component</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The component instance</p>\n</div></li><li><span class='pre'>floating</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>The component's new floating state</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-fullscreen' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-fullscreen' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-fullscreen' class='name expandable'>fullscreen</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever a Component with the fullscreen config is instantiated ...</div><div class='long'><p>Fires whenever a Component with the fullscreen config is instantiated</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The component instance</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-heightchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-height' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-heightchange' class='name expandable'>heightchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the height configuration is changed by setHeight. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-height\" rel=\"Ext.Component-cfg-height\" class=\"docClass\">height</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setHeight\" rel=\"Ext.Component-method-setHeight\" class=\"docClass\">setHeight</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-hiddenchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hidden' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-hiddenchange' class='name expandable'>hiddenchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> value, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the hidden configuration is changed by setHidden. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-hidden\" rel=\"Ext.Component-cfg-hidden\" class=\"docClass\">hidden</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setHidden\" rel=\"Ext.Component-method-setHidden\" class=\"docClass\">setHidden</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-hide' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-hide' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-hide' class='name expandable'>hide</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever the Component is hidden ...</div><div class='long'><p>Fires whenever the Component is hidden</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The component instance</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-initialize' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-initialize' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-initialize' class='name expandable'>initialize</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the component has been initialized ...</div><div class='long'><p>Fires when the component has been initialized</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The component instance</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-itemdoubletap' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-event-itemdoubletap' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-event-itemdoubletap' class='name expandable'>itemdoubletap</a>( <span class='pre'><a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> index, <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/<a href=\"#!/api/Ext.dataview.component.DataItem\" rel=\"Ext.dataview.component.DataItem\" class=\"docClass\">Ext.dataview.component.DataItem</a> target, <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a> record, <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a> e, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever an item is doubletapped ...</div><div class='long'><p>Fires whenever an item is doubletapped</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a><div class='sub-desc'>\n</div></li><li><span class='pre'>index</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The index of the item doubletapped</p>\n</div></li><li><span class='pre'>target</span> : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/<a href=\"#!/api/Ext.dataview.component.DataItem\" rel=\"Ext.dataview.component.DataItem\" class=\"docClass\">Ext.dataview.component.DataItem</a><div class='sub-desc'><p>The element or DataItem doubletapped</p>\n</div></li><li><span class='pre'>record</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a><div class='sub-desc'><p>The record assosciated to the item</p>\n</div></li><li><span class='pre'>e</span> : <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a><div class='sub-desc'><p>The event object</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-itemsingletap' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-event-itemsingletap' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-event-itemsingletap' class='name expandable'>itemsingletap</a>( <span class='pre'><a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> index, <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/<a href=\"#!/api/Ext.dataview.component.DataItem\" rel=\"Ext.dataview.component.DataItem\" class=\"docClass\">Ext.dataview.component.DataItem</a> target, <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a> record, <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a> e, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever an item is singletapped ...</div><div class='long'><p>Fires whenever an item is singletapped</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a><div class='sub-desc'>\n</div></li><li><span class='pre'>index</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The index of the item singletapped</p>\n</div></li><li><span class='pre'>target</span> : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/<a href=\"#!/api/Ext.dataview.component.DataItem\" rel=\"Ext.dataview.component.DataItem\" class=\"docClass\">Ext.dataview.component.DataItem</a><div class='sub-desc'><p>The element or DataItem singletapped</p>\n</div></li><li><span class='pre'>record</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a><div class='sub-desc'><p>The record assosciated to the item</p>\n</div></li><li><span class='pre'>e</span> : <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a><div class='sub-desc'><p>The event object</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-itemswipe' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-event-itemswipe' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-event-itemswipe' class='name expandable'>itemswipe</a>( <span class='pre'><a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> index, <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/<a href=\"#!/api/Ext.dataview.component.DataItem\" rel=\"Ext.dataview.component.DataItem\" class=\"docClass\">Ext.dataview.component.DataItem</a> target, <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a> record, <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a> e, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever an item is swiped ...</div><div class='long'><p>Fires whenever an item is swiped</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a><div class='sub-desc'>\n</div></li><li><span class='pre'>index</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The index of the item swiped</p>\n</div></li><li><span class='pre'>target</span> : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/<a href=\"#!/api/Ext.dataview.component.DataItem\" rel=\"Ext.dataview.component.DataItem\" class=\"docClass\">Ext.dataview.component.DataItem</a><div class='sub-desc'><p>The element or DataItem swiped</p>\n</div></li><li><span class='pre'>record</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a><div class='sub-desc'><p>The record assosciated to the item</p>\n</div></li><li><span class='pre'>e</span> : <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a><div class='sub-desc'><p>The event object</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-itemtap' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-event-itemtap' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-event-itemtap' class='name expandable'>itemtap</a>( <span class='pre'><a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> index, <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/<a href=\"#!/api/Ext.dataview.component.DataItem\" rel=\"Ext.dataview.component.DataItem\" class=\"docClass\">Ext.dataview.component.DataItem</a> target, <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a> record, <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a> e, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever an item is tapped ...</div><div class='long'><p>Fires whenever an item is tapped</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a><div class='sub-desc'>\n</div></li><li><span class='pre'>index</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The index of the item tapped</p>\n</div></li><li><span class='pre'>target</span> : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/<a href=\"#!/api/Ext.dataview.component.DataItem\" rel=\"Ext.dataview.component.DataItem\" class=\"docClass\">Ext.dataview.component.DataItem</a><div class='sub-desc'><p>The element or DataItem tapped</p>\n</div></li><li><span class='pre'>record</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a><div class='sub-desc'><p>The record assosciated to the item</p>\n</div></li><li><span class='pre'>e</span> : <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a><div class='sub-desc'><p>The event object</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-itemtaphold' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-event-itemtaphold' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-event-itemtaphold' class='name expandable'>itemtaphold</a>( <span class='pre'><a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> index, <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/<a href=\"#!/api/Ext.dataview.component.DataItem\" rel=\"Ext.dataview.component.DataItem\" class=\"docClass\">Ext.dataview.component.DataItem</a> target, <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a> record, <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a> e, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever an item's taphold event fires ...</div><div class='long'><p>Fires whenever an item's taphold event fires</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a><div class='sub-desc'>\n</div></li><li><span class='pre'>index</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The index of the item touched</p>\n</div></li><li><span class='pre'>target</span> : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/<a href=\"#!/api/Ext.dataview.component.DataItem\" rel=\"Ext.dataview.component.DataItem\" class=\"docClass\">Ext.dataview.component.DataItem</a><div class='sub-desc'><p>The element or DataItem touched</p>\n</div></li><li><span class='pre'>record</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a><div class='sub-desc'><p>The record assosciated to the item</p>\n</div></li><li><span class='pre'>e</span> : <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a><div class='sub-desc'><p>The event object</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-itemtouchend' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-event-itemtouchend' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-event-itemtouchend' class='name expandable'>itemtouchend</a>( <span class='pre'><a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> index, <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/<a href=\"#!/api/Ext.dataview.component.DataItem\" rel=\"Ext.dataview.component.DataItem\" class=\"docClass\">Ext.dataview.component.DataItem</a> target, <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a> record, <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a> e, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever an item is touched ...</div><div class='long'><p>Fires whenever an item is touched</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a><div class='sub-desc'>\n</div></li><li><span class='pre'>index</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The index of the item touched</p>\n</div></li><li><span class='pre'>target</span> : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/<a href=\"#!/api/Ext.dataview.component.DataItem\" rel=\"Ext.dataview.component.DataItem\" class=\"docClass\">Ext.dataview.component.DataItem</a><div class='sub-desc'><p>The element or DataItem touched</p>\n</div></li><li><span class='pre'>record</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a><div class='sub-desc'><p>The record assosciated to the item</p>\n</div></li><li><span class='pre'>e</span> : <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a><div class='sub-desc'><p>The event object</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-itemtouchmove' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-event-itemtouchmove' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-event-itemtouchmove' class='name expandable'>itemtouchmove</a>( <span class='pre'><a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> index, <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/<a href=\"#!/api/Ext.dataview.component.DataItem\" rel=\"Ext.dataview.component.DataItem\" class=\"docClass\">Ext.dataview.component.DataItem</a> target, <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a> record, <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a> e, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever an item is moved ...</div><div class='long'><p>Fires whenever an item is moved</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a><div class='sub-desc'>\n</div></li><li><span class='pre'>index</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The index of the item moved</p>\n</div></li><li><span class='pre'>target</span> : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/<a href=\"#!/api/Ext.dataview.component.DataItem\" rel=\"Ext.dataview.component.DataItem\" class=\"docClass\">Ext.dataview.component.DataItem</a><div class='sub-desc'><p>The element or DataItem moved</p>\n</div></li><li><span class='pre'>record</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a><div class='sub-desc'><p>The record assosciated to the item</p>\n</div></li><li><span class='pre'>e</span> : <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a><div class='sub-desc'><p>The event object</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-itemtouchstart' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-event-itemtouchstart' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-event-itemtouchstart' class='name expandable'>itemtouchstart</a>( <span class='pre'><a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> index, <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/<a href=\"#!/api/Ext.dataview.component.DataItem\" rel=\"Ext.dataview.component.DataItem\" class=\"docClass\">Ext.dataview.component.DataItem</a> target, <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a> record, <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a> e, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever an item is touched ...</div><div class='long'><p>Fires whenever an item is touched</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a><div class='sub-desc'>\n</div></li><li><span class='pre'>index</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The index of the item touched</p>\n</div></li><li><span class='pre'>target</span> : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/<a href=\"#!/api/Ext.dataview.component.DataItem\" rel=\"Ext.dataview.component.DataItem\" class=\"docClass\">Ext.dataview.component.DataItem</a><div class='sub-desc'><p>The element or DataItem touched</p>\n</div></li><li><span class='pre'>record</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a><div class='sub-desc'><p>The record assosciated to the item</p>\n</div></li><li><span class='pre'>e</span> : <a href=\"#!/api/Ext.event.Event\" rel=\"Ext.event.Event\" class=\"docClass\">Ext.EventObject</a><div class='sub-desc'><p>The event object</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-leftchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-left' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-leftchange' class='name expandable'>leftchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the left configuration is changed by setLeft. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-left\" rel=\"Ext.Component-cfg-left\" class=\"docClass\">left</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setLeft\" rel=\"Ext.Component-method-setLeft\" class=\"docClass\">setLeft</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-maxheightchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-maxHeight' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-maxheightchange' class='name expandable'>maxheightchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the maxHeight configuration is changed by setMaxHeight. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-maxHeight\" rel=\"Ext.Component-cfg-maxHeight\" class=\"docClass\">maxHeight</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setMaxHeight\" rel=\"Ext.Component-method-setMaxHeight\" class=\"docClass\">setMaxHeight</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-maxwidthchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-maxWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-maxwidthchange' class='name expandable'>maxwidthchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the maxWidth configuration is changed by setMaxWidth. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-maxWidth\" rel=\"Ext.Component-cfg-maxWidth\" class=\"docClass\">maxWidth</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setMaxWidth\" rel=\"Ext.Component-method-setMaxWidth\" class=\"docClass\">setMaxWidth</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-minheightchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-minHeight' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-minheightchange' class='name expandable'>minheightchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the minHeight configuration is changed by setMinHeight. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-minHeight\" rel=\"Ext.Component-cfg-minHeight\" class=\"docClass\">minHeight</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setMinHeight\" rel=\"Ext.Component-method-setMinHeight\" class=\"docClass\">setMinHeight</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-minwidthchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-minWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-minwidthchange' class='name expandable'>minwidthchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the minWidth configuration is changed by setMinWidth. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-minWidth\" rel=\"Ext.Component-cfg-minWidth\" class=\"docClass\">minWidth</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setMinWidth\" rel=\"Ext.Component-method-setMinWidth\" class=\"docClass\">setMinWidth</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-orientationchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-orientationchange' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-orientationchange' class='name expandable'>orientationchange</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )<strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>Fires when orientation changes. ...</div><div class='long'><p>Fires when orientation changes.</p>\n        <div class='signature-box removed'>\n        <p>This event has been <strong>removed</strong> since 2.0.0</p>\n        <p>This event is now only available on the Viewport's <a href=\"#!/api/Ext.Viewport-event-orientationchange\" rel=\"Ext.Viewport-event-orientationchange\" class=\"docClass\">Ext.Viewport.orientationchange</a></p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-painted' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-painted' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-painted' class='name expandable'>painted</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever this Component actually becomes visible (painted) on the screen. ...</div><div class='long'><p>Fires whenever this Component actually becomes visible (painted) on the screen. This is useful when you need to\nperform 'read' operations on the DOM element, i.e: calculating natural sizes and positioning. If you just need\nperform post-initialization tasks that don't rely on the fact that the element must be rendered and visible on\nthe screen, listen to <a href=\"#!/api/Ext.Component-event-initialize\" rel=\"Ext.Component-event-initialize\" class=\"docClass\">initialize</a></p>\n\n<p>Note: This event is not available to be used with event delegation. Instead 'painted' only fires if you explicily\nadd at least one listener to it, due to performance reason.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The component instance</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-refresh' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-event-refresh' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-event-refresh' class='name expandable'>refresh</a>( <span class='pre'><a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )<strong class='preventable signature'>preventable</strong></div><div class='description'><div class='short'>Fires whenever the DataView is refreshed ...</div><div class='long'><p>Fires whenever the DataView is refreshed</p>\n        <div class='signature-box preventable'>\n        <p>This action following this event is <b>preventable</b>.\n        When any of the listeners returns false, the action is cancelled.</p>\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a><div class='sub-desc'>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-renderedchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Container' rel='Ext.Container' class='defined-in docClass'>Ext.Container</a><br/><a href='source/Container2.html#Ext-Container-event-renderedchange' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Container-event-renderedchange' class='name expandable'>renderedchange</a>( <span class='pre'><a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> item, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> rendered, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Fires whenever an item is rendered into a container or derendered\nfrom a Container ...</div><div class='long'><p>Fires whenever an item is rendered into a container or derendered\nfrom a Container</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a><div class='sub-desc'><p>The Container instance</p>\n</div></li><li><span class='pre'>item</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The item in the Container</p>\n</div></li><li><span class='pre'>rendered</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>The current rendered status of the item</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-resize' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-resize' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-resize' class='name expandable'>resize</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Important note: For the best performance on mobile devices, use this only when you absolutely need to monitor\na Compo...</div><div class='long'><p>Important note: For the best performance on mobile devices, use this only when you absolutely need to monitor\na Component's size.</p>\n\n<p>Note: This event is not available to be used with event delegation. Instead 'resize' only fires if you explicily\nadd at least one listener to it, due to performance reason.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The component instance</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-rightchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-right' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-rightchange' class='name expandable'>rightchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the right configuration is changed by setRight. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-right\" rel=\"Ext.Component-cfg-right\" class=\"docClass\">right</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setRight\" rel=\"Ext.Component-method-setRight\" class=\"docClass\">setRight</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-select' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.dataview.DataView' rel='Ext.dataview.DataView' class='defined-in docClass'>Ext.dataview.DataView</a><br/><a href='source/DataView.html#Ext-dataview-DataView-event-select' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.DataView-event-select' class='name expandable'>select</a>( <span class='pre'><a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a> this, <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a> record, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )<strong class='preventable signature'>preventable</strong></div><div class='description'><div class='short'>Fires whenever an item is selected ...</div><div class='long'><p>Fires whenever an item is selected</p>\n        <div class='signature-box preventable'>\n        <p>This action following this event is <b>preventable</b>.\n        When any of the listeners returns false, the action is cancelled.</p>\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.dataview.DataView\" rel=\"Ext.dataview.DataView\" class=\"docClass\">Ext.dataview.DataView</a><div class='sub-desc'>\n</div></li><li><span class='pre'>record</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a><div class='sub-desc'><p>The record assosciated to the item</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-selectionchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Selectable' rel='Ext.mixin.Selectable' class='defined-in docClass'>Ext.mixin.Selectable</a><br/><a href='source/Selectable.html#Ext-mixin-Selectable-event-selectionchange' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Selectable-event-selectionchange' class='name expandable'>selectionchange</a>( <span class='pre'><a href=\"#!/api/Ext.mixin.Selectable\" rel=\"Ext.mixin.Selectable\" class=\"docClass\">Ext.mixin.Selectable</a> this, <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a>[] records, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when a selection changes ...</div><div class='long'><p>Fires when a selection changes</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.mixin.Selectable\" rel=\"Ext.mixin.Selectable\" class=\"docClass\">Ext.mixin.Selectable</a><div class='sub-desc'>\n</div></li><li><span class='pre'>records</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a>[]<div class='sub-desc'><p>The records whose selection has changed</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n</div></li></ul></div></div></div><div id='event-show' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-show' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-show' class='name expandable'>show</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever the Component is shown ...</div><div class='long'><p>Fires whenever the Component is shown</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The component instance</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-topchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-top' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-topchange' class='name expandable'>topchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the top configuration is changed by setTop. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-top\" rel=\"Ext.Component-cfg-top\" class=\"docClass\">top</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setTop\" rel=\"Ext.Component-method-setTop\" class=\"docClass\">setTop</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-updatedata' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-updatedata' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-updatedata' class='name expandable'>updatedata</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> newData, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever the data of the component is updated ...</div><div class='long'><p>Fires whenever the data of the component is updated</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The component instance</p>\n</div></li><li><span class='pre'>newData</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The new data</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-widthchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-width' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-widthchange' class='name expandable'>widthchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the width configuration is changed by setWidth. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-width\" rel=\"Ext.Component-cfg-width\" class=\"docClass\">width</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setWidth\" rel=\"Ext.Component-method-setWidth\" class=\"docClass\">setWidth</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-css_var'>CSS Variables</h3><div class='subsection'><div id='css_var-S-include-list-highlights' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/_list.scss.html#Ext-dataview-List-css_var-S-include-list-highlights' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-css_var-S-include-list-highlights' class='name expandable'>$include-list-highlights</a><span> : color</span></div><div class='description'><div class='short'>Optionally disable all list gradients, text-shadows, and box-shadows. ...</div><div class='long'><p>Optionally disable all list gradients, text-shadows, and box-shadows. Useful for CSS debugging,\nnon-performant browsers, or minimalist designs.</p>\n</div></div></div><div id='css_var-S-list-active-color' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/_list.scss.html#Ext-dataview-List-css_var-S-list-active-color' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-css_var-S-list-active-color' class='name not-expandable'>$list-active-color</a><span> : color</span></div><div class='description'><div class='short'><p>Background-color for selected list rows.</p>\n</div><div class='long'><p>Background-color for selected list rows.</p>\n</div></div></div><div id='css_var-S-list-active-gradient' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/_list.scss.html#Ext-dataview-List-css_var-S-list-active-gradient' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-css_var-S-list-active-gradient' class='name not-expandable'>$list-active-gradient</a><span> : string</span></div><div class='description'><div class='short'><p>Gradient style for selected list rows.</p>\n</div><div class='long'><p>Gradient style for selected list rows.</p>\n</div></div></div><div id='css_var-S-list-bg-color' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/_list.scss.html#Ext-dataview-List-css_var-S-list-bg-color' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-css_var-S-list-bg-color' class='name not-expandable'>$list-bg-color</a><span> : color</span></div><div class='description'><div class='short'><p>Background-color for list rows.</p>\n</div><div class='long'><p>Background-color for list rows.</p>\n</div></div></div><div id='css_var-S-list-color' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/_list.scss.html#Ext-dataview-List-css_var-S-list-color' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-css_var-S-list-color' class='name not-expandable'>$list-color</a><span> : color</span></div><div class='description'><div class='short'><p>Text color for list rows.</p>\n</div><div class='long'><p>Text color for list rows.</p>\n</div></div></div><div id='css_var-S-list-disclosure-round-size' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/_list.scss.html#Ext-dataview-List-css_var-S-list-disclosure-round-size' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-css_var-S-list-disclosure-round-size' class='name not-expandable'>$list-disclosure-round-size</a><span> : measurement</span></div><div class='description'><div class='short'><p>Default size (width/height) for disclosure icons in a list with a 'round' ui.</p>\n</div><div class='long'><p>Default size (width/height) for disclosure icons in a list with a 'round' ui.</p>\n</div></div></div><div id='css_var-S-list-disclosure-size' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/_list.scss.html#Ext-dataview-List-css_var-S-list-disclosure-size' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-css_var-S-list-disclosure-size' class='name not-expandable'>$list-disclosure-size</a><span> : measurement</span></div><div class='description'><div class='short'><p>Default size (width/height) for disclosure icons.</p>\n</div><div class='long'><p>Default size (width/height) for disclosure icons.</p>\n</div></div></div><div id='css_var-S-list-header-bg-color' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/_list.scss.html#Ext-dataview-List-css_var-S-list-header-bg-color' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-css_var-S-list-header-bg-color' class='name not-expandable'>$list-header-bg-color</a><span> : color</span></div><div class='description'><div class='short'><p>Background-color for list header rows (in grouped lists).</p>\n</div><div class='long'><p>Background-color for list header rows (in grouped lists).</p>\n</div></div></div><div id='css_var-S-list-header-gradient' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/_list.scss.html#Ext-dataview-List-css_var-S-list-header-gradient' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-css_var-S-list-header-gradient' class='name not-expandable'>$list-header-gradient</a><span> : string</span></div><div class='description'><div class='short'><p>Gradient style for list header rows (in grouped lists).</p>\n</div><div class='long'><p>Gradient style for list header rows (in grouped lists).</p>\n</div></div></div><div id='css_var-S-list-pressed-color' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/_list.scss.html#Ext-dataview-List-css_var-S-list-pressed-color' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-css_var-S-list-pressed-color' class='name not-expandable'>$list-pressed-color</a><span> : color</span></div><div class='description'><div class='short'><p>Background-color for pressed list rows.</p>\n</div><div class='long'><p>Background-color for pressed list rows.</p>\n</div></div></div><div id='css_var-S-list-zebrastripe' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/_list.scss.html#Ext-dataview-List-css_var-S-list-zebrastripe' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-css_var-S-list-zebrastripe' class='name not-expandable'>$list-zebrastripe</a><span> : boolean</span></div><div class='description'><div class='short'><p>Optionally zebra-stripe the list (alternating background colors).</p>\n</div><div class='long'><p>Optionally zebra-stripe the list (alternating background colors).</p>\n</div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-css_mixin'>CSS Mixins</h3><div class='subsection'><div id='css_mixin-sencha-list' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.dataview.List'>Ext.dataview.List</span><br/><a href='source/_list.scss.html#Ext-dataview-List-css_mixin-sencha-list' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.dataview.List-css_mixin-sencha-list' class='name expandable'>sencha-list</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Includes default list styles. ...</div><div class='long'><p>Includes default list styles.</p>\n</div></div></div></div></div></div></div>","parentMixins":["Ext.mixin.Selectable","Ext.mixin.Traversable","Ext.mixin.Observable"],"superclasses":["Ext.Base","Ext.Evented","Ext.AbstractComponent","Ext.Component","Ext.Container","Ext.dataview.DataView"],"tagname":"class","extends":"Ext.dataview.DataView","alternateClassNames":["Ext.List"],"requires":["Ext.dataview.element.List","Ext.dataview.IndexBar","Ext.dataview.ListItemHeader"],"inheritdoc":null,"members":{"event":[{"meta":{},"owner":"Ext.Container","tagname":"event","name":"activate","id":"event-activate"},{"meta":{},"owner":"Ext.Container","tagname":"event","name":"activeitemchange","id":"event-activeitemchange"},{"meta":{"removed":{"text":"This event is now only available onBefore the Viewport's {@link Ext.Viewport#orientationchange}","version":"2.0.0"}},"owner":"Ext.Component","tagname":"event","name":"beforeorientationchange","id":"event-beforeorientationchange"},{"meta":{"preventable":true,"deprecated":{"text":"Please listen to the {@link #selectionchange} event with an order of `before` instead.","version":"2.0.0"}},"owner":"Ext.mixin.Selectable","tagname":"event","name":"beforeselectionchange","id":"event-beforeselectionchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"bottomchange","id":"event-bottomchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"centeredchange","id":"event-centeredchange"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"event","name":"containertap","id":"event-containertap"},{"meta":{},"owner":"Ext.Container","tagname":"event","name":"deactivate","id":"event-deactivate"},{"meta":{"preventable":true},"owner":"Ext.dataview.DataView","tagname":"event","name":"deselect","id":"event-deselect"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"disabledchange","id":"event-disabledchange"},{"meta":{"preventable":true},"owner":"Ext.dataview.List","tagname":"event","name":"disclose","id":"event-disclose"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"dockedchange","id":"event-dockedchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"erased","id":"event-erased"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"floatingchange","id":"event-floatingchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"fullscreen","id":"event-fullscreen"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"heightchange","id":"event-heightchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"hiddenchange","id":"event-hiddenchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"hide","id":"event-hide"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"initialize","id":"event-initialize"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"event","name":"itemdoubletap","id":"event-itemdoubletap"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"event","name":"itemsingletap","id":"event-itemsingletap"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"event","name":"itemswipe","id":"event-itemswipe"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"event","name":"itemtap","id":"event-itemtap"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"event","name":"itemtaphold","id":"event-itemtaphold"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"event","name":"itemtouchend","id":"event-itemtouchend"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"event","name":"itemtouchmove","id":"event-itemtouchmove"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"event","name":"itemtouchstart","id":"event-itemtouchstart"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"leftchange","id":"event-leftchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"maxheightchange","id":"event-maxheightchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"maxwidthchange","id":"event-maxwidthchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"minheightchange","id":"event-minheightchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"minwidthchange","id":"event-minwidthchange"},{"meta":{"removed":{"text":"This event is now only available on the Viewport's {@link Ext.Viewport#orientationchange}","version":"2.0.0"}},"owner":"Ext.Component","tagname":"event","name":"orientationchange","id":"event-orientationchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"painted","id":"event-painted"},{"meta":{"preventable":true},"owner":"Ext.dataview.DataView","tagname":"event","name":"refresh","id":"event-refresh"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"event","name":"renderedchange","id":"event-renderedchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"resize","id":"event-resize"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"rightchange","id":"event-rightchange"},{"meta":{"preventable":true},"owner":"Ext.dataview.DataView","tagname":"event","name":"select","id":"event-select"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"event","name":"selectionchange","id":"event-selectionchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"show","id":"event-show"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"topchange","id":"event-topchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"updatedata","id":"event-updatedata"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"widthchange","id":"event-widthchange"}],"property":[{"meta":{"private":true},"owner":"Ext.Component","tagname":"property","name":"alignmentRegex","id":"property-alignmentRegex"},{"meta":{"private":true,"readonly":true},"owner":"Ext.Component","tagname":"property","name":"dockPositions","id":"property-dockPositions"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"property","name":"floating","id":"property-floating"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"property","name":"isComponent","id":"property-isComponent"},{"meta":{"deprecated":{"text":"Please use {@link #getItems} method instead.","version":"2.0.0"}},"owner":"Ext.Container","tagname":"property","name":"items","id":"property-items"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"property","name":"listenerOptionsRegex","id":"property-listenerOptionsRegex"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"property","name":"rendered","id":"property-rendered"},{"meta":{"protected":true},"owner":"Ext.Base","tagname":"property","name":"self","id":"property-self"}],"css_var":[{"meta":{},"owner":"Ext.dataview.List","tagname":"css_var","name":"$include-list-highlights","id":"css_var-S-include-list-highlights"},{"meta":{},"owner":"Ext.dataview.List","tagname":"css_var","name":"$list-active-color","id":"css_var-S-list-active-color"},{"meta":{},"owner":"Ext.dataview.List","tagname":"css_var","name":"$list-active-gradient","id":"css_var-S-list-active-gradient"},{"meta":{},"owner":"Ext.dataview.List","tagname":"css_var","name":"$list-bg-color","id":"css_var-S-list-bg-color"},{"meta":{},"owner":"Ext.dataview.List","tagname":"css_var","name":"$list-color","id":"css_var-S-list-color"},{"meta":{},"owner":"Ext.dataview.List","tagname":"css_var","name":"$list-disclosure-round-size","id":"css_var-S-list-disclosure-round-size"},{"meta":{},"owner":"Ext.dataview.List","tagname":"css_var","name":"$list-disclosure-size","id":"css_var-S-list-disclosure-size"},{"meta":{},"owner":"Ext.dataview.List","tagname":"css_var","name":"$list-header-bg-color","id":"css_var-S-list-header-bg-color"},{"meta":{},"owner":"Ext.dataview.List","tagname":"css_var","name":"$list-header-gradient","id":"css_var-S-list-header-gradient"},{"meta":{},"owner":"Ext.dataview.List","tagname":"css_var","name":"$list-pressed-color","id":"css_var-S-list-pressed-color"},{"meta":{},"owner":"Ext.dataview.List","tagname":"css_var","name":"$list-zebrastripe","id":"css_var-S-list-zebrastripe"}],"css_mixin":[{"meta":{},"owner":"Ext.dataview.List","tagname":"css_mixin","name":"sencha-list","id":"css_mixin-sencha-list"}],"method":[{"meta":{},"owner":"Ext.Component","tagname":"method","name":"constructor","id":"method-constructor"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"add","id":"method-add"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"addAfterListener","id":"method-addAfterListener"},{"meta":{"deprecated":{"text":"Please use {@link #method-add} instead.","version":"2.0.0"}},"owner":"Ext.Container","tagname":"method","name":"addAll","id":"method-addAll"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"addBeforeListener","id":"method-addBeforeListener"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"addCls","id":"method-addCls"},{"meta":{"deprecated":{"text":"It's no longer needed to add events before firing.","version":"2.0"}},"owner":"Ext.mixin.Observable","tagname":"method","name":"addEvents","id":"method-addEvents"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"addListener","id":"method-addListener"},{"meta":{"deprecated":{"text":"All listeners are now automatically managed where necessary. Simply use {@link #addListener}.","version":"2.0"}},"owner":"Ext.mixin.Observable","tagname":"method","name":"addManagedListener","id":"method-addManagedListener"},{"meta":{"private":true},"owner":"Ext.AbstractComponent","tagname":"method","name":"addReferenceNode","id":"method-addReferenceNode"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"alignTo","id":"method-alignTo"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"animateActiveItem","id":"method-animateActiveItem"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"applyActiveItem","id":"method-applyActiveItem"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"applyCls","id":"method-applyCls"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"applyControl","id":"method-applyControl"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"applyMasked","id":"method-applyMasked"},{"meta":{"private":true},"owner":"Ext.mixin.Selectable","tagname":"method","name":"applyMode","id":"method-applyMode"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"applyScrollable","id":"method-applyScrollable"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"applyTpl","id":"method-applyTpl"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"beforeInitialize","id":"method-beforeInitialize"},{"meta":{"deprecated":{"text":"please use {@link #setStore} instead","version":"2.0"}},"owner":"Ext.dataview.DataView","tagname":"method","name":"bindStore","id":"method-bindStore"},{"meta":{"protected":true},"owner":"Ext.Base","tagname":"method","name":"callOverridden","id":"method-callOverridden"},{"meta":{"protected":true},"owner":"Ext.Base","tagname":"method","name":"callParent","id":"method-callParent"},{"meta":{"private":true},"owner":"Ext.mixin.Observable","tagname":"method","name":"changeListener","id":"method-changeListener"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"child","id":"method-child"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"clearListeners","id":"method-clearListeners"},{"meta":{"deprecated":{"text":"Please use {@link #deselectAll} instead.","version":"2.0.0"}},"owner":"Ext.mixin.Selectable","tagname":"method","name":"clearSelections","id":"method-clearSelections"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"method","name":"collectData","id":"method-collectData"},{"meta":{"private":true},"owner":"Ext.mixin.Observable","tagname":"method","name":"createEventRelayer","id":"method-createEventRelayer"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"method","name":"deselect","id":"method-deselect"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"method","name":"deselectAll","id":"method-deselectAll"},{"meta":{"private":true},"owner":"Ext.Base","tagname":"method","name":"destroy","id":"method-destroy"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"disable","id":"method-disable"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"doAdd","id":"method-doAdd"},{"meta":{"private":true},"owner":"Ext.mixin.Observable","tagname":"method","name":"doAddListener","id":"method-doAddListener"},{"meta":{"deprecated":{"text":"Please use {@link #deselect} instead.","version":"2.0.0"}},"owner":"Ext.mixin.Selectable","tagname":"method","name":"doDeselect","id":"method-doDeselect"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"doInsert","id":"method-doInsert"},{"meta":{"private":true},"owner":"Ext.mixin.Selectable","tagname":"method","name":"doMultiSelect","id":"method-doMultiSelect"},{"meta":{"deprecated":{"text":"Please use {@link #select} instead.","version":"2.0.0"}},"owner":"Ext.mixin.Selectable","tagname":"method","name":"doSelect","id":"method-doSelect"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"doSetActiveItem","id":"method-doSetActiveItem"},{"meta":{"private":true},"owner":"Ext.mixin.Selectable","tagname":"method","name":"doSingleSelect","id":"method-doSingleSelect"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"down","id":"method-down"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"enable","id":"method-enable"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"enableBubble","id":"method-enableBubble"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"method","name":"findItemByChild","id":"method-findItemByChild"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"method","name":"findTargetByEvent","id":"method-findTargetByEvent"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"fireAction","id":"method-fireAction"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"fireEvent","id":"method-fireEvent"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"getActiveItem","id":"method-getActiveItem"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"method","name":"getAllowDeselect","id":"method-getAllowDeselect"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"getAt","id":"method-getAt"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"getAutoDestroy","id":"method-getAutoDestroy"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getBaseCls","id":"method-getBaseCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getBorder","id":"method-getBorder"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getBottom","id":"method-getBottom"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"getBubbleEvents","id":"method-getBubbleEvents"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getCentered","id":"method-getCentered"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getCls","id":"method-getCls"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"getComponent","id":"method-getComponent"},{"meta":{"private":true},"owner":"Ext.Base","tagname":"method","name":"getConfig","id":"method-getConfig"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getContentEl","id":"method-getContentEl"},{"meta":{"deprecated":{"text":"Please use {@link #getSelectionCount} instead.","version":"2.0.0"}},"owner":"Ext.mixin.Selectable","tagname":"method","name":"getCount","id":"method-getCount"},{"meta":{"private":true},"owner":"Ext.Base","tagname":"method","name":"getCurrentConfig","id":"method-getCurrentConfig"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getData","id":"method-getData"},{"meta":{"private":true},"owner":"Ext.dataview.List","tagname":"method","name":"getDefaultType","id":"method-getDefaultType"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"getDefaults","id":"method-getDefaults"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"getDeselectOnContainerClick","id":"method-getDeselectOnContainerClick"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"method","name":"getDisableSelection","id":"method-getDisableSelection"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getDisabled","id":"method-getDisabled"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getDisabledCls","id":"method-getDisabledCls"},{"meta":{},"owner":"Ext.dataview.List","tagname":"method","name":"getDisclosureProperty","id":"method-getDisclosureProperty"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getDocked","id":"method-getDocked"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"getDockedComponent","id":"method-getDockedComponent"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"getDockedItems","id":"method-getDockedItems"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getDraggable","id":"method-getDraggable"},{"meta":{"deprecated":{"text":"2.0.0 Please access the Component's element from the 'element' property instead, i.e:\n\n     var element = component.element;"}},"owner":"Ext.Component","tagname":"method","name":"getEl","id":"method-getEl"},{"meta":{"deprecated":{"text":"Please use {@link #showAnimation} instead.","version":"2.0.0"}},"owner":"Ext.Component","tagname":"method","name":"getEnterAnimation","id":"method-getEnterAnimation"},{"meta":{"deprecated":{"text":"2.0.0 Please use {@link #hideAnimation} instead.  Typically you want to use an\noutbound animation type such as 'fadeOut' or 'slideOut'."}},"owner":"Ext.Component","tagname":"method","name":"getExitAnimation","id":"method-getExitAnimation"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getFloatingCls","id":"method-getFloatingCls"},{"meta":{},"owner":"Ext.dataview.List","tagname":"method","name":"getGrouped","id":"method-getGrouped"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getHeight","id":"method-getHeight"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getHidden","id":"method-getHidden"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getHiddenCls","id":"method-getHiddenCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getHideAnimation","id":"method-getHideAnimation"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"getHideOnMaskTap","id":"method-getHideOnMaskTap"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getHtml","id":"method-getHtml"},{"meta":{},"owner":"Ext.mixin.Identifiable","tagname":"method","name":"getId","id":"method-getId"},{"meta":{},"owner":"Ext.dataview.List","tagname":"method","name":"getIndexBar","id":"method-getIndexBar"},{"meta":{},"owner":"Ext.Base","tagname":"method","name":"getInitialConfig","id":"method-getInitialConfig"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"getInline","id":"method-getInline"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"getInnerItems","id":"method-getInnerItems"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"getItemCls","id":"method-getItemCls"},{"meta":{"private":true},"owner":"Ext.dataview.List","tagname":"method","name":"getItemConfig","id":"method-getItemConfig"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getItemId","id":"method-getItemId"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"getItems","id":"method-getItems"},{"meta":{"private":true},"owner":"Ext.mixin.Selectable","tagname":"method","name":"getLastFocused","id":"method-getLastFocused"},{"meta":{"deprecated":{"text":"","version":"2.0.0"}},"owner":"Ext.mixin.Selectable","tagname":"method","name":"getLastSelected","id":"method-getLastSelected"},{"meta":{"private":true},"owner":"Ext.dataview.DataView","tagname":"method","name":"getLayout","id":"method-getLayout"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getLeft","id":"method-getLeft"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"getListeners","id":"method-getListeners"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getMargin","id":"method-getMargin"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"getMasked","id":"method-getMasked"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getMaxHeight","id":"method-getMaxHeight"},{"meta":{"private":true},"owner":"Ext.dataview.List","tagname":"method","name":"getMaxItemCache","id":"method-getMaxItemCache"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getMaxWidth","id":"method-getMaxWidth"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getMinHeight","id":"method-getMinHeight"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getMinWidth","id":"method-getMinWidth"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"getModal","id":"method-getModal"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"method","name":"getMode","id":"method-getMode"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"method","name":"getNode","id":"method-getNode"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"method","name":"getNodes","id":"method-getNodes"},{"meta":{},"owner":"Ext.dataview.List","tagname":"method","name":"getOnItemDisclosure","id":"method-getOnItemDisclosure"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getPadding","id":"method-getPadding"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getParent","id":"method-getParent"},{"meta":{},"owner":"Ext.dataview.List","tagname":"method","name":"getPinHeaders","id":"method-getPinHeaders"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getPlugins","id":"method-getPlugins"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"getPressedCls","id":"method-getPressedCls"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"getPressedDelay","id":"method-getPressedDelay"},{"meta":{},"owner":"Ext.dataview.List","tagname":"method","name":"getPreventSelectionOnDisclose","id":"method-getPreventSelectionOnDisclose"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getRecord","id":"method-getRecord"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"method","name":"getRecords","id":"method-getRecords"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getRenderTo","id":"method-getRenderTo"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getRenderTpl","id":"method-getRenderTpl"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getRight","id":"method-getRight"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"getScrollToTopOnRefresh","id":"method-getScrollToTopOnRefresh"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"getScrollable","id":"method-getScrollable"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"getScrollableBehavior","id":"method-getScrollableBehavior"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"getSelectedCls","id":"method-getSelectedCls"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"method","name":"getSelectedNodes","id":"method-getSelectedNodes"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"method","name":"getSelectedRecords","id":"method-getSelectedRecords"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"method","name":"getSelection","id":"method-getSelection"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"method","name":"getSelectionCount","id":"method-getSelectionCount"},{"meta":{"deprecated":{"text":"Please use {@link #getMode} instead.","version":"2.0.0"}},"owner":"Ext.mixin.Selectable","tagname":"method","name":"getSelectionMode","id":"method-getSelectionMode"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getShowAnimation","id":"method-getShowAnimation"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getSize","id":"method-getSize"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"getStore","id":"method-getStore"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getStyle","id":"method-getStyle"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getStyleHtmlCls","id":"method-getStyleHtmlCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getStyleHtmlContent","id":"method-getStyleHtmlContent"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getTop","id":"method-getTop"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getTpl","id":"method-getTpl"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getTplWriteMode","id":"method-getTplWriteMode"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"getTranslatable","id":"method-getTranslatable"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"getTriggerCtEvent","id":"method-getTriggerCtEvent"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"getTriggerEvent","id":"method-getTriggerEvent"},{"meta":{"private":true},"owner":"Ext.dataview.List","tagname":"method","name":"getUseComponents","id":"method-getUseComponents"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getWidth","id":"method-getWidth"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getXTypes","id":"method-getXTypes"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getZIndex","id":"method-getZIndex"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"handleException","id":"method-handleException"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"has","id":"method-has"},{"meta":{"private":true},"owner":"Ext.Base","tagname":"method","name":"hasConfig","id":"method-hasConfig"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"hasInnerItem","id":"method-hasInnerItem"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"hasListener","id":"method-hasListener"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"hasParent","id":"method-hasParent"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"method","name":"hasSelection","id":"method-hasSelection"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"hide","id":"method-hide"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"method","name":"indexOf","id":"method-indexOf"},{"meta":{"protected":true},"owner":"Ext.Base","tagname":"method","name":"initConfig","id":"method-initConfig"},{"meta":{"template":true,"protected":true},"owner":"Ext.Component","tagname":"method","name":"initialize","id":"method-initialize"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"insert","id":"method-insert"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"insertAfter","id":"method-insertAfter"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"insertBefore","id":"method-insertBefore"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"insertFirst","id":"method-insertFirst"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"insertInner","id":"method-insertInner"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"insertLast","id":"method-insertLast"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"isDisabled","id":"method-isDisabled"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"isHidden","id":"method-isHidden"},{"meta":{"deprecated":{"text":"Please use {@link #getDisableSelection} instead.","version":"2.0.0"}},"owner":"Ext.mixin.Selectable","tagname":"method","name":"isLocked","id":"method-isLocked"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"isPainted","id":"method-isPainted"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"isRendered","id":"method-isRendered"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"method","name":"isSelected","id":"method-isSelected"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"isXType","id":"method-isXType"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"mask","id":"method-mask"},{"meta":{"deprecated":{"text":"This is now done automatically","version":"2.0.0"}},"owner":"Ext.mixin.Observable","tagname":"method","name":"mon","id":"method-mon"},{"meta":{"deprecated":{"text":"This is now done automatically","version":"2.0.0"}},"owner":"Ext.mixin.Observable","tagname":"method","name":"mun","id":"method-mun"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"on","id":"method-on"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"onAfter","id":"method-onAfter"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"onBefore","id":"method-onBefore"},{"meta":{"private":true},"owner":"Ext.Base","tagname":"method","name":"onConfigUpdate","id":"method-onConfigUpdate"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"onFirstItemAdd","id":"method-onFirstItemAdd"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"onInitialized","id":"method-onInitialized"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"onItemAdd","id":"method-onItemAdd"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"onItemCenteredChange","id":"method-onItemCenteredChange"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"onItemDockedChange","id":"method-onItemDockedChange"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"onItemFloatingChange","id":"method-onItemFloatingChange"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"onItemMove","id":"method-onItemMove"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"onItemRemove","id":"method-onItemRemove"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"onShowByErased","id":"method-onShowByErased"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"prepareData","id":"method-prepareData"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"query","id":"method-query"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"refresh","id":"method-refresh"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"method","name":"refreshNode","id":"method-refreshNode"},{"meta":{"private":true},"owner":"Ext.mixin.Selectable","tagname":"method","name":"refreshSelection","id":"method-refreshSelection"},{"meta":{"private":true},"owner":"Ext.mixin.Observable","tagname":"method","name":"relayEvent","id":"method-relayEvent"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"relayEvents","id":"method-relayEvents"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"remove","id":"method-remove"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"removeAfterListener","id":"method-removeAfterListener"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"removeAll","id":"method-removeAll"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"removeAt","id":"method-removeAt"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"removeBeforeListener","id":"method-removeBeforeListener"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"removeCls","id":"method-removeCls"},{"meta":{"deprecated":{"text":"Please use {@link #method-remove} instead.","version":"2.0.0"}},"owner":"Ext.Container","tagname":"method","name":"removeDocked","id":"method-removeDocked"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"removeInner","id":"method-removeInner"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"removeInnerAt","id":"method-removeInnerAt"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"removeListener","id":"method-removeListener"},{"meta":{"deprecated":{"text":"All listeners are now automatically managed where necessary. Simply use {@link #removeListener}.","version":"2.0"}},"owner":"Ext.mixin.Observable","tagname":"method","name":"removeManagedListener","id":"method-removeManagedListener"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"replaceCls","id":"method-replaceCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"resetFloating","id":"method-resetFloating"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"resumeEvents","id":"method-resumeEvents"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"method","name":"select","id":"method-select"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"method","name":"selectAll","id":"method-selectAll"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"method","name":"selectRange","id":"method-selectRange"},{"meta":{"private":true},"owner":"Ext.dataview.List","tagname":"method","name":"setActiveGroup","id":"method-setActiveGroup"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"setActiveItem","id":"method-setActiveItem"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"method","name":"setAllowDeselect","id":"method-setAllowDeselect"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"setAutoDestroy","id":"method-setAutoDestroy"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setBaseCls","id":"method-setBaseCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setBorder","id":"method-setBorder"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setBottom","id":"method-setBottom"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"setBubbleEvents","id":"method-setBubbleEvents"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setCentered","id":"method-setCentered"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setCls","id":"method-setCls"},{"meta":{"private":true},"owner":"Ext.Base","tagname":"method","name":"setConfig","id":"method-setConfig"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setContentEl","id":"method-setContentEl"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setData","id":"method-setData"},{"meta":{"private":true},"owner":"Ext.dataview.List","tagname":"method","name":"setDefaultType","id":"method-setDefaultType"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"setDefaults","id":"method-setDefaults"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"setDeselectOnContainerClick","id":"method-setDeselectOnContainerClick"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"method","name":"setDisableSelection","id":"method-setDisableSelection"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setDisabled","id":"method-setDisabled"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setDisabledCls","id":"method-setDisabledCls"},{"meta":{},"owner":"Ext.dataview.List","tagname":"method","name":"setDisclosureProperty","id":"method-setDisclosureProperty"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setDocked","id":"method-setDocked"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setDraggable","id":"method-setDraggable"},{"meta":{"deprecated":{"text":"Please use {@link #showAnimation} instead.","version":"2.0.0"}},"owner":"Ext.Component","tagname":"method","name":"setEnterAnimation","id":"method-setEnterAnimation"},{"meta":{"deprecated":{"text":"2.0.0 Please use {@link #hideAnimation} instead.  Typically you want to use an\noutbound animation type such as 'fadeOut' or 'slideOut'."}},"owner":"Ext.Component","tagname":"method","name":"setExitAnimation","id":"method-setExitAnimation"},{"meta":{"deprecated":{"text":"This has been deprecated. Please use {@link #setTop}, {@link #setRight}, {@link #setBottom} and {@link #setLeft} instead.","version":"2.0.0"}},"owner":"Ext.Component","tagname":"method","name":"setFloating","id":"method-setFloating"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setFloatingCls","id":"method-setFloatingCls"},{"meta":{},"owner":"Ext.dataview.List","tagname":"method","name":"setGrouped","id":"method-setGrouped"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setHeight","id":"method-setHeight"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setHidden","id":"method-setHidden"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setHiddenCls","id":"method-setHiddenCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setHideAnimation","id":"method-setHideAnimation"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"setHideOnMaskTap","id":"method-setHideOnMaskTap"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setHtml","id":"method-setHtml"},{"meta":{},"owner":"Ext.dataview.List","tagname":"method","name":"setIndexBar","id":"method-setIndexBar"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"setInline","id":"method-setInline"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"setItemCls","id":"method-setItemCls"},{"meta":{"private":true},"owner":"Ext.dataview.List","tagname":"method","name":"setItemConfig","id":"method-setItemConfig"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setItemId","id":"method-setItemId"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"setItems","id":"method-setItems"},{"meta":{"deprecated":{"text":"","version":"2.0.0"}},"owner":"Ext.mixin.Selectable","tagname":"method","name":"setLastFocused","id":"method-setLastFocused"},{"meta":{"private":true},"owner":"Ext.mixin.Selectable","tagname":"method","name":"setLastSelected","id":"method-setLastSelected"},{"meta":{"private":true},"owner":"Ext.dataview.DataView","tagname":"method","name":"setLayout","id":"method-setLayout"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setLeft","id":"method-setLeft"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"setListeners","id":"method-setListeners"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setMargin","id":"method-setMargin"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"setMasked","id":"method-setMasked"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setMaxHeight","id":"method-setMaxHeight"},{"meta":{"private":true},"owner":"Ext.dataview.List","tagname":"method","name":"setMaxItemCache","id":"method-setMaxItemCache"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setMaxWidth","id":"method-setMaxWidth"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setMinHeight","id":"method-setMinHeight"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setMinWidth","id":"method-setMinWidth"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"setModal","id":"method-setModal"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"method","name":"setMode","id":"method-setMode"},{"meta":{},"owner":"Ext.dataview.List","tagname":"method","name":"setOnItemDisclosure","id":"method-setOnItemDisclosure"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setPadding","id":"method-setPadding"},{"meta":{},"owner":"Ext.dataview.List","tagname":"method","name":"setPinHeaders","id":"method-setPinHeaders"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setPlugins","id":"method-setPlugins"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"setPressedCls","id":"method-setPressedCls"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"setPressedDelay","id":"method-setPressedDelay"},{"meta":{},"owner":"Ext.dataview.List","tagname":"method","name":"setPreventSelectionOnDisclose","id":"method-setPreventSelectionOnDisclose"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setRecord","id":"method-setRecord"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setRenderTo","id":"method-setRenderTo"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setRenderTpl","id":"method-setRenderTpl"},{"meta":{"private":true},"owner":"Ext.Container","tagname":"method","name":"setRendered","id":"method-setRendered"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setRight","id":"method-setRight"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"setScrollToTopOnRefresh","id":"method-setScrollToTopOnRefresh"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"setScrollable","id":"method-setScrollable"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"setSelectedCls","id":"method-setSelectedCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setShowAnimation","id":"method-setShowAnimation"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setSize","id":"method-setSize"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"setStore","id":"method-setStore"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setStyle","id":"method-setStyle"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setStyleHtmlCls","id":"method-setStyleHtmlCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setStyleHtmlContent","id":"method-setStyleHtmlContent"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setTop","id":"method-setTop"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setTpl","id":"method-setTpl"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setTplWriteMode","id":"method-setTplWriteMode"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"setTranslatable","id":"method-setTranslatable"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"setTriggerCtEvent","id":"method-setTriggerCtEvent"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"method","name":"setTriggerEvent","id":"method-setTriggerEvent"},{"meta":{"private":true},"owner":"Ext.dataview.List","tagname":"method","name":"setUseComponents","id":"method-setUseComponents"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"setVisibility","id":"method-setVisibility"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setWidth","id":"method-setWidth"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setZIndex","id":"method-setZIndex"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"show","id":"method-show"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"showBy","id":"method-showBy"},{"meta":{"protected":true},"owner":"Ext.Base","tagname":"method","name":"statics","id":"method-statics"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"suspendEvents","id":"method-suspendEvents"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"triggerInitialized","id":"method-triggerInitialized"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"un","id":"method-un"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"unAfter","id":"method-unAfter"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"unBefore","id":"method-unBefore"},{"meta":{},"owner":"Ext.Container","tagname":"method","name":"unmask","id":"method-unmask"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"up","id":"method-up"},{"meta":{"deprecated":{"text":"Please use {@link #setHtml}, {@link #setTpl} or {@link #setData} instead.","version":"2.0.0"}},"owner":"Ext.Component","tagname":"method","name":"update","id":"method-update"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"updateCls","id":"method-updateCls"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"updateData","id":"method-updateData"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"updateFloatingCls","id":"method-updateFloatingCls"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"method","name":"updateLastFocused","id":"method-updateLastFocused"},{"meta":{"private":true},"owner":"Ext.mixin.Selectable","tagname":"method","name":"updateStore","id":"method-updateStore"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"updateStyleHtmlCls","id":"method-updateStyleHtmlCls"}],"cfg":[{"meta":{},"owner":"Ext.Container","tagname":"cfg","name":"activeItem","id":"cfg-activeItem"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"cfg","name":"allowDeselect","id":"cfg-allowDeselect"},{"meta":{},"owner":"Ext.Container","tagname":"cfg","name":"autoDestroy","id":"cfg-autoDestroy"},{"meta":{},"owner":"Ext.dataview.List","tagname":"cfg","name":"baseCls","id":"cfg-baseCls"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"blockRefresh","id":"cfg-blockRefresh"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"border","id":"cfg-border"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"bottom","id":"cfg-bottom"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"cfg","name":"bubbleEvents","id":"cfg-bubbleEvents"},{"meta":{"removed":{"text":"Please use {@link Ext.layout.Card#animation} instead","version":"2.0.0"}},"owner":"Ext.Container","tagname":"cfg","name":"cardSwitchAnimation","id":"cfg-cardSwitchAnimation"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"centered","id":"cfg-centered"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.dataview.List","tagname":"cfg","name":"clearSelectionOnDeactivate","id":"cfg-clearSelectionOnDeactivate"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"cls","id":"cfg-cls"},{"meta":{"deprecated":{"text":"","version":"2.0.0"}},"owner":"Ext.Component","tagname":"cfg","name":"componentCls","id":"cfg-componentCls"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"contentEl","id":"cfg-contentEl"},{"meta":{},"owner":"Ext.Container","tagname":"cfg","name":"control","id":"cfg-control"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"data","id":"cfg-data"},{"meta":{"private":true},"owner":"Ext.dataview.List","tagname":"cfg","name":"defaultType","id":"cfg-defaultType"},{"meta":{},"owner":"Ext.Container","tagname":"cfg","name":"defaults","id":"cfg-defaults"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"deferEmptyText","id":"cfg-deferEmptyText"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"deselectOnContainerClick","id":"cfg-deselectOnContainerClick"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"cfg","name":"disableSelection","id":"cfg-disableSelection"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"disabled","id":"cfg-disabled"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"disabledCls","id":"cfg-disabledCls"},{"meta":{},"owner":"Ext.dataview.List","tagname":"cfg","name":"disclosureProperty","id":"cfg-disclosureProperty"},{"meta":{"deprecated":{"text":"This has been deprecated. Please use {@link #docked} instead.","version":"2.0.0"}},"owner":"Ext.Component","tagname":"cfg","name":"dock","id":"cfg-dock"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"docked","id":"cfg-docked"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"draggable","id":"cfg-draggable"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"emptyText","id":"cfg-emptyText"},{"meta":{"deprecated":{"text":"Please use {@link #showAnimation} instead.","version":"2.0.0"}},"owner":"Ext.Component","tagname":"cfg","name":"enterAnimation","id":"cfg-enterAnimation"},{"meta":{"deprecated":{"text":"2.0.0 Please use {@link #hideAnimation} instead.  Typically you want to use an\noutbound animation type such as 'fadeOut' or 'slideOut'."}},"owner":"Ext.Component","tagname":"cfg","name":"exitAnimation","id":"cfg-exitAnimation"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"flex","id":"cfg-flex"},{"meta":{"deprecated":{"text":"","version":"2.0.0"}},"owner":"Ext.Component","tagname":"cfg","name":"floating","id":"cfg-floating"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"floatingCls","id":"cfg-floatingCls"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"fullscreen","id":"cfg-fullscreen"},{"meta":{},"owner":"Ext.dataview.List","tagname":"cfg","name":"grouped","id":"cfg-grouped"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"height","id":"cfg-height"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"hidden","id":"cfg-hidden"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"hiddenCls","id":"cfg-hiddenCls"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"hideAnimation","id":"cfg-hideAnimation"},{"meta":{},"owner":"Ext.Container","tagname":"cfg","name":"hideOnMaskTap","id":"cfg-hideOnMaskTap"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"html","id":"cfg-html"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"id","id":"cfg-id"},{"meta":{},"owner":"Ext.dataview.List","tagname":"cfg","name":"indexBar","id":"cfg-indexBar"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"inline","id":"cfg-inline"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"itemCls","id":"cfg-itemCls"},{"meta":{"private":true},"owner":"Ext.dataview.List","tagname":"cfg","name":"itemConfig","id":"cfg-itemConfig"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"itemId","id":"cfg-itemId"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"itemSelector","id":"cfg-itemSelector"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"itemTpl","id":"cfg-itemTpl"},{"meta":{},"owner":"Ext.Container","tagname":"cfg","name":"items","id":"cfg-items"},{"meta":{"private":true},"owner":"Ext.mixin.Selectable","tagname":"cfg","name":"lastFocused","id":"cfg-lastFocused"},{"meta":{"private":true},"owner":"Ext.mixin.Selectable","tagname":"cfg","name":"lastSelected","id":"cfg-lastSelected"},{"meta":{"private":true},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"layout","id":"cfg-layout"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.Component","tagname":"cfg","name":"layoutOnOrientationChange","id":"cfg-layoutOnOrientationChange"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"left","id":"cfg-left"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"cfg","name":"listeners","id":"cfg-listeners"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"loadingText","id":"cfg-loadingText"},{"meta":{"deprecated":{"text":"Please use {@link #disableSelection} instead.","version":"2.0.0"}},"owner":"Ext.mixin.Selectable","tagname":"cfg","name":"locked","id":"cfg-locked"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"margin","id":"cfg-margin"},{"meta":{},"owner":"Ext.Container","tagname":"cfg","name":"masked","id":"cfg-masked"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"maxHeight","id":"cfg-maxHeight"},{"meta":{"private":true},"owner":"Ext.dataview.List","tagname":"cfg","name":"maxItemCache","id":"cfg-maxItemCache"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"maxWidth","id":"cfg-maxWidth"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"minHeight","id":"cfg-minHeight"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"minWidth","id":"cfg-minWidth"},{"meta":{},"owner":"Ext.Container","tagname":"cfg","name":"modal","id":"cfg-modal"},{"meta":{},"owner":"Ext.mixin.Selectable","tagname":"cfg","name":"mode","id":"cfg-mode"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.Component","tagname":"cfg","name":"monitorOrientation","id":"cfg-monitorOrientation"},{"meta":{"removed":{"text":"multiSelect is deprecated. Please use {@link Ext.mixin.Selectable#mode mode} instead","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"multiSelect","id":"cfg-multiSelect"},{"meta":{},"owner":"Ext.dataview.List","tagname":"cfg","name":"onItemDisclosure","id":"cfg-onItemDisclosure"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"overItemCls","id":"cfg-overItemCls"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"padding","id":"cfg-padding"},{"meta":{},"owner":"Ext.dataview.List","tagname":"cfg","name":"pinHeaders","id":"cfg-pinHeaders"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"plugins","id":"cfg-plugins"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"pressedCls","id":"cfg-pressedCls"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"pressedDelay","id":"cfg-pressedDelay"},{"meta":{},"owner":"Ext.dataview.List","tagname":"cfg","name":"preventSelectionOnDisclose","id":"cfg-preventSelectionOnDisclose"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"record","id":"cfg-record"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"renderTo","id":"cfg-renderTo"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"renderTpl","id":"cfg-renderTpl"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"right","id":"cfg-right"},{"meta":{"deprecated":{"text":"Please use the {@link #scrollable} configuration.","version":"2.0.0"}},"owner":"Ext.Container","tagname":"cfg","name":"scroll","id":"cfg-scroll"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"scrollToTopOnRefresh","id":"cfg-scrollToTopOnRefresh"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"scrollable","id":"cfg-scrollable"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"selectedCls","id":"cfg-selectedCls"},{"meta":{"removed":{"text":"Please use {@link #selectedCls selectedCls} instead","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"selectedItemCls","id":"cfg-selectedItemCls"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"showAnimation","id":"cfg-showAnimation"},{"meta":{"removed":{"text":"Please use {@link Ext.mixin.Selectable#mode mode} instead","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"simpleSelect","id":"cfg-simpleSelect"},{"meta":{"removed":{"text":"Please use {@link Ext.mixin.Selectable#mode mode} instead","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"singleSelect","id":"cfg-singleSelect"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.Component","tagname":"cfg","name":"stopMaskTapEvent","id":"cfg-stopMaskTapEvent"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"store","id":"cfg-store"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"style","id":"cfg-style"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"styleHtmlCls","id":"cfg-styleHtmlCls"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"styleHtmlContent","id":"cfg-styleHtmlContent"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"top","id":"cfg-top"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"tpl","id":"cfg-tpl"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"tplWriteMode","id":"cfg-tplWriteMode"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"trackOver","id":"cfg-trackOver"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"cfg","name":"translatable","id":"cfg-translatable"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"triggerCtEvent","id":"cfg-triggerCtEvent"},{"meta":{},"owner":"Ext.dataview.DataView","tagname":"cfg","name":"triggerEvent","id":"cfg-triggerEvent"},{"meta":{},"owner":"Ext.dataview.List","tagname":"cfg","name":"ui","id":"cfg-ui"},{"meta":{"private":true},"owner":"Ext.dataview.List","tagname":"cfg","name":"useComponents","id":"cfg-useComponents"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"width","id":"cfg-width"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"xtype","id":"cfg-xtype"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"zIndex","id":"cfg-zIndex"}]},"files":[{"href":"List2.html#Ext-dataview-List","filename":"List.js"},{"href":"_list.scss.html#Ext-dataview-List","filename":"_list.scss"}],"private":null,"singleton":false,"statics":{"property":[{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"property","name":"$onExtended","id":"static-property-S-onExtended"}],"event":[],"css_var":[],"css_mixin":[],"cfg":[],"method":[{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"addConfig","id":"static-method-addConfig"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"addInheritableStatics","id":"static-method-addInheritableStatics"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"addMember","id":"static-method-addMember"},{"meta":{"static":true},"owner":"Ext.Base","tagname":"method","name":"addMembers","id":"static-method-addMembers"},{"meta":{"static":true},"owner":"Ext.Base","tagname":"method","name":"addStatics","id":"static-method-addStatics"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"addXtype","id":"static-method-addXtype"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"borrow","id":"static-method-borrow"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"callParent","id":"static-method-callParent"},{"meta":{"static":true},"owner":"Ext.Base","tagname":"method","name":"create","id":"static-method-create"},{"meta":{"static":true},"owner":"Ext.Base","tagname":"method","name":"createAlias","id":"static-method-createAlias"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"extend","id":"static-method-extend"},{"meta":{"static":true},"owner":"Ext.Base","tagname":"method","name":"getName","id":"static-method-getName"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"implement","id":"static-method-implement"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"mixin","id":"static-method-mixin"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"onExtended","id":"static-method-onExtended"},{"meta":{"deprecated":{"text":"Please use {@link Ext#define Ext.define} instead","version":"4.1.0"},"static":true},"owner":"Ext.Base","tagname":"method","name":"override","id":"static-method-override"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"triggerExtended","id":"static-method-triggerExtended"}]},"subclasses":[],"name":"Ext.dataview.List","html_meta":{"aside":["            <div class='aside guide'>\n              <h4>Guide</h4>\n              <p><a href='#!/guide/list'><img src='guides/list/icon.png' alt=''> Using List</a></p>\n            </div>\n","            <div class='aside video'>\n              <h4>Video</h4>\n              <p><a href='#!/video/list'><img src='http://b.vimeocdn.com/ts/255/531/255531831_200.jpg' alt=''> Intro to List Component</a></p>\n            </div>\n"]},"mixins":[],"code_type":"ext_define","inheritable":false,"id":"class-Ext.dataview.List","component":true,"uses":[]});