Ext.data.JsonP.Ext_field_Field({"meta":{"aside":[{"type":"guide","name":"forms"}]},"mixedInto":[],"aliases":{"widget":["field"]},"html":"<div><pre class=\"hierarchy\"><h4>Alternate names</h4><div class='alternate-class-name'>Ext.form.Field</div><h4>Hierarchy</h4><div class='subclass first-child'><a href='#!/api/Ext.Base' rel='Ext.Base' class='docClass'>Ext.Base</a><div class='subclass '><a href='#!/api/Ext.Evented' rel='Ext.Evented' class='docClass'>Ext.Evented</a><div class='subclass '><a href='#!/api/Ext.AbstractComponent' rel='Ext.AbstractComponent' class='docClass'>Ext.AbstractComponent</a><div class='subclass '><a href='#!/api/Ext.Component' rel='Ext.Component' class='docClass'>Ext.Component</a><div class='subclass '><a href='#!/api/Ext.Decorator' rel='Ext.Decorator' class='docClass'>Ext.Decorator</a><div class='subclass '><strong>Ext.field.Field</strong></div></div></div></div></div></div><h4>Inherited mixins</h4><div class='dependency'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='docClass'>Ext.mixin.Observable</a></div><div class='dependency'><a href='#!/api/Ext.mixin.Traversable' rel='Ext.mixin.Traversable' class='docClass'>Ext.mixin.Traversable</a></div><h4>Requires</h4><div class='dependency'><a href='#!/api/Ext.field.Input' rel='Ext.field.Input' class='docClass'>Ext.field.Input</a></div><h4>Subclasses</h4><div class='dependency'><a href='#!/api/Ext.field.Checkbox' rel='Ext.field.Checkbox' class='docClass'>Ext.field.Checkbox</a></div><div class='dependency'><a href='#!/api/Ext.field.Slider' rel='Ext.field.Slider' class='docClass'>Ext.field.Slider</a></div><div class='dependency'><a href='#!/api/Ext.field.Text' rel='Ext.field.Text' class='docClass'>Ext.field.Text</a></div><h4>Files</h4><div class='dependency'><a href='source/Field2.html#Ext-field-Field' target='_blank'>Field.js</a></div><div class='dependency'><a href='source/_form.scss.html#Ext-field-Field' target='_blank'>_form.scss</a></div><div class='dependency'><a href='source/_toolbar-forms.scss.html#Ext-field-Field' target='_blank'>_toolbar-forms.scss</a></div></pre><div class='doc-contents'>            <div class='aside guide'>\n              <h4>Guide</h4>\n              <p><a href='#!/guide/forms'><img src='guides/forms/icon.png' alt=''> Using Forms</a></p>\n            </div>\n<p>Field is the base class for all form fields used in Sencha Touch. It provides a lot of shared functionality to all\nfield subclasses (for example labels, simple validation, <a href=\"#!/api/Ext.field.Field-cfg-clearIcon\" rel=\"Ext.field.Field-cfg-clearIcon\" class=\"docClass\">clearing</a> and tab index management), but\nis rarely used directly. Instead, it is much more common to use one of the field subclasses:</p>\n\n<pre><code>xtype            Class\n---------------------------------------\ntextfield        <a href=\"#!/api/Ext.field.Text\" rel=\"Ext.field.Text\" class=\"docClass\">Ext.field.Text</a>\nnumberfield      <a href=\"#!/api/Ext.field.Number\" rel=\"Ext.field.Number\" class=\"docClass\">Ext.field.Number</a>\ntextareafield    <a href=\"#!/api/Ext.field.TextArea\" rel=\"Ext.field.TextArea\" class=\"docClass\">Ext.field.TextArea</a>\nhiddenfield      <a href=\"#!/api/Ext.field.Hidden\" rel=\"Ext.field.Hidden\" class=\"docClass\">Ext.field.Hidden</a>\nradiofield       <a href=\"#!/api/Ext.field.Radio\" rel=\"Ext.field.Radio\" class=\"docClass\">Ext.field.Radio</a>\ncheckboxfield    <a href=\"#!/api/Ext.field.Checkbox\" rel=\"Ext.field.Checkbox\" class=\"docClass\">Ext.field.Checkbox</a>\nselectfield      <a href=\"#!/api/Ext.field.Select\" rel=\"Ext.field.Select\" class=\"docClass\">Ext.field.Select</a>\ntogglefield      <a href=\"#!/api/Ext.field.Toggle\" rel=\"Ext.field.Toggle\" class=\"docClass\">Ext.field.Toggle</a>\nfieldset         <a href=\"#!/api/Ext.form.FieldSet\" rel=\"Ext.form.FieldSet\" class=\"docClass\">Ext.form.FieldSet</a>\n</code></pre>\n\n<p>Fields are normally used within the context of a form and/or fieldset. See the <a href=\"#!/api/Ext.form.Panel\" rel=\"Ext.form.Panel\" class=\"docClass\">FormPanel</a>\nand <a href=\"#!/api/Ext.form.FieldSet\" rel=\"Ext.form.FieldSet\" class=\"docClass\">FieldSet</a> docs for examples on how to put those together, or the list of links above\nfor usage of individual field types. If you wish to create your own Field subclasses you can extend this class,\nthough it is sometimes more useful to extend <a href=\"#!/api/Ext.field.Text\" rel=\"Ext.field.Text\" class=\"docClass\">Ext.field.Text</a> as this provides additional text entry\nfunctionality.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-cfg'>Config options</h3><div class='subsection'><div id='cfg-baseCls' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-baseCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-baseCls' class='name expandable'>baseCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The base CSS class to apply to this components's element. ...</div><div class='long'><p>The base CSS class to apply to this components's element. This will also be prepended to\nother elements within this component. To add specific styling for sub-classes, use the <a href=\"#!/api/Ext.field.Field-cfg-cls\" rel=\"Ext.field.Field-cfg-cls\" class=\"docClass\">cls</a> config.</p>\n<p>Defaults to: <code>&quot;x-field&quot;</code></p><p>Overrides: <a href='#!/api/Ext.Component-cfg-baseCls' rel='Ext.Component-cfg-baseCls' class='docClass'>Ext.Component.baseCls</a></p></div></div></div><div id='cfg-border' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-border' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-border' class='name expandable'>border</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The border to use on this Component. ...</div><div class='long'><p>The border to use on this Component. Can be specified as a number (in which\ncase all edges get the same border width) or a CSS string like '5 10 10 10'</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-bottom' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-bottom' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-bottom' class='name expandable'>bottom</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The absolute bottom position of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The absolute bottom position of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.\nExplicitly setting this value will make this Component become 'floating', which means its layout will no\nlonger be affected by the Container that it resides in.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-bubbleEvents' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-cfg-bubbleEvents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-cfg-bubbleEvents' class='name expandable'>bubbleEvents</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]</span></div><div class='description'><div class='short'>The event name to bubble, or an Array of event names. ...</div><div class='long'><p>The event name to bubble, or an Array of event names.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-centered' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-centered' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-centered' class='name expandable'>centered</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>Whether or not this Component is absolutely centered inside its Container ...</div><div class='long'><p>Whether or not this Component is absolutely centered inside its Container</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-clearIcon' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-clearIcon' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-clearIcon' class='name expandable'>clearIcon</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>True to use a clear icon in this field ...</div><div class='long'><p>True to use a clear icon in this field</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-cls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-cls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-cls' class='name expandable'>cls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]</span></div><div class='description'><div class='short'>The CSS class to add to this component's element, in addition to the baseCls ...</div><div class='long'><p>The CSS class to add to this component's element, in addition to the <a href=\"#!/api/Ext.Component-cfg-baseCls\" rel=\"Ext.Component-cfg-baseCls\" class=\"docClass\">baseCls</a></p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-component' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-component' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-component' class='name not-expandable'>component</a><span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span></div><div class='description'><div class='short'><p>The inner component for this field.</p>\n</div><div class='long'><p>The inner component for this field.</p>\n<p>Overrides: <a href='#!/api/Ext.Decorator-cfg-component' rel='Ext.Decorator-cfg-component' class='docClass'>Ext.Decorator.component</a></p></div></div></div><div id='cfg-componentCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-componentCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-componentCls' class='name expandable'>componentCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>CSS class to add to this Component. ...</div><div class='long'><p>CSS class to add to this Component. Deprecated, please use <a href=\"#!/api/Ext.Component-cfg-cls\" rel=\"Ext.Component-cfg-cls\" class=\"docClass\">cls</a> instead</p>\n        <div class='signature-box deprecated'>\n        <p>This cfg has been <strong>deprecated</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='cfg-contentEl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-contentEl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-contentEl' class='name expandable'>contentEl</a><span> : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The configured element will automatically be\nadded as the content of this component. ...</div><div class='long'><p>The configured element will automatically be\nadded as the content of this component. When you pass a string, we expect it to be an element id.\nIf the content element is hidden, we will automatically show it.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-data' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-data' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-data' class='name expandable'>data</a><span> : Mixed</span></div><div class='description'><div class='short'>The initial set of data to apply to the tpl to\nupdate the content area of the Component. ...</div><div class='long'><p>The initial set of data to apply to the <code><a href=\"#!/api/Ext.Component-cfg-tpl\" rel=\"Ext.Component-cfg-tpl\" class=\"docClass\">tpl</a></code> to\nupdate the content area of the Component.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-disabled' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-disabled' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-disabled' class='name expandable'>disabled</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>Whether or not this component is disabled ...</div><div class='long'><p>Whether or not this component is disabled</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-disabledCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-disabledCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-disabledCls' class='name not-expandable'>disabledCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'><p>The CSS class to add to the component when it is disabled</p>\n</div><div class='long'><p>The CSS class to add to the component when it is disabled</p>\n</div></div></div><div id='cfg-dock' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-dock' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-dock' class='name expandable'>dock</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>The dock position of this component in its container. ...</div><div class='long'><p>The dock position of this component in its container. Can be 'left', 'top', 'right' or 'bottom'.</p>\n\n<p><b>Notes</b></p>\n\n<p>You must use a HTML5 doctype for <a href=\"#!/api/Ext.Component-cfg-docked\" rel=\"Ext.Component-cfg-docked\" class=\"docClass\">docked</a> <code>bottom</code> to work. To do this, simply add the following code to the HTML file:</p>\n\n<pre><code>&lt;!doctype html&gt;\n</code></pre>\n\n<p>So your index.html file should look a little like this:</p>\n\n<pre><code>&lt;!doctype html&gt;\n&lt;html&gt;\n    &lt;head&gt;\n        &lt;title&gt;MY application title&lt;/title&gt;\n        ...\n</code></pre>\n        <div class='signature-box deprecated'>\n        <p>This cfg has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>This has been deprecated. Please use <a href=\"#!/api/Ext.Component-cfg-docked\" rel=\"Ext.Component-cfg-docked\" class=\"docClass\">docked</a> instead.</p>\n\n        </div>\n</div></div></div><div id='cfg-docked' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-docked' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-docked' class='name expandable'>docked</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The dock position of this component in its container. ...</div><div class='long'><p>The dock position of this component in its container. Can be 'left', 'top', 'right' or 'bottom'.</p>\n\n<p><b>Notes</b></p>\n\n<p>You must use a HTML5 doctype for <a href=\"#!/api/Ext.Component-cfg-docked\" rel=\"Ext.Component-cfg-docked\" class=\"docClass\">docked</a> <code>bottom</code> to work. To do this, simply add the following code to the HTML file:</p>\n\n<pre><code>&lt;!doctype html&gt;\n</code></pre>\n\n<p>So your index.html file should look a little like this:</p>\n\n<pre><code>&lt;!doctype html&gt;\n&lt;html&gt;\n    &lt;head&gt;\n        &lt;title&gt;MY application title&lt;/title&gt;\n        ...\n</code></pre>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-draggable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-draggable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-draggable' class='name expandable'>draggable</a><span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span></div><div class='description'><div class='short'>Configuration options to make this Component draggable ...</div><div class='long'><p>Configuration options to make this Component draggable</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-enterAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-enterAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-enterAnimation' class='name expandable'>enterAnimation</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</span><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Animation effect to apply when the Component is being shown. ...</div><div class='long'><p>Animation effect to apply when the Component is being shown.  Typically you want to use an\ninbound animation type such as 'fadeIn' or 'slideIn'.</p>\n<p>Defaults to: <code>null</code></p>        <div class='signature-box deprecated'>\n        <p>This cfg has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.Component-cfg-showAnimation\" rel=\"Ext.Component-cfg-showAnimation\" class=\"docClass\">showAnimation</a> instead.</p>\n\n        </div>\n</div></div></div><div id='cfg-exitAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-exitAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-exitAnimation' class='name expandable'>exitAnimation</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</span><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Animation effect to apply when the Component is being hidden. ...</div><div class='long'><p>Animation effect to apply when the Component is being hidden.</p>\n<p>Defaults to: <code>null</code></p>        <div class='signature-box deprecated'>\n        <p>This cfg has been <strong>deprecated</strong> </p>\n        <p>2.0.0 Please use <a href=\"#!/api/Ext.Component-cfg-hideAnimation\" rel=\"Ext.Component-cfg-hideAnimation\" class=\"docClass\">hideAnimation</a> instead.  Typically you want to use an\noutbound animation type such as 'fadeOut' or 'slideOut'.</p>\n\n        </div>\n</div></div></div><div id='cfg-fieldCls' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-fieldCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-fieldCls' class='name expandable'>fieldCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>CSS class to add to the field ...</div><div class='long'><p>CSS class to add to the field</p>\n        <div class='signature-box deprecated'>\n        <p>This cfg has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Deprecated, please use <a href=\"#!/api/Ext.field.Field-cfg-inputCls\" rel=\"Ext.field.Field-cfg-inputCls\" class=\"docClass\">inputCls</a></p>\n\n        </div>\n</div></div></div><div id='cfg-fieldLabel' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-fieldLabel' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-fieldLabel' class='name expandable'>fieldLabel</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>The label for this Field ...</div><div class='long'><p>The label for this Field</p>\n        <div class='signature-box deprecated'>\n        <p>This cfg has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use the <a href=\"#!/api/Ext.field.Field-cfg-label\" rel=\"Ext.field.Field-cfg-label\" class=\"docClass\">label</a> configuration instead</p>\n\n        </div>\n</div></div></div><div id='cfg-flex' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-flex' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-flex' class='name expandable'>flex</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></span></div><div class='description'><div class='short'>The flex of this item if this item item is inside a Ext.layout.HBox or Ext.layout.VBox\nlayout. ...</div><div class='long'><p>The flex of this item <em>if</em> this item item is inside a <a href=\"#!/api/Ext.layout.HBox\" rel=\"Ext.layout.HBox\" class=\"docClass\">Ext.layout.HBox</a> or <a href=\"#!/api/Ext.layout.VBox\" rel=\"Ext.layout.VBox\" class=\"docClass\">Ext.layout.VBox</a>\nlayout.</p>\n\n<p>You can also update the flex of a component dynamically using the <a href=\"#!/api/Ext.layout.AbstractBox-method-setItemFlex\" rel=\"Ext.layout.AbstractBox-method-setItemFlex\" class=\"docClass\">Ext.layout.AbstractBox.setItemFlex</a>\nmethod.</p>\n</div></div></div><div id='cfg-floating' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-floating' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-floating' class='name expandable'>floating</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Deprecated, please use left, top, right or\nbottom instead. ...</div><div class='long'><p>Deprecated, please use <a href=\"#!/api/Ext.Component-cfg-left\" rel=\"Ext.Component-cfg-left\" class=\"docClass\">left</a>, <a href=\"#!/api/Ext.Component-cfg-top\" rel=\"Ext.Component-cfg-top\" class=\"docClass\">top</a>, <a href=\"#!/api/Ext.Component-cfg-right\" rel=\"Ext.Component-cfg-right\" class=\"docClass\">right</a> or\n<a href=\"#!/api/Ext.Component-cfg-bottom\" rel=\"Ext.Component-cfg-bottom\" class=\"docClass\">bottom</a> instead.</p>\n\n<pre><code><a href=\"#!/api/Ext.Viewport-event-add\" rel=\"Ext.Viewport-event-add\" class=\"docClass\">Ext.Viewport.add</a>({\n    top: 100,\n    left: 100,\n    width: 500,\n    height: 200,\n    html: 'Floating component!'\n});\n</code></pre>\n        <div class='signature-box deprecated'>\n        <p>This cfg has been <strong>deprecated</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='cfg-floatingCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-floatingCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-floatingCls' class='name expandable'>floatingCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The CSS class to add to this component when it is floatable. ...</div><div class='long'><p>The CSS class to add to this component when it is floatable.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-height' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-height' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-height' class='name expandable'>height</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The height of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The height of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.\nBy default, if this is not explicitly set, this Component's element will simply have its own natual size.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-hidden' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hidden' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-hidden' class='name expandable'>hidden</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>Whether or not this Component is hidden (its CSS display property is set to none) ...</div><div class='long'><p>Whether or not this Component is hidden (its CSS <code>display</code> property is set to <code>none</code>)</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-hiddenCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hiddenCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-hiddenCls' class='name not-expandable'>hiddenCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'><p>The CSS class to add to the component when it is hidden</p>\n</div><div class='long'><p>The CSS class to add to the component when it is hidden</p>\n</div></div></div><div id='cfg-hideAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hideAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-hideAnimation' class='name expandable'>hideAnimation</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</span></div><div class='description'><div class='short'>Animation effect to apply when the Component is being hidden. ...</div><div class='long'><p>Animation effect to apply when the Component is being hidden.  Typically you want to use an\noutbound animation type such as 'fadeOut' or 'slideOut'.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-hideOnMaskTap' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hideOnMaskTap' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-hideOnMaskTap' class='name expandable'>hideOnMaskTap</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>This configuration has moved to Ext.Container. ...</div><div class='long'><p>This configuration has moved to <a href=\"#!/api/Ext.Container-cfg-hideOnMaskTap\" rel=\"Ext.Container-cfg-hideOnMaskTap\" class=\"docClass\">Ext.Container</a>. You can no longer use it in a <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a>.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        <p>This method has been moved from <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> to <a href=\"#!/api/Ext.Container-cfg-hideOnMaskTap\" rel=\"Ext.Container-cfg-hideOnMaskTap\" class=\"docClass\">Ext.Container</a></p>\n\n        </div>\n</div></div></div><div id='cfg-html' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-html' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-html' class='name expandable'>html</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement</span></div><div class='description'><div class='short'>Optional HTML content to render inside this Component, or a reference\nto an existing element on the page. ...</div><div class='long'><p>Optional HTML content to render inside this Component, or a reference\nto an existing element on the page.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-id' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-id' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-id' class='name expandable'>id</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The unique id of this component instance. ...</div><div class='long'><p>The <strong>unique id of this component instance.</strong></p>\n\n<p>It should not be necessary to use this configuration except for singleton objects in your application. Components\ncreated with an id may be accessed globally using <a href=\"#!/api/Ext-method-getCmp\" rel=\"Ext-method-getCmp\" class=\"docClass\">Ext.getCmp</a>.</p>\n\n<p>Instead of using assigned ids, use the <a href=\"#!/api/Ext.Component-cfg-itemId\" rel=\"Ext.Component-cfg-itemId\" class=\"docClass\">itemId</a> config, and <a href=\"#!/api/Ext.ComponentQuery\" rel=\"Ext.ComponentQuery\" class=\"docClass\">ComponentQuery</a>\nwhich provides selector-based searching for Sencha Components analogous to DOM querying. The\n<a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a> class contains <a href=\"#!/api/Ext.Container-method-down\" rel=\"Ext.Container-method-down\" class=\"docClass\">shortcut methods</a> to query\nits descendant Components by selector.</p>\n\n<p>Note that this id will also be used as the element id for the containing HTML element that is rendered to the\npage for this component. This allows you to write id-based CSS rules to style the specific instance of this\ncomponent uniquely, and also to select sub-elements using this component's id as the parent.</p>\n\n<p><strong>Note</strong>: to avoid complications imposed by a unique id also see <code><a href=\"#!/api/Ext.Component-cfg-itemId\" rel=\"Ext.Component-cfg-itemId\" class=\"docClass\">itemId</a></code>.</p>\n\n<p>Defaults to an auto-assigned id.</p>\n</div></div></div><div id='cfg-inputCls' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-inputCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-inputCls' class='name expandable'>inputCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>CSS class to add to the input element of this fields component ...</div><div class='long'><p>CSS class to add to the input element of this fields <a href=\"#!/api/Ext.field.Field-cfg-component\" rel=\"Ext.field.Field-cfg-component\" class=\"docClass\">component</a></p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-inputType' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-inputType' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-inputType' class='name expandable'>inputType</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>The type attribute for input fields -- e.g. ...</div><div class='long'><p>The type attribute for input fields -- e.g. radio, text, password, file (defaults\nto 'text'). The types 'file' and 'password' must be used to render those field types currently -- there are\nno separate Ext components for those.\nThis is now deprecated. Please use 'input.type' instead.</p>\n<p>Defaults to: <code>null</code></p>        <div class='signature-box deprecated'>\n        <p>This cfg has been <strong>deprecated</strong> since 2.0</p>\n        \n\n        </div>\n</div></div></div><div id='cfg-isFocused' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-isFocused' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-isFocused' class='name not-expandable'>isFocused</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'><p>True if this field is currently focused,</p>\n</div><div class='long'><p>True if this field is currently focused,</p>\n</div></div></div><div id='cfg-itemId' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-itemId' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-itemId' class='name expandable'>itemId</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>An itemId can be used as an alternative way to get a reference to a component when no object reference is\navailable. ...</div><div class='long'><p>An itemId can be used as an alternative way to get a reference to a component when no object reference is\navailable. Instead of using an <code><a href=\"#!/api/Ext.Component-cfg-id\" rel=\"Ext.Component-cfg-id\" class=\"docClass\">id</a></code> with <a href=\"#!/api/Ext-method-getCmp\" rel=\"Ext-method-getCmp\" class=\"docClass\">Ext.getCmp</a>, use <code>itemId</code> with\n<a href=\"#!/api/Ext.Container-method-getComponent\" rel=\"Ext.Container-method-getComponent\" class=\"docClass\">Ext.Container.getComponent</a> which will retrieve <code>itemId</code>'s or <a href=\"#!/api/Ext.Component-cfg-id\" rel=\"Ext.Component-cfg-id\" class=\"docClass\">id</a>'s. Since <code>itemId</code>'s are an\nindex to the container's internal MixedCollection, the <code>itemId</code> is scoped locally to the container - avoiding\npotential conflicts with <a href=\"#!/api/Ext.ComponentManager\" rel=\"Ext.ComponentManager\" class=\"docClass\">Ext.ComponentManager</a> which requires a <strong>unique</strong> <code><a href=\"#!/api/Ext.Component-cfg-id\" rel=\"Ext.Component-cfg-id\" class=\"docClass\">id</a></code>.</p>\n\n<p>Also see <a href=\"#!/api/Ext.Component-cfg-id\" rel=\"Ext.Component-cfg-id\" class=\"docClass\">id</a>, <a href=\"#!/api/Ext.Container-method-query\" rel=\"Ext.Container-method-query\" class=\"docClass\">Ext.Container.query</a>, <a href=\"#!/api/Ext.Container-method-down\" rel=\"Ext.Container-method-down\" class=\"docClass\">Ext.Container.down</a> and <a href=\"#!/api/Ext.Container-method-child\" rel=\"Ext.Container-method-child\" class=\"docClass\">Ext.Container.child</a>.</p>\n</div></div></div><div id='cfg-label' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-label' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-label' class='name expandable'>label</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The label of this field ...</div><div class='long'><p>The label of this field</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-labelAlign' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-labelAlign' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-labelAlign' class='name expandable'>labelAlign</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The position to render the label relative to the field input. ...</div><div class='long'><p>The position to render the label relative to the field input.\nAvailable options are: 'top', 'left', 'bottom' and 'right'\nDefaults to 'left'</p>\n<p>Defaults to: <code>&quot;left&quot;</code></p></div></div></div><div id='cfg-labelCls' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-labelCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-labelCls' class='name expandable'>labelCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>Optional CSS class to add to the Label element ...</div><div class='long'><p>Optional CSS class to add to the Label element</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-labelWidth' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-labelWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-labelWidth' class='name expandable'>labelWidth</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The width to make this field's label. ...</div><div class='long'><p>The width to make this field's label.</p>\n<p>Defaults to: <code>&quot;30%&quot;</code></p></div></div></div><div id='cfg-labelWrap' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-labelWrap' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-labelWrap' class='name expandable'>labelWrap</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>True to allow the label to wrap. ...</div><div class='long'><p>True to allow the label to wrap. If set to false, the label will be truncated with\nan ellipsis.</p>\n<p>Defaults to: <code>false</code></p></div></div></div><div id='cfg-layoutOnOrientationChange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-layoutOnOrientationChange' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-layoutOnOrientationChange' class='name not-expandable'>layoutOnOrientationChange</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'><p>True to automatically relayout this component on orientation change.</p>\n</div><div class='long'><p>True to automatically relayout this component on orientation change.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='cfg-left' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-left' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-left' class='name expandable'>left</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The absolute left position of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The absolute left position of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.\nExplicitly setting this value will make this Component become 'floating', which means its layout will no\nlonger be affected by the Container that it resides in.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-listeners' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-cfg-listeners' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-cfg-listeners' class='name expandable'>listeners</a><span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span></div><div class='description'><div class='short'>A config object containing one or more event handlers to be added to this object during initialization. ...</div><div class='long'><p>A config object containing one or more event handlers to be added to this object during initialization. This\nshould be a valid listeners config object as specified in the <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> example for attaching\nmultiple handlers at once.</p>\n\n<p>See the <a href=\"#!/guide/events\">Event guide</a> for more</p>\n\n<p><strong>Note</strong> it is bad practice to specify a listeners config when you are defining a class using <a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>.\nInstead, only specify listeners when you are instantiating your class with <a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-margin' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-margin' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-margin' class='name expandable'>margin</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The margin to use on this Component. ...</div><div class='long'><p>The margin to use on this Component. Can be specified as a number (in which case\nall edges get the same margin) or a CSS string like '5 10 10 10'</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-maxHeight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-maxHeight' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-maxHeight' class='name expandable'>maxHeight</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The maximum height of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The maximum height of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.\nNote that this config will not apply if the Component is 'floating' (absolutely positioned or centered)</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-maxWidth' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-maxWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-maxWidth' class='name expandable'>maxWidth</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The maximum width of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The maximum width of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.\nNote that this config will not apply if the Component is 'floating' (absolutely positioned or centered)</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-minHeight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-minHeight' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-minHeight' class='name expandable'>minHeight</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The minimum height of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The minimum height of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-minWidth' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-minWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-minWidth' class='name expandable'>minWidth</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The minimum width of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The minimum width of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-modal' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-modal' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-modal' class='name expandable'>modal</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>This configuration has moved to Ext.Container. ...</div><div class='long'><p>This configuration has moved to <a href=\"#!/api/Ext.Container-cfg-modal\" rel=\"Ext.Container-cfg-modal\" class=\"docClass\">Ext.Container</a>. You can no longer use it in a <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a>.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        <p>This method has been moved from <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> to <a href=\"#!/api/Ext.Container-cfg-modal\" rel=\"Ext.Container-cfg-modal\" class=\"docClass\">Ext.Container</a></p>\n\n        </div>\n</div></div></div><div id='cfg-monitorOrientation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-monitorOrientation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-monitorOrientation' class='name not-expandable'>monitorOrientation</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'><p>True to monitor Orientation change.</p>\n</div><div class='long'><p>True to monitor Orientation change.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='cfg-name' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-name' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-name' class='name expandable'>name</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The field's HTML name attribute. ...</div><div class='long'><p>The field's HTML name attribute.\n<b>Note</b>: this property must be set if this field is to be automatically included with\n<a href=\"#!/api/Ext.form.Panel-method-submit\" rel=\"Ext.form.Panel-method-submit\" class=\"docClass\">form submit()</a>.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-padding' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-padding' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-padding' class='name expandable'>padding</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The padding to use on this Component. ...</div><div class='long'><p>The padding to use on this Component. Can be specified as a number (in which\ncase all edges get the same padding) or a CSS string like '5 10 10 10'</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-plugins' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-plugins' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-plugins' class='name expandable'>plugins</a><span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a></span></div><div class='description'><div class='short'>An object or array of objects that will provide custom functionality for this component. ...</div><div class='long'><p>An object or array of objects that will provide custom functionality for this component.  The only\nrequirement for a valid plugin is that it contain an init method that accepts a reference of type <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a>.</p>\n\n<p>When a component is created, if any plugins are available, the component will call the init method on each\nplugin, passing a reference to itself.  Each plugin can then call methods or respond to events on the\ncomponent as needed to provide its functionality.</p>\n\n<p>For examples of plugins, see <a href=\"#!/api/Ext.plugin.PullRefresh\" rel=\"Ext.plugin.PullRefresh\" class=\"docClass\">Ext.plugin.PullRefresh</a> and <a href=\"#!/api/Ext.plugin.ListPaging\" rel=\"Ext.plugin.ListPaging\" class=\"docClass\">Ext.plugin.ListPaging</a></p>\n\n<h2>Example code</h2>\n\n<p>A plugin by alias:</p>\n\n<pre><code><a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">Ext.dataview.List</a>', {\n    config: {\n        plugins: 'listpaging',\n        itemTpl: '&lt;div class=\"item\"&gt;{title}&lt;/div&gt;',\n        store: 'Items'\n    }\n});\n</code></pre>\n\n<p>Multiple plugins by alias:</p>\n\n<pre><code><a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">Ext.dataview.List</a>', {\n    config: {\n        plugins: ['listpaging', 'pullrefresh'],\n        itemTpl: '&lt;div class=\"item\"&gt;{title}&lt;/div&gt;',\n        store: 'Items'\n    }\n});\n</code></pre>\n\n<p>Single plugin by class name with config options:</p>\n\n<pre><code><a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">Ext.dataview.List</a>', {\n    config: {\n        plugins: {\n            xclass: '<a href=\"#!/api/Ext.plugin.ListPaging\" rel=\"Ext.plugin.ListPaging\" class=\"docClass\">Ext.plugin.ListPaging</a>', // Reference plugin by class\n            autoPaging: true\n        },\n\n        itemTpl: '&lt;div class=\"item\"&gt;{title}&lt;/div&gt;',\n        store: 'Items'\n    }\n});\n</code></pre>\n\n<p>Multiple plugins by class name with config options:</p>\n\n<pre><code><a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.dataview.List\" rel=\"Ext.dataview.List\" class=\"docClass\">Ext.dataview.List</a>', {\n    config: {\n        plugins: [\n            {\n                xclass: '<a href=\"#!/api/Ext.plugin.PullRefresh\" rel=\"Ext.plugin.PullRefresh\" class=\"docClass\">Ext.plugin.PullRefresh</a>',\n                pullRefreshText: 'Pull to refresh...'\n            },\n            {\n                xclass: '<a href=\"#!/api/Ext.plugin.ListPaging\" rel=\"Ext.plugin.ListPaging\" class=\"docClass\">Ext.plugin.ListPaging</a>',\n                autoPaging: true\n            }\n        ],\n\n        itemTpl: '&lt;div class=\"item\"&gt;{title}&lt;/div&gt;',\n        store: 'Items'\n    }\n});\n</code></pre>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-record' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-record' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-record' class='name expandable'>record</a><span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a></span></div><div class='description'><div class='short'>A model instance which updates the Component's html based on it's tpl. ...</div><div class='long'><p>A model instance which updates the Component's html based on it's tpl. Similar to the data\nconfiguration, but tied to to a record to make allow dynamic updates.  This must be a model\ninstance and not a configuration of one.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-renderTo' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-renderTo' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-renderTo' class='name expandable'>renderTo</a><span> : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a></span></div><div class='description'><div class='short'>Optional element to render this Component to. ...</div><div class='long'><p>Optional element to render this Component to. Usually this is not needed because\na Component is normally full screen or automatically rendered inside another <a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Container</a></p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-renderTpl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-renderTpl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-renderTpl' class='name expandable'>renderTpl</a><span> : Mixed</span></div><div class='description'><div class='short'>An XTemplate used to create the internal structure inside this Component's\nencapsulating Element. ...</div><div class='long'><p>An <a href=\"#!/api/Ext.XTemplate\" rel=\"Ext.XTemplate\" class=\"docClass\">XTemplate</a> used to create the internal structure inside this Component's\nencapsulating Element.</p>\n\n\n<p>You do not normally need to specify this. For the base classes <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a>\nand <a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a>, this defaults to <b><code>null</code></b> which means that they will be initially rendered\nwith no internal structure; they render their <a href=\"#!/api/Ext.Component-method-getEl\" rel=\"Ext.Component-method-getEl\" class=\"docClass\">Element</a> empty. The more specialized ExtJS and Touch classes\nwhich use a more complex DOM structure, provide their own template definitions.</p>\n\n\n<p>This is intended to allow the developer to create application-specific utility Components with customized\ninternal structure.</p>\n\n</div></div></div><div id='cfg-required' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-required' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-required' class='name expandable'>required</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>True to make this field required. ...</div><div class='long'><p>True to make this field required. Note: this only causes a visual indication.\nDoesn't prevent user from submitting the form.</p>\n<p>Defaults to: <code>false</code></p></div></div></div><div id='cfg-requiredCls' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-requiredCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-requiredCls' class='name expandable'>requiredCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The className to be applied to this Field when the required configuration is set to true ...</div><div class='long'><p>The className to be applied to this Field when the <a href=\"#!/api/Ext.field.Field-cfg-required\" rel=\"Ext.field.Field-cfg-required\" class=\"docClass\">required</a> configuration is set to true</p>\n<p>Defaults to: <code>&quot;x-field-required&quot;</code></p></div></div></div><div id='cfg-right' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-right' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-right' class='name expandable'>right</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The absolute right position of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The absolute right position of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.\nExplicitly setting this value will make this Component become 'floating', which means its layout will no\nlonger be affected by the Container that it resides in.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-scroll' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-scroll' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-scroll' class='name expandable'>scroll</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>This configuration has moved to Ext.Container. ...</div><div class='long'><p>This configuration has moved to <a href=\"#!/api/Ext.Container-cfg-scrollable\" rel=\"Ext.Container-cfg-scrollable\" class=\"docClass\">Ext.Container</a>. You can no longer use it in a <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a>.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        <p>This method has been moved from <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> to <a href=\"#!/api/Ext.Container-cfg-scrollable\" rel=\"Ext.Container-cfg-scrollable\" class=\"docClass\">Ext.Container</a></p>\n\n        </div>\n</div></div></div><div id='cfg-showAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-showAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-showAnimation' class='name expandable'>showAnimation</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</span></div><div class='description'><div class='short'>Animation effect to apply when the Component is being shown. ...</div><div class='long'><p>Animation effect to apply when the Component is being shown.  Typically you want to use an\ninbound animation type such as 'fadeIn' or 'slideIn'.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-stopMaskTapEvent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-stopMaskTapEvent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-stopMaskTapEvent' class='name not-expandable'>stopMaskTapEvent</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='removed signature'>removed</strong></div><div class='description'><div class='short'><p>True to stop the event that fires when you click outside the floating component.</p>\n</div><div class='long'><p>True to stop the event that fires when you click outside the floating component.</p>\n        <div class='signature-box removed'>\n        <p>This cfg has been <strong>removed</strong> since 2.0.0</p>\n        \n\n        </div>\n</div></div></div><div id='cfg-style' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-style' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-style' class='name expandable'>style</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span></div><div class='description'><div class='short'>Optional CSS styles that will be rendered into an inline style attribute when the\nComponent is rendered. ...</div><div class='long'><p>Optional CSS styles that will be rendered into an inline style attribute when the\nComponent is rendered.</p>\n\n<p>You can pass either a string syntax:</p>\n\n<pre><code>style: 'background:red'\n</code></pre>\n\n<p>Or by using an object:</p>\n\n<pre><code>style: {\n    background: 'red'\n}\n</code></pre>\n\n<p>When using the object syntax, you can define CSS Properties by using a string:</p>\n\n<pre><code>style: {\n    'border-left': '1px solid red'\n}\n</code></pre>\n\n<p>Although the object syntax is much easier to read, we suggest you to use the string syntax for better performance.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-styleHtmlCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-styleHtmlCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-styleHtmlCls' class='name not-expandable'>styleHtmlCls</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'><p>The class that is added to the content target when you set styleHtmlContent to true.</p>\n</div><div class='long'><p>The class that is added to the content target when you set styleHtmlContent to true.</p>\n</div></div></div><div id='cfg-styleHtmlContent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-styleHtmlContent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-styleHtmlContent' class='name expandable'>styleHtmlContent</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>True to automatically style the html inside the content target of this component (body for panels). ...</div><div class='long'><p>True to automatically style the html inside the content target of this component (body for panels).</p>\n<p>Defaults to: <code>false</code></p></div></div></div><div id='cfg-tabIndex' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-tabIndex' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-tabIndex' class='name expandable'>tabIndex</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></span></div><div class='description'><div class='short'>The tabIndex for this field. ...</div><div class='long'><p>The tabIndex for this field. Note this only applies to fields that are rendered,\nnot those which are built via applyTo.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-top' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-top' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-top' class='name expandable'>top</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The absolute top position of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The absolute top position of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.\nExplicitly setting this value will make this Component become 'floating', which means its layout will no\nlonger be affected by the Container that it resides in.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-tpl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-tpl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-tpl' class='name expandable'>tpl</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]/<a href=\"#!/api/Ext.Template\" rel=\"Ext.Template\" class=\"docClass\">Ext.Template</a>[]/<a href=\"#!/api/Ext.XTemplate\" rel=\"Ext.XTemplate\" class=\"docClass\">Ext.XTemplate</a>[]</span></div><div class='description'><div class='short'>A String, Ext.Template, Ext.XTemplate or an Array of strings to form an Ext.XTemplate. ...</div><div class='long'><p>A <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>, <a href=\"#!/api/Ext.Template\" rel=\"Ext.Template\" class=\"docClass\">Ext.Template</a>, <a href=\"#!/api/Ext.XTemplate\" rel=\"Ext.XTemplate\" class=\"docClass\">Ext.XTemplate</a> or an <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a> of strings to form an <a href=\"#!/api/Ext.XTemplate\" rel=\"Ext.XTemplate\" class=\"docClass\">Ext.XTemplate</a>.\nUsed in conjunction with the <a href=\"#!/api/Ext.Component-cfg-data\" rel=\"Ext.Component-cfg-data\" class=\"docClass\">data</a> and <a href=\"#!/api/Ext.Component-cfg-tplWriteMode\" rel=\"Ext.Component-cfg-tplWriteMode\" class=\"docClass\">tplWriteMode</a> configurations.</p>\n\n<p><b>Note</b>\nThe <a href=\"#!/api/Ext.Component-cfg-data\" rel=\"Ext.Component-cfg-data\" class=\"docClass\">data</a> configuration <i>must</i> be set for any content to be shown in the component when using this configuration.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-tplWriteMode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-tplWriteMode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-tplWriteMode' class='name expandable'>tplWriteMode</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The Ext.(X)Template method to use when\nupdating the content area of the Component. ...</div><div class='long'><p>The Ext.(X)Template method to use when\nupdating the content area of the Component. Defaults to <code>'overwrite'</code>\n(see <code><a href=\"#!/api/Ext.XTemplate-method-overwrite\" rel=\"Ext.XTemplate-method-overwrite\" class=\"docClass\">Ext.XTemplate.overwrite</a></code>).</p>\n<p>Defaults to: <code>&quot;overwrite&quot;</code></p></div></div></div><div id='cfg-translatable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-translatable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-translatable' class='name expandable'>translatable</a><span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-ui' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-ui' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-ui' class='name expandable'>ui</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The ui to be used on this Component ...</div><div class='long'><p>The ui to be used on this Component</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-useClearIcon' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-useClearIcon' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-useClearIcon' class='name expandable'>useClearIcon</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>True to use a clear icon in this field ...</div><div class='long'><p>True to use a clear icon in this field</p>\n        <div class='signature-box deprecated'>\n        <p>This cfg has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use the <a href=\"#!/api/Ext.field.Field-cfg-clearIcon\" rel=\"Ext.field.Field-cfg-clearIcon\" class=\"docClass\">clearIcon</a> configuration instead</p>\n\n        </div>\n</div></div></div><div id='cfg-value' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-value' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-cfg-value' class='name expandable'>value</a><span> : Mixed</span></div><div class='description'><div class='short'>A value to initialize this field with. ...</div><div class='long'><p>A value to initialize this field with.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-width' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-width' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-width' class='name expandable'>width</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The width of this Component; must be a valid CSS length value, e.g: 300, 100px, 30%, etc. ...</div><div class='long'><p>The width of this Component; must be a valid CSS length value, e.g: <code>300</code>, <code>100px</code>, <code>30%</code>, etc.\nBy default, if this is not explicitly set, this Component's element will simply have its own natual size.</p>\n<p>Defaults to: <code>null</code></p></div></div></div><div id='cfg-xtype' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-xtype' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-xtype' class='name expandable'>xtype</a><span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span></div><div class='description'><div class='short'>The xtype configuration option can be used to optimize Component creation and rendering. ...</div><div class='long'><p>The <code>xtype</code> configuration option can be used to optimize Component creation and rendering. It serves as a\nshortcut to the full componet name. For example, the component <code>Ext.button.Button</code> has an xtype of <code>button</code>.</p>\n\n<p>You can define your own xtype on a custom <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">component</a> by specifying the\n<a href=\"#!/api/Ext.Class-cfg-alias\" rel=\"Ext.Class-cfg-alias\" class=\"docClass\">alias</a> config option with a prefix of <code>widget</code>. For example:</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('PressMeButton', {\n    extend: 'Ext.button.Button',\n    alias: 'widget.pressmebutton',\n    text: 'Press Me'\n})\n</code></pre>\n\n<p>Any Component can be created implicitly as an object config with an xtype specified, allowing it to be\ndeclared and passed into the rendering pipeline without actually being instantiated as an object. Not only is\nrendering deferred, but the actual creation of the object itself is also deferred, saving memory and resources\nuntil they are actually needed. In complex, nested layouts containing many Components, this can make a\nnoticeable improvement in performance.</p>\n\n<pre><code>// Explicit creation of contained Components:\nvar panel = new <a href=\"#!/api/Ext.Panel\" rel=\"Ext.Panel\" class=\"docClass\">Ext.Panel</a>({\n   ...\n   items: [\n      <a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('Ext.button.Button', {\n         text: 'OK'\n      })\n   ]\n};\n\n// Implicit creation using xtype:\nvar panel = new <a href=\"#!/api/Ext.Panel\" rel=\"Ext.Panel\" class=\"docClass\">Ext.Panel</a>({\n   ...\n   items: [{\n      xtype: 'button',\n      text: 'OK'\n   }]\n};\n</code></pre>\n\n<p>In the first example, the button will always be created immediately during the panel's initialization. With\nmany added Components, this approach could potentially slow the rendering of the page. In the second example,\nthe button will not be created or rendered until the panel is actually displayed in the browser. If the panel\nis never displayed (for example, if it is a tab that remains hidden) then the button will never be created and\nwill never consume any resources whatsoever.</p>\n<p>Defaults to: <code>&quot;component&quot;</code></p></div></div></div><div id='cfg-zIndex' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-zIndex' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-cfg-zIndex' class='name expandable'>zIndex</a><span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></span></div><div class='description'><div class='short'>The z-index to give this Component when it is rendered ...</div><div class='long'><p>The z-index to give this Component when it is rendered</p>\n<p>Defaults to: <code>null</code></p></div></div></div></div></div><div class='members-section'><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div class='definedBy'>Defined By</div><h4 class='members-subtitle'>Instance Properties</h3><div id='property-alignmentRegex' class='member first-child inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-property-alignmentRegex' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-property-alignmentRegex' class='name expandable'>alignmentRegex</a><span> : <a href=\"#!/api/RegExp\" rel=\"RegExp\" class=\"docClass\">RegExp</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>/^([a-z]+)-([a-z]+)(\\?)?$/</code></p></div></div></div><div id='property-dockPositions' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-property-dockPositions' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-property-dockPositions' class='name expandable'>dockPositions</a><span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><strong class='private signature'>private</strong><strong class='readonly signature'>readonly</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>{top: true, right: true, bottom: true, left: true}</code></p></div></div></div><div id='property-floating' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-property-floating' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-property-floating' class='name expandable'>floating</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>false</code></p></div></div></div><div id='property-isComponent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-property-isComponent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-property-isComponent' class='name expandable'>isComponent</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>true</code></p></div></div></div><div id='property-isField' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-property-isField' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-property-isField' class='name expandable'>isField</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span></div><div class='description'><div class='short'>Set to true on all Ext.field.Field subclasses. ...</div><div class='long'><p>Set to true on all <a href=\"#!/api/Ext.field.Field\" rel=\"Ext.field.Field\" class=\"docClass\">Ext.field.Field</a> subclasses. This is used by <a href=\"#!/api/Ext.form.Panel-method-getValues\" rel=\"Ext.form.Panel-method-getValues\" class=\"docClass\">Ext.form.Panel.getValues</a> to determine which\ncomponents inside a form are fields.</p>\n<p>Defaults to: <code>true</code></p></div></div></div><div id='property-labelEl' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-property-labelEl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-property-labelEl' class='name expandable'>labelEl</a><span> : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a></span><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>The label Element associated with this Field. ...</div><div class='long'><p>The label Element associated with this Field. <b>Only available if a <a href=\"#!/api/Ext.field.Field-cfg-label\" rel=\"Ext.field.Field-cfg-label\" class=\"docClass\">label</a> is specified.</b></p>\n\n\n<p>This has been deprecated.\n\n        <div class='signature-box deprecated'>\n        <p>This property has been <strong>deprecated</strong> since 2.0</p>\n        \n\n        </div>\n</div></div></div><div id='property-listenerOptionsRegex' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-property-listenerOptionsRegex' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-property-listenerOptionsRegex' class='name expandable'>listenerOptionsRegex</a><span> : <a href=\"#!/api/RegExp\" rel=\"RegExp\" class=\"docClass\">RegExp</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>/^(?:delegate|single|delay|buffer|args|prepend|element)$/</code></p></div></div></div><div id='property-originalValue' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-property-originalValue' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-property-originalValue' class='name expandable'>originalValue</a><span> : Mixed</span></div><div class='description'><div class='short'>The original value of the field as configured in the value configuration. ...</div><div class='long'><p>The original value of the field as configured in the <a href=\"#!/api/Ext.field.Field-cfg-value\" rel=\"Ext.field.Field-cfg-value\" class=\"docClass\">value</a> configuration.\nsetting is <code>true</code>.</p>\n</div></div></div><div id='property-rendered' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-property-rendered' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-property-rendered' class='name expandable'>rendered</a><span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>false</code></p></div></div></div><div id='property-self' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-property-self' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-property-self' class='name expandable'>self</a><span> : <a href=\"#!/api/Ext.Class\" rel=\"Ext.Class\" class=\"docClass\">Ext.Class</a></span><strong class='protected signature'>protected</strong></div><div class='description'><div class='short'>Get the reference to the current class from which this object was instantiated. ...</div><div class='long'><p>Get the reference to the current class from which this object was instantiated. Unlike <a href=\"#!/api/Ext.Base-method-statics\" rel=\"Ext.Base-method-statics\" class=\"docClass\">statics</a>,\n<code>this.self</code> is scope-dependent and it's meant to be used for dynamic inheritance. See <a href=\"#!/api/Ext.Base-method-statics\" rel=\"Ext.Base-method-statics\" class=\"docClass\">statics</a>\nfor a detailed comparison</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.Cat', {\n    statics: {\n        speciesName: 'Cat' // My.Cat.speciesName = 'Cat'\n    },\n\n    constructor: function() {\n        alert(this.self.speciesName); / dependentOL on 'this'\n    },\n\n    clone: function() {\n        return new this.self();\n    }\n});\n\n\n<a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.SnowLeopard', {\n    extend: 'My.Cat',\n    statics: {\n        speciesName: 'Snow Leopard'         // My.SnowLeopard.speciesName = 'Snow Leopard'\n    }\n});\n\nvar cat = new My.Cat();                     // alerts 'Cat'\nvar snowLeopard = new My.SnowLeopard();     // alerts 'Snow Leopard'\n\nvar clone = snowLeopard.clone();\nalert(<a href=\"#!/api/Ext-method-getClassName\" rel=\"Ext-method-getClassName\" class=\"docClass\">Ext.getClassName</a>(clone));             // alerts 'My.SnowLeopard'\n</code></pre>\n</div></div></div></div><div class='subsection'><div class='definedBy'>Defined By</div><h4 class='members-subtitle'>Static Properties</h3><div id='static-property-S-onExtended' class='member first-child inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-property-S-onExtended' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-property-S-onExtended' class='name expandable'>$onExtended</a><span> : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a></span><strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>[]</code></p></div></div></div></div></div><div class='members-section'><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div class='definedBy'>Defined By</div><h4 class='members-subtitle'>Instance Methods</h3><div id='method-constructor' class='member first-child inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-constructor' target='_blank' class='view-source'>view source</a></div><strong class='new-keyword'>new</strong><a href='#!/api/Ext.Component-method-constructor' class='name expandable'>Ext.field.Field</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> config</span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></div><div class='description'><div class='short'>Creates new Component. ...</div><div class='long'><p>Creates new Component.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>config</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The standard configuration object.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-addAfterListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-addAfterListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-addAfterListener' class='name expandable'>addAfterListener</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )</div><div class='description'><div class='short'>Appends an after-event handler. ...</div><div class='long'><p>Appends an after-event handler.</p>\n\n<p>Same as <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> with <code>order</code> set to <code>'after'</code>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event to listen for.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The method the event invokes.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope for <code>fn</code>.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>An object containing handler configuration.</p>\n\n</div></li></ul></div></div></div><div id='method-addBeforeListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-addBeforeListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-addBeforeListener' class='name expandable'>addBeforeListener</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )</div><div class='description'><div class='short'>Appends a before-event handler. ...</div><div class='long'><p>Appends a before-event handler.  Returning <code>false</code> from the handler will stop the event.</p>\n\n<p>Same as <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> with <code>order</code> set to <code>'before'</code>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event to listen for.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The method the event invokes.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope for <code>fn</code>.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>An object containing handler configuration.</p>\n\n</div></li></ul></div></div></div><div id='method-addCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-addCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-addCls' class='name expandable'>addCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> cls, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> prefix, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> suffix</span> )</div><div class='description'><div class='short'>Adds a CSS class (or classes) to this Component's rendered element ...</div><div class='long'><p>Adds a CSS class (or classes) to this Component's rendered element</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>cls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The CSS class to add</p>\n</div></li><li><span class='pre'>prefix</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>Optional prefix to add to each class</p>\n</div></li><li><span class='pre'>suffix</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>Optional suffix to add to each class</p>\n</div></li></ul></div></div></div><div id='method-addEvents' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-addEvents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-addEvents' class='name expandable'>addEvents</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>... eventNames</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Adds the specified events to the list of events which this Observable may fire. ...</div><div class='long'><p>Adds the specified events to the list of events which this Observable may fire.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0</p>\n        <p>It's no longer needed to add events before firing.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventNames</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>...<div class='sub-desc'><p>Either an object with event names as properties with a value of <code>true</code>\nor the first event name string if multiple event names are being passed as separate parameters.</p>\n</div></li></ul></div></div></div><div id='method-addListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-addListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-addListener' class='name expandable'>addListener</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options], [<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> order]</span> )</div><div class='description'><div class='short'>Appends an event handler to this object. ...</div><div class='long'><p>Appends an event handler to this object. You can review the available handlers by looking at the 'events'\nsection of the documentation for the component you are working with.</p>\n\n<h2>Combining Options</h2>\n\n<p>Using the options argument, it is possible to combine different types of listeners:</p>\n\n<p>A delayed, one-time listener:</p>\n\n<pre><code>container.on('tap', this.handleTap, this, {\n    single: true,\n    delay: 100\n});\n</code></pre>\n\n<h2>Attaching multiple handlers in 1 call</h2>\n\n<p>The method also allows for a single argument to be passed which is a config object containing properties which\nspecify multiple events. For example:</p>\n\n<pre><code>container.on({\n    tap  : this.onTap,\n    swipe: this.onSwipe,\n\n    scope: this // Important. Ensure \"this\" is correct during handler execution\n});\n</code></pre>\n\n<p>One can also specify options for each event handler separately:</p>\n\n<pre><code>container.on({\n    tap  : { fn: this.onTap, scope: this, single: true },\n    swipe: { fn: button.onSwipe, scope: button }\n});\n</code></pre>\n\n<p>See the <a href=\"#!/guide/events\">Events Guide</a> for more.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event to listen for. May also be an object who's property names are\nevent names.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The method the event invokes.  Will be called with arguments given to\n<a href=\"#!/api/Ext.mixin.Observable-method-fireEvent\" rel=\"Ext.mixin.Observable-method-fireEvent\" class=\"docClass\">fireEvent</a> plus the <code>options</code> parameter described below.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope (<code>this</code> reference) in which the handler function is executed. <strong>If\nomitted, defaults to the object which fired the event.</strong></p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>An object containing handler configuration.</p>\n\n\n\n\n<p>This object may contain any of the following properties:</p>\n\n\n\n\n<ul>\n<li><p><strong>scope</strong> : Object</p>\n\n<p>The scope (<code>this</code> reference) in which the handler function is executed. <strong>If omitted, defaults to the object\nwhich fired the event.</strong></p></li>\n<li><p><strong>delay</strong> : Number</p>\n\n<p>The number of milliseconds to delay the invocation of the handler after the event fires.</p></li>\n<li><p><strong>single</strong> : Boolean</p>\n\n<p>True to add a handler to handle just the next firing of the event, and then remove itself.</p></li>\n<li><p><strong>order</strong> : String</p>\n\n<p>The order of when the listener should be added into the listener queue.</p>\n\n<p>If you set an order of <code>before</code> and the event you are listening to is preventable, you can return <code>false</code> and it will stop the event.</p>\n\n<p>Available options are <code>before</code>, <code>current</code> and <code>after</code>. Defaults to <code>current</code>.</p></li>\n<li><p><strong>buffer</strong> : Number</p>\n\n<p>Causes the handler to be delayed by the specified number of milliseconds. If the event fires again within that\ntime, the original handler is <em>not</em> invoked, but the new handler is scheduled in its place.</p></li>\n<li><p><strong>element</strong> : String</p>\n\n<p>Allows you to add a listener onto a element of this component using the elements reference.</p>\n\n<pre><code><a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a>', {\n    listeners: {\n        element: 'element',\n        tap: function() {\n            console.log('element tap!');\n        }\n    }\n});\n</code></pre>\n\n<p>All components have the <code>element</code> reference, which is the outer most element of the component. <a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a> also has the\n<code>innerElement</code> element which contains all children. In most cases <code>element</code> is adequate.</p></li>\n<li><p><strong>delegate</strong> : String</p>\n\n<p>Uses <a href=\"#!/api/Ext.ComponentQuery\" rel=\"Ext.ComponentQuery\" class=\"docClass\">Ext.ComponentQuery</a> to delegate events to a specified query selector within this item.</p>\n\n<pre><code>// Create a container with a two children; a button and a toolbar\nvar container = <a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a>', {\n    items: [\n        {\n           xtype: 'toolbar',\n           docked: 'top',\n           title: 'My Toolbar'\n        },\n        {\n           xtype: 'button',\n           text: 'My Button'\n        }\n    ]\n});\n\ncontainer.on({\n    // Ext.Buttons have an xtype of 'button', so we use that are a selector for our delegate\n    delegate: 'button',\n\n    tap: function() {\n        alert('Button tapped!');\n    }\n});\n</code></pre></li>\n</ul>\n\n\n\n</div></li><li><span class='pre'>order</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> (optional)<div class='sub-desc'><p>The order of when the listener should be added into the listener queue.\nPossible values are <code>before</code>, <code>current</code> and <code>after</code>.</p>\n\n<p>Defaults to: <code>&quot;current&quot;</code></p></div></li></ul></div></div></div><div id='method-addManagedListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-addManagedListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-addManagedListener' class='name expandable'>addManagedListener</a>( <span class='pre'><a href=\"#!/api/Ext.mixin.Observable\" rel=\"Ext.mixin.Observable\" class=\"docClass\">Ext.mixin.Observable</a>/HTMLElement object, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, [<a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Adds listeners to any Observable object (or Element) which are automatically removed when this Component\nis destroyed. ...</div><div class='long'><p>Adds listeners to any Observable object (or Element) which are automatically removed when this Component\nis destroyed.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0</p>\n        <p>All listeners are now automatically managed where necessary. Simply use <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a>.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>object</span> : <a href=\"#!/api/Ext.mixin.Observable\" rel=\"Ext.mixin.Observable\" class=\"docClass\">Ext.mixin.Observable</a>/HTMLElement<div class='sub-desc'><p>The item to which to add a listener/listeners.</p>\n\n</div></li><li><span class='pre'>eventName</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The event name, or an object containing event name properties.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the handler function.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the scope in which\nthe handler function is executed.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the\n<a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> options.</p>\n\n</div></li></ul></div></div></div><div id='method-addReferenceNode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.AbstractComponent' rel='Ext.AbstractComponent' class='defined-in docClass'>Ext.AbstractComponent</a><br/><a href='source/AbstractComponent.html#Ext-AbstractComponent-method-addReferenceNode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.AbstractComponent-method-addReferenceNode' class='name expandable'>addReferenceNode</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> name, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> domNode</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Significantly improve instantiation time for Component with multiple references\nExt.Element instance of the reference...</div><div class='long'><p>Significantly improve instantiation time for Component with multiple references\n<a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a> instance of the reference domNode is only created the very first time\nit's ever used</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>domNode</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-alignTo' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-alignTo' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-alignTo' class='name expandable'>alignTo</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> component, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> alignment</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>component</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>alignment</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-applyCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-applyCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-applyCls' class='name expandable'>applyCls</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> cls</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Checks if the cls is a string. ...</div><div class='long'><p>Checks if the cls is a string. If it is, changed it into an array</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>cls</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-applyTpl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-applyTpl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-applyTpl' class='name expandable'>applyTpl</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> config</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>config</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-beforeInitialize' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-beforeInitialize' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-beforeInitialize' class='name expandable'>beforeInitialize</a>( <span class='pre'></span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-callOverridden' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-callOverridden' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-callOverridden' class='name expandable'>callOverridden</a>( <span class='pre'><a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/Arguments args</span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><strong class='protected signature'>protected</strong></div><div class='description'><div class='short'>Call the original method that was previously overridden with override\n\nExt.define('My.Cat', {\n    constructor: functi...</div><div class='long'><p>Call the original method that was previously overridden with <a href=\"#!/api/Ext.Base-static-method-override\" rel=\"Ext.Base-static-method-override\" class=\"docClass\">override</a></p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.Cat', {\n    constructor: function() {\n        alert(\"I'm a cat!\");\n    }\n});\n\nMy.Cat.override({\n    constructor: function() {\n        alert(\"I'm going to be a cat!\");\n\n        var instance = this.callOverridden();\n\n        alert(\"Meeeeoooowwww\");\n\n        return instance;\n    }\n});\n\nvar kitty = new My.Cat(); // alerts \"I'm going to be a cat!\"\n                          // alerts \"I'm a cat!\"\n                          // alerts \"Meeeeoooowwww\"\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>args</span> : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/Arguments<div class='sub-desc'><p>The arguments, either an array or the <code>arguments</code> object\nfrom the current method, for example: <code>this.callOverridden(arguments)</code></p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'><p>Returns the result of calling the overridden method</p>\n</div></li></ul></div></div></div><div id='method-callParent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-callParent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-callParent' class='name expandable'>callParent</a>( <span class='pre'><a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/Arguments args</span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><strong class='protected signature'>protected</strong></div><div class='description'><div class='short'>Call the \"parent\" method of the current method. ...</div><div class='long'><p>Call the \"parent\" method of the current method. That is the method previously\noverridden by derivation or by an override (see <a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>).</p>\n\n<pre><code> <a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.Base', {\n     constructor: function (x) {\n         this.x = x;\n     },\n\n     statics: {\n         method: function (x) {\n             return x;\n         }\n     }\n });\n\n <a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.Derived', {\n     extend: 'My.Base',\n\n     constructor: function () {\n         this.callParent([21]);\n     }\n });\n\n var obj = new My.Derived();\n\n alert(obj.x);  // alerts 21\n</code></pre>\n\n<p>This can be used with an override as follows:</p>\n\n<pre><code> <a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.DerivedOverride', {\n     override: 'My.Derived',\n\n     constructor: function (x) {\n         this.callParent([x*2]); // calls original My.Derived constructor\n     }\n });\n\n var obj = new My.Derived();\n\n alert(obj.x);  // now alerts 42\n</code></pre>\n\n<p>This also works with static methods.</p>\n\n<pre><code> <a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.Derived2', {\n     extend: 'My.Base',\n\n     statics: {\n         method: function (x) {\n             return this.callParent([x*2]); // calls My.Base.method\n         }\n     }\n });\n\n alert(My.Base.method(10);     // alerts 10\n alert(My.Derived2.method(10); // alerts 20\n</code></pre>\n\n<p>Lastly, it also works with overridden static methods.</p>\n\n<pre><code> <a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.Derived2Override', {\n     override: 'My.Derived2',\n\n     statics: {\n         method: function (x) {\n             return this.callParent([x*2]); // calls My.Derived2.method\n         }\n     }\n });\n\n alert(My.Derived2.method(10); // now alerts 40\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>args</span> : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/Arguments<div class='sub-desc'><p>The arguments, either an array or the <code>arguments</code> object\nfrom the current method, for example: <code>this.callParent(arguments)</code></p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'><p>Returns the result of calling the parent method</p>\n</div></li></ul></div></div></div><div id='method-changeListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-changeListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-changeListener' class='name expandable'>changeListener</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> operation, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eventName, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> fn, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> order</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>operation</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>eventName</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>order</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-clearListeners' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-clearListeners' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-clearListeners' class='name expandable'>clearListeners</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Removes all listeners for this object. ...</div><div class='long'><p>Removes all listeners for this object.</p>\n</div></div></div><div id='method-createEventRelayer' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-createEventRelayer' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-createEventRelayer' class='name expandable'>createEventRelayer</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> newName</span> ) : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><strong class='private signature'>private</strong></div><div class='description'><div class='short'>Creates an event handling function which refires the event from this object as the passed event name. ...</div><div class='long'><p>Creates an event handling function which refires the event from this object as the passed event name.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>newName</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-destroy' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-destroy' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-destroy' class='name expandable'>destroy</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Destroys this Component. ...</div><div class='long'><p>Destroys this Component. If it is currently added to a Container it will first be removed from that Container.\nAll <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a> references are also deleted and the Component is de-registered from <a href=\"#!/api/Ext.ComponentManager\" rel=\"Ext.ComponentManager\" class=\"docClass\">Ext.ComponentManager</a></p>\n<p>Overrides: <a href='#!/api/Ext.Base-method-destroy' rel='Ext.Base-method-destroy' class='docClass'>Ext.Base.destroy</a></p></div></div></div><div id='method-disable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-disable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-disable' class='name expandable'>disable</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Disables this Component ...</div><div class='long'><p>Disables this Component</p>\n</div></div></div><div id='method-doAddListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-doAddListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-doAddListener' class='name expandable'>doAddListener</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> name, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> fn, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-doInitValue' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-method-doInitValue' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-doInitValue' class='name expandable'>doInitValue</a>( <span class='pre'></span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-enable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-enable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-enable' class='name expandable'>enable</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Enables this Component ...</div><div class='long'><p>Enables this Component</p>\n</div></div></div><div id='method-enableBubble' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-enableBubble' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-enableBubble' class='name expandable'>enableBubble</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[] events</span> )</div><div class='description'><div class='short'>Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if\npresent. ...</div><div class='long'><p>Enables events fired by this Observable to bubble up an owner hierarchy by calling <code>this.getBubbleTarget()</code> if\npresent. There is no implementation in the Observable base class.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>events</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]<div class='sub-desc'><p>The event name to bubble, or an Array of event names.</p>\n</div></li></ul></div></div></div><div id='method-fireAction' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-fireAction' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-fireAction' class='name expandable'>fireAction</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a> args, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope</span> )</div><div class='description'><div class='short'>Fires the specified event with the passed parameters and execute a function (action)\nat the end if there are no liste...</div><div class='long'><p>Fires the specified event with the passed parameters and execute a function (action)\nat the end if there are no listeners that return false.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event to fire.</p>\n</div></li><li><span class='pre'>args</span> : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a><div class='sub-desc'><p>Arguments to pass to handers</p>\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>Action</p>\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>scope of fn</p>\n</div></li></ul></div></div></div><div id='method-fireEvent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-fireEvent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-fireEvent' class='name expandable'>fireEvent</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>... args</span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Fires the specified event with the passed parameters (minus the event name, plus the options object passed\nto addList...</div><div class='long'><p>Fires the specified event with the passed parameters (minus the event name, plus the <code>options</code> object passed\nto <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a>).</p>\n\n<p>An event may be set to bubble up an Observable parent hierarchy by calling <a href=\"#!/api/Ext.mixin.Observable-method-enableBubble\" rel=\"Ext.mixin.Observable-method-enableBubble\" class=\"docClass\">enableBubble</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event to fire.</p>\n</div></li><li><span class='pre'>args</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>...<div class='sub-desc'><p>Variable number of parameters are passed to handlers.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'><p>returns false if any of the handlers return false otherwise it returns true.</p>\n</div></li></ul></div></div></div><div id='method-getBaseCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-baseCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getBaseCls' class='name expandable'>getBaseCls</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of baseCls. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-baseCls\" rel=\"Ext.Component-cfg-baseCls\" class=\"docClass\">baseCls</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getBorder' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-border' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getBorder' class='name expandable'>getBorder</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of border. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-border\" rel=\"Ext.Component-cfg-border\" class=\"docClass\">border</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getBottom' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-bottom' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getBottom' class='name expandable'>getBottom</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of bottom. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-bottom\" rel=\"Ext.Component-cfg-bottom\" class=\"docClass\">bottom</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getBubbleEvents' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-cfg-bubbleEvents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-getBubbleEvents' class='name expandable'>getBubbleEvents</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]</div><div class='description'><div class='short'>Returns the value of bubbleEvents. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.mixin.Observable-cfg-bubbleEvents\" rel=\"Ext.mixin.Observable-cfg-bubbleEvents\" class=\"docClass\">bubbleEvents</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getCentered' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-centered' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getCentered' class='name expandable'>getCentered</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of centered. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-centered\" rel=\"Ext.Component-cfg-centered\" class=\"docClass\">centered</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getClearIcon' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-clearIcon' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-getClearIcon' class='name expandable'>getClearIcon</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of clearIcon. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.field.Field-cfg-clearIcon\" rel=\"Ext.field.Field-cfg-clearIcon\" class=\"docClass\">clearIcon</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-cls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getCls' class='name expandable'>getCls</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]</div><div class='description'><div class='short'>Returns the value of cls. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-cls\" rel=\"Ext.Component-cfg-cls\" class=\"docClass\">cls</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getConfig' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-getConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-getConfig' class='name expandable'>getConfig</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> name</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getContentEl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-contentEl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getContentEl' class='name expandable'>getContentEl</a>( <span class='pre'></span> ) : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of contentEl. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-contentEl\" rel=\"Ext.Component-cfg-contentEl\" class=\"docClass\">contentEl</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getCurrentConfig' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-getCurrentConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-getCurrentConfig' class='name expandable'>getCurrentConfig</a>( <span class='pre'></span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-getData' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-data' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getData' class='name expandable'>getData</a>( <span class='pre'></span> ) : Mixed</div><div class='description'><div class='short'>Returns the value of data. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-data\" rel=\"Ext.Component-cfg-data\" class=\"docClass\">data</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Mixed</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getDisabled' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-disabled' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getDisabled' class='name expandable'>getDisabled</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of disabled. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-disabled\" rel=\"Ext.Component-cfg-disabled\" class=\"docClass\">disabled</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getDisabledCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-disabledCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getDisabledCls' class='name expandable'>getDisabledCls</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of disabledCls. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-disabledCls\" rel=\"Ext.Component-cfg-disabledCls\" class=\"docClass\">disabledCls</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getDocked' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-docked' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getDocked' class='name expandable'>getDocked</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of docked. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-docked\" rel=\"Ext.Component-cfg-docked\" class=\"docClass\">docked</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getDraggable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-draggable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getDraggable' class='name expandable'>getDraggable</a>( <span class='pre'></span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></div><div class='description'><div class='short'>Returns the value of draggable. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-draggable\" rel=\"Ext.Component-cfg-draggable\" class=\"docClass\">draggable</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getEl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-getEl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getEl' class='name expandable'>getEl</a>( <span class='pre'></span> ) : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.dom.Element</a><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Retrieves the top level element representing this component. ...</div><div class='long'><p>Retrieves the top level element representing this component.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> </p>\n        <p>2.0.0 Please access the Component's element from the 'element' property instead, i.e:</p>\n\n<pre><code> var element = component.element;\n</code></pre>\n\n        </div>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.dom.Element</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getEnterAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-enterAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getEnterAnimation' class='name expandable'>getEnterAnimation</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Returns the value of enterAnimation. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-enterAnimation\" rel=\"Ext.Component-cfg-enterAnimation\" class=\"docClass\">enterAnimation</a>.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.Component-cfg-showAnimation\" rel=\"Ext.Component-cfg-showAnimation\" class=\"docClass\">showAnimation</a> instead.</p>\n\n        </div>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getExitAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-exitAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getExitAnimation' class='name expandable'>getExitAnimation</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Returns the value of exitAnimation. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-exitAnimation\" rel=\"Ext.Component-cfg-exitAnimation\" class=\"docClass\">exitAnimation</a>.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> </p>\n        <p>2.0.0 Please use <a href=\"#!/api/Ext.Component-cfg-hideAnimation\" rel=\"Ext.Component-cfg-hideAnimation\" class=\"docClass\">hideAnimation</a> instead.  Typically you want to use an\noutbound animation type such as 'fadeOut' or 'slideOut'.</p>\n\n        </div>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getFloatingCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-floatingCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getFloatingCls' class='name expandable'>getFloatingCls</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of floatingCls. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-floatingCls\" rel=\"Ext.Component-cfg-floatingCls\" class=\"docClass\">floatingCls</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getHeight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-height' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getHeight' class='name expandable'>getHeight</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of height. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-height\" rel=\"Ext.Component-cfg-height\" class=\"docClass\">height</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getHidden' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hidden' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getHidden' class='name expandable'>getHidden</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of hidden. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-hidden\" rel=\"Ext.Component-cfg-hidden\" class=\"docClass\">hidden</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getHiddenCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hiddenCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getHiddenCls' class='name expandable'>getHiddenCls</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of hiddenCls. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-hiddenCls\" rel=\"Ext.Component-cfg-hiddenCls\" class=\"docClass\">hiddenCls</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getHideAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hideAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getHideAnimation' class='name expandable'>getHideAnimation</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</div><div class='description'><div class='short'>Returns the value of hideAnimation. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-hideAnimation\" rel=\"Ext.Component-cfg-hideAnimation\" class=\"docClass\">hideAnimation</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getHtml' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-html' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getHtml' class='name expandable'>getHtml</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement</div><div class='description'><div class='short'>Returns the value of html. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-html\" rel=\"Ext.Component-cfg-html\" class=\"docClass\">html</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getId' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Identifiable' rel='Ext.mixin.Identifiable' class='defined-in docClass'>Ext.mixin.Identifiable</a><br/><a href='source/Identifiable.html#Ext-mixin-Identifiable-method-getId' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Identifiable-method-getId' class='name expandable'>getId</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Retrieves the id of this component. ...</div><div class='long'><p>Retrieves the id of this component. Will autogenerate an id if one has not already been set.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'><p>id</p>\n</div></li></ul></div></div></div><div id='method-getInitialConfig' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-getInitialConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-getInitialConfig' class='name expandable'>getInitialConfig</a>( <span class='pre'>[<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> name]</span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/Mixed</div><div class='description'><div class='short'>Returns the initial configuration passed to constructor. ...</div><div class='long'><p>Returns the initial configuration passed to constructor.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> (optional)<div class='sub-desc'><p>When supplied, value for particular configuration\noption is returned, otherwise the full config object is returned.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/Mixed</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getInputType' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-inputType' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-getInputType' class='name expandable'>getInputType</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Returns the value of inputType. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.field.Field-cfg-inputType\" rel=\"Ext.field.Field-cfg-inputType\" class=\"docClass\">inputType</a>.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0</p>\n        \n\n        </div>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getItemId' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-itemId' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getItemId' class='name expandable'>getItemId</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of itemId. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-itemId\" rel=\"Ext.Component-cfg-itemId\" class=\"docClass\">itemId</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getLabel' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-label' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-getLabel' class='name expandable'>getLabel</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of label. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.field.Field-cfg-label\" rel=\"Ext.field.Field-cfg-label\" class=\"docClass\">label</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getLabelAlign' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-labelAlign' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-getLabelAlign' class='name expandable'>getLabelAlign</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of labelAlign. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.field.Field-cfg-labelAlign\" rel=\"Ext.field.Field-cfg-labelAlign\" class=\"docClass\">labelAlign</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getLabelCls' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-labelCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-getLabelCls' class='name expandable'>getLabelCls</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of labelCls. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.field.Field-cfg-labelCls\" rel=\"Ext.field.Field-cfg-labelCls\" class=\"docClass\">labelCls</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getLabelWidth' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-labelWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-getLabelWidth' class='name expandable'>getLabelWidth</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of labelWidth. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.field.Field-cfg-labelWidth\" rel=\"Ext.field.Field-cfg-labelWidth\" class=\"docClass\">labelWidth</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getLabelWrap' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-labelWrap' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-getLabelWrap' class='name expandable'>getLabelWrap</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of labelWrap. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.field.Field-cfg-labelWrap\" rel=\"Ext.field.Field-cfg-labelWrap\" class=\"docClass\">labelWrap</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getLeft' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-left' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getLeft' class='name expandable'>getLeft</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of left. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-left\" rel=\"Ext.Component-cfg-left\" class=\"docClass\">left</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getListeners' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-cfg-listeners' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-getListeners' class='name expandable'>getListeners</a>( <span class='pre'></span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></div><div class='description'><div class='short'>Returns the value of listeners. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.mixin.Observable-cfg-listeners\" rel=\"Ext.mixin.Observable-cfg-listeners\" class=\"docClass\">listeners</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getMargin' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-margin' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getMargin' class='name expandable'>getMargin</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of margin. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-margin\" rel=\"Ext.Component-cfg-margin\" class=\"docClass\">margin</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getMaxHeight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-maxHeight' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getMaxHeight' class='name expandable'>getMaxHeight</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of maxHeight. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-maxHeight\" rel=\"Ext.Component-cfg-maxHeight\" class=\"docClass\">maxHeight</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getMaxWidth' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-maxWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getMaxWidth' class='name expandable'>getMaxWidth</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of maxWidth. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-maxWidth\" rel=\"Ext.Component-cfg-maxWidth\" class=\"docClass\">maxWidth</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getMinHeight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-minHeight' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getMinHeight' class='name expandable'>getMinHeight</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of minHeight. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-minHeight\" rel=\"Ext.Component-cfg-minHeight\" class=\"docClass\">minHeight</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getMinWidth' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-minWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getMinWidth' class='name expandable'>getMinWidth</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of minWidth. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-minWidth\" rel=\"Ext.Component-cfg-minWidth\" class=\"docClass\">minWidth</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getName' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-name' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-getName' class='name expandable'>getName</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of name. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.field.Field-cfg-name\" rel=\"Ext.field.Field-cfg-name\" class=\"docClass\">name</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getPadding' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-padding' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getPadding' class='name expandable'>getPadding</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of padding. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-padding\" rel=\"Ext.Component-cfg-padding\" class=\"docClass\">padding</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getParent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Traversable.html#Ext-Component-method-getParent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getParent' class='name expandable'>getParent</a>( <span class='pre'></span> ) : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a></div><div class='description'><div class='short'>Returns the parent of this component, if it has one. ...</div><div class='long'><p>Returns the parent of this component, if it has one.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a></span><div class='sub-desc'><p>The parent of this component.</p>\n</div></li></ul></div></div></div><div id='method-getPlugins' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-plugins' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getPlugins' class='name expandable'>getPlugins</a>( <span class='pre'></span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a></div><div class='description'><div class='short'>Returns the value of plugins. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-plugins\" rel=\"Ext.Component-cfg-plugins\" class=\"docClass\">plugins</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getRecord' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-record' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getRecord' class='name expandable'>getRecord</a>( <span class='pre'></span> ) : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a></div><div class='description'><div class='short'>Returns the value of record. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-record\" rel=\"Ext.Component-cfg-record\" class=\"docClass\">record</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getRenderTo' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-renderTo' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getRenderTo' class='name expandable'>getRenderTo</a>( <span class='pre'></span> ) : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a></div><div class='description'><div class='short'>Returns the value of renderTo. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-renderTo\" rel=\"Ext.Component-cfg-renderTo\" class=\"docClass\">renderTo</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getRenderTpl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-renderTpl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getRenderTpl' class='name expandable'>getRenderTpl</a>( <span class='pre'></span> ) : Mixed</div><div class='description'><div class='short'>Returns the value of renderTpl. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-renderTpl\" rel=\"Ext.Component-cfg-renderTpl\" class=\"docClass\">renderTpl</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Mixed</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getRequired' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-required' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-getRequired' class='name expandable'>getRequired</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of required. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.field.Field-cfg-required\" rel=\"Ext.field.Field-cfg-required\" class=\"docClass\">required</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getRequiredCls' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-requiredCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-getRequiredCls' class='name expandable'>getRequiredCls</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of requiredCls. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.field.Field-cfg-requiredCls\" rel=\"Ext.field.Field-cfg-requiredCls\" class=\"docClass\">requiredCls</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getRight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-right' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getRight' class='name expandable'>getRight</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of right. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-right\" rel=\"Ext.Component-cfg-right\" class=\"docClass\">right</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getShowAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-showAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getShowAnimation' class='name expandable'>getShowAnimation</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</div><div class='description'><div class='short'>Returns the value of showAnimation. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-showAnimation\" rel=\"Ext.Component-cfg-showAnimation\" class=\"docClass\">showAnimation</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getSize' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-getSize' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getSize' class='name expandable'>getSize</a>( <span class='pre'></span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></div><div class='description'><div class='short'>Returns the height and width of the Component ...</div><div class='long'><p>Returns the height and width of the Component</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'><p>The current height and width of the Component</p>\n</div></li></ul></div></div></div><div id='method-getStyle' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-style' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getStyle' class='name expandable'>getStyle</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></div><div class='description'><div class='short'>Returns the value of style. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-style\" rel=\"Ext.Component-cfg-style\" class=\"docClass\">style</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getStyleHtmlCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-styleHtmlCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getStyleHtmlCls' class='name expandable'>getStyleHtmlCls</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of styleHtmlCls. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-styleHtmlCls\" rel=\"Ext.Component-cfg-styleHtmlCls\" class=\"docClass\">styleHtmlCls</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getStyleHtmlContent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-styleHtmlContent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getStyleHtmlContent' class='name expandable'>getStyleHtmlContent</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns the value of styleHtmlContent. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-styleHtmlContent\" rel=\"Ext.Component-cfg-styleHtmlContent\" class=\"docClass\">styleHtmlContent</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getTabIndex' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-tabIndex' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-getTabIndex' class='name expandable'>getTabIndex</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></div><div class='description'><div class='short'>Returns the value of tabIndex. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.field.Field-cfg-tabIndex\" rel=\"Ext.field.Field-cfg-tabIndex\" class=\"docClass\">tabIndex</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getTop' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-top' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getTop' class='name expandable'>getTop</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of top. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-top\" rel=\"Ext.Component-cfg-top\" class=\"docClass\">top</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getTpl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-tpl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getTpl' class='name expandable'>getTpl</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]/<a href=\"#!/api/Ext.Template\" rel=\"Ext.Template\" class=\"docClass\">Ext.Template</a>[]/<a href=\"#!/api/Ext.XTemplate\" rel=\"Ext.XTemplate\" class=\"docClass\">Ext.XTemplate</a>[]</div><div class='description'><div class='short'>Returns the value of tpl. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-tpl\" rel=\"Ext.Component-cfg-tpl\" class=\"docClass\">tpl</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]/<a href=\"#!/api/Ext.Template\" rel=\"Ext.Template\" class=\"docClass\">Ext.Template</a>[]/<a href=\"#!/api/Ext.XTemplate\" rel=\"Ext.XTemplate\" class=\"docClass\">Ext.XTemplate</a>[]</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getTplWriteMode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-tplWriteMode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getTplWriteMode' class='name expandable'>getTplWriteMode</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of tplWriteMode. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-tplWriteMode\" rel=\"Ext.Component-cfg-tplWriteMode\" class=\"docClass\">tplWriteMode</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getTranslatable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-translatable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getTranslatable' class='name expandable'>getTranslatable</a>( <span class='pre'></span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><strong class='private signature'>private</strong></div><div class='description'><div class='short'>Returns the value of translatable. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">translatable</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getValue' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-value' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-getValue' class='name expandable'>getValue</a>( <span class='pre'></span> ) : Mixed</div><div class='description'><div class='short'>Returns the value of value. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.field.Field-cfg-value\" rel=\"Ext.field.Field-cfg-value\" class=\"docClass\">value</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Mixed</span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getWidth' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-width' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getWidth' class='name expandable'>getWidth</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns the value of width. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-width\" rel=\"Ext.Component-cfg-width\" class=\"docClass\">width</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-getXTypes' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-getXTypes' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getXTypes' class='name expandable'>getXTypes</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></div><div class='description'><div class='short'>Returns this Component's xtype hierarchy as a slash-delimited string. ...</div><div class='long'><p>Returns this Component's xtype hierarchy as a slash-delimited string. For a list of all\navailable xtypes, see the <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> header.</p>\n\n\n<p><b>If using your own subclasses, be aware that a Component must register its own xtype\nto participate in determination of inherited xtypes.</b></p>\n\n\n<p>Example usage:</p>\n\n\n<pre><code>var t = new <a href=\"#!/api/Ext.field.Text\" rel=\"Ext.field.Text\" class=\"docClass\">Ext.field.Text</a>();\nalert(t.getXTypes());  // alerts 'component/field/textfield'\n</code></pre>\n\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'><p>The xtype hierarchy string</p>\n</div></li></ul></div></div></div><div id='method-getZIndex' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-zIndex' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-getZIndex' class='name expandable'>getZIndex</a>( <span class='pre'></span> ) : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></div><div class='description'><div class='short'>Returns the value of zIndex. ...</div><div class='long'><p>Returns the value of <a href=\"#!/api/Ext.Component-cfg-zIndex\" rel=\"Ext.Component-cfg-zIndex\" class=\"docClass\">zIndex</a>.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-hasConfig' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-hasConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-hasConfig' class='name expandable'>hasConfig</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> name</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-hasListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-hasListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-hasListener' class='name expandable'>hasListener</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName</span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Checks to see if this object has any listeners for a specified event ...</div><div class='long'><p>Checks to see if this object has any listeners for a specified event</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event to check for</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'><p>True if the event is being listened for, else false</p>\n</div></li></ul></div></div></div><div id='method-hasParent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Traversable.html#Ext-Component-method-hasParent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-hasParent' class='name expandable'>hasParent</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns true if this component has a parent. ...</div><div class='long'><p>Returns <code>true</code> if this component has a parent.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'><p><code>true</code> if this component has a parent.</p>\n</div></li></ul></div></div></div><div id='method-hide' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-hide' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-hide' class='name expandable'>hide</a>( <span class='pre'>[<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> animation]</span> )</div><div class='description'><div class='short'>Hides this Component ...</div><div class='long'><p>Hides this Component</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>animation</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> (optional)<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-initConfig' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-initConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-initConfig' class='name expandable'>initConfig</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> instanceConfig</span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><strong class='protected signature'>protected</strong></div><div class='description'><div class='short'>Initialize configuration for this class. ...</div><div class='long'><p>Initialize configuration for this class. a typical example:</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.awesome.Class', {\n    // The default config\n    config: {\n        name: 'Awesome',\n        isAwesome: true\n    },\n\n    constructor: function(config) {\n        this.initConfig(config);\n    }\n});\n\nvar awesome = new My.awesome.Class({\n    name: 'Super Awesome'\n});\n\nalert(awesome.getName()); // 'Super Awesome'\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>instanceConfig</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'><p>mixins The mixin prototypes as key - value pairs</p>\n</div></li></ul></div></div></div><div id='method-initialize' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-initialize' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-initialize' class='name expandable'>initialize</a>( <span class='pre'></span> )<strong class='protected signature'>protected</strong><strong class='template signature'>template</strong></div><div class='description'><div class='short'>Allows addition of behavior to the rendering phase. ...</div><div class='long'><p>Allows addition of behavior to the rendering phase.</p>\n      <div class='signature-box template'>\n      <p>This is a <a href=\"#!/guide/components\">template method</a>.\n         a hook into the functionality of this class.\n         Feel free to override it in child classes.</p>\n      </div>\n</div></div></div><div id='method-isDirty' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-method-isDirty' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-isDirty' class='name expandable'>isDirty</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns true if the value of this Field has been changed from its originalValue. ...</div><div class='long'><p>Returns true if the value of this Field has been changed from its <a href=\"#!/api/Ext.field.Field-property-originalValue\" rel=\"Ext.field.Field-property-originalValue\" class=\"docClass\">originalValue</a>.\nWill return false if the field is disabled or has not been rendered yet.</p>\n\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'><p>True if this field has been changed from its original value (and\nis not disabled), false otherwise.</p>\n</div></li></ul></div></div></div><div id='method-isDisabled' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-isDisabled' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-isDisabled' class='name expandable'>isDisabled</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns true if this Component is currently disabled ...</div><div class='long'><p>Returns true if this Component is currently disabled</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'><p>True if currently disabled</p>\n</div></li></ul></div></div></div><div id='method-isHidden' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-isHidden' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-isHidden' class='name expandable'>isHidden</a>( <span class='pre'></span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Returns true if this Component is currently hidden ...</div><div class='long'><p>Returns true if this Component is currently hidden</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'><p>True if currently hidden</p>\n</div></li></ul></div></div></div><div id='method-isPainted' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-isPainted' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-isPainted' class='name expandable'>isPainted</a>( <span class='pre'></span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-isRendered' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-isRendered' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-isRendered' class='name expandable'>isRendered</a>( <span class='pre'></span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-isXType' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-isXType' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-isXType' class='name expandable'>isXType</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> xtype, [<a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> shallow]</span> ) : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></div><div class='description'><div class='short'>Tests whether or not this Component is of a specific xtype. ...</div><div class='long'><p>Tests whether or not this Component is of a specific xtype. This can test whether this Component is descended\nfrom the xtype (default) or whether it is directly of the xtype specified (shallow = true).</p>\n\n\n<p><b>If using your own subclasses, be aware that a Component must register its own xtype\nto participate in determination of inherited xtypes.</b></p>\n\n\n<p>For a list of all available xtypes, see the <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> header.</p>\n\n\n<p>Example usage:</p>\n\n\n<pre><code>var t = new <a href=\"#!/api/Ext.field.Text\" rel=\"Ext.field.Text\" class=\"docClass\">Ext.field.Text</a>();\nvar isText = t.isXType('textfield');        // true\nvar isBoxSubclass = t.isXType('field');       // true, descended from <a href=\"#!/api/Ext.field.Field\" rel=\"Ext.field.Field\" class=\"docClass\">Ext.field.Field</a>\nvar isBoxInstance = t.isXType('field', true); // false, not a direct <a href=\"#!/api/Ext.field.Field\" rel=\"Ext.field.Field\" class=\"docClass\">Ext.field.Field</a> instance\n</code></pre>\n\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>xtype</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The xtype to check for this Component</p>\n</div></li><li><span class='pre'>shallow</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> (optional)<div class='sub-desc'><p>False to check whether this Component is descended from the xtype (this is\nthe default), or true to check whether this Component is directly of the specified xtype.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a></span><div class='sub-desc'><p>True if this component descends from the specified xtype, false otherwise.</p>\n</div></li></ul></div></div></div><div id='method-mon' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-mon' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-mon' class='name expandable'>mon</a>( <span class='pre'><a href=\"#!/api/Ext.mixin.Observable\" rel=\"Ext.mixin.Observable\" class=\"docClass\">Ext.mixin.Observable</a>/HTMLElement object, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, [<a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Alias for addManagedListener. ...</div><div class='long'><p>Alias for <a href=\"#!/api/Ext.mixin.Observable-method-addManagedListener\" rel=\"Ext.mixin.Observable-method-addManagedListener\" class=\"docClass\">addManagedListener</a>.</p>\n\n<p>Adds listeners to any Observable object (or Element) which are automatically removed when this Component\nis destroyed.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>This is now done automatically</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>object</span> : <a href=\"#!/api/Ext.mixin.Observable\" rel=\"Ext.mixin.Observable\" class=\"docClass\">Ext.mixin.Observable</a>/HTMLElement<div class='sub-desc'><p>The item to which to add a listener/listeners.</p>\n\n</div></li><li><span class='pre'>eventName</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The event name, or an object containing event name properties.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the handler function.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the scope in which\nthe handler function is executed.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the\n<a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> options.</p>\n\n</div></li></ul></div></div></div><div id='method-mun' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-mun' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-mun' class='name expandable'>mun</a>( <span class='pre'><a href=\"#!/api/Ext.mixin.Observable\" rel=\"Ext.mixin.Observable\" class=\"docClass\">Ext.mixin.Observable</a>/HTMLElement object, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, [<a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope]</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Alias for removeManagedListener. ...</div><div class='long'><p>Alias for <a href=\"#!/api/Ext.mixin.Observable-method-removeManagedListener\" rel=\"Ext.mixin.Observable-method-removeManagedListener\" class=\"docClass\">removeManagedListener</a>.</p>\n\n<p>Adds listeners to any Observable object (or Element) which are automatically removed when this Component\nis destroyed.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>This is now done automatically</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>object</span> : <a href=\"#!/api/Ext.mixin.Observable\" rel=\"Ext.mixin.Observable\" class=\"docClass\">Ext.mixin.Observable</a>/HTMLElement<div class='sub-desc'><p>The item to which to add a listener/listeners.</p>\n\n</div></li><li><span class='pre'>eventName</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The event name, or an object containing event name properties.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the handler function.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the scope in which\nthe handler function is executed.</p>\n\n</div></li></ul></div></div></div><div id='method-on' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-on' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-on' class='name expandable'>on</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options], [<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> order]</span> )</div><div class='description'><div class='short'>Alias for addListener. ...</div><div class='long'><p>Alias for <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a>.</p>\n\n<p>Appends an event handler to this object. You can review the available handlers by looking at the 'events'\nsection of the documentation for the component you are working with.</p>\n\n<h2>Combining Options</h2>\n\n<p>Using the options argument, it is possible to combine different types of listeners:</p>\n\n<p>A delayed, one-time listener:</p>\n\n<pre><code>container.on('tap', this.handleTap, this, {\n    single: true,\n    delay: 100\n});\n</code></pre>\n\n<h2>Attaching multiple handlers in 1 call</h2>\n\n<p>The method also allows for a single argument to be passed which is a config object containing properties which\nspecify multiple events. For example:</p>\n\n<pre><code>container.on({\n    tap  : this.onTap,\n    swipe: this.onSwipe,\n\n    scope: this // Important. Ensure \"this\" is correct during handler execution\n});\n</code></pre>\n\n<p>One can also specify options for each event handler separately:</p>\n\n<pre><code>container.on({\n    tap  : { fn: this.onTap, scope: this, single: true },\n    swipe: { fn: button.onSwipe, scope: button }\n});\n</code></pre>\n\n<p>See the <a href=\"#!/guide/events\">Events Guide</a> for more.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event to listen for. May also be an object who's property names are\nevent names.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The method the event invokes.  Will be called with arguments given to\n<a href=\"#!/api/Ext.mixin.Observable-method-fireEvent\" rel=\"Ext.mixin.Observable-method-fireEvent\" class=\"docClass\">fireEvent</a> plus the <code>options</code> parameter described below.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope (<code>this</code> reference) in which the handler function is executed. <strong>If\nomitted, defaults to the object which fired the event.</strong></p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>An object containing handler configuration.</p>\n\n\n\n\n<p>This object may contain any of the following properties:</p>\n\n\n\n\n<ul>\n<li><p><strong>scope</strong> : Object</p>\n\n<p>The scope (<code>this</code> reference) in which the handler function is executed. <strong>If omitted, defaults to the object\nwhich fired the event.</strong></p></li>\n<li><p><strong>delay</strong> : Number</p>\n\n<p>The number of milliseconds to delay the invocation of the handler after the event fires.</p></li>\n<li><p><strong>single</strong> : Boolean</p>\n\n<p>True to add a handler to handle just the next firing of the event, and then remove itself.</p></li>\n<li><p><strong>order</strong> : String</p>\n\n<p>The order of when the listener should be added into the listener queue.</p>\n\n<p>If you set an order of <code>before</code> and the event you are listening to is preventable, you can return <code>false</code> and it will stop the event.</p>\n\n<p>Available options are <code>before</code>, <code>current</code> and <code>after</code>. Defaults to <code>current</code>.</p></li>\n<li><p><strong>buffer</strong> : Number</p>\n\n<p>Causes the handler to be delayed by the specified number of milliseconds. If the event fires again within that\ntime, the original handler is <em>not</em> invoked, but the new handler is scheduled in its place.</p></li>\n<li><p><strong>element</strong> : String</p>\n\n<p>Allows you to add a listener onto a element of this component using the elements reference.</p>\n\n<pre><code><a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a>', {\n    listeners: {\n        element: 'element',\n        tap: function() {\n            console.log('element tap!');\n        }\n    }\n});\n</code></pre>\n\n<p>All components have the <code>element</code> reference, which is the outer most element of the component. <a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a> also has the\n<code>innerElement</code> element which contains all children. In most cases <code>element</code> is adequate.</p></li>\n<li><p><strong>delegate</strong> : String</p>\n\n<p>Uses <a href=\"#!/api/Ext.ComponentQuery\" rel=\"Ext.ComponentQuery\" class=\"docClass\">Ext.ComponentQuery</a> to delegate events to a specified query selector within this item.</p>\n\n<pre><code>// Create a container with a two children; a button and a toolbar\nvar container = <a href=\"#!/api/Ext-method-create\" rel=\"Ext-method-create\" class=\"docClass\">Ext.create</a>('<a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a>', {\n    items: [\n        {\n           xtype: 'toolbar',\n           docked: 'top',\n           title: 'My Toolbar'\n        },\n        {\n           xtype: 'button',\n           text: 'My Button'\n        }\n    ]\n});\n\ncontainer.on({\n    // Ext.Buttons have an xtype of 'button', so we use that are a selector for our delegate\n    delegate: 'button',\n\n    tap: function() {\n        alert('Button tapped!');\n    }\n});\n</code></pre></li>\n</ul>\n\n\n\n</div></li><li><span class='pre'>order</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> (optional)<div class='sub-desc'><p>The order of when the listener should be added into the listener queue.\nPossible values are <code>before</code>, <code>current</code> and <code>after</code>.</p>\n\n<p>Defaults to: <code>&quot;current&quot;</code></p></div></li></ul></div></div></div><div id='method-onAfter' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-onAfter' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-onAfter' class='name expandable'>onAfter</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )</div><div class='description'><div class='short'>Alias for addAfterListener. ...</div><div class='long'><p>Alias for <a href=\"#!/api/Ext.mixin.Observable-method-addAfterListener\" rel=\"Ext.mixin.Observable-method-addAfterListener\" class=\"docClass\">addAfterListener</a>.</p>\n\n<p>Appends an after-event handler.</p>\n\n<p>Same as <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> with <code>order</code> set to <code>'after'</code>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event to listen for.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The method the event invokes.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope for <code>fn</code>.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>An object containing handler configuration.</p>\n\n</div></li></ul></div></div></div><div id='method-onBefore' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-onBefore' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-onBefore' class='name expandable'>onBefore</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )</div><div class='description'><div class='short'>Alias for addBeforeListener. ...</div><div class='long'><p>Alias for <a href=\"#!/api/Ext.mixin.Observable-method-addBeforeListener\" rel=\"Ext.mixin.Observable-method-addBeforeListener\" class=\"docClass\">addBeforeListener</a>.</p>\n\n<p>Appends a before-event handler.  Returning <code>false</code> from the handler will stop the event.</p>\n\n<p>Same as <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> with <code>order</code> set to <code>'before'</code>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event to listen for.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The method the event invokes.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope for <code>fn</code>.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>An object containing handler configuration.</p>\n\n</div></li></ul></div></div></div><div id='method-onConfigUpdate' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-onConfigUpdate' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-onConfigUpdate' class='name expandable'>onConfigUpdate</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> names, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> callback, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>names</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>callback</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-onInitialized' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-onInitialized' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-onInitialized' class='name expandable'>onInitialized</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> fn, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>fn</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-onShowByErased' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-onShowByErased' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-onShowByErased' class='name expandable'>onShowByErased</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> component</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>component</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-relayEvent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-relayEvent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-relayEvent' class='name expandable'>relayEvent</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> args, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> fn</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>args</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-relayEvents' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-relayEvents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-relayEvents' class='name expandable'>relayEvents</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> object, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> events</span> )</div><div class='description'><div class='short'>Relays selected events from the specified Observable as if the events were fired by this. ...</div><div class='long'><p>Relays selected events from the specified Observable as if the events were fired by <code><b>this</b></code>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>object</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The Observable whose events this object is to relay.</p>\n</div></li><li><span class='pre'>events</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>Array of event names to relay.</p>\n</div></li></ul></div></div></div><div id='method-removeAfterListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-removeAfterListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-removeAfterListener' class='name expandable'>removeAfterListener</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )</div><div class='description'><div class='short'>Removes a before-event handler. ...</div><div class='long'><p>Removes a before-event handler.</p>\n\n<p>Same as <a href=\"#!/api/Ext.mixin.Observable-method-removeListener\" rel=\"Ext.mixin.Observable-method-removeListener\" class=\"docClass\">removeListener</a> with <code>order</code> set to <code>'after'</code>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event the handler was associated with.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The handler to remove.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope originally specified for <code>fn</code>.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>Extra options object.</p>\n\n</div></li></ul></div></div></div><div id='method-removeBeforeListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-removeBeforeListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-removeBeforeListener' class='name expandable'>removeBeforeListener</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )</div><div class='description'><div class='short'>Removes a before-event handler. ...</div><div class='long'><p>Removes a before-event handler.</p>\n\n<p>Same as <a href=\"#!/api/Ext.mixin.Observable-method-removeListener\" rel=\"Ext.mixin.Observable-method-removeListener\" class=\"docClass\">removeListener</a> with <code>order</code> set to <code>'before'</code>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event the handler was associated with.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The handler to remove.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope originally specified for <code>fn</code>.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>Extra options object.</p>\n\n</div></li></ul></div></div></div><div id='method-removeCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-removeCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-removeCls' class='name expandable'>removeCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> cls, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> prefix, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> suffix</span> )</div><div class='description'><div class='short'>Removes the given CSS class(es) from this Component's rendered element ...</div><div class='long'><p>Removes the given CSS class(es) from this Component's rendered element</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>cls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The class(es) to remove</p>\n</div></li><li><span class='pre'>prefix</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>Optional prefix to prepend before each class</p>\n</div></li><li><span class='pre'>suffix</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>Optional suffix to append to each class</p>\n</div></li></ul></div></div></div><div id='method-removeListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-removeListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-removeListener' class='name expandable'>removeListener</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options], [<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> order]</span> )</div><div class='description'><div class='short'>Removes an event handler. ...</div><div class='long'><p>Removes an event handler.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The type of event the handler was associated with.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The handler to remove. <strong>This must be a reference to the function passed into the\n<a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> call.</strong></p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope originally specified for the handler. It must be the same as the\nscope argument specified in the original call to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> or the listener will not be removed.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>Extra options object. See <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> for details.</p>\n\n</div></li><li><span class='pre'>order</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> (optional)<div class='sub-desc'><p>The order of the listener to remove.\nPossible values are <code>before</code>, <code>current</code> and <code>after</code>.</p>\n\n<p>Defaults to: <code>&quot;current&quot;</code></p></div></li></ul></div></div></div><div id='method-removeManagedListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-removeManagedListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-removeManagedListener' class='name expandable'>removeManagedListener</a>( <span class='pre'><a href=\"#!/api/Ext.mixin.Observable\" rel=\"Ext.mixin.Observable\" class=\"docClass\">Ext.mixin.Observable</a>/HTMLElement object, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, [<a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope]</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Adds listeners to any Observable object (or Element) which are automatically removed when this Component\nis destroyed. ...</div><div class='long'><p>Adds listeners to any Observable object (or Element) which are automatically removed when this Component\nis destroyed.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0</p>\n        <p>All listeners are now automatically managed where necessary. Simply use <a href=\"#!/api/Ext.mixin.Observable-method-removeListener\" rel=\"Ext.mixin.Observable-method-removeListener\" class=\"docClass\">removeListener</a>.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>object</span> : <a href=\"#!/api/Ext.mixin.Observable\" rel=\"Ext.mixin.Observable\" class=\"docClass\">Ext.mixin.Observable</a>/HTMLElement<div class='sub-desc'><p>The item to which to add a listener/listeners.</p>\n\n</div></li><li><span class='pre'>eventName</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The event name, or an object containing event name properties.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the handler function.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>If the <code>eventName</code> parameter was an event name, this is the scope in which\nthe handler function is executed.</p>\n\n</div></li></ul></div></div></div><div id='method-replaceCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-replaceCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-replaceCls' class='name expandable'>replaceCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldCls, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> newCls, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> prefix, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> suffix</span> )</div><div class='description'><div class='short'>Replaces specified classes with the newly specified classes. ...</div><div class='long'><p>Replaces specified classes with the newly specified classes.\nIt uses the <a href=\"#!/api/Ext.Component-method-addCls\" rel=\"Ext.Component-method-addCls\" class=\"docClass\">addCls</a> and <a href=\"#!/api/Ext.Component-method-removeCls\" rel=\"Ext.Component-method-removeCls\" class=\"docClass\">removeCls</a> methdos, so if the class(es) you are removing don't exist, it will\nstill add the new classes.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>oldCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The class(es) to remove</p>\n</div></li><li><span class='pre'>newCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The class(es) to add</p>\n</div></li><li><span class='pre'>prefix</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>Optional prefix to prepend before each class</p>\n</div></li><li><span class='pre'>suffix</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>Optional suffix to append to each class</p>\n</div></li></ul></div></div></div><div id='method-reset' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-method-reset' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-reset' class='name expandable'>reset</a>( <span class='pre'></span> ) : <a href=\"#!/api/Ext.field.Field\" rel=\"Ext.field.Field\" class=\"docClass\">Ext.field.Field</a></div><div class='description'><div class='short'>Resets the current field value back to the original value on this field when it was created. ...</div><div class='long'><p>Resets the current field value back to the original value on this field when it was created.</p>\n\n<pre><code>// This will create a field with an original value\nvar field = <a href=\"#!/api/Ext.Viewport-event-add\" rel=\"Ext.Viewport-event-add\" class=\"docClass\">Ext.Viewport.add</a>({\n    xtype: 'textfield',\n    value: 'first value'\n});\n\n// Update the value\nfield.setValue('new value');\n\n// Now you can reset it back to the `first value`\nfield.reset();\n</code></pre>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.field.Field\" rel=\"Ext.field.Field\" class=\"docClass\">Ext.field.Field</a></span><div class='sub-desc'><p>this</p>\n</div></li></ul></div></div></div><div id='method-resetFloating' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-resetFloating' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-resetFloating' class='name expandable'>resetFloating</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Resets top, right, bottom and left configurations to null, which\nwill unfloat this component. ...</div><div class='long'><p>Resets <a href=\"#!/api/Ext.Component-cfg-top\" rel=\"Ext.Component-cfg-top\" class=\"docClass\">top</a>, <a href=\"#!/api/Ext.Component-cfg-right\" rel=\"Ext.Component-cfg-right\" class=\"docClass\">right</a>, <a href=\"#!/api/Ext.Component-cfg-bottom\" rel=\"Ext.Component-cfg-bottom\" class=\"docClass\">bottom</a> and <a href=\"#!/api/Ext.Component-cfg-left\" rel=\"Ext.Component-cfg-left\" class=\"docClass\">left</a> configurations to <code>null</code>, which\nwill unfloat this component.</p>\n</div></div></div><div id='method-resumeEvents' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-resumeEvents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-resumeEvents' class='name expandable'>resumeEvents</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Resumes firing events (see suspendEvents). ...</div><div class='long'><p>Resumes firing events (see <a href=\"#!/api/Ext.mixin.Observable-method-suspendEvents\" rel=\"Ext.mixin.Observable-method-suspendEvents\" class=\"docClass\">suspendEvents</a>).</p>\n\n<p>If events were suspended using the <code>queueSuspended</code> parameter, then all events fired\nduring event suspension will be sent to any listeners now.</p>\n</div></div></div><div id='method-setBaseCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-baseCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setBaseCls' class='name expandable'>setBaseCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> baseCls</span> )</div><div class='description'><div class='short'>Sets the value of baseCls. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-baseCls\" rel=\"Ext.Component-cfg-baseCls\" class=\"docClass\">baseCls</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>baseCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setBorder' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-border' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setBorder' class='name expandable'>setBorder</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> border</span> )</div><div class='description'><div class='short'>Sets the value of border. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-border\" rel=\"Ext.Component-cfg-border\" class=\"docClass\">border</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>border</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setBottom' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-bottom' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setBottom' class='name expandable'>setBottom</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> bottom</span> )</div><div class='description'><div class='short'>Sets the value of bottom. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-bottom\" rel=\"Ext.Component-cfg-bottom\" class=\"docClass\">bottom</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>bottom</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setBubbleEvents' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-cfg-bubbleEvents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-setBubbleEvents' class='name expandable'>setBubbleEvents</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[] bubbleEvents</span> )</div><div class='description'><div class='short'>Sets the value of bubbleEvents. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.mixin.Observable-cfg-bubbleEvents\" rel=\"Ext.mixin.Observable-cfg-bubbleEvents\" class=\"docClass\">bubbleEvents</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>bubbleEvents</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setCentered' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-centered' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setCentered' class='name expandable'>setCentered</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> centered</span> )</div><div class='description'><div class='short'>Sets the value of centered. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-centered\" rel=\"Ext.Component-cfg-centered\" class=\"docClass\">centered</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>centered</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setClearIcon' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-clearIcon' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-setClearIcon' class='name expandable'>setClearIcon</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> clearIcon</span> )</div><div class='description'><div class='short'>Sets the value of clearIcon. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.field.Field-cfg-clearIcon\" rel=\"Ext.field.Field-cfg-clearIcon\" class=\"docClass\">clearIcon</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>clearIcon</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-cls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setCls' class='name expandable'>setCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[] cls</span> )</div><div class='description'><div class='short'>Sets the value of cls. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-cls\" rel=\"Ext.Component-cfg-cls\" class=\"docClass\">cls</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>cls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setConfig' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-setConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-setConfig' class='name expandable'>setConfig</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> config, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> applyIfNotSet</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>config</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>applyIfNotSet</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setContentEl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-contentEl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setContentEl' class='name expandable'>setContentEl</a>( <span class='pre'><a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> contentEl</span> )</div><div class='description'><div class='short'>Sets the value of contentEl. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-contentEl\" rel=\"Ext.Component-cfg-contentEl\" class=\"docClass\">contentEl</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>contentEl</span> : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setData' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-data' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setData' class='name expandable'>setData</a>( <span class='pre'>Mixed data</span> )</div><div class='description'><div class='short'>Sets the value of data. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-data\" rel=\"Ext.Component-cfg-data\" class=\"docClass\">data</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>data</span> : Mixed<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setDisabled' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-disabled' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setDisabled' class='name expandable'>setDisabled</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> disabled</span> )</div><div class='description'><div class='short'>Sets the value of disabled. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-disabled\" rel=\"Ext.Component-cfg-disabled\" class=\"docClass\">disabled</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>disabled</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setDisabledCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-disabledCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setDisabledCls' class='name expandable'>setDisabledCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> disabledCls</span> )</div><div class='description'><div class='short'>Sets the value of disabledCls. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-disabledCls\" rel=\"Ext.Component-cfg-disabledCls\" class=\"docClass\">disabledCls</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>disabledCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setDocked' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-docked' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setDocked' class='name expandable'>setDocked</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> docked</span> )</div><div class='description'><div class='short'>Sets the value of docked. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-docked\" rel=\"Ext.Component-cfg-docked\" class=\"docClass\">docked</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>docked</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setDraggable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-draggable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setDraggable' class='name expandable'>setDraggable</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> draggable</span> )</div><div class='description'><div class='short'>Sets the value of draggable. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-draggable\" rel=\"Ext.Component-cfg-draggable\" class=\"docClass\">draggable</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>draggable</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setEnterAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-enterAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setEnterAnimation' class='name expandable'>setEnterAnimation</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed enterAnimation</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Sets the value of enterAnimation. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-enterAnimation\" rel=\"Ext.Component-cfg-enterAnimation\" class=\"docClass\">enterAnimation</a>.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.Component-cfg-showAnimation\" rel=\"Ext.Component-cfg-showAnimation\" class=\"docClass\">showAnimation</a> instead.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>enterAnimation</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setExitAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-exitAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setExitAnimation' class='name expandable'>setExitAnimation</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed exitAnimation</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Sets the value of exitAnimation. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-exitAnimation\" rel=\"Ext.Component-cfg-exitAnimation\" class=\"docClass\">exitAnimation</a>.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> </p>\n        <p>2.0.0 Please use <a href=\"#!/api/Ext.Component-cfg-hideAnimation\" rel=\"Ext.Component-cfg-hideAnimation\" class=\"docClass\">hideAnimation</a> instead.  Typically you want to use an\noutbound animation type such as 'fadeOut' or 'slideOut'.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>exitAnimation</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setFloating' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-setFloating' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setFloating' class='name expandable'>setFloating</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> floating</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Used to update the floating state of this component. ...</div><div class='long'><p>Used to update the floating state of this component.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>This has been deprecated. Please use <a href=\"#!/api/Ext.Component-method-setTop\" rel=\"Ext.Component-method-setTop\" class=\"docClass\">setTop</a>, <a href=\"#!/api/Ext.Component-method-setRight\" rel=\"Ext.Component-method-setRight\" class=\"docClass\">setRight</a>, <a href=\"#!/api/Ext.Component-method-setBottom\" rel=\"Ext.Component-method-setBottom\" class=\"docClass\">setBottom</a> and <a href=\"#!/api/Ext.Component-method-setLeft\" rel=\"Ext.Component-method-setLeft\" class=\"docClass\">setLeft</a> instead.</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>floating</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>True if you want to float this component</p>\n</div></li></ul></div></div></div><div id='method-setFloatingCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-floatingCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setFloatingCls' class='name expandable'>setFloatingCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> floatingCls</span> )</div><div class='description'><div class='short'>Sets the value of floatingCls. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-floatingCls\" rel=\"Ext.Component-cfg-floatingCls\" class=\"docClass\">floatingCls</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>floatingCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setHeight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-height' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setHeight' class='name expandable'>setHeight</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> height</span> )</div><div class='description'><div class='short'>Sets the value of height. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-height\" rel=\"Ext.Component-cfg-height\" class=\"docClass\">height</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>height</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setHidden' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hidden' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setHidden' class='name expandable'>setHidden</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> hidden</span> )</div><div class='description'><div class='short'>Sets the value of hidden. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-hidden\" rel=\"Ext.Component-cfg-hidden\" class=\"docClass\">hidden</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>hidden</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setHiddenCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hiddenCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setHiddenCls' class='name expandable'>setHiddenCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> hiddenCls</span> )</div><div class='description'><div class='short'>Sets the value of hiddenCls. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-hiddenCls\" rel=\"Ext.Component-cfg-hiddenCls\" class=\"docClass\">hiddenCls</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>hiddenCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setHideAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hideAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setHideAnimation' class='name expandable'>setHideAnimation</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed hideAnimation</span> )</div><div class='description'><div class='short'>Sets the value of hideAnimation. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-hideAnimation\" rel=\"Ext.Component-cfg-hideAnimation\" class=\"docClass\">hideAnimation</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>hideAnimation</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setHtml' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-html' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setHtml' class='name expandable'>setHtml</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement html</span> )</div><div class='description'><div class='short'>Sets the value of html. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-html\" rel=\"Ext.Component-cfg-html\" class=\"docClass\">html</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>html</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a>/HTMLElement<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setInputType' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-inputType' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-setInputType' class='name expandable'>setInputType</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> inputType</span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Sets the value of inputType. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.field.Field-cfg-inputType\" rel=\"Ext.field.Field-cfg-inputType\" class=\"docClass\">inputType</a>.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0</p>\n        \n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>inputType</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setItemId' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-itemId' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setItemId' class='name expandable'>setItemId</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> itemId</span> )</div><div class='description'><div class='short'>Sets the value of itemId. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-itemId\" rel=\"Ext.Component-cfg-itemId\" class=\"docClass\">itemId</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>itemId</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setLabel' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-label' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-setLabel' class='name expandable'>setLabel</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> label</span> )</div><div class='description'><div class='short'>Sets the value of label. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.field.Field-cfg-label\" rel=\"Ext.field.Field-cfg-label\" class=\"docClass\">label</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>label</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setLabelAlign' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-labelAlign' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-setLabelAlign' class='name expandable'>setLabelAlign</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> labelAlign</span> )</div><div class='description'><div class='short'>Sets the value of labelAlign. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.field.Field-cfg-labelAlign\" rel=\"Ext.field.Field-cfg-labelAlign\" class=\"docClass\">labelAlign</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>labelAlign</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setLabelCls' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-labelCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-setLabelCls' class='name expandable'>setLabelCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> labelCls</span> )</div><div class='description'><div class='short'>Sets the value of labelCls. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.field.Field-cfg-labelCls\" rel=\"Ext.field.Field-cfg-labelCls\" class=\"docClass\">labelCls</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>labelCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setLabelWidth' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-labelWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-setLabelWidth' class='name expandable'>setLabelWidth</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> labelWidth</span> )</div><div class='description'><div class='short'>Sets the value of labelWidth. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.field.Field-cfg-labelWidth\" rel=\"Ext.field.Field-cfg-labelWidth\" class=\"docClass\">labelWidth</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>labelWidth</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setLabelWrap' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-labelWrap' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-setLabelWrap' class='name expandable'>setLabelWrap</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> labelWrap</span> )</div><div class='description'><div class='short'>Sets the value of labelWrap. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.field.Field-cfg-labelWrap\" rel=\"Ext.field.Field-cfg-labelWrap\" class=\"docClass\">labelWrap</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>labelWrap</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setLeft' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-left' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setLeft' class='name expandable'>setLeft</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> left</span> )</div><div class='description'><div class='short'>Sets the value of left. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-left\" rel=\"Ext.Component-cfg-left\" class=\"docClass\">left</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>left</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setListeners' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-cfg-listeners' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-setListeners' class='name expandable'>setListeners</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> listeners</span> )</div><div class='description'><div class='short'>Sets the value of listeners. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.mixin.Observable-cfg-listeners\" rel=\"Ext.mixin.Observable-cfg-listeners\" class=\"docClass\">listeners</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>listeners</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setMargin' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-margin' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setMargin' class='name expandable'>setMargin</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> margin</span> )</div><div class='description'><div class='short'>Sets the value of margin. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-margin\" rel=\"Ext.Component-cfg-margin\" class=\"docClass\">margin</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>margin</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setMaxHeight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-maxHeight' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setMaxHeight' class='name expandable'>setMaxHeight</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> maxHeight</span> )</div><div class='description'><div class='short'>Sets the value of maxHeight. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-maxHeight\" rel=\"Ext.Component-cfg-maxHeight\" class=\"docClass\">maxHeight</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>maxHeight</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setMaxWidth' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-maxWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setMaxWidth' class='name expandable'>setMaxWidth</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> maxWidth</span> )</div><div class='description'><div class='short'>Sets the value of maxWidth. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-maxWidth\" rel=\"Ext.Component-cfg-maxWidth\" class=\"docClass\">maxWidth</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>maxWidth</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setMinHeight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-minHeight' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setMinHeight' class='name expandable'>setMinHeight</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> minHeight</span> )</div><div class='description'><div class='short'>Sets the value of minHeight. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-minHeight\" rel=\"Ext.Component-cfg-minHeight\" class=\"docClass\">minHeight</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>minHeight</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setMinWidth' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-minWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setMinWidth' class='name expandable'>setMinWidth</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> minWidth</span> )</div><div class='description'><div class='short'>Sets the value of minWidth. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-minWidth\" rel=\"Ext.Component-cfg-minWidth\" class=\"docClass\">minWidth</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>minWidth</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setName' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-name' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-setName' class='name expandable'>setName</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> name</span> )</div><div class='description'><div class='short'>Sets the value of name. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.field.Field-cfg-name\" rel=\"Ext.field.Field-cfg-name\" class=\"docClass\">name</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setPadding' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-padding' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setPadding' class='name expandable'>setPadding</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> padding</span> )</div><div class='description'><div class='short'>Sets the value of padding. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-padding\" rel=\"Ext.Component-cfg-padding\" class=\"docClass\">padding</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>padding</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setPlugins' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-plugins' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setPlugins' class='name expandable'>setPlugins</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a> plugins</span> )</div><div class='description'><div class='short'>Sets the value of plugins. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-plugins\" rel=\"Ext.Component-cfg-plugins\" class=\"docClass\">plugins</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>plugins</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setRecord' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-record' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setRecord' class='name expandable'>setRecord</a>( <span class='pre'><a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a> record</span> )</div><div class='description'><div class='short'>Sets the value of record. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-record\" rel=\"Ext.Component-cfg-record\" class=\"docClass\">record</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>record</span> : <a href=\"#!/api/Ext.data.Model\" rel=\"Ext.data.Model\" class=\"docClass\">Ext.data.Model</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setRenderTo' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-renderTo' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setRenderTo' class='name expandable'>setRenderTo</a>( <span class='pre'><a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a> renderTo</span> )</div><div class='description'><div class='short'>Sets the value of renderTo. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-renderTo\" rel=\"Ext.Component-cfg-renderTo\" class=\"docClass\">renderTo</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>renderTo</span> : <a href=\"#!/api/Ext.dom.Element\" rel=\"Ext.dom.Element\" class=\"docClass\">Ext.Element</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setRenderTpl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-renderTpl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setRenderTpl' class='name expandable'>setRenderTpl</a>( <span class='pre'>Mixed renderTpl</span> )</div><div class='description'><div class='short'>Sets the value of renderTpl. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-renderTpl\" rel=\"Ext.Component-cfg-renderTpl\" class=\"docClass\">renderTpl</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>renderTpl</span> : Mixed<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setRendered' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-setRendered' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setRendered' class='name expandable'>setRendered</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> rendered</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>rendered</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setRequired' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-required' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-setRequired' class='name expandable'>setRequired</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> required</span> )</div><div class='description'><div class='short'>Sets the value of required. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.field.Field-cfg-required\" rel=\"Ext.field.Field-cfg-required\" class=\"docClass\">required</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>required</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setRequiredCls' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-requiredCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-setRequiredCls' class='name expandable'>setRequiredCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> requiredCls</span> )</div><div class='description'><div class='short'>Sets the value of requiredCls. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.field.Field-cfg-requiredCls\" rel=\"Ext.field.Field-cfg-requiredCls\" class=\"docClass\">requiredCls</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>requiredCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setRight' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-right' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setRight' class='name expandable'>setRight</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> right</span> )</div><div class='description'><div class='short'>Sets the value of right. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-right\" rel=\"Ext.Component-cfg-right\" class=\"docClass\">right</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>right</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setScrollable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-setScrollable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setScrollable' class='name expandable'>setScrollable</a>( <span class='pre'></span> )<strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>This method has moved to Ext.Container. ...</div><div class='long'><p>This method has moved to <a href=\"#!/api/Ext.Container-method-setScrollable\" rel=\"Ext.Container-method-setScrollable\" class=\"docClass\">Ext.Container</a>. You can no longer use it in a <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a>.</p>\n        <div class='signature-box removed'>\n        <p>This method has been <strong>removed</strong> since 2.0.0</p>\n        <p>This method has been moved from <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> to <a href=\"#!/api/Ext.Container-method-setScrollable\" rel=\"Ext.Container-method-setScrollable\" class=\"docClass\">Ext.Container</a></p>\n\n        </div>\n</div></div></div><div id='method-setShowAnimation' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-showAnimation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setShowAnimation' class='name expandable'>setShowAnimation</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed showAnimation</span> )</div><div class='description'><div class='short'>Sets the value of showAnimation. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-showAnimation\" rel=\"Ext.Component-cfg-showAnimation\" class=\"docClass\">showAnimation</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>showAnimation</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/Mixed<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setSize' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-setSize' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setSize' class='name expandable'>setSize</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> width, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> height</span> )</div><div class='description'><div class='short'>Sets the size of the Component ...</div><div class='long'><p>Sets the size of the Component</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>width</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The new width for the Component</p>\n</div></li><li><span class='pre'>height</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'><p>The new height for the Component</p>\n</div></li></ul></div></div></div><div id='method-setStyle' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-style' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setStyle' class='name expandable'>setStyle</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> style</span> )</div><div class='description'><div class='short'>Sets the value of style. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-style\" rel=\"Ext.Component-cfg-style\" class=\"docClass\">style</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>style</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setStyleHtmlCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-styleHtmlCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setStyleHtmlCls' class='name expandable'>setStyleHtmlCls</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> styleHtmlCls</span> )</div><div class='description'><div class='short'>Sets the value of styleHtmlCls. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-styleHtmlCls\" rel=\"Ext.Component-cfg-styleHtmlCls\" class=\"docClass\">styleHtmlCls</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>styleHtmlCls</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setStyleHtmlContent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-styleHtmlContent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setStyleHtmlContent' class='name expandable'>setStyleHtmlContent</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> styleHtmlContent</span> )</div><div class='description'><div class='short'>Sets the value of styleHtmlContent. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-styleHtmlContent\" rel=\"Ext.Component-cfg-styleHtmlContent\" class=\"docClass\">styleHtmlContent</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>styleHtmlContent</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setTabIndex' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-tabIndex' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-setTabIndex' class='name expandable'>setTabIndex</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> tabIndex</span> )</div><div class='description'><div class='short'>Sets the value of tabIndex. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.field.Field-cfg-tabIndex\" rel=\"Ext.field.Field-cfg-tabIndex\" class=\"docClass\">tabIndex</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>tabIndex</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setTop' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-top' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setTop' class='name expandable'>setTop</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> top</span> )</div><div class='description'><div class='short'>Sets the value of top. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-top\" rel=\"Ext.Component-cfg-top\" class=\"docClass\">top</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>top</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setTpl' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-tpl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setTpl' class='name expandable'>setTpl</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]/<a href=\"#!/api/Ext.Template\" rel=\"Ext.Template\" class=\"docClass\">Ext.Template</a>[]/<a href=\"#!/api/Ext.XTemplate\" rel=\"Ext.XTemplate\" class=\"docClass\">Ext.XTemplate</a>[] tpl</span> )</div><div class='description'><div class='short'>Sets the value of tpl. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-tpl\" rel=\"Ext.Component-cfg-tpl\" class=\"docClass\">tpl</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>tpl</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>[]/<a href=\"#!/api/Ext.Template\" rel=\"Ext.Template\" class=\"docClass\">Ext.Template</a>[]/<a href=\"#!/api/Ext.XTemplate\" rel=\"Ext.XTemplate\" class=\"docClass\">Ext.XTemplate</a>[]<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setTplWriteMode' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-tplWriteMode' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setTplWriteMode' class='name expandable'>setTplWriteMode</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> tplWriteMode</span> )</div><div class='description'><div class='short'>Sets the value of tplWriteMode. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-tplWriteMode\" rel=\"Ext.Component-cfg-tplWriteMode\" class=\"docClass\">tplWriteMode</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>tplWriteMode</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setTranslatable' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-translatable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setTranslatable' class='name expandable'>setTranslatable</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> translatable</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Sets the value of translatable. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">translatable</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>translatable</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setValue' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-cfg-value' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-setValue' class='name expandable'>setValue</a>( <span class='pre'>Mixed value</span> )</div><div class='description'><div class='short'>Sets the value of value. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.field.Field-cfg-value\" rel=\"Ext.field.Field-cfg-value\" class=\"docClass\">value</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>value</span> : Mixed<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setVisibility' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-setVisibility' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setVisibility' class='name expandable'>setVisibility</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> isVisible</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>isVisible</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setWidth' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-width' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setWidth' class='name expandable'>setWidth</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> width</span> )</div><div class='description'><div class='short'>Sets the value of width. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-width\" rel=\"Ext.Component-cfg-width\" class=\"docClass\">width</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>width</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-setZIndex' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-zIndex' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-setZIndex' class='name expandable'>setZIndex</a>( <span class='pre'><a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a> zIndex</span> )</div><div class='description'><div class='short'>Sets the value of zIndex. ...</div><div class='long'><p>Sets the value of <a href=\"#!/api/Ext.Component-cfg-zIndex\" rel=\"Ext.Component-cfg-zIndex\" class=\"docClass\">zIndex</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>zIndex</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-show' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-show' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-show' class='name expandable'>show</a>( <span class='pre'>[<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> animation]</span> )</div><div class='description'><div class='short'>Shows this component ...</div><div class='long'><p>Shows this component</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>animation</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a>/<a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> (optional)<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-showBy' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-showBy' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-showBy' class='name expandable'>showBy</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> component, [<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> alignment]</span> )</div><div class='description'><div class='short'>Shows this component by another component. ...</div><div class='long'><p>Shows this component by another component. If you specify no alignment, it will automatically\nposition this component relative to the reference component.</p>\n\n<p>For example, say we are aligning a Panel next to a Button, the alignment string would look like this:</p>\n\n<pre><code>[panel-vertical (t/b/c)][panel-horizontal (l/r/c)]-[button-vertical (t/b/c)][button-horizontal (l/r/c)]\n</code></pre>\n\n<p>where t = top, b = bottom, c = center, l = left, r = right.</p>\n\n<h2>Examples</h2>\n\n<ul>\n<li><code>tl-tr</code> means top-left corner of the Panel to the top-right corner of the Button</li>\n<li><code>tc-bc</code> means top-center of the Panel to the bottom-center of the Button</li>\n</ul>\n\n\n<p>You can put a '?' at the end of the alignment string to constrain the floating element to the\n<a href=\"#!/api/Ext.Viewport\" rel=\"Ext.Viewport\" class=\"docClass\">Viewport</a></p>\n\n<pre><code>// show `panel` by `button` using the default positioning (auto fit)\npanel.showBy(button);\n\n// align the top left corner of `panel` with the top right corner of `button` (constrained to viewport)\npanel.showBy(button, \"tl-tr?\");\n\n// align the bottom right corner of `panel` with the center left edge of `button` (not constrained by viewport)\npanel.showBy(button, \"br-cl\");\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>component</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The target component to show this component by</p>\n</div></li><li><span class='pre'>alignment</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> (optional)<div class='sub-desc'><p>The specific alignment.</p>\n</div></li></ul></div></div></div><div id='method-statics' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-method-statics' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-method-statics' class='name expandable'>statics</a>( <span class='pre'></span> ) : <a href=\"#!/api/Ext.Class\" rel=\"Ext.Class\" class=\"docClass\">Ext.Class</a><strong class='protected signature'>protected</strong></div><div class='description'><div class='short'>Get the reference to the class from which this object was instantiated. ...</div><div class='long'><p>Get the reference to the class from which this object was instantiated. Note that unlike <a href=\"#!/api/Ext.Base-property-self\" rel=\"Ext.Base-property-self\" class=\"docClass\">self</a>,\n<code>this.statics()</code> is scope-independent and it always returns the class from which it was called, regardless of what\n<code>this</code> points to during run-time</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.Cat', {\n    statics: {\n        totalCreated: 0,\n        speciesName: 'Cat' // My.Cat.speciesName = 'Cat'\n    },\n\n    constructor: function() {\n        var statics = this.statics();\n\n        alert(statics.speciesName);     // always equals to 'Cat' no matter what 'this' refers to\n                                        // equivalent to: My.Cat.speciesName\n\n        alert(this.self.speciesName);   // dependent on 'this'\n\n        statics.totalCreated++;\n    },\n\n    clone: function() {\n        var cloned = new this.self;                      // dependent on 'this'\n\n        cloned.groupName = this.statics().speciesName;   // equivalent to: My.Cat.speciesName\n\n        return cloned;\n    }\n});\n\n\n<a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.SnowLeopard', {\n    extend: 'My.Cat',\n\n    statics: {\n        speciesName: 'Snow Leopard'     // My.SnowLeopard.speciesName = 'Snow Leopard'\n    },\n\n    constructor: function() {\n        this.callParent();\n    }\n});\n\nvar cat = new My.Cat();                 // alerts 'Cat', then alerts 'Cat'\n\nvar snowLeopard = new My.SnowLeopard(); // alerts 'Cat', then alerts 'Snow Leopard'\n\nvar clone = snowLeopard.clone();\nalert(<a href=\"#!/api/Ext-method-getClassName\" rel=\"Ext-method-getClassName\" class=\"docClass\">Ext.getClassName</a>(clone));         // alerts 'My.SnowLeopard'\nalert(clone.groupName);                 // alerts 'Cat'\n\nalert(My.Cat.totalCreated);             // alerts 3\n</code></pre>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.Class\" rel=\"Ext.Class\" class=\"docClass\">Ext.Class</a></span><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-suspendEvents' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-suspendEvents' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-suspendEvents' class='name expandable'>suspendEvents</a>( <span class='pre'><a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> queueSuspended</span> )</div><div class='description'><div class='short'>Suspends the firing of all events. ...</div><div class='long'><p>Suspends the firing of all events. (see <a href=\"#!/api/Ext.mixin.Observable-method-resumeEvents\" rel=\"Ext.mixin.Observable-method-resumeEvents\" class=\"docClass\">resumeEvents</a>)</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>queueSuspended</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>Pass as true to queue up suspended events to be fired\nafter the <a href=\"#!/api/Ext.mixin.Observable-method-resumeEvents\" rel=\"Ext.mixin.Observable-method-resumeEvents\" class=\"docClass\">resumeEvents</a> call instead of discarding all suspended events.</p>\n</div></li></ul></div></div></div><div id='method-triggerInitialized' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-triggerInitialized' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-triggerInitialized' class='name expandable'>triggerInitialized</a>( <span class='pre'></span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-un' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-un' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-un' class='name expandable'>un</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options], [<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> order]</span> )</div><div class='description'><div class='short'>Alias for removeListener. ...</div><div class='long'><p>Alias for <a href=\"#!/api/Ext.mixin.Observable-method-removeListener\" rel=\"Ext.mixin.Observable-method-removeListener\" class=\"docClass\">removeListener</a>.</p>\n\n<p>Removes an event handler.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The type of event the handler was associated with.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The handler to remove. <strong>This must be a reference to the function passed into the\n<a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> call.</strong></p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope originally specified for the handler. It must be the same as the\nscope argument specified in the original call to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> or the listener will not be removed.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>Extra options object. See <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">addListener</a> for details.</p>\n\n</div></li><li><span class='pre'>order</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> (optional)<div class='sub-desc'><p>The order of the listener to remove.\nPossible values are <code>before</code>, <code>current</code> and <code>after</code>.</p>\n\n<p>Defaults to: <code>&quot;current&quot;</code></p></div></li></ul></div></div></div><div id='method-unAfter' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-unAfter' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-unAfter' class='name expandable'>unAfter</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )</div><div class='description'><div class='short'>Alias for removeAfterListener. ...</div><div class='long'><p>Alias for <a href=\"#!/api/Ext.mixin.Observable-method-removeAfterListener\" rel=\"Ext.mixin.Observable-method-removeAfterListener\" class=\"docClass\">removeAfterListener</a>.</p>\n\n<p>Removes a before-event handler.</p>\n\n<p>Same as <a href=\"#!/api/Ext.mixin.Observable-method-removeListener\" rel=\"Ext.mixin.Observable-method-removeListener\" class=\"docClass\">removeListener</a> with <code>order</code> set to <code>'after'</code>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event the handler was associated with.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The handler to remove.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope originally specified for <code>fn</code>.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>Extra options object.</p>\n\n</div></li></ul></div></div></div><div id='method-unBefore' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.mixin.Observable' rel='Ext.mixin.Observable' class='defined-in docClass'>Ext.mixin.Observable</a><br/><a href='source/Observable.html#Ext-mixin-Observable-method-unBefore' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.mixin.Observable-method-unBefore' class='name expandable'>unBefore</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> eventName, <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a> fn, [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope], [<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> options]</span> )</div><div class='description'><div class='short'>Alias for removeBeforeListener. ...</div><div class='long'><p>Alias for <a href=\"#!/api/Ext.mixin.Observable-method-removeBeforeListener\" rel=\"Ext.mixin.Observable-method-removeBeforeListener\" class=\"docClass\">removeBeforeListener</a>.</p>\n\n<p>Removes a before-event handler.</p>\n\n<p>Same as <a href=\"#!/api/Ext.mixin.Observable-method-removeListener\" rel=\"Ext.mixin.Observable-method-removeListener\" class=\"docClass\">removeListener</a> with <code>order</code> set to <code>'before'</code>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eventName</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The name of the event the handler was associated with.</p>\n\n</div></li><li><span class='pre'>fn</span> : <a href=\"#!/api/Function\" rel=\"Function\" class=\"docClass\">Function</a><div class='sub-desc'><p>The handler to remove.</p>\n\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>The scope originally specified for <code>fn</code>.</p>\n\n</div></li><li><span class='pre'>options</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> (optional)<div class='sub-desc'><p>Extra options object.</p>\n\n</div></li></ul></div></div></div><div id='method-up' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-up' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-up' class='name expandable'>up</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> selector</span> ) : <a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a></div><div class='description'><div class='short'>Walks up the ownerCt axis looking for an ancestor Container which matches\nthe passed simple selector. ...</div><div class='long'><p>Walks up the <code>ownerCt</code> axis looking for an ancestor Container which matches\nthe passed simple selector.</p>\n\n\n<p>Example:\n<pre><code>var owningTabPanel = grid.up('tabpanel');\n</code></pre>\n\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>selector</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>Optional. The simple selector to test.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.Container\" rel=\"Ext.Container\" class=\"docClass\">Ext.Container</a></span><div class='sub-desc'><p>The matching ancestor Container (or <code>undefined</code> if no match was found).</p>\n</div></li></ul></div></div></div><div id='method-update' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-update' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-update' class='name expandable'>update</a>( <span class='pre'></span> )<strong class='deprecated signature'>deprecated</strong></div><div class='description'><div class='short'>Updates the HTML content of the Component. ...</div><div class='long'><p>Updates the HTML content of the Component.</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 2.0.0</p>\n        <p>Please use <a href=\"#!/api/Ext.Component-method-setHtml\" rel=\"Ext.Component-method-setHtml\" class=\"docClass\">setHtml</a>, <a href=\"#!/api/Ext.Component-method-setTpl\" rel=\"Ext.Component-method-setTpl\" class=\"docClass\">setTpl</a> or <a href=\"#!/api/Ext.Component-method-setData\" rel=\"Ext.Component-method-setData\" class=\"docClass\">setData</a> instead.</p>\n\n        </div>\n</div></div></div><div id='method-updateCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-updateCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-updateCls' class='name expandable'>updateCls</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> newCls, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> oldCls</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>All cls methods directly report to the cls configuration, so anytime it changes, updateCls will be called ...</div><div class='long'><p>All cls methods directly report to the <a href=\"#!/api/Ext.Component-cfg-cls\" rel=\"Ext.Component-cfg-cls\" class=\"docClass\">cls</a> configuration, so anytime it changes, <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">updateCls</a> will be called</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>newCls</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>oldCls</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-updateData' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-updateData' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-updateData' class='name expandable'>updateData</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> newData</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>newData</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-updateFloatingCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-updateFloatingCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-updateFloatingCls' class='name expandable'>updateFloatingCls</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> newFloatingCls, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> oldFloatingCls</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Updates the floatingCls if the component is currently floating ...</div><div class='long'><p>Updates the floatingCls if the component is currently floating</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>newFloatingCls</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>oldFloatingCls</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-updateRequired' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-method-updateRequired' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-updateRequired' class='name expandable'>updateRequired</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> newRequired</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Updates the required configuration ...</div><div class='long'><p>Updates the <a href=\"#!/api/Ext.field.Field-cfg-required\" rel=\"Ext.field.Field-cfg-required\" class=\"docClass\">required</a> configuration</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>newRequired</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-updateRequiredCls' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/Field2.html#Ext-field-Field-method-updateRequiredCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-method-updateRequiredCls' class='name expandable'>updateRequiredCls</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> newRequiredCls, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> oldRequiredCls</span> )<strong class='private signature'>private</strong></div><div class='description'><div class='short'>Updates the required configuration ...</div><div class='long'><p>Updates the <a href=\"#!/api/Ext.field.Field-cfg-required\" rel=\"Ext.field.Field-cfg-required\" class=\"docClass\">required</a> configuration</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>newRequiredCls</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>oldRequiredCls</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-updateStyleHtmlCls' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-method-updateStyleHtmlCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-method-updateStyleHtmlCls' class='name expandable'>updateStyleHtmlCls</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> newHtmlCls, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> oldHtmlCls</span> )</div><div class='description'><div class='short'>Updates the styleHtmlCls configuration ...</div><div class='long'><p>Updates the <a href=\"#!/api/Ext.Component-cfg-styleHtmlCls\" rel=\"Ext.Component-cfg-styleHtmlCls\" class=\"docClass\">styleHtmlCls</a> configuration</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>newHtmlCls</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>oldHtmlCls</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div></div><div class='subsection'><div class='definedBy'>Defined By</div><h4 class='members-subtitle'>Static Methods</h3><div id='static-method-addConfig' class='member first-child inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-addConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-addConfig' class='name expandable'>addConfig</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> config, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> fullMerge</span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>config</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>fullMerge</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-addInheritableStatics' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-addInheritableStatics' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-addInheritableStatics' class='name expandable'>addInheritableStatics</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> members</span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>members</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-addMember' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-addMember' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-addMember' class='name expandable'>addMember</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> name, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> member</span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>member</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-addMembers' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-addMembers' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-addMembers' class='name expandable'>addMembers</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> members</span> )<strong class='static signature'>static</strong></div><div class='description'><div class='short'>Add methods / properties to the prototype of this class. ...</div><div class='long'><p>Add methods / properties to the prototype of this class.</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.awesome.Cat', {\n    constructor: function() {\n        ...\n    }\n});\n\n My.awesome.Cat.implement({\n     meow: function() {\n        alert('Meowww...');\n     }\n });\n\n var kitty = new My.awesome.Cat;\n kitty.meow();\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>members</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-addStatics' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-addStatics' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-addStatics' class='name expandable'>addStatics</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> members</span> ) : <a href=\"#!/api/Ext.Base\" rel=\"Ext.Base\" class=\"docClass\">Ext.Base</a><strong class='static signature'>static</strong></div><div class='description'><div class='short'>Add / override static properties of this class. ...</div><div class='long'><p>Add / override static properties of this class.</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.cool.Class', {\n    ...\n});\n\nMy.cool.Class.addStatics({\n    someProperty: 'someValue',      // My.cool.Class.someProperty = 'someValue'\n    method1: function() { ... },    // My.cool.Class.method1 = function() { ... };\n    method2: function() { ... }     // My.cool.Class.method2 = function() { ... };\n});\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>members</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.Base\" rel=\"Ext.Base\" class=\"docClass\">Ext.Base</a></span><div class='sub-desc'><p>this</p>\n</div></li></ul></div></div></div><div id='static-method-addXtype' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-addXtype' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-addXtype' class='name expandable'>addXtype</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> xtype</span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>xtype</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-borrow' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-borrow' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-borrow' class='name expandable'>borrow</a>( <span class='pre'><a href=\"#!/api/Ext.Base\" rel=\"Ext.Base\" class=\"docClass\">Ext.Base</a> fromClass, <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> members</span> ) : <a href=\"#!/api/Ext.Base\" rel=\"Ext.Base\" class=\"docClass\">Ext.Base</a><strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'>Borrow another class' members to the prototype of this class. ...</div><div class='long'><p>Borrow another class' members to the prototype of this class.</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('Bank', {\n    money: '$$$',\n    printMoney: function() {\n        alert('$$$$$$$');\n    }\n});\n\n<a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('Thief', {\n    ...\n});\n\nThief.borrow(Bank, ['money', 'printMoney']);\n\nvar steve = new Thief();\n\nalert(steve.money); // alerts '$$$'\nsteve.printMoney(); // alerts '$$$$$$$'\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>fromClass</span> : <a href=\"#!/api/Ext.Base\" rel=\"Ext.Base\" class=\"docClass\">Ext.Base</a><div class='sub-desc'><p>The class to borrow members from</p>\n</div></li><li><span class='pre'>members</span> : <a href=\"#!/api/Array\" rel=\"Array\" class=\"docClass\">Array</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The names of the members to borrow</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.Base\" rel=\"Ext.Base\" class=\"docClass\">Ext.Base</a></span><div class='sub-desc'><p>this</p>\n</div></li></ul></div></div></div><div id='static-method-callParent' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-callParent' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-callParent' class='name expandable'>callParent</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> args</span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>args</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-create' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-create' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-create' class='name expandable'>create</a>( <span class='pre'></span> ) : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><strong class='static signature'>static</strong></div><div class='description'><div class='short'>Create a new instance of this Class. ...</div><div class='long'><p>Create a new instance of this Class.</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.cool.Class', {\n    ...\n});\n\nMy.cool.Class.create({\n    someConfig: true\n});\n</code></pre>\n\n<p>All parameters are passed to the constructor of the class.</p>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a></span><div class='sub-desc'><p>the created instance.</p>\n</div></li></ul></div></div></div><div id='static-method-createAlias' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-createAlias' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-createAlias' class='name expandable'>createAlias</a>( <span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> alias, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> origin</span> )<strong class='static signature'>static</strong></div><div class='description'><div class='short'>Create aliases for existing prototype methods. ...</div><div class='long'><p>Create aliases for existing prototype methods. Example:</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.cool.Class', {\n    method1: function() { ... },\n    method2: function() { ... }\n});\n\nvar test = new My.cool.Class();\n\nMy.cool.Class.createAlias({\n    method3: 'method1',\n    method4: 'method2'\n});\n\ntest.method3(); // test.method1()\n\nMy.cool.Class.createAlias('method5', 'method3');\n\ntest.method5(); // test.method3() -&gt; test.method1()\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>alias</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The new method name, or an object to set multiple aliases. See\n<a href=\"#!/api/Ext.Function-method-flexSetter\" rel=\"Ext.Function-method-flexSetter\" class=\"docClass\">flexSetter</a></p>\n</div></li><li><span class='pre'>origin</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a>/<a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The original method name</p>\n</div></li></ul></div></div></div><div id='static-method-extend' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-extend' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-extend' class='name expandable'>extend</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> parent</span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>parent</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-getName' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-getName' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-getName' class='name expandable'>getName</a>( <span class='pre'></span> ) : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><strong class='static signature'>static</strong></div><div class='description'><div class='short'>Get the current class' name in string format. ...</div><div class='long'><p>Get the current class' name in string format.</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.cool.Class', {\n    constructor: function() {\n        alert(this.self.getName()); // alerts 'My.cool.Class'\n    }\n});\n\nMy.cool.Class.getName(); // 'My.cool.Class'\n</code></pre>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a></span><div class='sub-desc'><p>className</p>\n</div></li></ul></div></div></div><div id='static-method-implement' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-implement' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-implement' class='name expandable'>implement</a>( <span class='pre'></span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='static-method-mixin' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-mixin' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-mixin' class='name expandable'>mixin</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> name, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> mixinClass</span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'>Used internally by the mixins pre-processor ...</div><div class='long'><p>Used internally by the mixins pre-processor</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>mixinClass</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-onExtended' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-onExtended' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-onExtended' class='name expandable'>onExtended</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> fn, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> scope</span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>fn</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li><li><span class='pre'>scope</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'>\n</div></li></ul></div></div></div><div id='static-method-override' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-override' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-override' class='name expandable'>override</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> members</span> ) : <a href=\"#!/api/Ext.Base\" rel=\"Ext.Base\" class=\"docClass\">Ext.Base</a><strong class='deprecated signature'>deprecated</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'>Override members of this class. ...</div><div class='long'><p>Override members of this class. Overridden methods can be invoked via\n<a href=\"#!/api/Ext.Base-method-callParent\" rel=\"Ext.Base-method-callParent\" class=\"docClass\">callParent</a>.</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.Cat', {\n    constructor: function() {\n        alert(\"I'm a cat!\");\n    }\n});\n\nMy.Cat.override({\n    constructor: function() {\n        alert(\"I'm going to be a cat!\");\n\n        var instance = this.callParent(arguments);\n\n        alert(\"Meeeeoooowwww\");\n\n        return instance;\n    }\n});\n\nvar kitty = new My.Cat(); // alerts \"I'm going to be a cat!\"\n                          // alerts \"I'm a cat!\"\n                          // alerts \"Meeeeoooowwww\"\n</code></pre>\n\n<p>As of 4.1, direct use of this method is deprecated. Use <a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>\ninstead:</p>\n\n<pre><code><a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a>('My.CatOverride', {\n    override: 'My.Cat',\n    constructor: function() {\n        alert(\"I'm going to be a cat!\");\n\n        var instance = this.callParent(arguments);\n\n        alert(\"Meeeeoooowwww\");\n\n        return instance;\n    }\n});\n</code></pre>\n\n<p>The above accomplishes the same result but can be managed by the <a href=\"#!/api/Ext.Loader\" rel=\"Ext.Loader\" class=\"docClass\">Ext.Loader</a>\nwhich can properly order the override and its target class and the build process\ncan determine whether the override is needed based on the required state of the\ntarget class (My.Cat).</p>\n        <div class='signature-box deprecated'>\n        <p>This method has been <strong>deprecated</strong> since 4.1.0</p>\n        <p>Please use <a href=\"#!/api/Ext-method-define\" rel=\"Ext-method-define\" class=\"docClass\">Ext.define</a> instead</p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>members</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The properties to add to this class. This should be\nspecified as an object literal containing one or more properties.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ext.Base\" rel=\"Ext.Base\" class=\"docClass\">Ext.Base</a></span><div class='sub-desc'><p>this class</p>\n</div></li></ul></div></div></div><div id='static-method-triggerExtended' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Base' rel='Ext.Base' class='defined-in docClass'>Ext.Base</a><br/><a href='source/Base.html#Ext-Base-static-method-triggerExtended' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Base-static-method-triggerExtended' class='name expandable'>triggerExtended</a>( <span class='pre'></span> )<strong class='private signature'>private</strong><strong class='static signature'>static</strong></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-event'>Events</h3><div class='subsection'><div id='event-beforeorientationchange' class='member first-child inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-beforeorientationchange' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-beforeorientationchange' class='name expandable'>beforeorientationchange</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )<strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>Fires before orientation changes. ...</div><div class='long'><p>Fires before orientation changes.</p>\n        <div class='signature-box removed'>\n        <p>This event has been <strong>removed</strong> since 2.0.0</p>\n        <p>This event is now only available onBefore the Viewport's <a href=\"#!/api/Ext.Viewport-event-orientationchange\" rel=\"Ext.Viewport-event-orientationchange\" class=\"docClass\">Ext.Viewport.orientationchange</a></p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-bottomchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-bottom' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-bottomchange' class='name expandable'>bottomchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the bottom configuration is changed by setBottom. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-bottom\" rel=\"Ext.Component-cfg-bottom\" class=\"docClass\">bottom</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setBottom\" rel=\"Ext.Component-method-setBottom\" class=\"docClass\">setBottom</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-centeredchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-centered' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-centeredchange' class='name expandable'>centeredchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> value, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the centered configuration is changed by setCentered. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-centered\" rel=\"Ext.Component-cfg-centered\" class=\"docClass\">centered</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setCentered\" rel=\"Ext.Component-method-setCentered\" class=\"docClass\">setCentered</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-disabledchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-disabled' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-disabledchange' class='name expandable'>disabledchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> value, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the disabled configuration is changed by setDisabled. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-disabled\" rel=\"Ext.Component-cfg-disabled\" class=\"docClass\">disabled</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setDisabled\" rel=\"Ext.Component-method-setDisabled\" class=\"docClass\">setDisabled</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-dockedchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-docked' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-dockedchange' class='name expandable'>dockedchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the docked configuration is changed by setDocked. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-docked\" rel=\"Ext.Component-cfg-docked\" class=\"docClass\">docked</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setDocked\" rel=\"Ext.Component-method-setDocked\" class=\"docClass\">setDocked</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-erased' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-erased' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-erased' class='name expandable'>erased</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>The opposite event of painted. ...</div><div class='long'><p>The opposite event of <a href=\"#!/api/Ext.Component-event-painted\" rel=\"Ext.Component-event-painted\" class=\"docClass\">painted</a>. This event fires whenever this Component are no longer visible\n(erased) on the screen. This might be triggered either when this Component <a href=\"#!/api/Ext.Component-cfg-hidden\" rel=\"Ext.Component-cfg-hidden\" class=\"docClass\">hidden</a> config is set to\n<code>true</code>, or when its Element is taken out of the document's DOM tree. This is normally useful to perform cleaning\nup after what you have set up from listening to <a href=\"#!/api/Ext.Component-event-painted\" rel=\"Ext.Component-event-painted\" class=\"docClass\">painted</a> event.</p>\n\n<p>Note: This event is not available to be used with event delegation. Instead 'erased' only fires if you explicily\nadd at least one listener to it, due to performance reason.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The component instance</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-floatingchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-floatingchange' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-floatingchange' class='name expandable'>floatingchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> floating, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever there is a change in the floating status of a component ...</div><div class='long'><p>Fires whenever there is a change in the floating status of a component</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The component instance</p>\n</div></li><li><span class='pre'>floating</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>The component's new floating state</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-fullscreen' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-fullscreen' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-fullscreen' class='name expandable'>fullscreen</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever a Component with the fullscreen config is instantiated ...</div><div class='long'><p>Fires whenever a Component with the fullscreen config is instantiated</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The component instance</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-heightchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-height' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-heightchange' class='name expandable'>heightchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the height configuration is changed by setHeight. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-height\" rel=\"Ext.Component-cfg-height\" class=\"docClass\">height</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setHeight\" rel=\"Ext.Component-method-setHeight\" class=\"docClass\">setHeight</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-hiddenchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-hidden' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-hiddenchange' class='name expandable'>hiddenchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> value, <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the hidden configuration is changed by setHidden. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-hidden\" rel=\"Ext.Component-cfg-hidden\" class=\"docClass\">hidden</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setHidden\" rel=\"Ext.Component-method-setHidden\" class=\"docClass\">setHidden</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Boolean\" rel=\"Boolean\" class=\"docClass\">Boolean</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-hide' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-hide' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-hide' class='name expandable'>hide</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever the Component is hidden ...</div><div class='long'><p>Fires whenever the Component is hidden</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The component instance</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-initialize' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-initialize' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-initialize' class='name expandable'>initialize</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the component has been initialized ...</div><div class='long'><p>Fires when the component has been initialized</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The component instance</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-leftchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-left' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-leftchange' class='name expandable'>leftchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the left configuration is changed by setLeft. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-left\" rel=\"Ext.Component-cfg-left\" class=\"docClass\">left</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setLeft\" rel=\"Ext.Component-method-setLeft\" class=\"docClass\">setLeft</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-maxheightchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-maxHeight' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-maxheightchange' class='name expandable'>maxheightchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the maxHeight configuration is changed by setMaxHeight. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-maxHeight\" rel=\"Ext.Component-cfg-maxHeight\" class=\"docClass\">maxHeight</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setMaxHeight\" rel=\"Ext.Component-method-setMaxHeight\" class=\"docClass\">setMaxHeight</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-maxwidthchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-maxWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-maxwidthchange' class='name expandable'>maxwidthchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the maxWidth configuration is changed by setMaxWidth. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-maxWidth\" rel=\"Ext.Component-cfg-maxWidth\" class=\"docClass\">maxWidth</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setMaxWidth\" rel=\"Ext.Component-method-setMaxWidth\" class=\"docClass\">setMaxWidth</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-minheightchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-minHeight' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-minheightchange' class='name expandable'>minheightchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the minHeight configuration is changed by setMinHeight. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-minHeight\" rel=\"Ext.Component-cfg-minHeight\" class=\"docClass\">minHeight</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setMinHeight\" rel=\"Ext.Component-method-setMinHeight\" class=\"docClass\">setMinHeight</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-minwidthchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-minWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-minwidthchange' class='name expandable'>minwidthchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the minWidth configuration is changed by setMinWidth. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-minWidth\" rel=\"Ext.Component-cfg-minWidth\" class=\"docClass\">minWidth</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setMinWidth\" rel=\"Ext.Component-method-setMinWidth\" class=\"docClass\">setMinWidth</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-orientationchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-orientationchange' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-orientationchange' class='name expandable'>orientationchange</a>( <span class='pre'><a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )<strong class='removed signature'>removed</strong></div><div class='description'><div class='short'>Fires when orientation changes. ...</div><div class='long'><p>Fires when orientation changes.</p>\n        <div class='signature-box removed'>\n        <p>This event has been <strong>removed</strong> since 2.0.0</p>\n        <p>This event is now only available on the Viewport's <a href=\"#!/api/Ext.Viewport-event-orientationchange\" rel=\"Ext.Viewport-event-orientationchange\" class=\"docClass\">Ext.Viewport.orientationchange</a></p>\n\n        </div>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-painted' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-painted' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-painted' class='name expandable'>painted</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever this Component actually becomes visible (painted) on the screen. ...</div><div class='long'><p>Fires whenever this Component actually becomes visible (painted) on the screen. This is useful when you need to\nperform 'read' operations on the DOM element, i.e: calculating natural sizes and positioning. If you just need\nperform post-initialization tasks that don't rely on the fact that the element must be rendered and visible on\nthe screen, listen to <a href=\"#!/api/Ext.Component-event-initialize\" rel=\"Ext.Component-event-initialize\" class=\"docClass\">initialize</a></p>\n\n<p>Note: This event is not available to be used with event delegation. Instead 'painted' only fires if you explicily\nadd at least one listener to it, due to performance reason.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The component instance</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-resize' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-resize' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-resize' class='name expandable'>resize</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Important note: For the best performance on mobile devices, use this only when you absolutely need to monitor\na Compo...</div><div class='long'><p>Important note: For the best performance on mobile devices, use this only when you absolutely need to monitor\na Component's size.</p>\n\n<p>Note: This event is not available to be used with event delegation. Instead 'resize' only fires if you explicily\nadd at least one listener to it, due to performance reason.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The component instance</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-rightchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-right' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-rightchange' class='name expandable'>rightchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the right configuration is changed by setRight. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-right\" rel=\"Ext.Component-cfg-right\" class=\"docClass\">right</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setRight\" rel=\"Ext.Component-method-setRight\" class=\"docClass\">setRight</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-show' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-show' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-show' class='name expandable'>show</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever the Component is shown ...</div><div class='long'><p>Fires whenever the Component is shown</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The component instance</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-topchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-top' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-topchange' class='name expandable'>topchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the top configuration is changed by setTop. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-top\" rel=\"Ext.Component-cfg-top\" class=\"docClass\">top</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setTop\" rel=\"Ext.Component-method-setTop\" class=\"docClass\">setTop</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-updatedata' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-event-updatedata' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-updatedata' class='name expandable'>updatedata</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> newData, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires whenever the data of the component is updated ...</div><div class='long'><p>Fires whenever the data of the component is updated</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The component instance</p>\n</div></li><li><span class='pre'>newData</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The new data</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div><div id='event-widthchange' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Ext.Component' rel='Ext.Component' class='defined-in docClass'>Ext.Component</a><br/><a href='source/Component.html#Ext-Component-cfg-width' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.Component-event-widthchange' class='name expandable'>widthchange</a>( <span class='pre'><a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> this, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> value, <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a> oldValue, <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a> eOpts</span> )</div><div class='description'><div class='short'>Fires when the width configuration is changed by setWidth. ...</div><div class='long'><p>Fires when the <a href=\"#!/api/Ext.Component-cfg-width\" rel=\"Ext.Component-cfg-width\" class=\"docClass\">width</a> configuration is changed by <a href=\"#!/api/Ext.Component-method-setWidth\" rel=\"Ext.Component-method-setWidth\" class=\"docClass\">setWidth</a>.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>this</span> : <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a><div class='sub-desc'><p>The <a href=\"#!/api/Ext.Component\" rel=\"Ext.Component\" class=\"docClass\">Ext.Component</a> instance.</p>\n</div></li><li><span class='pre'>value</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The new value being set.</p>\n</div></li><li><span class='pre'>oldValue</span> : <a href=\"#!/api/Number\" rel=\"Number\" class=\"docClass\">Number</a>/<a href=\"#!/api/String\" rel=\"String\" class=\"docClass\">String</a><div class='sub-desc'><p>The existing value.</p>\n</div></li><li><span class='pre'>eOpts</span> : <a href=\"#!/api/Object\" rel=\"Object\" class=\"docClass\">Object</a><div class='sub-desc'><p>The options object passed to <a href=\"#!/api/Ext.mixin.Observable-method-addListener\" rel=\"Ext.mixin.Observable-method-addListener\" class=\"docClass\">Ext.util.Observable.addListener</a>.</p>\n\n\n\n</div></li></ul></div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-css_var'>CSS Variables</h3><div class='subsection'><div id='css_var-S-form-dark' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/_form.scss.html#Ext-field-Field-css_var-S-form-dark' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-css_var-S-form-dark' class='name not-expandable'>$form-dark</a><span> : color</span></div><div class='description'><div class='short'><p>Dark color for form fields, mostly used on labels/text.</p>\n</div><div class='long'><p>Dark color for form fields, mostly used on labels/text.</p>\n</div></div></div><div id='css_var-S-form-field-bg-color' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/_form.scss.html#Ext-field-Field-css_var-S-form-field-bg-color' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-css_var-S-form-field-bg-color' class='name not-expandable'>$form-field-bg-color</a><span> : color</span></div><div class='description'><div class='short'><p>Default background-color for form fields.</p>\n</div><div class='long'><p>Default background-color for form fields.</p>\n</div></div></div><div id='css_var-S-form-field-height' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/_form.scss.html#Ext-field-Field-css_var-S-form-field-height' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-css_var-S-form-field-height' class='name not-expandable'>$form-field-height</a><span> : measurement</span></div><div class='description'><div class='short'><p>Default height for form fields.</p>\n</div><div class='long'><p>Default height for form fields.</p>\n</div></div></div><div id='css_var-S-form-label-background-color' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/_form.scss.html#Ext-field-Field-css_var-S-form-label-background-color' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-css_var-S-form-label-background-color' class='name not-expandable'>$form-label-background-color</a><span> : color</span></div><div class='description'><div class='short'><p>The default background color for labels</p>\n</div><div class='long'><p>The default background color for labels</p>\n</div></div></div><div id='css_var-S-form-label-width' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/_form.scss.html#Ext-field-Field-css_var-S-form-label-width' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-css_var-S-form-label-width' class='name not-expandable'>$form-label-width</a><span> : measurement</span></div><div class='description'><div class='short'><p>Default width for form labels.</p>\n</div><div class='long'><p>Default width for form labels.</p>\n</div></div></div><div id='css_var-S-form-light' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/_form.scss.html#Ext-field-Field-css_var-S-form-light' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-css_var-S-form-light' class='name not-expandable'>$form-light</a><span> : color</span></div><div class='description'><div class='short'><p>Light color for form fields, mostly used on field borders.</p>\n</div><div class='long'><p>Light color for form fields, mostly used on field borders.</p>\n</div></div></div><div id='css_var-S-form-spacing' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/_form.scss.html#Ext-field-Field-css_var-S-form-spacing' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-css_var-S-form-spacing' class='name not-expandable'>$form-spacing</a><span> : measurement</span></div><div class='description'><div class='short'><p>Default spacing for form fields, used for padding, etc.</p>\n</div><div class='long'><p>Default spacing for form fields, used for padding, etc.</p>\n</div></div></div><div id='css_var-S-toolbar-input-bg' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/_toolbar-forms.scss.html#Ext-field-Field-css_var-S-toolbar-input-bg' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-css_var-S-toolbar-input-bg' class='name not-expandable'>$toolbar-input-bg</a><span> : color</span></div><div class='description'><div class='short'><p>Background-color for toolbar form fields.</p>\n</div><div class='long'><p>Background-color for toolbar form fields.</p>\n</div></div></div><div id='css_var-S-toolbar-input-border-color' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/_toolbar-forms.scss.html#Ext-field-Field-css_var-S-toolbar-input-border-color' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-css_var-S-toolbar-input-border-color' class='name not-expandable'>$toolbar-input-border-color</a><span> : color</span></div><div class='description'><div class='short'><p>Border color for toolbar form fields.</p>\n</div><div class='long'><p>Border color for toolbar form fields.</p>\n</div></div></div><div id='css_var-S-toolbar-input-color' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/_toolbar-forms.scss.html#Ext-field-Field-css_var-S-toolbar-input-color' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-css_var-S-toolbar-input-color' class='name not-expandable'>$toolbar-input-color</a><span> : color</span></div><div class='description'><div class='short'><p>Text color for toolbar form fields.</p>\n</div><div class='long'><p>Text color for toolbar form fields.</p>\n</div></div></div><div id='css_var-S-toolbar-input-height' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ext.field.Field'>Ext.field.Field</span><br/><a href='source/_toolbar-forms.scss.html#Ext-field-Field-css_var-S-toolbar-input-height' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Ext.field.Field-css_var-S-toolbar-input-height' class='name not-expandable'>$toolbar-input-height</a><span> : measurement</span></div><div class='description'><div class='short'><p>Text color for toolbar form fields.</p>\n</div><div class='long'><p>Text color for toolbar form fields.</p>\n</div></div></div></div></div></div></div>","parentMixins":["Ext.mixin.Traversable","Ext.mixin.Observable"],"superclasses":["Ext.Base","Ext.Evented","Ext.AbstractComponent","Ext.Component","Ext.Decorator"],"tagname":"class","extends":"Ext.Decorator","alternateClassNames":["Ext.form.Field"],"requires":["Ext.field.Input"],"inheritdoc":null,"members":{"event":[{"meta":{"removed":{"text":"This event is now only available onBefore the Viewport's {@link Ext.Viewport#orientationchange}","version":"2.0.0"}},"owner":"Ext.Component","tagname":"event","name":"beforeorientationchange","id":"event-beforeorientationchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"bottomchange","id":"event-bottomchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"centeredchange","id":"event-centeredchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"disabledchange","id":"event-disabledchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"dockedchange","id":"event-dockedchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"erased","id":"event-erased"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"floatingchange","id":"event-floatingchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"fullscreen","id":"event-fullscreen"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"heightchange","id":"event-heightchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"hiddenchange","id":"event-hiddenchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"hide","id":"event-hide"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"initialize","id":"event-initialize"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"leftchange","id":"event-leftchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"maxheightchange","id":"event-maxheightchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"maxwidthchange","id":"event-maxwidthchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"minheightchange","id":"event-minheightchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"minwidthchange","id":"event-minwidthchange"},{"meta":{"removed":{"text":"This event is now only available on the Viewport's {@link Ext.Viewport#orientationchange}","version":"2.0.0"}},"owner":"Ext.Component","tagname":"event","name":"orientationchange","id":"event-orientationchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"painted","id":"event-painted"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"resize","id":"event-resize"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"rightchange","id":"event-rightchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"show","id":"event-show"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"topchange","id":"event-topchange"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"updatedata","id":"event-updatedata"},{"meta":{},"owner":"Ext.Component","tagname":"event","name":"widthchange","id":"event-widthchange"}],"property":[{"meta":{"private":true},"owner":"Ext.Component","tagname":"property","name":"alignmentRegex","id":"property-alignmentRegex"},{"meta":{"private":true,"readonly":true},"owner":"Ext.Component","tagname":"property","name":"dockPositions","id":"property-dockPositions"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"property","name":"floating","id":"property-floating"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"property","name":"isComponent","id":"property-isComponent"},{"meta":{},"owner":"Ext.field.Field","tagname":"property","name":"isField","id":"property-isField"},{"meta":{"deprecated":{"text":"","version":"2.0"}},"owner":"Ext.field.Field","tagname":"property","name":"labelEl","id":"property-labelEl"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"property","name":"listenerOptionsRegex","id":"property-listenerOptionsRegex"},{"meta":{},"owner":"Ext.field.Field","tagname":"property","name":"originalValue","id":"property-originalValue"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"property","name":"rendered","id":"property-rendered"},{"meta":{"protected":true},"owner":"Ext.Base","tagname":"property","name":"self","id":"property-self"}],"css_var":[{"meta":{},"owner":"Ext.field.Field","tagname":"css_var","name":"$form-dark","id":"css_var-S-form-dark"},{"meta":{},"owner":"Ext.field.Field","tagname":"css_var","name":"$form-field-bg-color","id":"css_var-S-form-field-bg-color"},{"meta":{},"owner":"Ext.field.Field","tagname":"css_var","name":"$form-field-height","id":"css_var-S-form-field-height"},{"meta":{},"owner":"Ext.field.Field","tagname":"css_var","name":"$form-label-background-color","id":"css_var-S-form-label-background-color"},{"meta":{},"owner":"Ext.field.Field","tagname":"css_var","name":"$form-label-width","id":"css_var-S-form-label-width"},{"meta":{},"owner":"Ext.field.Field","tagname":"css_var","name":"$form-light","id":"css_var-S-form-light"},{"meta":{},"owner":"Ext.field.Field","tagname":"css_var","name":"$form-spacing","id":"css_var-S-form-spacing"},{"meta":{},"owner":"Ext.field.Field","tagname":"css_var","name":"$toolbar-input-bg","id":"css_var-S-toolbar-input-bg"},{"meta":{},"owner":"Ext.field.Field","tagname":"css_var","name":"$toolbar-input-border-color","id":"css_var-S-toolbar-input-border-color"},{"meta":{},"owner":"Ext.field.Field","tagname":"css_var","name":"$toolbar-input-color","id":"css_var-S-toolbar-input-color"},{"meta":{},"owner":"Ext.field.Field","tagname":"css_var","name":"$toolbar-input-height","id":"css_var-S-toolbar-input-height"}],"css_mixin":[],"method":[{"meta":{},"owner":"Ext.Component","tagname":"method","name":"constructor","id":"method-constructor"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"addAfterListener","id":"method-addAfterListener"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"addBeforeListener","id":"method-addBeforeListener"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"addCls","id":"method-addCls"},{"meta":{"deprecated":{"text":"It's no longer needed to add events before firing.","version":"2.0"}},"owner":"Ext.mixin.Observable","tagname":"method","name":"addEvents","id":"method-addEvents"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"addListener","id":"method-addListener"},{"meta":{"deprecated":{"text":"All listeners are now automatically managed where necessary. Simply use {@link #addListener}.","version":"2.0"}},"owner":"Ext.mixin.Observable","tagname":"method","name":"addManagedListener","id":"method-addManagedListener"},{"meta":{"private":true},"owner":"Ext.AbstractComponent","tagname":"method","name":"addReferenceNode","id":"method-addReferenceNode"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"alignTo","id":"method-alignTo"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"applyCls","id":"method-applyCls"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"applyTpl","id":"method-applyTpl"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"beforeInitialize","id":"method-beforeInitialize"},{"meta":{"protected":true},"owner":"Ext.Base","tagname":"method","name":"callOverridden","id":"method-callOverridden"},{"meta":{"protected":true},"owner":"Ext.Base","tagname":"method","name":"callParent","id":"method-callParent"},{"meta":{"private":true},"owner":"Ext.mixin.Observable","tagname":"method","name":"changeListener","id":"method-changeListener"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"clearListeners","id":"method-clearListeners"},{"meta":{"private":true},"owner":"Ext.mixin.Observable","tagname":"method","name":"createEventRelayer","id":"method-createEventRelayer"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"destroy","id":"method-destroy"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"disable","id":"method-disable"},{"meta":{"private":true},"owner":"Ext.mixin.Observable","tagname":"method","name":"doAddListener","id":"method-doAddListener"},{"meta":{"private":true},"owner":"Ext.field.Field","tagname":"method","name":"doInitValue","id":"method-doInitValue"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"enable","id":"method-enable"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"enableBubble","id":"method-enableBubble"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"fireAction","id":"method-fireAction"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"fireEvent","id":"method-fireEvent"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getBaseCls","id":"method-getBaseCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getBorder","id":"method-getBorder"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getBottom","id":"method-getBottom"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"getBubbleEvents","id":"method-getBubbleEvents"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getCentered","id":"method-getCentered"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"getClearIcon","id":"method-getClearIcon"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getCls","id":"method-getCls"},{"meta":{"private":true},"owner":"Ext.Base","tagname":"method","name":"getConfig","id":"method-getConfig"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getContentEl","id":"method-getContentEl"},{"meta":{"private":true},"owner":"Ext.Base","tagname":"method","name":"getCurrentConfig","id":"method-getCurrentConfig"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getData","id":"method-getData"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getDisabled","id":"method-getDisabled"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getDisabledCls","id":"method-getDisabledCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getDocked","id":"method-getDocked"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getDraggable","id":"method-getDraggable"},{"meta":{"deprecated":{"text":"2.0.0 Please access the Component's element from the 'element' property instead, i.e:\n\n     var element = component.element;"}},"owner":"Ext.Component","tagname":"method","name":"getEl","id":"method-getEl"},{"meta":{"deprecated":{"text":"Please use {@link #showAnimation} instead.","version":"2.0.0"}},"owner":"Ext.Component","tagname":"method","name":"getEnterAnimation","id":"method-getEnterAnimation"},{"meta":{"deprecated":{"text":"2.0.0 Please use {@link #hideAnimation} instead.  Typically you want to use an\noutbound animation type such as 'fadeOut' or 'slideOut'."}},"owner":"Ext.Component","tagname":"method","name":"getExitAnimation","id":"method-getExitAnimation"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getFloatingCls","id":"method-getFloatingCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getHeight","id":"method-getHeight"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getHidden","id":"method-getHidden"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getHiddenCls","id":"method-getHiddenCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getHideAnimation","id":"method-getHideAnimation"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getHtml","id":"method-getHtml"},{"meta":{},"owner":"Ext.mixin.Identifiable","tagname":"method","name":"getId","id":"method-getId"},{"meta":{},"owner":"Ext.Base","tagname":"method","name":"getInitialConfig","id":"method-getInitialConfig"},{"meta":{"deprecated":{"text":"","version":"2.0"}},"owner":"Ext.field.Field","tagname":"method","name":"getInputType","id":"method-getInputType"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getItemId","id":"method-getItemId"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"getLabel","id":"method-getLabel"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"getLabelAlign","id":"method-getLabelAlign"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"getLabelCls","id":"method-getLabelCls"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"getLabelWidth","id":"method-getLabelWidth"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"getLabelWrap","id":"method-getLabelWrap"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getLeft","id":"method-getLeft"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"getListeners","id":"method-getListeners"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getMargin","id":"method-getMargin"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getMaxHeight","id":"method-getMaxHeight"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getMaxWidth","id":"method-getMaxWidth"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getMinHeight","id":"method-getMinHeight"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getMinWidth","id":"method-getMinWidth"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"getName","id":"method-getName"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getPadding","id":"method-getPadding"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getParent","id":"method-getParent"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getPlugins","id":"method-getPlugins"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getRecord","id":"method-getRecord"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getRenderTo","id":"method-getRenderTo"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getRenderTpl","id":"method-getRenderTpl"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"getRequired","id":"method-getRequired"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"getRequiredCls","id":"method-getRequiredCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getRight","id":"method-getRight"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getShowAnimation","id":"method-getShowAnimation"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getSize","id":"method-getSize"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getStyle","id":"method-getStyle"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getStyleHtmlCls","id":"method-getStyleHtmlCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getStyleHtmlContent","id":"method-getStyleHtmlContent"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"getTabIndex","id":"method-getTabIndex"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getTop","id":"method-getTop"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getTpl","id":"method-getTpl"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getTplWriteMode","id":"method-getTplWriteMode"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"getTranslatable","id":"method-getTranslatable"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"getValue","id":"method-getValue"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getWidth","id":"method-getWidth"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getXTypes","id":"method-getXTypes"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"getZIndex","id":"method-getZIndex"},{"meta":{"private":true},"owner":"Ext.Base","tagname":"method","name":"hasConfig","id":"method-hasConfig"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"hasListener","id":"method-hasListener"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"hasParent","id":"method-hasParent"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"hide","id":"method-hide"},{"meta":{"protected":true},"owner":"Ext.Base","tagname":"method","name":"initConfig","id":"method-initConfig"},{"meta":{"template":true,"protected":true},"owner":"Ext.Component","tagname":"method","name":"initialize","id":"method-initialize"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"isDirty","id":"method-isDirty"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"isDisabled","id":"method-isDisabled"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"isHidden","id":"method-isHidden"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"isPainted","id":"method-isPainted"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"isRendered","id":"method-isRendered"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"isXType","id":"method-isXType"},{"meta":{"deprecated":{"text":"This is now done automatically","version":"2.0.0"}},"owner":"Ext.mixin.Observable","tagname":"method","name":"mon","id":"method-mon"},{"meta":{"deprecated":{"text":"This is now done automatically","version":"2.0.0"}},"owner":"Ext.mixin.Observable","tagname":"method","name":"mun","id":"method-mun"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"on","id":"method-on"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"onAfter","id":"method-onAfter"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"onBefore","id":"method-onBefore"},{"meta":{"private":true},"owner":"Ext.Base","tagname":"method","name":"onConfigUpdate","id":"method-onConfigUpdate"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"onInitialized","id":"method-onInitialized"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"onShowByErased","id":"method-onShowByErased"},{"meta":{"private":true},"owner":"Ext.mixin.Observable","tagname":"method","name":"relayEvent","id":"method-relayEvent"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"relayEvents","id":"method-relayEvents"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"removeAfterListener","id":"method-removeAfterListener"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"removeBeforeListener","id":"method-removeBeforeListener"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"removeCls","id":"method-removeCls"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"removeListener","id":"method-removeListener"},{"meta":{"deprecated":{"text":"All listeners are now automatically managed where necessary. Simply use {@link #removeListener}.","version":"2.0"}},"owner":"Ext.mixin.Observable","tagname":"method","name":"removeManagedListener","id":"method-removeManagedListener"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"replaceCls","id":"method-replaceCls"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"reset","id":"method-reset"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"resetFloating","id":"method-resetFloating"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"resumeEvents","id":"method-resumeEvents"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setBaseCls","id":"method-setBaseCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setBorder","id":"method-setBorder"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setBottom","id":"method-setBottom"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"setBubbleEvents","id":"method-setBubbleEvents"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setCentered","id":"method-setCentered"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"setClearIcon","id":"method-setClearIcon"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setCls","id":"method-setCls"},{"meta":{"private":true},"owner":"Ext.Base","tagname":"method","name":"setConfig","id":"method-setConfig"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setContentEl","id":"method-setContentEl"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setData","id":"method-setData"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setDisabled","id":"method-setDisabled"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setDisabledCls","id":"method-setDisabledCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setDocked","id":"method-setDocked"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setDraggable","id":"method-setDraggable"},{"meta":{"deprecated":{"text":"Please use {@link #showAnimation} instead.","version":"2.0.0"}},"owner":"Ext.Component","tagname":"method","name":"setEnterAnimation","id":"method-setEnterAnimation"},{"meta":{"deprecated":{"text":"2.0.0 Please use {@link #hideAnimation} instead.  Typically you want to use an\noutbound animation type such as 'fadeOut' or 'slideOut'."}},"owner":"Ext.Component","tagname":"method","name":"setExitAnimation","id":"method-setExitAnimation"},{"meta":{"deprecated":{"text":"This has been deprecated. Please use {@link #setTop}, {@link #setRight}, {@link #setBottom} and {@link #setLeft} instead.","version":"2.0.0"}},"owner":"Ext.Component","tagname":"method","name":"setFloating","id":"method-setFloating"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setFloatingCls","id":"method-setFloatingCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setHeight","id":"method-setHeight"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setHidden","id":"method-setHidden"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setHiddenCls","id":"method-setHiddenCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setHideAnimation","id":"method-setHideAnimation"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setHtml","id":"method-setHtml"},{"meta":{"deprecated":{"text":"","version":"2.0"}},"owner":"Ext.field.Field","tagname":"method","name":"setInputType","id":"method-setInputType"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setItemId","id":"method-setItemId"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"setLabel","id":"method-setLabel"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"setLabelAlign","id":"method-setLabelAlign"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"setLabelCls","id":"method-setLabelCls"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"setLabelWidth","id":"method-setLabelWidth"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"setLabelWrap","id":"method-setLabelWrap"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setLeft","id":"method-setLeft"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"setListeners","id":"method-setListeners"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setMargin","id":"method-setMargin"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setMaxHeight","id":"method-setMaxHeight"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setMaxWidth","id":"method-setMaxWidth"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setMinHeight","id":"method-setMinHeight"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setMinWidth","id":"method-setMinWidth"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"setName","id":"method-setName"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setPadding","id":"method-setPadding"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setPlugins","id":"method-setPlugins"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setRecord","id":"method-setRecord"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setRenderTo","id":"method-setRenderTo"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setRenderTpl","id":"method-setRenderTpl"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"setRendered","id":"method-setRendered"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"setRequired","id":"method-setRequired"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"setRequiredCls","id":"method-setRequiredCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setRight","id":"method-setRight"},{"meta":{"removed":{"text":"This method has been moved from {@link Ext.Component} to {@link Ext.Container#setScrollable Ext.Container}","version":"2.0.0"}},"owner":"Ext.Component","tagname":"method","name":"setScrollable","id":"method-setScrollable"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setShowAnimation","id":"method-setShowAnimation"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setSize","id":"method-setSize"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setStyle","id":"method-setStyle"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setStyleHtmlCls","id":"method-setStyleHtmlCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setStyleHtmlContent","id":"method-setStyleHtmlContent"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"setTabIndex","id":"method-setTabIndex"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setTop","id":"method-setTop"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setTpl","id":"method-setTpl"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setTplWriteMode","id":"method-setTplWriteMode"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"setTranslatable","id":"method-setTranslatable"},{"meta":{},"owner":"Ext.field.Field","tagname":"method","name":"setValue","id":"method-setValue"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"setVisibility","id":"method-setVisibility"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setWidth","id":"method-setWidth"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"setZIndex","id":"method-setZIndex"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"show","id":"method-show"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"showBy","id":"method-showBy"},{"meta":{"protected":true},"owner":"Ext.Base","tagname":"method","name":"statics","id":"method-statics"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"suspendEvents","id":"method-suspendEvents"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"triggerInitialized","id":"method-triggerInitialized"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"un","id":"method-un"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"unAfter","id":"method-unAfter"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"method","name":"unBefore","id":"method-unBefore"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"up","id":"method-up"},{"meta":{"deprecated":{"text":"Please use {@link #setHtml}, {@link #setTpl} or {@link #setData} instead.","version":"2.0.0"}},"owner":"Ext.Component","tagname":"method","name":"update","id":"method-update"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"updateCls","id":"method-updateCls"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"updateData","id":"method-updateData"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"method","name":"updateFloatingCls","id":"method-updateFloatingCls"},{"meta":{"private":true},"owner":"Ext.field.Field","tagname":"method","name":"updateRequired","id":"method-updateRequired"},{"meta":{"private":true},"owner":"Ext.field.Field","tagname":"method","name":"updateRequiredCls","id":"method-updateRequiredCls"},{"meta":{},"owner":"Ext.Component","tagname":"method","name":"updateStyleHtmlCls","id":"method-updateStyleHtmlCls"}],"cfg":[{"meta":{},"owner":"Ext.field.Field","tagname":"cfg","name":"baseCls","id":"cfg-baseCls"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"border","id":"cfg-border"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"bottom","id":"cfg-bottom"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"cfg","name":"bubbleEvents","id":"cfg-bubbleEvents"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"centered","id":"cfg-centered"},{"meta":{},"owner":"Ext.field.Field","tagname":"cfg","name":"clearIcon","id":"cfg-clearIcon"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"cls","id":"cfg-cls"},{"meta":{},"owner":"Ext.field.Field","tagname":"cfg","name":"component","id":"cfg-component"},{"meta":{"deprecated":{"text":"","version":"2.0.0"}},"owner":"Ext.Component","tagname":"cfg","name":"componentCls","id":"cfg-componentCls"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"contentEl","id":"cfg-contentEl"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"data","id":"cfg-data"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"disabled","id":"cfg-disabled"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"disabledCls","id":"cfg-disabledCls"},{"meta":{"deprecated":{"text":"This has been deprecated. Please use {@link #docked} instead.","version":"2.0.0"}},"owner":"Ext.Component","tagname":"cfg","name":"dock","id":"cfg-dock"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"docked","id":"cfg-docked"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"draggable","id":"cfg-draggable"},{"meta":{"deprecated":{"text":"Please use {@link #showAnimation} instead.","version":"2.0.0"}},"owner":"Ext.Component","tagname":"cfg","name":"enterAnimation","id":"cfg-enterAnimation"},{"meta":{"deprecated":{"text":"2.0.0 Please use {@link #hideAnimation} instead.  Typically you want to use an\noutbound animation type such as 'fadeOut' or 'slideOut'."}},"owner":"Ext.Component","tagname":"cfg","name":"exitAnimation","id":"cfg-exitAnimation"},{"meta":{"deprecated":{"text":"Deprecated, please use {@link #inputCls}","version":"2.0.0"}},"owner":"Ext.field.Field","tagname":"cfg","name":"fieldCls","id":"cfg-fieldCls"},{"meta":{"deprecated":{"text":"Please use the {@link #label} configuration instead","version":"2.0.0"}},"owner":"Ext.field.Field","tagname":"cfg","name":"fieldLabel","id":"cfg-fieldLabel"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"flex","id":"cfg-flex"},{"meta":{"deprecated":{"text":"","version":"2.0.0"}},"owner":"Ext.Component","tagname":"cfg","name":"floating","id":"cfg-floating"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"floatingCls","id":"cfg-floatingCls"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"height","id":"cfg-height"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"hidden","id":"cfg-hidden"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"hiddenCls","id":"cfg-hiddenCls"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"hideAnimation","id":"cfg-hideAnimation"},{"meta":{"removed":{"text":"This method has been moved from {@link Ext.Component} to {@link Ext.Container#hideOnMaskTap Ext.Container}","version":"2.0.0"}},"owner":"Ext.Component","tagname":"cfg","name":"hideOnMaskTap","id":"cfg-hideOnMaskTap"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"html","id":"cfg-html"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"id","id":"cfg-id"},{"meta":{},"owner":"Ext.field.Field","tagname":"cfg","name":"inputCls","id":"cfg-inputCls"},{"meta":{"deprecated":{"text":"","version":"2.0"}},"owner":"Ext.field.Field","tagname":"cfg","name":"inputType","id":"cfg-inputType"},{"meta":{"private":true},"owner":"Ext.field.Field","tagname":"cfg","name":"isFocused","id":"cfg-isFocused"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"itemId","id":"cfg-itemId"},{"meta":{},"owner":"Ext.field.Field","tagname":"cfg","name":"label","id":"cfg-label"},{"meta":{},"owner":"Ext.field.Field","tagname":"cfg","name":"labelAlign","id":"cfg-labelAlign"},{"meta":{},"owner":"Ext.field.Field","tagname":"cfg","name":"labelCls","id":"cfg-labelCls"},{"meta":{},"owner":"Ext.field.Field","tagname":"cfg","name":"labelWidth","id":"cfg-labelWidth"},{"meta":{},"owner":"Ext.field.Field","tagname":"cfg","name":"labelWrap","id":"cfg-labelWrap"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.Component","tagname":"cfg","name":"layoutOnOrientationChange","id":"cfg-layoutOnOrientationChange"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"left","id":"cfg-left"},{"meta":{},"owner":"Ext.mixin.Observable","tagname":"cfg","name":"listeners","id":"cfg-listeners"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"margin","id":"cfg-margin"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"maxHeight","id":"cfg-maxHeight"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"maxWidth","id":"cfg-maxWidth"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"minHeight","id":"cfg-minHeight"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"minWidth","id":"cfg-minWidth"},{"meta":{"removed":{"text":"This method has been moved from {@link Ext.Component} to {@link Ext.Container#modal Ext.Container}","version":"2.0.0"}},"owner":"Ext.Component","tagname":"cfg","name":"modal","id":"cfg-modal"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.Component","tagname":"cfg","name":"monitorOrientation","id":"cfg-monitorOrientation"},{"meta":{},"owner":"Ext.field.Field","tagname":"cfg","name":"name","id":"cfg-name"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"padding","id":"cfg-padding"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"plugins","id":"cfg-plugins"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"record","id":"cfg-record"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"renderTo","id":"cfg-renderTo"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"renderTpl","id":"cfg-renderTpl"},{"meta":{},"owner":"Ext.field.Field","tagname":"cfg","name":"required","id":"cfg-required"},{"meta":{},"owner":"Ext.field.Field","tagname":"cfg","name":"requiredCls","id":"cfg-requiredCls"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"right","id":"cfg-right"},{"meta":{"removed":{"text":"This method has been moved from {@link Ext.Component} to {@link Ext.Container#scrollable Ext.Container}","version":"2.0.0"}},"owner":"Ext.Component","tagname":"cfg","name":"scroll","id":"cfg-scroll"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"showAnimation","id":"cfg-showAnimation"},{"meta":{"removed":{"text":"","version":"2.0.0"}},"owner":"Ext.Component","tagname":"cfg","name":"stopMaskTapEvent","id":"cfg-stopMaskTapEvent"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"style","id":"cfg-style"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"styleHtmlCls","id":"cfg-styleHtmlCls"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"styleHtmlContent","id":"cfg-styleHtmlContent"},{"meta":{},"owner":"Ext.field.Field","tagname":"cfg","name":"tabIndex","id":"cfg-tabIndex"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"top","id":"cfg-top"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"tpl","id":"cfg-tpl"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"tplWriteMode","id":"cfg-tplWriteMode"},{"meta":{"private":true},"owner":"Ext.Component","tagname":"cfg","name":"translatable","id":"cfg-translatable"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"ui","id":"cfg-ui"},{"meta":{"deprecated":{"text":"Please use the {@link #clearIcon} configuration instead","version":"2.0.0"}},"owner":"Ext.field.Field","tagname":"cfg","name":"useClearIcon","id":"cfg-useClearIcon"},{"meta":{},"owner":"Ext.field.Field","tagname":"cfg","name":"value","id":"cfg-value"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"width","id":"cfg-width"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"xtype","id":"cfg-xtype"},{"meta":{},"owner":"Ext.Component","tagname":"cfg","name":"zIndex","id":"cfg-zIndex"}]},"files":[{"href":"Field2.html#Ext-field-Field","filename":"Field.js"},{"href":"_form.scss.html#Ext-field-Field","filename":"_form.scss"},{"href":"_toolbar-forms.scss.html#Ext-field-Field","filename":"_toolbar-forms.scss"}],"private":null,"singleton":false,"statics":{"property":[{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"property","name":"$onExtended","id":"static-property-S-onExtended"}],"event":[],"css_var":[],"css_mixin":[],"cfg":[],"method":[{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"addConfig","id":"static-method-addConfig"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"addInheritableStatics","id":"static-method-addInheritableStatics"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"addMember","id":"static-method-addMember"},{"meta":{"static":true},"owner":"Ext.Base","tagname":"method","name":"addMembers","id":"static-method-addMembers"},{"meta":{"static":true},"owner":"Ext.Base","tagname":"method","name":"addStatics","id":"static-method-addStatics"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"addXtype","id":"static-method-addXtype"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"borrow","id":"static-method-borrow"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"callParent","id":"static-method-callParent"},{"meta":{"static":true},"owner":"Ext.Base","tagname":"method","name":"create","id":"static-method-create"},{"meta":{"static":true},"owner":"Ext.Base","tagname":"method","name":"createAlias","id":"static-method-createAlias"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"extend","id":"static-method-extend"},{"meta":{"static":true},"owner":"Ext.Base","tagname":"method","name":"getName","id":"static-method-getName"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"implement","id":"static-method-implement"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"mixin","id":"static-method-mixin"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"onExtended","id":"static-method-onExtended"},{"meta":{"deprecated":{"text":"Please use {@link Ext#define Ext.define} instead","version":"4.1.0"},"static":true},"owner":"Ext.Base","tagname":"method","name":"override","id":"static-method-override"},{"meta":{"static":true,"private":true},"owner":"Ext.Base","tagname":"method","name":"triggerExtended","id":"static-method-triggerExtended"}]},"subclasses":["Ext.field.Checkbox","Ext.field.Text","Ext.field.Slider"],"name":"Ext.field.Field","html_meta":{"aside":["            <div class='aside guide'>\n              <h4>Guide</h4>\n              <p><a href='#!/guide/forms'><img src='guides/forms/icon.png' alt=''> Using Forms</a></p>\n            </div>\n"]},"mixins":[],"code_type":"ext_define","inheritable":false,"id":"class-Ext.field.Field","component":true,"uses":[]});